Attribute VB_Name = "FileDialog"
Option Explicit
Const c_sModuleFileName As String = "FileDialog.frm"

Public Function GetSaveFileName(tTitle As String, prjDir As String, tabFilename As String) As Variant
  On Error GoTo ErrorHandler

    Dim pGxDialog As IGxDialog
    Dim pFilterCol As IGxObjectFilterCollection
    Dim pFileFilter As IGxObjectFilter
    
11:     Set pGxDialog = New GxDialog
12:     Set pFilterCol = pGxDialog
    
        Dim pFileExt As String
15:     pFileExt = FileDialog.GetFileExtension(tabFilename)
        Select Case pFileExt
            Case "dbf"
18:             Set pFileFilter = New GxFilterdBASEFiles
            Case "txt"
20:             Set pFileFilter = New GxFilterTextFiles
            Case "dta"
                'Set pFileFilter = New GxFilterNeurNetFiles
23:             GetSaveFileName = FileDialog2.GetSaveFileName(tTitle, prjDir, tabFilename)
                Exit Function
            Case "out", "tba", "dat"
                'Set pFileFilter = New GxFilterLogRegrFiles
27:                 GetSaveFileName = FileDialog2.GetSaveFileName(tTitle, prjDir, tabFilename)
                Exit Function
            Case Else
                'Set pFileFilter = New GxFilterFiles
31:                 GetSaveFileName = FileDialog2.GetSaveFileName(tTitle, prjDir, tabFilename)
                Exit Function
33:     End Select
34:     pFilterCol.AddFilter pFileFilter, True
35:     pGxDialog.title = tTitle
36:     pGxDialog.Name = tabFilename
37:     pGxDialog.StartingLocation = prjDir
38:     Set pGxDialog.ObjectFilter = pFileFilter
39:     If Not pGxDialog.DoModalSave(0) Then
40:         GetSaveFileName = Empty
            Exit Function
42:     End If
43:     Do While (pFileExt = "dbf") And pGxDialog.ReplacingObject And _
             (Not WOETableUtils.FindStandAloneTableByName(FileDialog.GetBaseName(tabFilename), SDMGlobals.SDMMap) Is Nothing)
45:             MsgBox "Cannot replace table in Table of Contents", , "Create Table"
46:             If Not pGxDialog.DoModalSave(0) Then
47:                 GetSaveFileName = Empty
                    Exit Function
49:             End If
50:     Loop
 
52:     GetSaveFileName = Array(pGxDialog.Name, pGxDialog.FinalLocation.FullName, pGxDialog.ReplacingObject)
    Exit Function
ErrorHandler:
    HandleError True, "getSaveFileName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
56:   GetSaveFileName = Empty

End Function
Public Function GetReadFileName(tTitle As String, prjDir As String, tabFilename As String) As Variant
  On Error GoTo ErrorHandler

    Dim pGxDialog As IGxDialog
    Dim pFilterCol As IGxObjectFilterCollection
    Dim pFileFilter As IGxObjectFilter
        
66:     Set pGxDialog = New GxDialog
67:     Set pFilterCol = pGxDialog
    
        Dim pFileExt As String
70:     pFileExt = FileDialog.GetFileExtension(tabFilename)
        Select Case pFileExt
            Case "dbf"
73:             Set pFileFilter = New GxFilterdBASEFiles
            Case "txt", "dat"
75:             Set pFileFilter = New GxFilterTextFiles
            Case "dta", "dat"
63:                 'Set pFileFilter = New GxFilterNeurNetFiles
78:                 GetReadFileName = FileDialog.GetReadFileName(tTitle, prjDir, tabFilename)
                Exit Function
            Case "out", "tba"
65:                 'Set pFileFilter = New GxFilterLogRegrFiles
82:                 GetReadFileName = FileDialog.GetReadFileName(tTitle, prjDir, tabFilename)
                Exit Function
            Case Else
               'Set pFileFilter = New GxFilterFiles
86:                 GetReadFileName = FileDialog.GetReadFileName(tTitle, prjDir, tabFilename)
                Exit Function
88:     End Select
89:     Set pGxDialog.ObjectFilter = pFileFilter
'showEnabledObjFilters
91:     pGxDialog.title = tTitle
92:     pGxDialog.AllowMultiSelect = False
93:     pGxDialog.StartingLocation = prjDir
        Dim pEnumGxObj As IEnumGxObject
95:     If Not pGxDialog.DoModalOpen(0, pEnumGxObj) Then
96:         GetReadFileName = Empty
            Exit Function
98:     End If
        Dim pGxObj As IGxObject
100:         Set pGxObj = pEnumGxObj.Next
101:     GetReadFileName = Array(FileDialog.GetFileName(pGxObj.FullName), pGxDialog.FinalLocation.FullName)
  Exit Function
ErrorHandler:
  HandleError True, "getSaveDirForFileName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
105:   GetReadFileName = Empty
End Function
Public Function GetFileExtension(FN As String) As String
    Dim tokens As Variant
109:     tokens = Split(FN, ".")
110:     If UBound(tokens) = 1 Then
111:         GetFileExtension = tokens(1)
112:     Else
113:         GetFileExtension = ""
114:     End If
End Function
Public Function GetTempFileName() As IFileName
    Dim fs As Object
118:     Set fs = CreateObject("Scripting.FileSystemObject")
119:     Set GetTempFileName = New fileName
120:     GetTempFileName.path = fs.getTempname
121:     Set fs = Nothing
End Function

Public Function ExistsFilename(fileName As String) As Boolean
    Dim fs As Object
126:     Set fs = CreateObject("Scripting.FileSystemObject")
127:     ExistsFilename = fs.FileExists(fileName)
128:     Set fs = Nothing
End Function

Public Function DeleteFilename(fileName As String) As Boolean
    Dim fs As Object
133:     Set fs = CreateObject("Scripting.FileSystemObject")
    On Error Resume Next
135:     Err.Clear
136:     fs.DeleteFile fileName, True
137:     If (Err.Number <> 0) Then
138:         If (Err.Number = 70) Then
139:             MsgBox fileName & " belongs to another map.", vbCritical, "Delete File Name"
140:         End If
141:         DeleteFilename = False
142:     Else
143:         DeleteFilename = True
144:     End If
145:     Set fs = Nothing
End Function

Public Function MakeTmp(Name As String, ext As String) As IFileName
  On Error GoTo ErrorHandler

        Dim fs As Object
152:     Set fs = CreateObject("Scripting.FileSystemObject")
        Dim n As Long
154:     For n = 1 To 999
             Dim path As String
156:         path = FileDialog.GetCWD.path & "\" & Name & Format(n, "000")
157:         If Not (ext = "") Then path = path & "." & ext
158:         If Not fs.FileExists(path) Then
159:             Set MakeTmp = New fileName
160:             MakeTmp.path = path
                 Exit Function
162:         End If
163:     Next n
164:     Set MakeTmp = Nothing

  Exit Function
ErrorHandler:
  HandleError True, "MakeTmp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Function MakeTmpinWorkSpace(wks As IWorkspaceName, Name As String, ext As String) As IFileName
    Dim fs As Object
172:     Set fs = CreateObject("Scripting.FileSystemObject")
    Dim n As Long
174:     For n = 1 To 999
        Dim path As String
176:         path = wks.PathName & "\" & Name & Format(n, "000") & "." & ext
177:         If Not fs.FileExists(path) Then
178:             Set MakeTmpinWorkSpace = New fileName
179:             MakeTmpinWorkSpace.path = path
                Exit Function
181:         End If
182:     Next n
183:     Set MakeTmpinWorkSpace = Nothing
End Function

Public Function SetCurDir(ByRef newDir As String) As IFileName
187:         ChDir newDir
End Function

Public Function GetCWD() As IFileName
191:     Set GetCWD = New fileName
192:     GetCWD.path = FileDialog.getProjectDir
End Function

Public Function getDir(path As String) As String
    Dim fs As Object
197:     Set fs = CreateObject("Scripting.FileSystemObject")
198:     getDir = fs.getParentFolderName(path)
End Function
Public Function getDriveName(path As String) As String
    Dim fs As Object
202:     Set fs = CreateObject("Scripting.FileSystemObject")
203:     getDriveName = fs.getDriveName(path)
End Function
Public Function GetFileName(path As String) As String
    Dim fs As Object
207:     Set fs = CreateObject("Scripting.FileSystemObject")
208:     GetFileName = fs.GetFileName(path)
End Function
Public Function GetBaseName(path As String) As String
    Dim fs As Object
212:     Set fs = CreateObject("Scripting.FileSystemObject")
213:     GetBaseName = fs.GetFileName(path)
    Dim tokens As Variant
215:     tokens = Split(GetBaseName, ".")
    If UBound(tokens) = 0 Then Exit Function
217:     GetBaseName = tokens(UBound(tokens) - 1)
End Function
Function getProjectDir() As String
On Error GoTo ErrorHandler
' Name:  gSDI.GetProjectDir

' Topics:  Spatial Data Modeller

' Description:  Gets the project
'               directory.  If there is no project
'               directory (the project file has not
'               yet been saved) or the directory is
'               read-only, gets
'               the windows temp directory or
'               users home directory.
'
'
'
' Requires:
'
' Self:        empty list
'
' Returns:     directory (filename)

'=============================================
' Try to get the project directory
'----------------------------------------------
    Dim ProjectDir As String
    Dim pTemplates As ITemplates
    Dim lTempCount As Long
    Dim strDocPath As String
248: If SDMGlobals.SDMApp Is Nothing Then
249:     Set SDMGlobals.SDMApp = New AppRef
250: End If
251:     Set pTemplates = SDMGlobals.SDMApp.Templates
252:     lTempCount = pTemplates.Count
    ' The document is always the last item
254:     strDocPath = pTemplates.item(lTempCount - 1)
         Dim fs As Object
256:     Set fs = CreateObject("Scripting.FileSystemObject")
257:     If (fs.GetExtensionName(strDocPath) = "tmp") _
            Then SDMGlobals.SDMApp.SaveAsDocument
259:     ProjectDir = fs.getParentFolderName(strDocPath)
    
261:     If (ProjectDir = "") Then
262:             ProjectDir = CurDir
263:     ElseIf (ProjectDir = "") Then
264:         If (Len(Environ("TEMP")) <> 0) Then
265:              ProjectDir = Environ("TEMP")
266:         ElseIf (Len(Environ("HOME")) <> 0) Then
267:              ProjectDir = Environ("HOME")
268:         End If
269:     End If
270:     SDMGlobals.SDMPrjDir = ProjectDir
271:     getProjectDir = ProjectDir
Exit Function

ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
276:     getProjectDir = Environ("TEMP")
End Function

Function CreateWriteLineFile(FN As String) As Object
    Dim fs As Object
281:     Set fs = CreateObject("Scripting.FileSystemObject")
282:     Err.Clear
    On Error Resume Next
284:     Set CreateWriteLineFile = fs.CreateTextFile(FN, True, False)
285:     If Err.Number <> 0 Then
286:         MsgBox Err.Description, vbCritical, "FileDialog: CreateWriteLineFile"
287:         Set CreateWriteLineFile = Nothing
288:     End If
End Function
Function CreateReadLineFile(FN As String) As Object
291:     Const ForReading As Long = 1
    Dim fs As Object
293:     Set fs = CreateObject("Scripting.FileSystemObject")
294:     Err.Clear
        On Error Resume Next
296:     Set CreateReadLineFile = fs.OpenTextFile(FN, ForReading, False, 0)
297:     If Err.Number <> 0 Then
298:         MsgBox Err.Description, vbCritical, "FileDialog: CreateReadLineFile"
299:         Set CreateReadLineFile = Nothing
300:     End If
End Function

