VERSION 5.00
Begin VB.Form gBr 
   Caption         =   "Add Bearings to Line Features"
   ClientHeight    =   1950
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5205
   LinkTopic       =   "gBr1"
   ScaleHeight     =   1950
   ScaleWidth      =   5205
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton lbt_OK 
      Caption         =   "OK"
      Height          =   465
      Left            =   480
      TabIndex        =   0
      ToolTipText     =   "Click to add bearing or azimuths to selected line theme"
      Top             =   1200
      Width           =   1125
   End
   Begin VB.CommandButton lbt_Can 
      Caption         =   "Cancel"
      Height          =   465
      Left            =   1755
      TabIndex        =   1
      ToolTipText     =   "Press SHIFT then click for Help"
      Top             =   1200
      Width           =   1125
   End
   Begin VB.ComboBox cbx_Thm 
      Height          =   315
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   2
      ToolTipText     =   "Select a line theme to add bearings or azimuths to"
      Top             =   480
      Width           =   2550
   End
   Begin VB.OptionButton radBr 
      Caption         =   "Bearings"
      Height          =   420
      Left            =   3195
      TabIndex        =   4
      ToolTipText     =   "Direction angle about north direction (-90 - +90)"
      Top             =   480
      Width           =   1440
   End
   Begin VB.OptionButton radAz 
      Caption         =   "Azimuths"
      Height          =   420
      Left            =   3195
      TabIndex        =   5
      ToolTipText     =   "Direction angle clockwise from north direction (0 - 360)"
      Top             =   780
      Width           =   1440
   End
   Begin VB.Label SDMLogo 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H0000C000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "ArcSDM3"
      BeginProperty Font 
         Name            =   "Roman"
         Size            =   14.25
         Charset         =   255
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FFFF&
      Height          =   375
      Left            =   3480
      TabIndex        =   6
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label txt_Lin 
      Caption         =   "Select line theme:"
      Height          =   255
      Left            =   180
      TabIndex        =   3
      Top             =   120
      Width           =   2970
   End
End
Attribute VB_Name = "gBr"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const c_sModuleFileName As String = "gBr.frm"
Const c_sDLLFileName As String = "SDMAccessories" ' Constant reflect file module name

Private Listeners As SDMUtilities.SDMListeners
Private WithEvents aCtl As SDMUtilities.SDMListeners
Attribute aCtl.VB_VarHelpID = -1

Private shiftDown As Boolean

Private ObjectTag As SDMUtilities.SDMList

Public Function isShiftdown() As Boolean
13:     isShiftdown = shiftDown
14:     shiftDown = False
End Function
Public Property Set setObjectTag(ByRef anObject As SDMUtilities.SDMList)
  On Error GoTo ErrorHandler
18:     Set ObjectTag = anObject
  Exit Property
ErrorHandler:
  HandleError True, "setObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Public Property Get getObjectTag() As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

27:     If (ObjectTag Is Nothing) Then
28:         Set getObjectTag = New SDMUtilities.SDMList
29:     Else
30:         Set getObjectTag = ObjectTag
31:     End If
  Exit Property
ErrorHandler:
  HandleError True, "getObjectTag " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

Private Sub Form_Initialize()
38:     Me.KeyPreview = True
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
43:     shiftDown = (Shift And vbShiftMask) > 0
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyDown " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
  On Error GoTo ErrorHandler
50:     shiftDown = False
  Exit Sub
ErrorHandler:
  HandleError True, "Form_KeyUp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Property Get getEars() As SDMUtilities.SDMListeners
  On Error GoTo ErrorHandler
58:     Set getEars = Listeners
  Exit Property
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property

'Include selections for all controls with an update method
'Method could be local or belong to an instantiated object
Private Sub aCtl_UpdateEvt(ByRef ctl As Object)
    On Error GoTo ErrorHandler
    Select Case (ctl.Name)
    Case Me.cbx_Thm.Name
        Dim gBrcbxThmUpdate As gBr_cbx_Thm_Update
71:         Set gBrcbxThmUpdate = New gBr_cbx_Thm_Update
72:         gBrcbxThmUpdate.gBr_cbx_Thm_Update
73:         Set gBrcbxThmUpdate = Nothing
    Case Me.radAz.Name, Me.radBr.Name
    Case Me.lbt_Can.Name
    Case Me.lbt_OK.Name
        ' gBr.lbt_OK.Update
        'self.SetEnabled (self.GetDialog.FindByName("cbx_Thm").GetCurrentValue <> "No line themes found.")
79:         Me.lbt_OK.Enabled = Me.cbx_Thm.Text <> "No line themes found."
    Case Else
81:         MsgBox "Update not found: " & ctl.Parent.Name, vbCritical, "gL.aCtl.Update"
82:     End Select
    Exit Sub
ErrorHandler:
  HandleError True, "getEars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Form_Load()
    On Error GoTo ErrorHandler
90:         Me.Caption = "Add Bearings"
91:     Set Listeners = New SDMUtilities.SDMListeners
92:     Set aCtl = Listeners
93:    If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
94:    If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
95:     If SDMGlobals.SDMMap Is Nothing Then
            Dim pMxDoc As IMxDocument
97:         Set pMxDoc = SDMGlobals.SDMDoc
98:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
99:     End If
100:    If SDMGlobals.SDMUtil Is Nothing Then
101:             Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
102:             Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
103:         End If
104:    If SDMGlobals.SDMStatusBar Is Nothing Then Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
105:    If SDMGlobals.SDMHelp Is Nothing Then Set SDMGlobals.SDMHelp = New SDMUtilities.gSDI_Help
106:    If SDMGlobals.SDMdataDict Is Nothing Then Set SDMGlobals.SDMdataDict = New SDMUtilities.SDMDictionary
107:    If SDMGlobals.SDMWorkspace Is Nothing Then
            Dim cwdPath As String
            Dim lyr As IDataset
110:        Set lyr = SDMGlobals.SDMMap.layers.Next
111:        If Not lyr Is Nothing Then
112:            cwdPath = lyr.Workspace.PathName
113:        Else
114:            cwdPath = Environ("TEMP")
115:        End If
116:        Set SDMGlobals.SDMWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(cwdPath)
120:    End If
121:    shiftDown = False
    Exit Sub
ErrorHandler:
  HandleError True, "gFM_Load " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub lbt_OK_Click()
 'gSDI.AddBearing
129: If shiftDown Then
130:     SDMHelp.gSDI_Help ("sdmaddbr.htm")
    Exit Sub
132: End If
 Dim gSDIAddBearing As gSDI_AddBearing
134:  Set gSDIAddBearing = New gSDI_AddBearing
135:  gSDIAddBearing.AddBearing
136:  Set gSDIAddBearing = Nothing
End Sub
Private Sub lbt_Can_Click()
 'gBr.lbt_Can.Click
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmaddbr.htm"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
'self.GetDialog.Close
148:     If isShiftdown Then
'           SDMHelp.gSDI_Help ("sdmaddbr.htm")
150:             MsgBox "Open help for ""Add Bearings"" at ARCSDM command menu", vbInformation, c_sModuleFileName
        Exit Sub
152:     End If
153:     Unload Me
End Sub
Private Sub radBr_Click()
 'gBr.radBr.Click
End Sub
Private Sub radAz_Click()
 'gBr.radAz.Click
End Sub

