Attribute VB_Name = "FlexGridUtils"
Option Explicit
Const c_sModuleFileName As String = "FlexGridUtils.bas"

Public Function GetSelection(ByRef theListBox As MSHFlexGrid) As SDMList
  On Error GoTo ErrorHandler
'This is just the selected rectangular box in the Table
7: Set GetSelection = New SDMList
Dim ridx As Long, cidx As Long
Dim row1 As Long, row2 As Long
Dim col1 As Long, col2 As Long
11: If (theListBox.rowSel < theListBox.row) Then
12:     row1 = theListBox.rowSel
13:     row2 = theListBox.row
14: Else
15:     row1 = theListBox.row
16:     row2 = theListBox.rowSel
17: End If
18: If (theListBox.ColSel < theListBox.Col) Then
19:     col1 = theListBox.ColSel
20:     col2 = theListBox.Col
21: Else
22:     col1 = theListBox.Col
23:     col2 = theListBox.ColSel
24: End If

Dim rowcolVal As String
27: For ridx = row1 To row2
28:     For cidx = col1 To col2
29:         rowcolVal = theListBox.TextMatrix(ridx, cidx)
30:         If (cidx = 0 And rowcolVal = "") Then GoTo next1
31:         GetSelection.Add rowcolVal
32:     Next cidx
33: Next ridx
next1:

  Exit Function
ErrorHandler:
  'HandleError True, "GetSelection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Function getList(ByRef theListBox As MSHFlexGrid) As SDMList
  On Error GoTo ErrorHandler
'This is the whole rectangle of the Table
'Each row is a list of values
45: Set getList = New SDMList
Dim rowlist As SDMList
Dim ridx As Long, cidx As Long
Dim row1 As Long, row2 As Long
Dim col1 As Long, col2 As Long

51: For ridx = theListBox.FixedRows To theListBox.Rows - 1
52:     Set rowlist = New SDMList
53:     For cidx = theListBox.FixedCols To theListBox.Cols - 1
        Dim rowcolVal As String
55:         rowcolVal = theListBox.TextMatrix(ridx, cidx)
56:         If (cidx = theListBox.FixedCols And rowcolVal = "") Then GoTo next2
57:         rowlist.Add rowcolVal
58:     Next cidx
59:     getList.Add rowlist
60: Next ridx
next2:
'MsgBox str, , "getlist"

  Exit Function
ErrorHandler:
  HandleError True, "getList " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub FlexGridReset(ByRef Table1 As MSHFlexGrid)
    Dim firstLine As String
71:     firstLine = "< Class|< Descriptor|< Definition|< #Records|< #CurrentClasses"
72: With Table1
73:     .Clear
74:     .SelectionMode = flexSelectionByRow
75:     .BackColorBkg = vbWhite
76:     .ForeColorSel = vbBlack
77:     .BackColorSel = vbCyan
78:     .Rows = 2 'This resets fixedrows/cols
79:     .Cols = 5
80:     .FixedRows = 1
81:     .FixedCols = 0
82:     .FormatString = firstLine
83:     .ColWidth(0) = 1440 * 0.85
84:     .ColWidth(1) = 1440 * 1.25
85:     .ColWidth(2) = 1440 * 2
86:     .ColWidth(3) = 1440 * 0.75
87:     .ColWidth(4) = 1440
88:     .row = 1
89: End With

End Sub

Sub FlexGridAddItem(ByRef Table As MSHFlexGrid, ByRef line As SDMList)
    Dim i As Long
95:     If Table.Rows = 2 And Table.TextMatrix(1, 0) = "" Then
96:         For i = 0 To line.Count - 1
97:             Table.TextMatrix(1, i) = line.GetVal(i)
98:         Next i
99:     Else
        Dim s As String
101:         s = line.GetVal(0)
102:         For i = 1 To line.Count - 1
103:             s = s & vbTab & line.GetVal(i)
104:         Next i
105:         Table.AddItem s
106:     End If
107:     Table.row = 1
108:     Table.ColSel = Table.Cols - 1
End Sub
Sub FlexGridRemoveItem(ByRef Table As MSHFlexGrid)
111:     If (Table.Rows > 1) Then
        If Table.row = 0 Then Exit Sub
        Dim rowlist As SDMList
114:         Set rowlist = FlexGridUtils.getList(Table)
        'MsgBox "rowlist.count: " & rowlist.Count
116:         rowlist.Remove Table.row - Table.FixedRows 'Remove selected row
        'MsgBox "rowlist.count: " & rowlist.Count
118:         Table.Rows = 2
        Dim i As Long
120:         For i = 0 To 4
121:             Table.TextMatrix(1, i) = ""
122:         Next i
123:         For i = 0 To rowlist.Count - 1
124:             FlexGridUtils.FlexGridAddItem Table, rowlist.GetObj(i)
125:         Next i
126:     End If
End Sub
