Attribute VB_Name = "LayerToTableJoin"
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\SDMExtension\LayerToTableJoin.bas"

Public Sub RelateTabletoLayer()
  On Error GoTo EH

  Dim pDoc As IMxDocument
  Dim pMap As IMap
9:   Set pDoc = ThisDocument
10:   Set pMap = pDoc.FocusMap
11:   If pMap.LayerCount = 0 Then
12:     MsgBox "Must have at least one layer"
    Exit Sub
14:   End If
  
  ' Get the first layer in the table of contents
  Dim pRasLayer As IRasterLayer
  Dim pTLayer As ITable
19:   Set pRasLayer = pMap.Layer(1)
20:   Set pTLayer = pRasLayer
  
  ' Get the first table in the table on contents
  Dim pTabCollection As IStandaloneTableCollection
  Dim pStTable As IStandaloneTable
  Dim pDispTable2 As IDisplayTable
  Dim pTTable As ITable
27:   Set pTabCollection = pMap
28:   If pTabCollection.StandaloneTableCount = 0 Then
29:     MsgBox "Must have atleast one table"
    Exit Sub
31:   End If
32:   Set pStTable = pTabCollection.StandaloneTable(2)
33:   Set pDispTable2 = pStTable
34:   Set pTTable = pDispTable2.DisplayTable
  
  ' Prompt for the join field, in this example both joined
  ' fields must be named the same.
'  Dim strJnField As String
'  strJnField = InputBox("Provide the name of the join field:", "Joining a table to a layer", _
'  "FIPS_CODE")
  
  ' Create virtual relate
  Dim pMemRelFact As IMemoryRelationshipClassFactory
  Dim pRelClass As IRelationshipClass
45:   Set pMemRelFact = New MemoryRelationshipClassFactory
46:   Set pRelClass = pMemRelFact.Open(pStTable.Name, pTTable, "Class", pTLayer, _
  "Value", "forward", "backward", esriRelCardinalityManyToMany)

  ' Add it to the relates for the raster layer in Map
  Dim pRelClassCollEdit As IRelationshipClassCollectionEdit
51:   Set pRelClassCollEdit = pRasLayer
52:   pRelClassCollEdit.AddRelationshipClass pRelClass

Exit Sub
EH:
   
57:   MsgBox Err.Number & "  " & Err.Description

End Sub
Public Sub joinTableToLayer(ByRef rLayer As ILayer, joinFldLayer As String, ByRef saTable As IStandaloneTable, joinFldTable As String)
  On Error GoTo ErrorHandler

  ' Get the first layer in the table on contents
  Dim pRasLayer As IRasterLayer
  Dim pDispTable As IDisplayTable
  'Dim pFCLayer As IFeatureClass
  Dim pTLayer As ITable
68:   Set pRasLayer = rLayer
69:   Set pDispTable = pRasLayer
70:   Set pFCLayer = pDispTable.DisplayTable
71:   Set pTLayer = pFCLayer
  
  ' Get the first table in the table on contents
  Dim pTabCollection As IStandaloneTableCollection
  Dim pStTable As IStandaloneTable
  Dim pDispTable2 As IDisplayTable
  Dim pTTable As ITable
78:   Set pStTable = saTable
79:   Set pDispTable2 = pStTable
80:   Set pTTable = pDispTable2.DisplayTable

' Create virtual relate
  Dim pMemRelFact As IMemoryRelationshipClassFactory
  Dim pRelClass As IRelationshipClass
85:   Set pMemRelFact = New MemoryRelationshipClassFactory
86:   Set pRelClass = pMemRelFact.Open("TabletoLayer", pTTable, joinFldTable, pTLayer, _
  joinFldLayer, "forward", "backward", esriRelCardinalityOneToMany)

  ' use Relate to perform a join
  Dim pDispRC As IDisplayRelationshipClass
91:   Set pDispRC = pRasLayer
92:   pDispRC.DisplayRelationshipClass pRelClass, esriLeftOuterJoin
  Exit Sub
ErrorHandler:
  HandleError True, "JoinTabletoLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Public Sub RemoveAllJoins(ByRef pSelItem As IUnknown)

  On Error GoTo EH
  ' Get the selected layer or table
101:   If pSelItem Is Nothing Then
            Exit Sub
103:   End If
104:   If Not (TypeOf pSelItem Is ILayer Or TypeOf pSelItem Is IStandaloneTable) Then
105:     'MsgBox "A layer or standalone table must be selected."
            Exit Sub
107:   End If
  
  ' Make sure the selected layer is joined
        Dim pDispTable As IDisplayTable
        Dim pTable As ITable
112:   Set pDispTable = pSelItem
113:   Set pTable = pDispTable.DisplayTable
114:   If Not TypeOf pTable Is IRelQueryTable Then
            'MsgBox "The layer or table is not joined"
            Exit Sub
117:   End If
  
       Dim pDispRC As IDisplayRelationshipClass
120:   Set pDispRC = pSelItem
  
  Dim relshipClass As IRelationshipClass
123:   Set relshipClass = pDispRC.RelationshipClass
124:   pDispRC.DisplayRelationshipClass Nothing, esriLeftInnerJoin
       Exit Sub
EH:
128:   MsgBox Err.Number & "  " & Err.Description, , "LayerToTableJoin"
   
End Sub

Public Sub RemoveLastJoin(ByRef pSelItem As IUnknown)

134:   If Not TypeOf pSelItem Is IDisplayTable Then
135:     MsgBox "No Feature layer or table selected"
    Exit Sub
137:   End If
  
  ' Make sure the selected layer is joined
  Dim pDispTable As IDisplayTable
  Dim pTable As ITable
142:   Set pDispTable = pSelItem
143:   Set pTable = pDispTable.DisplayTable
144:   If Not TypeOf pTable Is IRelQueryTable Then
145:     MsgBox "The layer or table is not joined"
    Exit Sub
147:   End If
 
  ' Get the source table of the current join
  ' object (RelQueryTable)
  Dim pRelQTab As IRelQueryTable
152:   Set pRelQTab = pTable
153:   Set pTable = pRelQTab.SourceTable

  ' UnJoin
  Dim pDispRC As IDisplayRelationshipClass
157:   Set pDispRC = pSelItem
  ' If more than one table had been joined, replace
  ' the current join with the previous join
160:   If TypeOf pTable Is IRelQueryTable Then
161:     Set pRelQTab = pTable
162:     pDispRC.DisplayRelationshipClass pRelQTab.RelationshipClass, esriLeftInnerJoin
  ' If one table has been joined, remove all joins
164:   Else
165:     pDispRC.DisplayRelationshipClass Nothing, esriLeftInnerJoin
166:   End If

End Sub


