Attribute VB_Name = "ListUtils"
Option Explicit

Const NONE = 0
Const VAR = 1
Const OBJECT = 2
Const VARLIST = 4



Function ListtoString(list As SDMList) As String

    Dim SubList As SDMList
    
14:     ListtoString = "-->" & vbCrLf
    
16:     If list.Count = 0 Then
17:         ListtoString = ListtoString & "empty list" & vbCrLf
18:     Else
        Dim item As Variant
20:         For Each item In list.list
            Dim vt As Integer
22:             vt = getVarType(item)
23:             If vt = OBJECT Then
24:                 If item Is Nothing Then
25:                     ListtoString = ListtoString & "Nothing" & vbCrLf
26:                 ElseIf TypeOf item Is SDMList Then
27:                     Set SubList = item
28:                     ListtoString = ListtoString & ListtoString(SubList)
29:                 Else
30:                     ListtoString = ListtoString & "an Object" & vbCrLf
31:                 End If
32:             ElseIf vt = VARLIST Then
33:                 ListtoString = ListtoString & ArraytoString(item)
34:             ElseIf vt = VAR Then
35:                 ListtoString = ListtoString & CStr(item) & vbCrLf
36:             Else 'NONE
37:                 ListtoString = ListtoString & "Nil" & vbCrLf
38:             End If
39:         Next item
40:     End If
41: ListtoString = ListtoString & "<--" & vbCrLf
    
End Function

Private Function ArraytoString(list As Variant) As String

    Dim SubList As SDMList
    
49:     ArraytoString = "-->" & vbCrLf
    
51:     If UBound(list) = -1 Then
52:         ArraytoString = ArraytoString & "empty array" & vbCrLf
53:     Else
        Dim vt As Integer
        Dim item As Variant
56:         For Each item In list
57:             vt = getVarType(item)
58:             If vt = OBJECT Then
59:                 If TypeOf item Is SDMList Then
60:                     Set SubList = item
61:                     ArraytoString = ArraytoString & ListtoString(SubList)
62:                 Else
63:                     ArraytoString = ArraytoString & "an Object" & vbCrLf
64:                 End If
65:             ElseIf vt = VARLIST Then
66:                 ArraytoString = ArraytoString & ArraytoString(item)
67:             ElseIf vt = VAR Then
68:                 ArraytoString = ArraytoString & CStr(item) & vbCrLf
69:             Else 'NONE
70:                 ArraytoString = ArraytoString & "Nil" & vbCrLf
71:             End If
72:         Next item
73:     End If
74: ArraytoString = ArraytoString & "<--" & vbCrLf
    
End Function

Function getVarType(item As Variant) As Integer

Dim vt As Integer
81: vt = VarType(item)

Select Case vt
    Case vbEmpty, vbNull
85:         getVarType = NONE
    Case vbInteger To vbString, vbError To vbBoolean, vbDecimal, vbByte
87:         getVarType = VAR
    Case vbObject, vbDataObject, vbUserDefinedType
89:         getVarType = OBJECT
    Case vbArray To (vbArray + vbUserDefinedType)
        Select Case vt - vbArray
            Case vbEmpty, vbNull
93:                 getVarType = NONE
            Case vbInteger To vbString, vbError To vbBoolean
95:                 getVarType = VARLIST
            Case vbObject
97:                 getVarType = OBJECT
            Case vbVariant
99:                 getVarType = VARLIST
            Case vbDataObject
101:                 getVarType = NONE
            Case vbDecimal, vbByte
103:                 getVarType = VARLIST
            Case vbUserDefinedType
105:                 getVarType = NONE
106:    End Select
107: End Select

End Function

Public Function FindObj(ByRef anItem As Variant, ByRef myList As SDMList) As Long
On Error GoTo ErrorHandler

        Dim i As Long
115:         i = 0
        Dim VAR As Variant
        Dim theType As Boolean
118:         theType = (VarType(anItem) = vbObject) Or (VarType(anItem) = vbDataObject)
119:         If (theType) Then
120:             For Each VAR In myList.list
121:                 If (VarType(VAR) = VarType(anItem)) Then
122:                         If (anItem Is VAR) Then
123:                             FindObj = i
                            Exit Function
125:                         End If
126:                 End If
127:                 i = i + 1
128:             Next VAR
129:         End If
130:     FindObj = -1
Exit Function
ErrorHandler:
133:     FindObj = -1
End Function 'Find

Public Function getObj(Index As Long, ByRef myList As SDMList) As Variant
137:     Set getObj = myList.list(Index + 1)
End Function 'Find

Public Function Clone(ByRef aList As SDMList) As SDMList
141:     Set Clone = New SDMList
    Dim VAR As Variant
143:     For Each VAR In aList.list
144:         Clone.Add VAR
145:     Next VAR
End Function
Public Sub RemoveObj(ByRef anItem As Variant, ByRef myList As SDMList)
    Dim ifound As Long
149:     ifound = FindObj(anItem, myList)
150:     If (ifound <> -1) Then
151:         myList.Remove ifound
        Exit Sub
153:     End If
End Sub
Public Sub ShuffleObj(ByRef anItem As Variant, Position As Long, ByRef myList As SDMList)
    Dim ifound As Long
157:     ifound = FindObj(anItem, myList)
158:     If (ifound > -1) Then
159:         If Position = 0 Then
160:             RemoveObj anItem, myList
161:             myList.Insert anItem
162:         Else
163:             MsgBox "Can't do interior shuffle", vbCritical, "ListUtils.ShuffleObj"
164:         End If
165:     Else
166:         MsgBox "Object to shuffle not found", vbCritical, "ListUtils.ShuffleObj"
167:     End If
End Sub

