Attribute VB_Name = "RasterUtils"
Option Explicit
Option Compare Text

Const c_sModuleFileName As String = "RasterUtils"


Public Sub MakePermanent(pRasterDS As IRasterDataset)
        Dim pTempDS As ITemporaryDataset
9:     Set pTempDS = pRasterDS
    ' Make permanent
11:     If pTempDS.IsTemporary Then pTempDS.MakePermanent
End Sub

Function GetTPsInRasterDataArea(ByRef minTheme As IFeatureLayer, ByRef baseMap As IRasterLayer) As ISelectionSet
  On Error GoTo ErrorHandler

'Generate a selection of OIDs of points within study area extent.
        Dim pScratchWorkspace As IWorkspace
        Dim pScratchWorkspaceFactory As IScratchWorkspaceFactory
20:     Set pScratchWorkspaceFactory = New ScratchWorkspaceFactory
21:     Set pScratchWorkspace = pScratchWorkspaceFactory.DefaultScratchWorkspace
    
23:     Set GetTPsInRasterDataArea = minTheme.FeatureClass.Select(Nothing, esriSelectionTypeHybrid, esriSelectionOptionEmpty, pScratchWorkspace)
    
        Dim rastBuf As IRasterBuffer
26:     Set rastBuf = New IRasterBuffer
27:     If Not rastBuf.OpenBuffer(baseMap) Then
28:         MsgBox "Illegal integer raster type", , c_sModuleFileName
29:         Set GetTPsInRasterDataArea = Nothing
            Exit Function
31:     End If
         
        Dim qry As IQueryFilter
34:     Set qry = New QueryFilter
        Dim curs As ICursor
36:     Set curs = minTheme.Search(Nothing, True)
    
         Dim row As irow
39:     Set row = curs.NextRow
        Dim shapeidx As Long
41:     shapeidx = minTheme.FeatureClass.FindField(minTheme.FeatureClass.shapeFieldName)
42:     SDMGlobals.SDMStatusBar.ProgressBar.Position = 0
43:     SDMGlobals.SDMStatusBar.ShowProgressBar "Checking TPs...", 1, row.Table.RowCount(Nothing), 1, True
44:     While Not row Is Nothing
            Dim pnt As IPoint
46:         Set pnt = row.Value(shapeidx)
            Dim cellVal As Variant
48:         cellVal = rastBuf.GetVal(pnt)
49:         If Not IsNull(cellVal) Then
                'NoData areas within study areas allowed
51:                 GetTPsInRasterDataArea.Add row.OID
52:         Else
            'NULL cell value is outside of study area extent
'50:             Err.Raise vbObject + 1, "GetVal()", "Raster buffer error"
'51:             GoTo ErrorHandler
56:         End If
57:         Set row = curs.NextRow
58:         SDMGlobals.SDMStatusBar.StepProgressBar
59:     Wend
60:     SDMGlobals.SDMStatusBar.HideProgressBar

  Exit Function
ErrorHandler:
  HandleError True, "GetTPsInRasterDataArea " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
65:   MsgBox "Cannot get training points within study area", vbCritical, c_sModuleFileName
66:   Set GetTPsInRasterDataArea = Nothing
End Function

Function GetTable(ByRef raslayer As IRasterLayer) As ITable
  On Error GoTo ErrorHandler
'Single-valued rasters often will not return a table object
'This is a kluge based on the undocumented IWorkspaceFactory.OpenTable method

    Dim rasBandColl As IRasterBandCollection
75: Set rasBandColl = RasterUtils.GetDatasetRaster(raslayer)
    Dim rasBand As IRasterBand
77: Set rasBand = rasBandColl.item(0)
    
    Dim ExistsTable As Boolean
80: rasBand.HasTable ExistsTable
81: If Not ExistsTable Then
82:     Set GetTable = Nothing
        Exit Function
84:     GoTo getVAT
85: ElseIf TypeOf raslayer Is IDisplayTable Then
        Dim dispTbl As IDisplayTable
87:     Set dispTbl = raslayer
88:     Set GetTable = dispTbl.DisplayTable
        Exit Function
90: ElseIf rasBand.RasterDataset.Format = "GRID" Then
91:     Set GetTable = rasBand.AttributeTable
        Exit Function
93: Else
94:     Set GetTable = Nothing
        Exit Function
96: End If

    
getVAT:
100: Set GetTable = Nothing
     Exit Function
    
'''    Dim rasDs As IRasterDataset
'''96: Set rasDs = rasBand.RasterDataset
'''    Dim rasDSPath As String
'''98: rasDSPath = rasDs.CompleteName
'''
'''     Dim pWSF As IWorkspaceFactory
'''101: Set pWSF = New ArcInfoWorkspaceFactory
'''
'''     Dim FileDialog As Object
'''104: Set FileDialog = CreateObject("Scripting.FileSystemObject")
'''105: If Not pWSF.IsWorkspace(FileDialog.getFolderName(rasDSPath)) Then
'''106:    Set GetTable = Nothing
'''107:    Exit Function
'''108: End If
'''     Dim pFWS As IFeatureWorkspace
'''109: Set pFWS = pWSF.OpenFromFile(FileDialog.getFolderName(rasDSPath), 0)
'''     On Error GoTo Out:
'''     Dim rsDSName As String
'''110: rsDSName = FileDialog.GetBaseName(rasDSPath) & ".VAT"
'''     Dim pFWS2 As IWorkspace2
'''112: Set pFWS2 = pFWS
'''113: If pFWS2.NameExists(esriDTRasterDataset, rsDSName) Then
'''        Dim pAITable As IArcInfoTable
'''115:    Set pAITable = pFWS.OpenTable(rsDSName)
'''116:    Set GetTable = pAITable
'''        Exit Function
'''118: Else
'''119:    GoTo Out
'''120: End If
'''     Exit Function
'''Out: Set GetTable = Nothing
     Exit Function
ErrorHandler:
  HandleError True, "GetTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
137:   Set GetTable = Nothing
End Function

Function getSDMUCName(ByRef pRasLayer As IRasterLayer) As String
        Dim pRasBandCol As IRasterBandCollection
142:   Set pRasBandCol = pRasLayer.Raster
        Dim pRasBand As IRasterBand
144:   Set pRasBand = pRasBandCol.item(0)
        Dim pRasDS As IDataset
146:   Set pRasDS = pRasBand
147:   getSDMUCName = Mid(pRasDS.Name, 7)

End Function
Public Function OpenRasterDataset(sPath As String, sFileName As String) As IRasterDataset
    ' sPath: directory where dataset resides
    ' sFileName: name of the raster dataset
     On Error GoTo ErrorHandler
    
    ' Create RasterWorkSpaceFactory
     Dim pWSF As IWorkspaceFactory
157: Set pWSF = New RasterWorkspaceFactory
    
    ' Get RasterWorkspace
     Dim pRasWS As IRasterWorkspace
161: If pWSF.IsWorkspace(sPath) Then
162:    Set pRasWS = pWSF.OpenFromFile(sPath, 0)
163:    Set OpenRasterDataset = pRasWS.OpenRasterDataset(sFileName)
164: End If
    
    ' Release memeory
167: Set pRasWS = Nothing
168: Set pWSF = Nothing
     Exit Function
ErrorHandler:
171:     Set OpenRasterDataset = Nothing
End Function

Function GetNoDataValue(ByRef rasobject As IUnknown) As Variant
  On Error GoTo ErrorHandler
        Dim raslayer As IRasterLayer
177:     If TypeOf rasobject Is IRasterLayer Then
178:         Set raslayer = rasobject
             Dim pRaster As IRaster
180:         Set pRaster = RasterUtils.GetDatasetRaster(raslayer)
181:     Else
182:         Err.Raise vbObjectError + 513, "GetNoDataValue", "Argument not a rasterlayer"
183:     End If
         Dim pRasProps As IRasterProps
185:     Set pRasProps = pRaster
        Select Case pRasProps.PixelType
            Case PT_SHORT, PT_LONG
188:             GetNoDataValue = pRasProps.NoDataValue(0)
            Case PT_USHORT, PT_ULONG
190:             GetNoDataValue = 0 'Avoid Automation error
            Case PT_UCHAR
192:             GetNoDataValue = pRasProps.NoDataValue(0)
            Case PT_CHAR
194:             GetNoDataValue = -128 'Avoid Automation error
            Case PT_FLOAT, PT_DOUBLE, PT_COMPLEX, PT_DCOMPLEX
196:             GetNoDataValue = pRasProps.NoDataValue(0)
            Case Else 'other types: complex and 1-, 2-, & 4-bit rasters
198:             GetNoDataValue = pRasProps.NoDataValue(0)
199:     End Select
      Exit Function
ErrorHandler:
  HandleError True, "GetNoDataValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
203:     GetNoDataValue = -1
    
End Function

Function GetLayerNamesForTempNames(plyr As ILayer) As SDMUtilities.SDMList
     On Error GoTo ErrorHandler

210: Set GetLayerNamesForTempNames = New SDMUtilities.SDMList
     Dim pLyrDesc As ILayerGeneralProperties
212: Set pLyrDesc = plyr
     Dim Desc, i, Pair, key, Value
'270: MsgBox pLyrDesc.LayerDescription, , "Layer Description"
215: If pLyrDesc.LayerDescription = "" Then GoTo Abort
216: Desc = Split(pLyrDesc.LayerDescription, vbCrLf)
217: For i = 0 To UBound(Desc)
218:     If Trim(Desc(i)) = "" Then
219:        If i = 0 Then
220:            GoTo Abort
221:        Else
                Exit Function
223:        End If
224:     End If
225:     Pair = Split(Desc(i), " ")
226:     key = Trim(Pair(0))
227:     If Not UCase(key) Like "SDMTEMP*" Then GoTo Abort
228:     Value = Trim(Pair(1))
229:     GetLayerNamesForTempNames.Add Value
230: Next i
     Exit Function
Abort:
233: MsgBox "Required mappings of SDMTEMPnn to Evidence Layers not found" & vbCrLf & _
                   "in Description property of layer: " & plyr.Name & vbCrLf & _
                   "Aborting command.", vbCritical, "Neural Network"
236: Set GetLayerNamesForTempNames = Nothing
     Exit Function
ErrorHandler:
     HandleError False, "GetLayerNamesForTempNames " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
240: Set GetLayerNamesForTempNames = Nothing
End Function

Function GetTempNamesForLayerNames(plyr As ILayer) As SDMUtilities.SDMList
     On Error GoTo ErrorHandler

246: Set GetTempNamesForLayerNames = New SDMUtilities.SDMList
     Dim pLyrDesc As ILayerGeneralProperties
248: Set pLyrDesc = plyr
     Dim Desc, i, Pair, key, Value
'292:      MsgBox pLyrDesc.LayerDescription, , "Layer Description"
251: Desc = Split(pLyrDesc.LayerDescription, vbCrLf)
252: For i = 0 To UBound(Desc)
         If Trim(Desc(i)) = "" Then Exit Function
254:     Pair = Split(Desc(i), " ")
255:     key = Trim(Pair(0))
256:     Value = Trim(Pair(1))
257:     GetTempNamesForLayerNames.Add key
258: Next i
'MsgBox "GetTempNamesForLayerNames" & vbCrLf & GetTempNamesForLayerNames.asString, , "Layer Description"
  Exit Function
ErrorHandler:
  HandleError False, "GetLayerNamesForTempNames " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Function GetDatasetRaster(raslayer As IRasterLayer) As IRaster
     On Error GoTo ErrorHandler
     Dim rasbndColl As IRasterBandCollection
268: Set rasbndColl = raslayer.Raster
     Dim rasbnd As IRasterBand
270: Set rasbnd = rasbndColl.item(0)
     Dim rasDS As IRasterDataset
272: Set rasDS = rasbnd.RasterDataset
     
     Dim fs
275: Set fs = CreateObject("Scripting.FileSystemObject")
     Dim sPath As String
277: sPath = fs.getParentFolderName(rasDS.CompleteName)
    
    ' Create RasterWorkspace
     Dim pRWS As IRasterWorkspace
     Dim pWSF As IWorkspaceFactory
282: Set pWSF = New RasterWorkspaceFactory
     If Not pWSF.IsWorkspace(sPath) Then Exit Function
284: Set pRWS = pWSF.OpenFromFile(sPath, 0)

    ' Open RasterDataset and get default raster
     Dim sInName As String
288: sInName = fs.GetFileName(rasDS.CompleteName)
289: Set GetDatasetRaster = pRWS.OpenRasterDataset(sInName).CreateDefaultRaster
     Exit Function
ErrorHandler:
  HandleError True, "GetDatasetRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

