Attribute VB_Name = "ReclassByClassList"
Option Explicit
Const c_sModuleFileName As String = "ReclassByClassList"

Function ReclassByClassList(ByRef pRasterly As IRasterLayer, fldName As String, Optional noData As Boolean = True, Optional nclass As Long = 4) As IGeoDataset
  On Error GoTo ErrorHandler
  
7:     If fldName = "Value" Then
8:         Set ReclassByClassList = ReclassifyByValueField(pRasterly, fldName, True, nclass)
9:     Else
            Dim dispTbl As IDisplayTable
11:         Set dispTbl = pRasterly
            Dim pTbl As ITable
13:         Set pTbl = dispTbl.DisplayTable
14:         If pTbl.Fields.Field(pTbl.FindField(fldName)).Type = esriFieldTypeString Then
15:             Set ReclassByClassList = ReclassifyByStringField(pRasterly, fldName, True)
16:         Else
17:             Set ReclassByClassList = ReclassifyByValueField(pRasterly, fldName, True, nclass)
18:         End If
19:     End If


        Exit Function
ErrorHandler:
        HandleError True, "ReclassByClassList " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
25:     Set ReclassByClassList = Nothing
End Function
Function ReclassifyByValueField(ByRef pRasterly As IRasterLayer, fldName As String, noData As Boolean, Optional nclass As Long = 4) As IGeoDataset
    On Error GoTo ErrorHandler
    'rasterlayer and class field are arguments
    
    ' Get the Map
    Dim pApp As IApplication
33:     Set pApp = New AppRef
    Dim pMxDoc As IMxDocument
35: Set pMxDoc = pApp.Document
    Dim pMap As IMap
37: Set pMap = pMxDoc.FocusMap

   'Deal with joined attribute
   
   ' Create a Spatial operator
    Dim pReclassOp As IReclassOp
43: Set pReclassOp = New RasterReclassOp

    'Init the reclassify field
    Dim pEnv As IRasterAnalysisEnvironment
47: Set pEnv = pReclassOp
48: setRAEnv pEnv, RasterAEUtils.getRasterAnalysisEnvironment
49: pEnv.DefaultOutputRasterPrefix = "SDMReclass"

    'Select classification method and get class breaks
    Dim breaks As Variant
53: breaks = OpenClassDlg(pRasterly, fldName, nclass)
54: If IsNull(breaks) Then
55:     Set ReclassifyByValueField = Nothing
        Exit Function
57: End If
58: gC.breaks = breaks
    
'Set the Remap Table
    Dim nRemapOp As INumberRemap
62: Set nRemapOp = New NumberRemap

    Dim i As Long
    Dim j As Long
66: j = 1
67: For i = 1 To UBound(breaks)
68:         If breaks(i - 1) <> breaks(i) Then
69:             nRemapOp.MapRange breaks(i - 1), breaks(i), j
70:             j = j + 1
71:         End If
72: Next i
    Dim remapOp As IRemap
74: Set remapOp = nRemapOp


    Dim bIsValid As Boolean, sErrorInfo As String
78: remapOp.Validate bIsValid, sErrorInfo
79: If Not bIsValid Then
80:         MsgBox sErrorInfo, vbExclamation, "Bad remap table"
81:         Set ReclassifyByValueField = Nothing
            Exit Function
83: Else
'82:         SDMGlobals.SDMStatusBar.Message(0) = "Remap Table OK: " & UBound(breaks)
85: End If

'Because can't use joined table fieldname must do a surrogate remapping
'of field name to Value to remapped value

    Dim nRemapOp2 As INumberRemap
91: Set nRemapOp2 = New NumberRemap
    Dim RemapOp2 As IRemap
93: Set RemapOp2 = nRemapOp2
94: If fldName <> "Value" Then
        Dim pDispTbl As IDisplayTable
96:     Set pDispTbl = pRasterly
        Dim vTab As ITable
98:     Set vTab = pDispTbl.DisplayTable
'97:         MsgBox ListtoString(WOETableUtils.getFieldsNames(vTab)), , pRasterly.Name
        Dim valIdx As Long
101:     valIdx = vTab.FindField("Value")
        Dim fldIdx As Long
103:    fldIdx = vTab.FindField(fldName)
'102:        MsgBox "Found: " & fldIdx & vbCrLf & "No. fields=" & vTab.Fields.FieldCount, , "field name: " & fldName
        Dim curs As ICursor
106:    Set curs = vTab.Search(Nothing, False)
'105:        MsgBox "No. fields=" & curs.Fields.FieldCount, , "SearchCursor"
        Dim rw As irow
109:    Set rw = curs.NextRow
        Dim Value As Double
111:    If Not rw Is Nothing Then Value = rw.Value(valIdx)
        Dim hasNulls As Boolean
113:    hasNulls = False
114:    While Not rw Is Nothing
            Dim fldVal As Variant
116:        fldVal = rw.Value(fldIdx)
117:        If IsNull(fldVal) Then
118:            fldVal = 0#
119:            hasNulls = True
'Err.Raise vbObjectError, c_sModuleFileName, "OID=" & rw.OID & ": " & fldName & " value is null"
121:        Else
122:            fldVal = CDbl(fldVal)
123:        End If
            Dim noDataSt As Boolean
            Dim outVal As Long
126:        For j = 0 To remapOp.RecordCount - 1
                Dim minVal As Double, maxVal As Double, isNoData As Boolean
128:                nRemapOp.QueryNumberRecord j, minVal, maxVal, outVal, isNoData
129:            If (j = 0 And fldVal >= minVal And fldVal <= maxVal) Or _
                    (fldVal > minVal And fldVal <= maxVal) Then
131:                    nRemapOp.QueryNumberValue fldVal, outVal, noDataSt
132:            Exit For
133:            End If
134:        Next j
135:        nRemapOp2.MapValue Value, outVal
136:        Set rw = curs.NextRow
137:        If Not rw Is Nothing Then
                'To handle skips in value objects
                Dim Value2 As Double
140:            Value2 = rw.Value(valIdx)
141:            Do Until Value = Value2 - 1
142:                    Value = Value + 1
'140:                    nRemapOp2.MapValueToNoData Value
144:            Loop
145:        End If
146:        Value = Value2
147:    Wend
148:    If hasNulls Then MsgBox "One of the comparison fields has NULL values. Set to 0.0", vbExclamation, "ReclassByClassList"
' End of kluge re-remap
150: Else
151:     Set nRemapOp2 = nRemapOp
152: End If

     Dim isValid As Boolean, errorInfo As String
155: RemapOp2.Validate isValid, errorInfo
156: If Not isValid Then
157:    MsgBox "Remap error=" & errorInfo, , c_sModuleFileName
158:    Set ReclassifyByValueField = Nothing
        Exit Function
160: End If
    
     Dim inRas As IGeoDataset
163: Set inRas = pRasterly.Raster

   ' Create a raster descriptor and select the field used for reclassify
     Dim pRD As IRasterDescriptor
167: Set pRD = New RasterDescriptor

169: pRD.Create inRas, New QueryFilter, "Value"
170: Set inRas = pRD
171: Set ReclassifyByValueField = pReclassOp.ReclassByRemap(inRas, nRemapOp2, noData)

' Add reclassified layer into ArcMap
     Dim prasterly2 As IRasterLayer
175: Set prasterly2 = New RasterLayer
176: prasterly2.CreateFromRaster ReclassifyByValueField
177: pMap.AddLayer prasterly2
     Exit Function
ErrorHandler:
  HandleError True, "ReclassifyByValueField " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
181:     Set ReclassifyByValueField = Nothing
End Function

Sub setRAEnv(destinationEnv As IRasterAnalysisEnvironment, sourceEnv As IRasterAnalysisEnvironment)
    On Error GoTo ErrorHandler

        Dim cellsize As Double
188:     sourceEnv.GetCellSize esriRasterEnvValue, cellsize
189:     destinationEnv.SetCellSize esriRasterEnvValue, cellsize
    
        Dim ext As IEnvelope
192:     sourceEnv.GetExtent esriRasterEnvValue, ext
193:     destinationEnv.SetExtent esriRasterEnvValue, ext
    
        Dim mask As IGeoDataset
196:     Set mask = sourceEnv.mask
197:     Set destinationEnv.mask = mask
    
        Dim wks As IWorkspace
200:     Set wks = sourceEnv.OutWorkspace
201:     Set destinationEnv.OutWorkspace = wks
    
        Dim spatRef As ISpatialReference
204:     Set spatRef = sourceEnv.OutSpatialReference
205:     Set destinationEnv.OutSpatialReference = spatRef


  Exit Sub
ErrorHandler:
210: If GetErrorLineNumberString(Erl) = "66" Then
    
212: End If
  HandleError True, "setRAEnv " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
Function ReclassifyByStringField(ByRef pRasterly As IRasterLayer, fldName As String, noData As Boolean, Optional nclass As Long) As IGeoDataset
  On Error GoTo ErrorHandler

    'Get reclassification list
219: StringClassList.Show vbModal
     Dim choice As Long
221: choice = CLng(StringClassList.Tag)
222: Unload StringClassList
223: If choice < 0 Then
224:    Set ReclassifyByStringField = Nothing
        Exit Function
226: End If
        
     Dim pRemap As IRemap
     Dim pSRemap As IStringRemap
230: Set pSRemap = New StringRemap
     Dim i As Long
     Select Case choice
        Case 0: 'Table source
             Dim saTblColl As IStandaloneTableCollection
235:         Set saTblColl = SDMGlobals.SDMMap
             Dim lstDlg2 As IListDialog
237:         Set lstDlg2 = New ListDialog
238:         If saTblColl.StandaloneTableCount = 0 Then
239:             MsgBox "No tables in ArcMap document.", vbExclamation, "Compare results..."
240:             Set ReclassifyByStringField = Nothing
                 Exit Function
242:         End If
243:         For i = 0 To saTblColl.StandaloneTableCount - 1
244:             If Not saTblColl.StandaloneTable(i).Name Like "*-Data Types of Evidential Themes" Then _
                    lstDlg2.AddString saTblColl.StandaloneTable(i).Name
246:         Next i
247:         If Not lstDlg2.doModal("Select a reclass table.", 0, 0) Then
248:             Set ReclassifyByStringField = Nothing
                 Exit Function
250:         Else
                 Dim saTbl As IStandaloneTable
252:             Set saTbl = saTblColl.StandaloneTable(lstDlg2.choice)
253:         End If
        
             Dim remapTbl As ITable
256:         Set remapTbl = saTbl.Table
257:         If remapTbl.HasOID Then
                 Dim outFieldName As String
259:             outFieldName = remapTbl.Fields.Field(2).Name
                 Dim inFieldName As String
261:             inFieldName = remapTbl.Fields.Field(1).Name
262:         Else
263:             outFieldName = remapTbl.Fields.Field(1).Name
264:             inFieldName = remapTbl.Fields.Field(0).Name
265:         End If
266:         pSRemap.LoadStringsFromTable remapTbl, outFieldName, inFieldName
         Case 1: 'Dialog source
268:         Load gReclsTbl
269:         Set gReclsTbl.rasterObj = pRasterly
270:         gReclsTbl.fieldName = fldName
271:         gReclsTbl.Show vbModal
272:         Set pSRemap = gReclsTbl.breaks
         Case 2: 'UV Renderer source
274:         If Not TypeOf pRasterly.Renderer Is IRasterUniqueValueRenderer Then
275:             MsgBox pRasterly.Name & "-" & fldName & " does not have Unique Value symbolization.", _
                vbExclamation, "Classify Results..."
277:             Set ReclassifyByStringField = Nothing
                 Exit Function
279:         Else
                 Dim pUVRdrer As IRasterUniqueValueRenderer
281:             Set pUVRdrer = pRasterly.Renderer
282:             If pUVRdrer.HeadingCount > 1 Then
283:                 MsgBox "More than one heading in the symbolization of " & pRasterly.Name & ".", vbExclamation, "Classify Results..."
284:                 Set ReclassifyByStringField = Nothing
                     Exit Function
286:             Else
287:                 For i = 0 To pUVRdrer.ClassCount(0) - 1
288:                     If pUVRdrer.ValueCount(0, 0) > 1 Then
289:                         MsgBox "More than one class in the heading of " & pRasterly.Name & ".", vbExclamation, "Classify Results..."
290:                         Set ReclassifyByStringField = Nothing
                             Exit Function
292:                     End If
293:                     If Not IsNumeric(pUVRdrer.Label(0, i)) Then
294:                         MsgBox "The labels in Unique Value symbolization of " & pRasterly.Name & " must be numeric", vbExclamation, "Compare results..."
295:                         Set ReclassifyByStringField = Nothing
                             Exit Function
297:                     End If
298:                     pSRemap.MapString pUVRdrer.Value(0, i, 0), pUVRdrer.Label(0, i)
299:                 Next i
300:             End If
301:         End If
302:     End Select
    
    ' Get the Map
         Dim pMxDoc As IMxDocument
306:     Set pMxDoc = SDMGlobals.SDMDoc
         Dim pMap As IMap
308:     Set pMap = pMxDoc.FocusMap

         Dim pGeoDS As IGeoDataset
311:     Set pGeoDS = pRasterly.Raster
    
   ' Create a raster descriptor and select the field used for reclassify
         Dim pRD As IRasterDescriptor
315:     Set pRD = New RasterDescriptor
316:     pRD.Create pGeoDS, New QueryFilter, fldName
317:     Set pGeoDS = pRD

   ' Create a Spatial operator
         Dim pReclassOp As IReclassOp
321:     Set pReclassOp = New RasterReclassOp

    ' Set output workspace
         Dim pEnv As IRasterAnalysisEnvironment
325:     Set pEnv = pReclassOp
326:     setRAEnv pEnv, RasterAEUtils.getRasterAnalysisEnvironment

    ' Set the Remap
329:     Set pRemap = pSRemap

    ' Perform Spatial operation
         Dim pOutRaster As IRaster
333:     Set pOutRaster = pReclassOp.ReclassByRemap(pGeoDS, pRemap, noData)
334:     Set ReclassifyByStringField = pOutRaster
    
    ' Add it into ArcMap
'267:     Set pRasterly = New RasterLayer
'268:     pRasterly.CreateFromRaster pOutRaster
'269:     pMap.AddLayer pRasterly



     Exit Function
ErrorHandler:
     HandleError True, "ReclassifyByStringField " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
346: Set ReclassifyByStringField = Nothing
End Function

Function OpenClassDlg(ByRef pRasLayer As IRasterLayer, fldName As String, Optional nclass As Long = 4) As Variant
    On Error GoTo ErrorHandler
' opens ClassificationDialog with histogram data from Raster layer and gets
' class breaks from dialog for selected dialogs.

354:    OpenClassDlg = Null

        Dim pMxDoc As IMxDocument
357:    Set pMxDoc = SDMGlobals.SDMDoc
  
        Dim pTableHist As ITableHistogram
360:    Set pTableHist = New TableHistogram
361:    pTableHist.Field = fldName
        Dim gSDIGetVTab As gSDI_GetVTab
363:    Set gSDIGetVTab = New gSDI_GetVTab
        Dim pTable As ITable
365:    If TypeOf pRasLayer Is IDisplayTable Then
            Dim dspTbl As IDisplayTable
367:        Set dspTbl = pRasLayer
368:        Set pTable = dspTbl.DisplayTable
369:    Else
370:        Set pTable = gSDIGetVTab.gSDI_GetVTab(pRasLayer)
371:    End If
        If pTable Is Nothing Then Exit Function
373:    Set pTableHist.Table = pTable
    
        Dim pvarValues As Variant, pvarCounts As Variant
        Dim pHistogram As IHistogram
377:    Set pHistogram = pTableHist
        'Dim samplingOK As Boolean
        'pHistogram.SamplingDoModal 0, samplingOK
380:    pHistogram.GetHistogram pvarValues, pvarCounts
    
       Dim pClassify As IClassify
383:   Set pClassify = New Quantile
384:   pClassify.SetHistogramData pvarValues, pvarCounts
385:   pClassify.Classify nclass
    
       Dim pUid As UID
388:   Set pUid = New UID
389:   Set pUid = pClassify.ClassID
    
       Dim pClassDialog As IClassificationDialog
392:   Set pClassDialog = New ClassificationDialog
393:   pClassDialog.Classification = pUid
394:   pClassDialog.SetHistogramData pHistogram
395:   pClassDialog.ClassBreaks = pClassify.ClassBreaks
        
       Dim OK As Boolean
398:   ProgressAnimation.Show "Classification of " & pRasLayer.Name & "-" & fldName
399:   OK = pClassDialog.doModal(0) 'open the dialog
400:   ProgressAnimation.Hide
401:   If Not OK Then
402:     OpenClassDlg = Null
         Exit Function
404:   End If

  'return Breaks
407:   OpenClassDlg = pClassDialog.ClassBreaks 'retrieve breaks from the dialog
       Exit Function
ErrorHandler:
        HandleError True, "OpenClassDlg " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
411:         OpenClassDlg = Null
End Function

