Attribute VB_Name = "WOETableUtils"
Option Explicit
Const c_sModuleFileName As String = "WOETableUtils.bas"
Dim pMap As IMap

Public Function CreateTable(sName As String, strWorkspace As String, _
                        ByRef fieldsDesc As Variant, isBeingReplaced As Boolean) As ITable
    On Error GoTo ErrorHandler
    
    'Create the workspace name object
        Dim SDMTblUtil As SDMTableUtils
11:      Set SDMTblUtil = New SDMTableUtils
        Dim pFeatWorkSpace As IFeatureWorkspace
13:     Set pFeatWorkSpace = SDMTblUtil.CreateWorkSpaceObject(strWorkspace)
14:     If (pFeatWorkSpace Is Nothing) Then
15:         Set CreateTable = Nothing
            Exit Function
17:     End If
'MsgBox "got featureworkspace"
19:     If SDMGlobals.SDMMap Is Nothing Then setSDMMap
20:     Set pMap = SDMGlobals.SDMMap
'MsgBox "got working map"
'Open table
23: If isBeingReplaced Then
        Dim pTbl As ITable
25:     Set pTbl = OpenTable(strWorkspace, sName)
26:     If pTbl Is Nothing Then
27:         MsgBox "Can't open table to be deleted", vbCritical, "Create Table"
28:         Set CreateTable = Nothing
            Exit Function
30:     End If
'Get browse name
        Dim pdataSet As IDataset
33:     Set pdataSet = pTbl
'Delete table
35:         If pdataSet.CanDelete Then
36:             pdataSet.Delete
'78:             MsgBox "Deleted table: " & strWorkspace & "\" & sName, , "CreateTable"
38:         Else
39:             MsgBox "Can't delete table: " & sName & " from " & strWorkspace, , "CreateTable"
40:             Set CreateTable = Nothing
                Exit Function
42:         End If
43: End If
'MsgBox "done deleted table"
        
'MsgBox "creating new table"

    'Create OID field
        Dim pTable As ITable
        Dim pField As esrigeodatabase.IField
        Dim pfields As esrigeodatabase.IFields
        Dim pFieldEdit As esrigeodatabase.IFieldEdit
        Dim pFieldsEdit As esrigeodatabase.IFieldsEdit
54:     Set pfields = New esrigeodatabase.Fields
55:     Set pFieldsEdit = pfields
56:     pFieldsEdit.FieldCount = fieldsDesc.Count + 1

    'Create Object ID Field
59:     Set pField = New esrigeodatabase.Field
60:     Set pFieldEdit = pField

62:     With pFieldEdit
63:         .Name = "OID"
64:         .Type = esriFieldTypeOID
65:         .Required = True
66:     End With
    
68:     Set pFieldsEdit.Field(0) = pField

'Add other defined fields
71:     AddFieldsToFieldsEdit pFieldsEdit, fieldsDesc

    'Create table
74:     Set pTable = pFeatWorkSpace.CreateTable(sName, pfields, Nothing, Nothing, "")
75:     Set CreateTable = pTable
'145:     MsgBox "Created table: " & sName & " from " & strWorkspace, , "CreateTable"
    Exit Function
ErrorHandler:
HandleError True, "CreateTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
80:     Set CreateTable = Nothing
End Function

Private Sub AddFieldsToFieldsEdit(ByRef pFieldsEdit As esrigeodatabase.IFieldsEdit, fieldsDesc As Variant)
        On Error GoTo ErrorHandler
        Dim i As Long
86:     i = 1
        Dim fieldDesc As Variant
88:     For Each fieldDesc In fieldsDesc
             Dim pField As esrigeodatabase.IField
90:          Set pField = New esrigeodatabase.Field
             Dim pFieldEdit As esrigeodatabase.IFieldEdit
92:         Set pFieldEdit = pField
93:         With pFieldEdit
94:             .Editable = True
95:             .Name = fieldDesc(0)
96:             .Type = fieldDesc(1)
97:             .AliasName = fieldDesc(4)
98:             If fieldDesc(1) = esriFieldTypeString Or _
                        fieldDesc(1) = esriFieldTypeInteger Then
100:                .Length = fieldDesc(2)
101:             Else
102:                .Precision = fieldDesc(2)
103:                .Scale = fieldDesc(3)
104:             End If
105:             If fieldDesc(5) Then
106:                     If pField.IsNullable Then
107:                         .IsNullable = True
108:                         .DefaultValue = Null
109:                     End If
110:             End If
111:         End With
112:         Set pFieldsEdit.Field(i) = pField
113:         i = i + 1
114:     Next fieldDesc
Exit Sub
ErrorHandler:
HandleError True, "AddFieldsToFieldsEdit " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
118: Error.Clear
End Sub

Public Function MakeTmp(dirName As String, tmpPrefix As String, tmpExt As String) As IFileName
  On Error GoTo ErrorHandler

Dim fName As IFileName
125: Set fName = New fileName
Dim fs As Object
127: Set fs = CreateObject("Scripting.FileSystemObject")
Dim n As Long
129: n = 1
130: fName.path = dirName & "\" & tmpPrefix & n
131: If tmpExt <> "" Then fName.path = fName.path & "." & tmpExt
132: While fs.FileExists(fName.path)
133:     n = n + 1
134:     fName.path = dirName & "\" & tmpPrefix & n
135:     If tmpExt <> "" Then fName.path = fName.path & "." & tmpExt
136: Wend
137: Set MakeTmp = fName
138: Set fs = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "MakeTmp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Function MakeTmpDir(dirName As String, tmpPrefix As String, tmpExt As String) As IFileName
  On Error GoTo ErrorHandler

     Dim fName As IFileName
149: Set fName = New fileName
     Dim fs As Object
151: Set fs = CreateObject("Scripting.FileSystemObject")
     Dim n As Long
153: n = 1
154: fName.path = dirName & "\" & tmpPrefix & n
155: If tmpExt <> "" Then fName.path = fName.path & "." & tmpExt
156: While fs.folderExists(fName.path)
157:     n = n + 1
158:     fName.path = dirName & "\" & tmpPrefix & n
159:     If tmpExt <> "" Then fName.path = fName.path & "." & tmpExt
160: Wend
161: Set MakeTmpDir = fName
162: Set fs = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "MakeTmp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Function PutDataSet(aSrcClass As String, aTitle As String, ByRef defaultFileName As IFileName, doCheck As Boolean) As IFileName
  On Error GoTo ErrorHandler

    Dim fs As Object
174:     Set fs = CreateObject("Scripting.FileSystemObject")
    Dim pathDir As String
176:     pathDir = fs.getParentFolderName(defaultFileName.path)
    Dim fdlg As CommonDialog
178:     Set fdlg = FileDialog2.CommonDialog1
179:     fdlg.DialogTitle = aTitle
180:     fdlg.initDir = pathDir
181:     fdlg.fileName = fs.GetBaseName(defaultFileName.path)
182:     fdlg.Filter = "Table (*.dbf)|*.dbf| Raster (*.ras)|*.ras"
183:     If doCheck Then
184:         fdlg.Flags = cdlOFNOverwritePrompt
185:     End If
186:     If aSrcClass = "GRID" Then
187:         fdlg.DefaultExt = "ras"
188:         fdlg.FilterIndex = 2
189:     ElseIf aSrcClass = "TABLE" Then
190:         fdlg.DefaultExt = "dbf"
191:         fdlg.FilterIndex = 1
192:     Else
193:         MsgBox "Source type incorrect", vbCritical, "PutDataSet"
194:         Set PutDataSet = Nothing
            Exit Function
196:     End If
197:    fdlg.ShowSave
        Dim srcFilename As String
199:    srcFilename = fdlg.fileName
200:    If srcFilename = "" Then
201:         Set PutDataSet = Nothing
             Exit Function
203:    End If
204:    Set PutDataSet = New fileName
205:    PutDataSet.path = srcFilename
206:    Set fs = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "PutDataSet " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Sub UnJoinAll(ByRef pSelItem As IUnknown)
  On Error GoTo ErrorHandler
         Dim pdataSet As IDataset
217:     Set pdataSet = pSelItem
  ' Get the selected layer or table
219:    If pSelItem Is Nothing Then
            Exit Sub
221:    End If
222:   If Not (TypeOf pSelItem Is ILayer Or TypeOf pSelItem Is IStandaloneTable) Then
        'MsgBox "Cannot unjoin all: " & pdataSet.Name, , c_sModuleFileName
            Exit Sub
225:   End If

       Dim pDispRC As IDisplayRelationshipClass
228:   Set pDispRC = pSelItem
  ' Remove all joins
230:   pDispRC.DisplayRelationshipClass Nothing, esriLeftInnerJoin

  Exit Sub
ErrorHandler:
  HandleError True, "UnJoinAll " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Function JoinTables(ByRef LeftTable As IObjectClass, leftJoinFldName As String, _
                       ByRef RightTable As IObjectClass, rightJoinFldName As String) As ITable
         On Error GoTo ErrorHandler
240:     If LeftTable.FindField(leftJoinFldName) = -1 Or _
            RightTable.FindField(rightJoinFldName) = -1 Then
242:         Set JoinTables = Nothing
243:         MsgBox "Field not found.", vbCritical, "JoinTables"
             Exit Function
245:     End If
        Dim pdataSet As IDataset
247:     Set pdataSet = LeftTable
        Dim leftName As String
249:     leftName = pdataSet.Name
250:     Set pdataSet = RightTable
        Dim rightName As String
252:     rightName = pdataSet.Name
    'MsgBox "Joining: " & leftName & " & " & rightName, , c_sModuleFileName
  ' ++ Create the MemoryRelationshipClass that defines what is to be joined
       Dim pMemRelClassFact As IMemoryRelationshipClassFactory
256:   Set pMemRelClassFact = New MemoryRelationshipClassFactory
       Dim pRelClass As IRelationshipClass
258:   Set pRelClass = pMemRelClassFact.Open("WOETableJoin1", LeftTable, _
  leftJoinFldName, RightTable, rightJoinFldName, "forward", "backward", esriRelCardinalityOneToMany)
  ' ++ Perform the join
        Dim pRelQueryTableFact As IRelQueryTableFactory
        Dim pRelQueryTab As ITable
263:   Set pRelQueryTableFact = New RelQueryTableFactory
264:   Set pRelQueryTab = pRelQueryTableFact.Open(pRelClass, True, Nothing, Nothing, "", True, True)
265:   Set JoinTables = pRelQueryTab


  Exit Function
ErrorHandler:
  HandleError True, "JoinTables " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
271:     Set JoinTables = Nothing
End Function
                       
Sub ChangeRenderToUVRenderer(ByRef pRasterLayer As IRasterLayer, fieldName As String)
  On Error GoTo ErrorHandler
  ' Create a default Unique Value Renderer and set it to the layer
  Dim pUVRenderer As IRasterUniqueValueRenderer
  Dim pRasterRendereer As IRasterRenderer
  
280:   Set pUVRenderer = New RasterUniqueValueRenderer
281:   pUVRenderer.Field = fieldName
282:   MsgBox pUVRenderer.Field
283:   Set pRasterRendereer = pUVRenderer
284:   If pRasterRendereer.CanRender(pRasterLayer.Raster) Then
285:     Set pRasterRendereer.Raster = pRasterLayer.Raster
286:     Set pRasterLayer.Renderer = pUVRenderer
287:     pRasterLayer.Renderer.Update
288:   End If
  
290:   Set pUVRenderer = Nothing
291:   Set pRasterRendereer = Nothing
  
  Exit Sub
ErrorHandler:
HandleError True, "ChangeRenderToUVRenderer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Sub AddFields(ByRef pTable As ITable, ByRef fieldsDesc As SDMList)
  On Error GoTo ErrorHandler
'Notice:  This should add a field the same way as AddFieldsToFieldsEdit method
    'Create fields
    Dim pField As esrigeodatabase.IField
    Dim pFieldEdit As esrigeodatabase.IFieldEdit
            
         Dim fieldDesc As Variant
306:     For Each fieldDesc In fieldsDesc.list
307:         Set pField = New esrigeodatabase.Field
308:         Set pFieldEdit = pField
309:         With pFieldEdit
310:             .Editable = True
311:             .Name = fieldDesc(0)
312:             .Type = fieldDesc(1)
313:             .AliasName = fieldDesc(4)
314:             If fieldDesc(1) = esriFieldTypeString Or _
                        fieldDesc(1) = esriFieldTypeInteger Then
316:                .Length = fieldDesc(2)
317:             Else
318:                .Precision = fieldDesc(2)
319:                .Scale = fieldDesc(3)
320:             End If
321:             If fieldDesc(5) Then
322:                     If pField.IsNullable Then
323:                         .IsNullable = True
324:                         .DefaultValue = Null
325:                     End If
326:             End If
327:         End With
328:         pTable.AddField pField
329:     Next fieldDesc
  Exit Sub
ErrorHandler:
  HandleError True, "AddFields " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Function getFieldsNames(ByRef tbl As ITable) As SDMList
  On Error GoTo ErrorHandler

338:   Set getFieldsNames = New SDMList
         Dim nf As Long
340:     For nf = 0 To tbl.Fields.FieldCount - 1
341:         getFieldsNames.Add tbl.Fields.Field(nf).Name
342:     Next nf
  Exit Function
ErrorHandler:
  HandleError True, "getFieldsNames " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Function getFieldsNamesByType(ByRef tbl As ITable, fldType As esriFieldType) As SDMList
  On Error GoTo ErrorHandler

351:     Set getFieldsNamesByType = New SDMList
         Dim nf As Long
353:     For nf = 0 To tbl.Fields.FieldCount - 1
354:         If tbl.Fields.Field(nf).Type = fldType Then _
                getFieldsNamesByType.Add tbl.Fields.Field(nf).Name
356:     Next nf
  Exit Function
ErrorHandler:
  HandleError True, "getStringFieldsNamesbyType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function getFieldsAliasNamesByType(ByRef tbl As ITable, fldType As esriFieldType) As SDMList
  On Error GoTo ErrorHandler

364:     Set getFieldsAliasNamesByType = New SDMList
         Dim nf As Long
366:     For nf = 0 To tbl.Fields.FieldCount - 1
367:         If tbl.Fields.Field(nf).Type = fldType Then _
                getFieldsAliasNamesByType.Add tbl.Fields.Field(nf).AliasName
369:     Next nf
  Exit Function
ErrorHandler:
  HandleError True, "getFieldsAliasNamesByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Sub AddTable(dir As String, tablename As String, ByRef pApp As IApplication)
  On Error GoTo ErrorHandler

    Dim pMxDoc As IMxDocument
    Dim pTable As ITable
    Dim pTableCollection As ITableCollection
    
381:     setSDMMap
382:     Set pTableCollection = SDMGlobals.SDMMap
383:     Set pTable = OpenTable(dir, tablename)
         If (pTable Is Nothing) Then Exit Sub
385:     pTableCollection.AddTable pTable
386:     Set pMxDoc = SDMGlobals.SDMDoc
387:     pMxDoc.UpdateContents

  Exit Sub
ErrorHandler:
  HandleError True, "AddTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Public Function OpenTable(strWorkspace As String, strTableName As String) As ITable
    On Error GoTo ErrorHandler
    'Dim line As Integer
    
        Dim pShpWorkspaceName As IWorkspaceName
        Dim pDatasetName As IDatasetName
        Dim pName As IName
    'Create the workspace name object
402:     Set pShpWorkspaceName = New WorkspaceName
403:     pShpWorkspaceName.PathName = strWorkspace
404:     pShpWorkspaceName.WorkspaceFactoryProgID = "esriCore.ShapefileWorkspaceFactory"
    'Create the table name object
406:     Set pDatasetName = New tablename
407:     pDatasetName.Name = strTableName
408:     Set pDatasetName.WorkspaceName = pShpWorkspaceName
    'Open the table
410:     Set pName = pDatasetName
411:     Set OpenTable = pName.Open
    Exit Function
ErrorHandler:
  HandleError True, "OpenTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
415:     Set OpenTable = Nothing
End Function


Function SetAliases(saTblName As String, fieldsDesc As Variant) As Boolean
  On Error GoTo ErrorHandler
421:     If SDMGlobals.SDMMap Is Nothing Then setSDMMap
422:     Set pMap = SDMGlobals.SDMMap

    Dim saTbl As IStandaloneTable
425:     Set saTbl = FindStandAloneTableByName(saTblName, pMap)
426:     If saTbl Is Nothing Then
427:         MsgBox "Can't find standalonetable " & saTblName, , "SetAliases"
428:         SetAliases = False
             Exit Function
430:     End If
431:     If IsEmpty(fieldsDesc) Then
432:         MsgBox "No field descriptors", , "SetAliases"
433:         SetAliases = False
             Exit Function
435:     End If
        
         Dim pTblFlds As ITableFields
438:     Set pTblFlds = saTbl
         Dim pFldInfo As esrigeodatabase.IFieldInfo
440:     Set pFldInfo = pTblFlds.FieldInfo(saTbl.Table.FindField(saTbl.Table.OIDFieldName))
441:     pFldInfo.Visible = False
    
    Dim i As Long
444:     For i = 1 To fieldsDesc.Count
             Dim fldDesc As Variant
446:         fldDesc = fieldsDesc(i)
             Dim fldIdx As Long
448:              fldIdx = saTbl.Table.FindField(CStr(fldDesc(0)))
449:              If fldIdx = -1 Then
450:                 MsgBox "Field not found: " & CStr(fldDesc(0)), vbCritical, c_sModuleFileName
451:                      SetAliases = False
                     Exit Function
453:              End If
454:         Set pFldInfo = pTblFlds.FieldInfo(fldIdx)
455:         pFldInfo.Alias = CStr(fldDesc(4))
456:     Next i

458:     SetAliases = True
  Exit Function
ErrorHandler:
  HandleError True, "SetAliases " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
462:   SetAliases = False
End Function
Function getProjectDir() As String
On Error GoTo ErrorHandler
    Dim ProjectDir As String
    Dim pTemplates As ITemplates
    Dim lTempCount As Long
    Dim strDocPath As String
470:    If SDMGlobals.SDMMap Is Nothing Then setSDMMap
471:    Set pTemplates = SDMGlobals.SDMApp.Templates
472:     lTempCount = pTemplates.Count
    ' The document is always the last item
474:     strDocPath = pTemplates.item(lTempCount - 1)
    Dim fs As Object
476:     Set fs = CreateObject("Scripting.FileSystemObject")
477:     If (fs.GetExtensionName(strDocPath) = "tmp") _
                        Then SDMGlobals.SDMApp.SaveAsDocument
479:     ProjectDir = fs.getParentFolderName(strDocPath)
    
481:     If (ProjectDir = "") Then ProjectDir = CurDir
482:     If (ProjectDir = "") Then
483:         If (Len(Environ("TEMP")) <> 0) Then
484:              ProjectDir = Environ("TEMP")
485:         ElseIf (Len(Environ("HOME")) <> 0) Then
486:              ProjectDir = Environ("HOME")
487:         End If
488:     End If
489:     getProjectDir = ProjectDir
Exit Function

ErrorHandler:
  HandleError True, "getProjectDir" & c_sModuleFileName & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
494:     getProjectDir = Environ("TEMP")
End Function

Function FindStandAloneTableByName(saName As String, Optional pMap As IMap) As IStandaloneTable
  On Error GoTo ErrorHandler

        Dim saColl As IStandaloneTableCollection
501:    If SDMGlobals.SDMMap Is Nothing Then setSDMMap
502:    Set saColl = SDMGlobals.SDMMap
        Dim nsa As Long
504:     For nsa = 0 To saColl.StandaloneTableCount - 1
             Dim saTbl As IStandaloneTable
506:         Set saTbl = saColl.StandaloneTable(nsa)
507:         If UCase(saTbl.Name) = UCase(saName) Then
508:             Set FindStandAloneTableByName = saTbl
                Exit Function
510:         End If
511:     Next nsa
512:     Set FindStandAloneTableByName = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "FindStandAloneTableByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub RemoveTable(tblName As String, Optional pMap As IMap)
  On Error GoTo ErrorHandler

        Dim tbls As IStandaloneTableCollection
524:         If SDMGlobals.SDMMap Is Nothing Then setSDMMap
525:        Set tbls = SDMGlobals.SDMMap
        Dim i As Long
527:     For i = 0 To tbls.StandaloneTableCount - 1
528:         If UCase(tbls.StandaloneTable(i).Name) = UCase(tblName) Then
529:             tbls.RemoveStandaloneTable tbls.StandaloneTable(i)
530:         End If
531:     Next i

  Exit Sub
ErrorHandler:
  HandleError True, "RemoveTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Function FindLayerByName(lName As String) As ILayer
  On Error GoTo ErrorHandler
540:     If SDMGlobals.SDMMap Is Nothing Then setSDMMap
541:     Set pMap = SDMGlobals.SDMMap
542:     If pMap.LayerCount = 0 Then
543:        Set FindLayerByName = Nothing
            Exit Function
545:     End If
         Dim layers As IEnumLayer
547:     Set layers = pMap.layers
548:     layers.Reset
         Dim lyr As ILayer
550:     Set lyr = layers.Next
551:     While (Not lyr Is Nothing)
552:             If lyr.Valid Then
553:                If UCase(lName) = UCase(lyr.Name) Then
554:                    Set FindLayerByName = lyr
                        Exit Function
556:                End If
557:             End If
558:         Set lyr = layers.Next
559:     Wend
560:     Set FindLayerByName = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "FindLayerByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Function hasJoins(ByRef pFLayer As IUnknown) As Boolean
  On Error GoTo ErrorHandler
  ' ++ Get the Display table from the layer
        Dim pTable As ITable
        Dim pDisplayTable As IDisplayTable
573:   If Not TypeOf pFLayer Is IDisplayTable Then
574:     hasJoins = False
         Exit Function
576:   End If
577:   Set pDisplayTable = pFLayer
578:   If Not TypeOf pFLayer Is ITable Then
579:     hasJoins = False
         Exit Function
581:   End If
582:   Set pTable = pDisplayTable.DisplayTable
583:   If pTable Is Nothing Then
584:     hasJoins = False
         Exit Function
586:   End If

588:   hasJoins = TypeOf pTable Is IRelQueryTable
  Exit Function
ErrorHandler:
591: Debug.Print "hasJoins Error: " ' & pFLayer.Name
  HandleError True, "hasJoins " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4

594:     hasJoins = False
End Function

Function CreateStandAloneTable(ByRef pTbl As ITable, pTblName As String) As IStandaloneTable
  On Error GoTo ErrorHandler

    
    Dim saTbl As IStandaloneTable
602:     Set saTbl = New StandaloneTable
603:     Set saTbl.Table = pTbl
604:     saTbl.Name = pTblName
605:     Set CreateStandAloneTable = saTbl


  Exit Function
ErrorHandler:
  HandleError True, "CreateStandAloneTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Function GetTmpDir() As String
On Error GoTo ErrorHandler
'' gSDI.GetTmpDir
'
'sepChr = av.Run("gSDI.GetSeparatorChar", Array())
Dim gsdiGetSepChar As gSDI_GetSepChar
618: Set gsdiGetSepChar = New gSDI_GetSepChar
Dim sepChr As String
620: sepChr = gsdiGetSepChar.gSDI_GetSeparatorChar
'dirPrjct = av.Run("gSDI.GetProjectDir",{})
'''''Dim getPrjDir As gSDI_getProjectDir
'''''Set getPrjDir = New gSDI_getProjectDir
Dim dirPrjct As String
625: dirPrjct = getProjectDir
'If (dirPrjct = Nil) Then
627: If (dirPrjct = "") Then
'  MsgBox.Error("SDI requires a temporary directory to which you have write permission.  Please ensure that your project file has been saved and/or that you have a temporary directory specified via your operating system.",
'  "Error writing temporary files")
630:     MsgBox "SDI requires a temporary directory to which you have write permission.  Please ensure that your project file has been saved and/or that you have a temporary directory specified via your operating system.", vbCritical, "Error writing temporary files"
'  return Nil
632:     GetTmpDir = ""
    Exit Function
'End
635: End If
'strTmpDir = dirPrjct.GetFullName + sepChr + "~sdmtemp"
Dim strTmpDir As String
638: strTmpDir = dirPrjct & sepChr & "~sdmtemp"
'if (File.Exists((strTmpDir).AsFileName).Not) then
Dim fs As Object
641: Set fs = CreateObject("Scripting.FileSystemObject")
642: If (Not fs.folderExists(strTmpDir)) Then
'  dirTmpName = av.Run("gSDI.MakeTempDir",{dirPrjct})
    Dim MakeTmpDir As gSDI_MakeTempDir
645:     Set MakeTmpDir = New gSDI_MakeTempDir
    Dim dirTmpName As String
647:     dirTmpName = MakeTmpDir.gSDI_MakeTempDir(Array(dirPrjct))
'  if (File.Exists((strTmpDir).AsFileName).Not) then
649:     If (Not fs.folderExists(strTmpDir)) Then
'    MsgBox.Error("Unable to find or create " + strTmpDir + ".  Please create " + vbcrlf +
'                 "manually before running function again.","Temporary Directory")
652:         MsgBox "Unable to find or create " & strTmpDir & ".  Please create " & vbCrLf & _
                 "manually before running function again.", vbCritical, "Temporary Directory"
'    return Nil
655:         GetTmpDir = ""
'  Else
657:     Else
'    dirTmp = strTmpDir.AsFileName
        Dim dirTmp As String
660:         dirTmp = strTmpDir
'  End
662:     End If
'Else
664: Else
'  dirTmp = strTmpDir.AsFileName
666:     dirTmp = strTmpDir
'End
668: End If
'return dirTmp
670: GetTmpDir = strTmpDir
Exit Function

ErrorHandler:
  HandleError True, "getTmpDir" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Sub joinTableToLayer(ByRef ucLayer As IRasterLayer, lyrField As String, ByRef pStTable As IStandaloneTable, saField As String)
  On Error GoTo ErrorHandler

 Dim pDispTable As IDisplayTable
681:  Set pDispTable = ucLayer
 Dim pFCLayer As ITable
683:  Set pFCLayer = pDispTable.DisplayTable
 Dim pTLayer As ITable
685:  Set pTLayer = pFCLayer

  Dim pDispTable2 As IDisplayTable
688:  Set pDispTable2 = pStTable
 Dim pTTable As ITable
690:  Set pTTable = pDispTable2.DisplayTable

' Create virtual relate
  Dim pMemRelFact As IMemoryRelationshipClassFactory
  Dim pRelClass As IRelationshipClass
695:   Set pMemRelFact = New MemoryRelationshipClassFactory
696:   Set pRelClass = pMemRelFact.Open("TabletoLayer", pTTable, saField, pTLayer, _
  lyrField, "forward", "backward", esriRelCardinalityOneToMany)

  ' use Relate to perform a join
  Dim pDispRC As IDisplayRelationshipClass
701:   Set pDispRC = ucLayer
702:   pDispRC.DisplayRelationshipClass pRelClass, esriLeftOuterJoin



  Exit Sub
ErrorHandler:
  HandleError True, "joinTableToLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


Function isJoined(ByRef pFLayer As IUnknown, ByRef aTable As ITable) As Boolean
  On Error GoTo ErrorHandler
  ' ++ Get the Display table from the layer
     Dim pTable As ITable
     Dim pDisplayTable As IDisplayTable
717: If Not TypeOf pFLayer Is IDisplayTable Then
718:    isJoined = False
        Exit Function
720: End If
721: Set pDisplayTable = pFLayer
722: Set pTable = pDisplayTable.DisplayTable
723: If pTable Is Nothing Then
724:    isJoined = False
        Exit Function
726: End If
     Dim pRelQryTbl As IRelQueryTable
     Dim pDestTbl As ITable
     Dim pdataSet As IDataset
     Dim aDataSet As IDataset
731: Set aDataSet = aTable
    
733: Do While TypeOf pTable Is IRelQueryTable
734:    Set pRelQryTbl = pTable
735:    Set pDestTbl = pRelQryTbl.DestinationTable
736:    Set pdataSet = pDestTbl
737:    If pdataSet.Name = aDataSet.Name Then
738:        isJoined = True
            Exit Function
740:    End If
741:    Set pTable = pRelQryTbl.SourceTable
742: Loop
743:     isJoined = False
    Exit Function
ErrorHandler:
  HandleError True, "isJoined" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
747:     isJoined = False
End Function

Public Function ListJoins(pFLayer As IUnknown) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

753:   Set ListJoins = New SDMUtilities.SDMList
        Dim pTable As ITable
  ' ++ Get the Display table from the layer
        Dim pDisplayTable As IDisplayTable
757:    If Not TypeOf pFLayer Is IDisplayTable Then
758:        ListJoins.Clear
            Exit Function
760:    End If
761:   Set pDisplayTable = pFLayer
762:   Set pTable = pDisplayTable.DisplayTable
763:   If pTable Is Nothing Then
764:     ListJoins.Clear
         Exit Function
766:   End If

  ' ++ Get the list of joined tables
        Dim pRelQueryTable As IRelQueryTable
        Dim pDestTable As ITable
        Dim pdataSet As IDataset
772:   Do While TypeOf pTable Is IRelQueryTable
773:     Set pRelQueryTable = pTable
774:     Set pDestTable = pRelQueryTable.DestinationTable
775:     Set pdataSet = pDestTable
776:     ListJoins.Add pdataSet '.BrowseName
777:     Set pTable = pRelQueryTable.SourceTable
778:   Loop

  Exit Function
ErrorHandler:
  HandleError True, "ListJoins " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
Public Function ListJoinsStr(pFLayer As IUnknown) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

787:   Set ListJoinsStr = New SDMUtilities.SDMList
        Dim pTable As ITable
  ' ++ Get the Display table from the layer
        Dim pDisplayTable As IDisplayTable
791:    If Not TypeOf pFLayer Is IDisplayTable Then
792:        ListJoinsStr.Clear
            Exit Function
794:    End If
795:   Set pDisplayTable = pFLayer
796:   Set pTable = pDisplayTable.DisplayTable
797:   If pTable Is Nothing Then
798:     ListJoinsStr.Clear
         Exit Function
800:   End If
  
  ' ++ Get the list of joined tables
        Dim pRelQueryTable As IRelQueryTable
        Dim pDestTable As ITable
        Dim pdataSet As IDataset
806:   Do While TypeOf pTable Is IRelQueryTable
807:     Set pRelQueryTable = pTable
808:     Set pDestTable = pRelQueryTable.DestinationTable
809:     Set pdataSet = pDestTable
810:     ListJoinsStr.Add pdataSet.Name
811:     Set pTable = pRelQueryTable.SourceTable
812:   Loop

  Exit Function
ErrorHandler:
  HandleError True, "ListJoinsStr " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Public Function RemoveLastJoin(ByRef pSelItem As IUnknown) As Boolean
  On Error GoTo ErrorHandler

822:   RemoveLastJoin = False
823:   If Not TypeOf pSelItem Is IDisplayTable Then
     'MsgBox "No Feature layer or table selected"
825:     RemoveLastJoin = False
         Exit Function
827:   End If
  
  ' Make sure the selected layer is joined
        Dim pDispTable As IDisplayTable
        Dim pTable As ITable
832:   Set pDispTable = pSelItem
833:   Set pTable = pDispTable.DisplayTable
834:   If Not TypeOf pTable Is IRelQueryTable Then
        'MsgBox "The layer or table is not joined"
836:        RemoveLastJoin = False
            Exit Function
838:   End If
 
  ' Get the source table of the current join
  ' object (RelQueryTable)
        Dim pRelQTab As IRelQueryTable
843:   Set pRelQTab = pTable
844:   Set pTable = pRelQTab.SourceTable

  ' UnJoin
        Dim pDispRC As IDisplayRelationshipClass
848:    Set pDispRC = pSelItem
  ' If more than one table is joined, replace
  ' the current join with the previous join
851:    If TypeOf pTable Is IRelQueryTable Then
852:        Set pRelQTab = pTable
853:        pDispRC.DisplayRelationshipClass pRelQTab.RelationshipClass, esriLeftInnerJoin
854:        RemoveLastJoin = True
855:    Else
  ' If only one table is joined, remove it
857:        pDispRC.DisplayRelationshipClass Nothing, esriLeftInnerJoin
858:        RemoveLastJoin = True
859:    End If

  Exit Function
ErrorHandler:
  HandleError True, "RemoveLastJoin " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub Unjoin(ByRef pLayer As ILayer, ByRef pTbl As IUnknown)
     On Error GoTo ErrorHandler
868:      RemoveLastJoin pLayer
     Exit Sub
ErrorHandler:
  HandleError True, "Unjoin " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub setSDMMap()
875:     If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
876:     If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
877:     If SDMGlobals.SDMMap Is Nothing Then
             Dim pMxDoc As IMxDocument
879:         Set pMxDoc = SDMGlobals.SDMDoc
880:         Set SDMGlobals.SDMMap = pMxDoc.FocusMap
881:     End If

End Sub

Function FindLikeByValue(ByRef ValList As SDMUtilities.SDMList, likeValue As String) As Long
        Dim val As Variant
        Dim i As Long
888:         i = 0
889:         For Each val In ValList.list
890:             If val Like likeValue Then
891:                 FindLikeByValue = i
                     Exit Function
893:             End If
894:             i = i + 1
895:         Next val
896:         FindLikeByValue = -1
End Function








