Attribute VB_Name = "gSDI_Stats"
Option Explicit
Const c_sModuleFileName As String = "gSDI_Stats.bas"

Function gSDI_Stats(statstype As esriGeoAnalysisStatisticsEnum, Optional Gamma As Double) As IRasterLayer
  On Error GoTo ErrorHandler

Dim stattype As String
Select Case statstype
    Case esriGeoAnalysisStatsMinimum
10:         stattype = "AND"
    Case esriGeoAnalysisStatsMaximum
12:         stattype = "OR"
    Case esriGeoAnalysisStatsSum
14:         stattype = "SUM"
    Case esriGeoAnalysisStatsStd
16:         stattype = "PRD"
    Case esriGeoAnalysisStatsVariety
18:         stattype = "GAU"
    Case Else
20:         Set gSDI_Stats = Nothing
            Exit Function
22: End Select

        
'Get the study area mask
Dim anlparms As AnalysisParameters.AnlParams
27: Set anlparms = New AnalysisParameters.AnlParams
Dim gParam As Form
29: Set gParam = anlparms.gParamFrm
Dim maskName As String
31: maskName = gParam.cbxSA.Text
Dim masklayer As IRasterLayer
33: Set masklayer = WOETableUtils.FindLayerByName(maskName)

' Prompt user for name, location of new grid
'----------------------------------------------
'defname = fileName.GetCWD.MakeTmp("SUM", "")
    Dim defname As IFileName
39: Set defname = WOETableUtils.MakeTmpDir(FileDialog.getProjectDir, "FL" & stattype, "")
    Dim gridDir As String
41: gridDir = FileDialog.getDir(defname.path)
    Dim gridName As String
43: gridName = FileDialog.GetFileName(defname.path)
    Dim fnGrdNew As Variant
'fnGrdNew = SourceManager.PutDataSet(GRID, "Result of Fuzzy SUM operation", defname, True)
46: fnGrdNew = FileDialog2.GetSaveFileName("Result of Fuzzy " & stattype & " operation", gridDir, gridName)
'If (fnGrdNew = nil) Then
48: If IsEmpty(fnGrdNew) Then
'  return nil
50:     Set gSDI_Stats = Nothing
        Exit Function
'End
53: End If

'Set the raster workspace
    Dim wrkSpaceFact As IWorkspaceFactory
57: Set wrkSpaceFact = New RasterWorkspaceFactory
    Dim WrkSpace As IRasterWorkspace
    Dim WSfname As IFileName
60: Set WSfname = New fileName
61: WSfname.path = fnGrdNew(1)
62: Set WrkSpace = wrkSpaceFact.OpenFromFile(WSfname.path, 0)

' Create a raster bandcollection
    Dim plocalCollection As IRasterBandCollection
66: Set plocalCollection = New Raster

Dim inputList As String

Dim nSel As Long
71: For nSel = 0 To gFL.lbxTF.ListCount - 1
72:     If gFL.lbxTF.Selected(nSel) Then
            Dim pInputraster As IRasterLayer
74:         Set pInputraster = WOETableUtils.FindLayerByName(gFL.lbxTF.List(nSel))
            Dim pRasBandColl As IRasterBandCollection
76:         Set pRasBandColl = pInputraster.Raster
77:         plocalCollection.AppendBand pRasBandColl.Item(0)
78:         inputList = inputList & pInputraster.Name
79:         If nSel < gFL.lbxTF.ListCount - 1 Then inputList = inputList & ","
80:     End If
81: Next nSel

''Dim pInputDataset As IGeoDataset
''96: Set pInputDataset = pLocalCollection

'Do the method
    Dim pOutputRaster As IGeoDataset
88: Set pOutputRaster = fuzzyFunction(plocalCollection, statstype, WrkSpace, masklayer, Gamma)
89: If pOutputRaster Is Nothing Then
90:     Set gSDI_Stats = Nothing
        Exit Function
92: End If

'Add new raster to Map
    Dim pOutRasLayer As IRasterLayer
96: Set pOutRasLayer = New RasterLayer
97: pOutRasLayer.CreateFromRaster pOutputRaster
98: pOutRasLayer.Name = fnGrdNew(0)
99: SDMGlobals.SDMMap.AddLayer pOutRasLayer
' Set Unique Value renderer
101: 'ChangeRenderToUVRenderer pOutRasLayer
' SaveAs the projected raster
     Dim pDS As IDataset
     Dim pRasBandCol As IRasterBandCollection
105: Set pRasBandCol = pOutRasLayer.Raster
106: Set pDS = pRasBandCol.SaveAs(fnGrdNew(0), WrkSpace, "GRID")

'Fuzzy Table
     Dim fmSATbl As IStandaloneTable
110: Set fmSATbl = gFL.getFModel
111: If stattype = "GAU" Then stattype = stattype & "(" & Format(Gamma, "0.00") & ")"
112: FuzzyModelUtils.writeFuzzyModel fmSATbl.Table, "Input: " & plocalCollection.Count, stattype & ": " & inputList, pOutRasLayer.Name

114: Set gSDI_Stats = pOutRasLayer
  
Exit Function
ErrorHandler:
  HandleError True, "gSDI_Stats " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
119:   Set gSDI_Stats = Nothing
End Function

Function fuzzyFunction(ByRef plocalCollection As IRasterBandCollection, statstype As esriGeoAnalysisStatisticsEnum, ByRef WrkSpace As IWorkspace, ByRef masklayer As IRasterLayer, Optional Gamma As Double) As IGeoDataset
  On Error GoTo ErrorHandler

Dim stattype As String
Select Case statstype
    Case esriGeoAnalysisStatsMinimum
128:         stattype = "AND"
    Case esriGeoAnalysisStatsMaximum
130:         stattype = "OR"
    Case esriGeoAnalysisStatsSum
132:         stattype = "SUM"
    Case esriGeoAnalysisStatsStd
134:         stattype = "PRD"
    Case esriGeoAnalysisStatsVariety
136:         stattype = "GAU"
    Case Else
138:         Set fuzzyFunction = Nothing
            Exit Function
140: End Select

' Create the RasterLocalOp object
     Dim pLocalOp As ILocalOp
144: Set pLocalOp = New RasterLocalOp

'set the raster analysis environment
     Dim raEnv As IRasterAnalysisEnvironment
148: Set raEnv = pLocalOp
149: raEnv.SetExtent esriRasterEnvMinOf
150: raEnv.SetCellSize esriRasterEnvMinOf
151: Set raEnv.Mask = masklayer.Raster
152: Set raEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
153: Set raEnv.OutWorkspace = WrkSpace

' Declare the output raster object
     Dim pOutputRaster As IGeoDataset

' Calls the method
Select Case stattype
     Case "OR", "AND"
161:         Set pOutputRaster = pLocalOp.LocalStatistics(plocalCollection, statstype)
     Case "SUM"
             Dim rastMaker As IRasterMakerOp
164:         Set rastMaker = New RasterMakerOp
             Dim rmkAE As IRasterAnalysisEnvironment
166:         Set rmkAE = rastMaker
167:         RasterAEUtils.SetToSDMRAEnv rmkAE
'166:         rmkAE.SetCellSize esriRasterEnvMinOf
'167:         rmkAE.SetExtent esriRasterEnvMinOf
'168:         Set rmkAE.Mask = masklayer.Raster
''169:         Set rmkAE.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
'170:         Set rmkAE.OutWorkspace = WrkSpace
        
             Dim unitRast As IGeoDataset
175:         Set unitRast = rastMaker.MakeConstant(1#, False)
        
             Dim rastOp As IMathOp
178:         Set rastOp = New RasterMathOps
             Dim rOpAE As IRasterAnalysisEnvironment
180:         Set rOpAE = rastOp
181:         RasterAEUtils.SetToSDMRAEnv rOpAE
'180:         rOpAE.SetCellSize esriRasterEnvMinOf
'181:         rOpAE.SetExtent esriRasterEnvMinOf
'182:         Set rOpAE.Mask = masklayer.Raster
''183:         Set rOpAE.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
'184:         Set rOpAE.OutWorkspace = WrkSpace
        
             Dim pNewCollection As IRasterBandCollection
189:         Set pNewCollection = New Raster
190:         pNewCollection.Clear
             Dim nRasBand As Long
192:         For nRasBand = 0 To plocalCollection.Count - 1
193:             Set pOutputRaster = rastOp.Minus(unitRast, plocalCollection.Item(nRasBand))
                 Dim pOutputRastBandColl As IRasterBandCollection
195:             Set pOutputRastBandColl = pOutputRaster
196:             pNewCollection.AppendBand pOutputRastBandColl.Item(0)
197:         Next nRasBand
198:         Set pOutputRaster = pNewCollection.Item(0)
199:         For nRasBand = 1 To pNewCollection.Count - 1
200:             Set pOutputRaster = rastOp.Times(pOutputRaster, pNewCollection.Item(nRasBand))
201:         Next nRasBand
202:         Set pOutputRaster = rastOp.Minus(unitRast, pOutputRaster)

     Case "PRD"
        'Dim rastOp As IMathOp
206:         Set rastOp = New RasterMathOps
        'Dim rOpAE As IRasterAnalysisEnvironment
208:         Set rOpAE = rastOp
209:         rOpAE.SetCellSize esriRasterEnvMinOf
210:         rOpAE.SetExtent esriRasterEnvMinOf
211:         Set rOpAE.Mask = masklayer.Raster
212:         Set rOpAE.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
213:         Set rOpAE.OutWorkspace = WrkSpace
        
        'Dim nRasBand As Long
216:         Set pOutputRaster = plocalCollection.Item(0)
217:         For nRasBand = 1 To plocalCollection.Count - 1
218:             Set pOutputRaster = rastOp.Times(pOutputRaster, plocalCollection.Item(nRasBand))
219:         Next nRasBand
     Case "GAU"
        'Dim rastOp As IMathOp
222:         Set rastOp = New RasterMathOps
        'Dim rOpAE As IRasterAnalysisEnvironment
224:         Set rOpAE = rastOp
225:         rOpAE.SetCellSize esriRasterEnvMinOf
226:         rOpAE.SetExtent esriRasterEnvMinOf
227:         Set rOpAE.Mask = masklayer.Raster
228:         Set rOpAE.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
229:         Set rOpAE.OutWorkspace = WrkSpace
        
        'Dim nRasBand As Long
             Dim poutputrasterSUM As IGeoDataset
233:         Set poutputrasterSUM = fuzzyFunction(plocalCollection, esriGeoAnalysisStatsSum, WrkSpace, masklayer)
234:         Set pOutputRaster = rastOp.Power(poutputrasterSUM, Gamma)
             Dim poutputrasterPRD As IGeoDataset
236:         Set poutputrasterPRD = fuzzyFunction(plocalCollection, esriGeoAnalysisStatsStd, WrkSpace, masklayer)
237:         Set pOutputRaster = rastOp.Times(pOutputRaster, rastOp.Power(poutputrasterPRD, 1# - Gamma))
     Case Else
239:        Set fuzzyFunction = Nothing
            Exit Function
241: End Select
242:     Set fuzzyFunction = pOutputRaster

  Exit Function
ErrorHandler:
  HandleError True, "fuzzyFunction " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub ChangeRenderToUVRenderer(ByRef pRLayer As IRasterLayer)
        On Error GoTo ErrorHandler
  ' Get raster input from layer
    'Dim pRLayer As IRasterLayer
    'Set pRLayer = pMap.layer(0)
        Dim pRaster As IRaster
255:     Set pRaster = pRLayer.Raster
  ' Get the number of rows from raster table
        Dim pTable As ITable
        Dim pBand As IRasterBand
        Dim pBandCol As IRasterBandCollection
260:     Set pBandCol = pRaster
261:     Set pBand = pBandCol.Item(0)
        Dim TableExist As Boolean
    'pBand.HasTable TableExist
    'If Not TableExist Then Exit Sub
265:     Set pTable = pBand.AttributeTable
        Dim NumOfValues As Integer
267:     NumOfValues = pTable.RowCount(Nothing)
  
   ' Specified a field and get the field index for the specified field to be rendered.
        Dim FieldIndex As Integer
        Dim fieldName As String
272:     fieldName = "Value" ' Value is the default field, you can specify other field here
273:     FieldIndex = pTable.FindField(fieldName)
  
  ' Create random color
        Dim pRamp As IRandomColorRamp
277:     Set pRamp = New RandomColorRamp
278:     pRamp.Size = NumOfValues
279:     pRamp.Seed = 100
280:     pRamp.CreateRamp (True)
        Dim pFSymbol As ISimpleFillSymbol
  
  ' Create UniqueValue renderer and QI RasterRenderer
        Dim pUVRen As IRasterUniqueValueRenderer
285:     Set pUVRen = New RasterUniqueValueRenderer
        Dim pRasRen As IRasterRenderer
287:     Set pRasRen = pUVRen
  
  ' Connect the renderer and the raster
290:     Set pRasRen.Raster = pRaster
291:     pRasRen.Update
  
  ' Set UniqueValue renderer
294:     pUVRen.HeadingCount = 1   ' Use one heading
295:     pUVRen.Heading(0) = "All Data Values"
296:     pUVRen.ClassCount(0) = NumOfValues
297:     pUVRen.Field = fieldName
298:          pUVRen.ColorScheme = ""
         Dim i As Long
         Dim pRow As IRow
         Dim LabelValue As Variant
302:     For i = 0 To NumOfValues - 1
303:         Set pRow = pTable.GetRow(i) 'Get a row from the table
304:         LabelValue = pRow.Value(FieldIndex)
305:         pUVRen.AddValue 0, i, LabelValue 'Get a row from the table
306:         pUVRen.Label(0, i) = CStr(LabelValue) ' Set label
307:         Set pFSymbol = New SimpleFillSymbol
308:         pFSymbol.Color = pRamp.Color(i)
309:         pUVRen.Symbol(0, i) = pFSymbol  'Set symbol
310:     Next i
  
    'Update render and refresh layer
313:     pRasRen.Update
314:     Set pRLayer.Renderer = pUVRen
         Dim pMxDoc As IMxDocument
316:          Set pMxDoc = SDMGlobals.SDMDoc
317:     pMxDoc.ActiveView.Refresh
318:     pMxDoc.UpdateContents
  ' Clean up

  Exit Sub
ErrorHandler:
  HandleError True, "ChangeRenderToUVRenderer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


