VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SDMCommands"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'+++ The class module contains the commands that will be placed on the
'+++ ArcSDM dropdown menu


Option Explicit
Option Compare Text

Implements ICommand
Implements ICommandSubType

Private m_pApp As IApplication
Private m_pDoc As IMxDocument
Private m_pMap As IMap
Private m_pExt As IExtensionConfig

' Need to listen for the MxDocument events
Dim WithEvents m_pDocEvt As MxDocument
Attribute m_pDocEvt.VB_VarHelpID = -1

Private subType As Long
Private theForm As Object

' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "ArcSDMCommands"       ' Constant reflect file module name


Private Sub Class_Terminate()
    Set m_pMap = Nothing
    Set m_pDoc = Nothing
    Set m_pExt = Nothing
    Set m_pApp = Nothing
End Sub

Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE

End Property

Private Property Get ICommand_Caption() As String
  Select Case subType
    Case 1
      ICommand_Caption = "Set Analysis Parameters..."
    Case 2
      'ICommand_Caption = "Select Points by Location..."
    Case 3
      ICommand_Caption = "Calculate Theme Weights..."
    Case 4
      ICommand_Caption = "Create Chart..."
    Case 5, 51
      ICommand_Caption = "Generalize Evidential Themes..."
    Case 6
      ICommand_Caption = "Calculate Response Theme..."
    Case 7
      ICommand_Caption = "Check Conditional Independence..."
    Case 8
      ICommand_Caption = "Use Existing Weights/Variances Tables..."
    Case 9
      ICommand_Caption = "Define Fuzzy Membership..."
    Case 10
      ICommand_Caption = "Fuzzy Logic..."
    Case 11
      ICommand_Caption = "Process Existing Model..."
    Case 12
      ICommand_Caption = "Generate Random Training Points..."
    Case 13
      ICommand_Caption = "Generate Neural Network Input Files..."
    Case 14
      ICommand_Caption = "Run Neural Network Module DataXplore..."
    Case 15
      ICommand_Caption = "Read Results from Neural Network Module..."
    Case 16
      ICommand_Caption = "Compare Results..."
    Case 17
      ICommand_Caption = "Associate Responses with Point Theme..."
    Case 18
      ICommand_Caption = "Reclassify Tool..."
    Case 19
      ICommand_Caption = "Normalize Posterior Probability..."
    Case 20
      ICommand_Caption = "Extract Contacts..."
    Case 21
      ICommand_Caption = "Create Raster..."
    Case 22
      ICommand_Caption = "Add Bearings..."
    Case 23
      ICommand_Caption = "Quick Display Tools..."
    Case 24
      ICommand_Caption = "Area vs. Probability..."
    Case 25
      ICommand_Caption = "Help..."
    Case 26
      ICommand_Caption = "Run Neural Network Module GeoXplore..."
'''    Case 27
'''      ICommand_Caption = "Neural Network Input Files from Response raster"
'''    Case 28
'''      ICommand_Caption = "-------------------------------------------------"
  End Select
End Property

Private Property Get ICommand_Category() As String
  ICommand_Category = "ArcSDM Command"
End Property

Private Property Get ICommand_Checked() As Boolean
    ICommand_Checked = False
End Property


Private Property Get ICommand_Enabled() As Boolean

  If (getSAExtState = esriESEnabled) And _
     (m_pMap.LayerCount > 0) Then
     
'    (getSDMExtState = esriESEnabled) And _

    Dim anlprms As AnalysisParameters.AnlParams
    Set anlprms = New AnalysisParameters.AnlParams
    Dim gParam As Form
    Set gParam = anlprms.gParamFrm
    
   Select Case subType
     Case 1
        ICommand_Enabled = True
     Case 2
'        Dim gsdiselbylocupdate As New gSDI_SelByLocUpdate
'        ICommand_Enabled = False 'gsdiselbylocupdate.gSDI_SelByLocUpdate
     Case 3
        ICommand_Enabled = (gParam.chkWofE.Value = 1)
     Case 4
'        Dim gsdichtupdate As New gSDI_ChtUpdate
        ICommand_Enabled = (gParam.chkWofE.Value = 1) 'gsdichtupdate.gSDI_Cht_Update
     Case 5
        'Dim gsdiETUpdate As New gSDI_ET_Update
        ICommand_Enabled = (gParam.chkWofE.Value = 1) Or _
            (gParam.chklr.Value = 1) 'gsdiETUpdate.gSDI_ET_Update
     Case 6
        'Dim gsdiMenuItemUpdate As New gSDI_MenuItem_Update
        ICommand_Enabled = (gParam.chkWofE.Value = 1) Or _
            (gParam.chklr.Value = 1) 'gsdiMenuItemUpdate.gSDI_MenuItem_Update
     Case 7
        'Dim gsdiCheckCIUpdate As New gSDI_CheckCI_Update
        'gsdiCheckCIUpdate.gSDI_CheckCI_Update
        ICommand_Enabled = False  'gSDI_CheckCI_Update.gSDI_CheckCI_Update
     Case 8
'        Dim gSDIUseExistingUD As New gSDI_UseExistingUD
        ICommand_Enabled = False '(gParam.chkWofE.Value = 1) 'gSDIUseExistingUD.gSDI_UseExistingUD
     Case 9
'        Dim gSDIFMUpdate As New gSDI_FM_Update
        ICommand_Enabled = (gParam.chkfl.Value = 1) 'gSDI_FM_Update.gSDI_FM_Update
     Case 10
'        Dim gSDIFLUpdate As New gSDI_FL_Update
        ICommand_Enabled = (gParam.chkfl.Value = 1) 'gSDI_FL_Update.gSDI_FL_Update
     Case 11
'        Dim gSDIProcFLMUpdate As New gSDI_ProcFLM_Update
        ICommand_Enabled = False '(gParam.chkfl.Value = 1) 'gSDI_ProcFLM_Update.gSDI_ProcFLM_Update
     Case 12
        ICommand_Enabled = gSDI_GRP_Update.gSDI_GRP_Update
     Case 13, 51
'        Dim gSDINNInputUpdate As New gSDI_NNInput_Update
        ICommand_Enabled = gSDI_NNInput_Update.gSDI_NNInput_Update
     Case 14, 15
'        Dim gSDINNOutputUpdate As New gSDI_NNOutput_Update
        ICommand_Enabled = gSDI_NNOutput_Update.gSDI_NNOutput_Update
     Case 16
        Dim gSDICmpResUpdate As New gSDI_CmpRes_Update
        ICommand_Enabled = gSDICmpResUpdate.gSDI_CmpRes_Update
     Case 17 'Associate response...
        Dim gSDIPRTMenuUpdate As gSDI_PRTMenuUpdate
        Set gSDIPRTMenuUpdate = New gSDI_PRTMenuUpdate
        ICommand_Enabled = gSDIPRTMenuUpdate.gSDI_PRTMenuUpdate
     Case 18
        ICommand_Enabled = False 'gSDI_ReclassifyUpdate.gSDI_ReclassifyUpdate
     Case 19
        'Dim gSDINormUpdate As New gSDI_NormUpdate
        ICommand_Enabled = gSDI_NormUpdate.gSDI_NormUpdate
     Case 20
        'gSDIExtractUpdate.gSDI_ExtractUpdate
        Dim gSDIExtractUpdate As gSDI_ExtractUpdate
        Set gSDIExtractUpdate = New gSDI_ExtractUpdate
        ICommand_Enabled = gSDIExtractUpdate.gSDI_ExtractUpdate
     Case 21
'        Dim gSDIBufUpdate As New gSDI_BufUpdate
        ICommand_Enabled = True 'gSDIBufUpdate.gSDI_BufUpdate
     Case 22
        'gSDIBearingUpdate.gSDI_BearingUpdate
        Dim gSDIBearingUpdate As gSDI_BearingUpdate
        Set gSDIBearingUpdate = New gSDI_BearingUpdate
        ICommand_Enabled = gSDIBearingUpdate.gSDI_BearingUpdate
     Case 23
        ICommand_Enabled = True
     Case 24
        ICommand_Enabled = gSDI_AreaProb_Update.gSDI_AreaProb_Update
     Case 25
        ICommand_Enabled = True
     Case 26
        ICommand_Enabled = gSDI_NNOutput_Update.gSDI_NNOutput_Update
'''     Case 27
'''        ICommand_Enabled = False 'gSDI_NNOutput_Update.gSDI_NNOutput_Update
     Case Else
        ICommand_Enabled = False 'True
    End Select
Else
    ICommand_Enabled = False
End If
   
End Property

Private Property Get ICommand_HelpContextID() As Long

End Property

Private Property Get ICommand_HelpFile() As String

End Property

Private Property Get ICommand_Message() As String
  Select Case subType
    Case 1
      ICommand_Message = "Opens dialog for setting parameters."
    Case 2
      'ICommand_Message = "Subsets points interactively in view."
    Case 3
      ICommand_Message = "Calculates weights table for a single evidential theme."
    Case 4
      ICommand_Message = "Creates a chart."
    Case 5, 51
      ICommand_Message = "Generalizes evidential themes."
    Case 6
      ICommand_Message = "Generates a response theme using weights of evidence and/or logistic regression."
    Case 7
      ICommand_Message = "Checks conditional independence."
    Case 8
      ICommand_Message = "Generates a weights of evidence response theme using weights and variances previously generated."
    Case 9
      ICommand_Message = "Defines fuzzy membership values for an evidential theme."
    Case 10
      ICommand_Message = "Combines evidential themes using fuzzy logic."
    Case 11
      'ICommand_Message = "Plots or re-runs a previously recorded fuzzy logic model."
    Case 12
      ICommand_Message = "Generates a point theme based on values in a polygon or grid theme."
    Case 13
      ICommand_Message = "Generates by calculating response theme files for input to DataXplore and GeoXplore."
    Case 14
      ICommand_Message = "Launches DataXplore."
    Case 15
      ICommand_Message = "Reads and symbolizes files generated by DataXplore and GeoXplore."
    Case 16
      ICommand_Message = "Compares the results from two models."
    Case 17
      ICommand_Message = "Associates response values with a point theme."
    Case 18
      ICommand_Message = "Reclassifies a grid theme, preserving class information."
    Case 19
      ICommand_Message = "Scales a grid theme values between 0 and 1."
    Case 20
      ICommand_Message = "Extracts contacts from feature or grid theme polygons."
    Case 21
      'ICommand_Message = "Generates buffers around point, line or polygon features."
      ICommand_Message = "Creates a new raster from one of the attributes."
    Case 22
      ICommand_Message = "Records bearings of line features in theme attribute table."
    Case 23
      ICommand_Message = "Displays help for Arc-SDM's symbolization tool menu."
    Case 24
      ICommand_Message = "Create a chart of cumulative areas vs. posterior probability from your response theme."
    Case 25
      ICommand_Message = "Opens on-line help in web browser."
    Case 26
      ICommand_Message = "Launches GeoXplore."
'''    Case 27
'''      ICommand_Message = "Generates input files from existing response theme for input to DataXplore and GeoXplore."
  End Select
End Property

Private Property Get ICommand_Name() As String
  Select Case subType
    Case 1
      ICommand_Name = "Set_Analysis_Parameters"
    Case 2
      'ICommand_Name = "Select_Points_by_Location"
    Case 3
      ICommand_Name = "Calculate_Theme_Weights"
    Case 4
      ICommand_Name = "Create_Chart"
    Case 5, 51
      ICommand_Name = "Generalize_Evidential_Themes"
    Case 6
      ICommand_Name = "Calculate_Response_Theme"
    Case 7
      ICommand_Name = "Check_Conditional_Independence"
    Case 8
      ICommand_Name = "Use_Existing_Weights_Variances_Tables"
    Case 9
      ICommand_Name = "Define_Fuzzy_Membership"
    Case 10
      ICommand_Name = "Fuzzy_Logic"
    Case 11
      ICommand_Name = "Process_Existing_Model"
    Case 12
      ICommand_Name = "Generate_Random_Training_Points"
    Case 13
      ICommand_Name = "Generate_Neural_Network_Input_Files"
    Case 14
      ICommand_Name = "Run_Neural_Network_Module_DataXplor"
    Case 15
      ICommand_Name = "Read_Results_from_Neural_Network_Module"
    Case 16
      ICommand_Name = "Compare_Results"
    Case 17
      ICommand_Name = "Associate_Responses_with_Point_Theme"
    Case 18
      ICommand_Name = "Reclassify_Tool"
    Case 19
      ICommand_Name = "Normalize_Grid"
    Case 20
      ICommand_Name = "Extract_Contacts"
    Case 21
      ICommand_Name = "Attribute_To_Raster"
    Case 22
      ICommand_Name = "Add_Bearings"
    Case 23
      ICommand_Name = "Quick_Display_Tools"
    Case 24
      ICommand_Name = "Area vs. Probability"
    Case 25
      ICommand_Name = "Help"
    Case 26
      ICommand_Name = ICommand_Name = "Run_Neural_Network_Module_GeoXplore"
    'Case 27
    '  ICommand_Name = ICommand_Name = "Generate_Neural_Network_Input_Files_UC"

  End Select
End Property

Private Sub ICommand_OnClick()
  On Error GoTo ErrChk
    Dim no As Integer
  Select Case subType
    Case 1
    Dim gParamRun As New gParam_Run
    gParamRun.gParam_Run
    Case 2
    'SDMExtension.gLoc.Caption = ICommand_Caption
    'sdmapp.FindDialog("gTW").OpenIt
    'Set dialog = sdmapp.findDialog("gLoc")
'    Dim gSelbyLoc As New gSDI_SelByLocation
'    gSelbyLoc.gSDI_SelByLocation
    Case 3
    'SDMExtension.gTW.Caption = ICommand_Caption
    'Set dialog = sdmapp.findDialog("gTW")
    Dim gTWRun As New WgtsOfEvidence.gTW_Run
    gTWRun.gTW_Run
    
    Case 4
    'SDMExtension.gCht.Caption = ICommand_Caption
    'Set dialog = sdmapp.findDialog("gCht")
    Dim gChtRun As New CreateChart.gCht_run
    gChtRun.gCht_run
    
  Case 5, 51
    'SDMExtension.gGen.Caption = ICommand_Caption
    'Set dialog = sdmapp.findDialog("gGen")
    Dim gGenRun As New gGen_Run
    gGenRun.gGen_Run
    
  Case 6
    'Dim Calculate_Response_Theme As New Calculate_Response_Theme
    'Calculate_Response_Theme.gSDI_ListSetup
    Dim gSDIListSetup As gSDI_ListSetup
    Set gSDIListSetup = New gSDI_ListSetup
    gSDIListSetup.gSDI_ListSetup Me
    
  Case 7
    'sdmapp.findDialog("gL").OpenIt
    'Dim Check_Conditional_Independence As New Check_Conditional_Independence
    'Check_Conditional_Independence.gSDI_ListSetup
    'Dim gSDIListSetup As New gSDI_ListSetup
    'gSDIListSetup.gSDI_ListSetup Me
  
  Case 8
'    gFnl.Caption = ICommand_Caption
    'sdmapp.findDialog("gFnl").OpenIt
    'Dim Use_Existing_Weights/Variances_Tables As New Use_Existing_Weights/Variances_Tables
    'Use_Existing_Weights/Variances_Tables.gFnl_Run
'    Dim gfnlrun As New gFnl_Run
'    gfnlrun.gFnl_Run
  
  Case 9
'    gFM.Caption = ICommand_Caption
    'sdmapp.findDialog("gFM").OpenIt
    'Dim Define_Fuzzy_Membership As New Define_Fuzzy_Membership
    'Define_Fuzzy_Membership.gFM_Run
    Dim gfmrun As New gFM_Run
    gfmrun.gFM_Run
     
  Case 10
'    gFL.Caption = ICommand_Caption
    'sdmapp.findDialog("gFL").OpenIt
    'Dim Fuzzy_Logic As New Fuzzy_Logic
    'Fuzzy_Logic.gFL_Run
'    Dim gflrun As New gFL_Run
'    gflrun.gFL_Run
     Dim gflrun As New gFL_Run
     gflrun.gFL_Run
  Case 11
'    gMod.Caption = ICommand_Caption
    'sdmapp.findDialog("gMod").OpenIt
    'Dim Process_Existing_Model As New Process_Existing_Model
    'Process_Existing_Model.gSDI_PrcExistingFLM
'    Dim gsdiprcexistingflm As New gSDI_PrcExistingFLM
'    gsdiprcexistingflm.gSDI_PrcExistingFLM
'    MsgBox "Command not yet implemented", vbExclamation, "SDMExtension"
  Case 12
    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
    'Dim Generate_Random_Training_Points As New Generate_Random_Training_Points
    'Generate_Random_Training_Points.gRPSrc_Run
    Dim gRPrun As New gRP_Run
'    gRP.Caption = ICommand_Caption
    gRPrun.gRP_Run
  
  Case 13
    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
    'Dim gSDIListSetup As gSDI_ListSetup
    Set gSDIListSetup = New gSDI_ListSetup
    gSDIListSetup.gSDI_ListSetup Me
  
  Case 14
    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
'    MsgBox "Launch DataXplore.exe", vbOKOnly, ICommand_Caption
'    Dim Run_Neural_Network_Module As New Run_Neural_Network_Module
'    Run_Neural_Network_Module.gSDI_RunNNCode
    Dim gSDIRunNNCode As gSDI_RunNNCode
    Set gSDIRunNNCode = New gSDI_RunNNCode
    gSDIRunNNCode.gSDI_RunNNCode Me

  Case 15
    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
'    Dim Read_Results_from_Neural_Network_Module As New Read_Results_from_Neural_Network_Module
'    Read_Results_from_Neural_Network_Module.gSDI_ReadNNResults
    Dim gSDIReadNNResults As gSDI_ReadNNResults
    Set gSDIReadNNResults = New gSDI_ReadNNResults
    gSDIReadNNResults.gSDI_ReadNNResults
  Case 16
'    MsgBox "Not yet converted.", vbExclamation, "Compare Results..."
'    Exit Sub
   'sdmapp.findDialog("gC").OpenIt
    Dim gcRun As gC_Run
    Set gcRun = New gC_Run
    gcRun.gC_Run
    Set gcRun = Nothing
  Case 17
'    gPRT.Caption = ICommand_Caption
    'sdmapp.findDialog("gPRT").OpenIt
    'Dim Associate_Responses_with_Point_Theme As New Associate_Responses_with_Point_Theme
    'Associate_Responses_with_Point_Theme.gPRT_Run
'    MsgBox "Not yet converted.", vbExclamation, "Associate Response..."
'    Exit Sub
    
    Dim gPRTRun As gPRT_Run
    Set gPRTRun = New gPRT_Run
    gPRTRun.gPRT_Run
    Set gPRTRun = Nothing
  Case 18
'    gRcl.Caption = ICommand_Caption
    'sdmapp.findDialog("gRcl").OpenIt
    'Dim Reclassify_Tool As New Reclassify_Tool
    'Reclassify_Tool.gRcl_Run
'    Dim grclrun As New gRcl_Run
'    grclrun.gRcl_Run
    MsgBox "Reclassify_Tool....", , c_sModuleFileName
  Case 19
    'MsgBox ICommand_Caption, vbOKOnly, ICommand_Caption
    'Dim Normalize_Grid As New Normalize_Grid
    'Normalize_Grid.gSDI_RunNormalize
'    MsgBox "Not yet implemented.", vbExclamation, c_sModuleFileName
    Dim gNormRun As SDMAccessories.gNorm_Run
    Set gNormRun = New SDMAccessories.gNorm_Run
    gNormRun.gNorm_Run
  Case 20
'    gExt.Caption = ICommand_Caption
'    Set dialog = SDMApp.findDialog("gExt")
'    dialog.dlgForm = gExt
'    dialog.OpenIt
    'Dim Extract_Contacts As New Extract_Contacts
    'Extract_Contacts.gExt_Run
    Dim gExtOpen As SDMAccessories.gExt_Open
    Set gExtOpen = New SDMAccessories.gExt_Open
    gExtOpen.gExt_Open
  Case 21
'    gBff.Caption = ICommand_Caption
'    Set dialog = SDMApp.findDialog("gBff")
'    dialog.dlgForm = gBff
'    dialog.OpenIt
    'Dim Buffer_Features As New Buffer_Features
    'Buffer_Features.gBff_Run
    Dim gSDIFld2Ras As SDMAccessories.gFld2Ras_Run
    Set gSDIFld2Ras = New SDMAccessories.gFld2Ras_Run
    gSDIFld2Ras.gFld2Ras_Run
  Case 22
'    gBr.Caption = ICommand_Caption
'    Set dialog = SDMApp.findDialog("gBr")
'    dialog.dlgForm = gBr
'    dialog.OpenIt
    'Dim Add_Bearings As New Add_Bearings
    'Add_Bearings.gBr_Run
    Dim gBrOpen As SDMAccessories.gBr_Open
    Set gBrOpen = New SDMAccessories.gBr_Open
    gBrOpen.gBr_Open
  Case 23
    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
    'Dim Quick_Display_Tools As New Quick_Display_Tools
    'Quick_Display_Tools.gSDI_QuickDisplayHelp
    SDMHelp.gSDI_Help ("sdmsym.htm")
  Case 24
    Dim gSDICumFreq As SDMAccessories.gSDI_CumulativeFreq
    Set gSDICumFreq = New SDMAccessories.gSDI_CumulativeFreq
    gSDICumFreq.gSDI_CumulativeFreq
    Set gSDICumFreq = Nothing
  Case 25
    Dim Help As New gSDI_Help
    Help.gSDI_Help ("sdmhelp.htm")
  Case 26
    Dim gSDIRunGeoXplorCode As gSDI_RunGeoXplorCode
    Set gSDIRunGeoXplorCode = New gSDI_RunGeoXplorCode
    gSDIRunGeoXplorCode.gSDI_RunGeoXplorCode Me
'''  Case 27
'''    'MsgBox "Not Implemented", vbOKOnly, ICommand_Caption
'''    'Dim gSDIListSetup As gSDI_ListSetup
'''    Set gSDIListSetup = New gSDI_ListSetup
'''    gSDIListSetup.gSDI_ListSetup Me
'''  Case 28
  Case Default
    Err.Raise vbObjectError + 99, , "No SDM command subtype=" & subType
  End Select
 
 Exit Sub
  
ErrChk:
  Dim lNum As Long, sSrc As String, sDesc As String
  lNum = Err.Number
  sSrc = Err.Source
  sDesc = Err.Description
  MsgBox "Error in ArcSDMCommands::ICommand_OnClick " & sDesc & vbCrLf & lNum, vbExclamation, "ArcSDM Extension"
End Sub

Private Sub ICommand_OnCreate(ByVal hook As Object)
  Set m_pApp = hook 'Hook up the command to the application
  Set m_pDoc = m_pApp.Document
  Set m_pMap = m_pDoc.FocusMap
  'Start listening for the MxDocument events.
  Set m_pDocEvt = m_pApp.Document
End Sub
Private Function getSAExtState() As esriExtensionState
  'Get the extensions' state
  Dim u As New UID
  'u.Value = "esriSpatialAnalystUI.SAExtension"
  'Set m_pExt = m_pApp.FindExtensionByCLSID(u)
  Set m_pExt = m_pApp.FindExtensionByName("Spatial Analyst")
  Dim m_pExtCfg As IExtensionConfig
  Set m_pExtCfg = m_pExt
  getSAExtState = m_pExtCfg.State
  Select Case getSAExtState
    Case esriESEnabled
    Case esriESDisabled
        'MsgBox "Spatial Analyst is not enabled."
        m_pApp.StatusBar.Message(0) = "Spatial Analyst is not enabled."
    Case esriESUnavailable
        m_pApp.StatusBar.Message(0) = "Spatial Analyst is unlicensed."
  End Select
End Function
Private Function getSDMExtState() As esriExtensionState
  'Get the extensions' state
  Dim u As New UID
  Set m_pExt = m_pApp.FindExtensionByName("Spatial Data Modeller")
  Dim m_pExtCfg As IExtensionConfig
  Set m_pExtCfg = m_pExt
  getSDMExtState = m_pExtCfg.State
  Select Case getSDMExtState
    Case esriESEnabled
    Case esriESDisabled
        'MsgBox "Spatial Data Modeller is not enabled."
        m_pApp.StatusBar.Message(0) = "Spatial Data Modeller is not enabled."
    Case esriESUnavailable
        m_pApp.StatusBar.Message(0) = "Spatial Data Modeller is unlicensed."
  End Select
End Function

Private Property Get ICommand_Tooltip() As String
  ICommand_Tooltip = "See status line message."
End Property

Private Function ICommandSubType_GetCount() As Long
  ICommandSubType_GetCount = 27 '28
End Function

Private Sub ICommandSubType_SetSubType(ByVal aSubType As Long)
  subType = aSubType
End Sub

Private Function m_pDocEvt_ActiveViewChanged() As Boolean
  Set m_pDoc = m_pApp.Document
  Set m_pMap = m_pDoc.FocusMap
End Function
'''Private Function m_pDocEvt_beforeCloseDocument() As Boolean
'''    If m_pMap.LayerCount > 0 Then
'''        Dim doclyrs As IEnumLayer
'''        Set doclyrs = m_pMap.Layers
'''        doclyrs.Reset
'''        Dim lyr As ILayer
'''        Set lyr = doclyrs.Next
'''        While Not lyr Is Nothing
'''            If lyr.Name Like "SDMUC*" Then
'''                Dim raslyr As IRasterLayer
'''                Set raslyr = lyr
'''                Dim rasBColl As IRasterBandCollection
'''                Set rasBColl = raslyr.Raster
'''                Dim tmpDS As ITemporaryDataset
'''                Set tmpDS = rasBColl.Item(0).RasterDataset
'''                If tmpDS.IsTemporary Then
'''                    m_pDocEvt_beforeCloseDocument = _
'''                            MsgBox("There are temporary raster layers named SDMUCnn. " & vbCrLf & _
'''                                "Do you want to cancel closing this document?", vbYesNo, "SDM Extension") = vbYes
'''                    Exit Function
'''                End If
'''            End If
'''            Set lyr = doclyrs.Next
'''        Wend
'''    End If
'''    m_pDocEvt_beforeCloseDocument = False
    
'''End Function

Private Function m_pDocEvt_MapsChanged() As Boolean
  Set m_pDoc = m_pApp.Document
  Set m_pMap = m_pDoc.FocusMap
End Function

Private Function m_pDocEvt_NewDocument() As Boolean
  Set m_pDoc = m_pApp.Document
  Set m_pMap = m_pDoc.FocusMap
End Function

Private Function m_pDocEvt_OpenDocument() As Boolean
  Set m_pDoc = m_pApp.Document
  Set m_pMap = m_pDoc.FocusMap
End Function



