VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IRasterBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim raslayer As IRasterLayer
Dim pRaster As IRaster
Dim pIdentify As IIdentify
Dim pRasProps As IRasterProps
Dim pNoDataValue As Variant
Dim pRx As Double, pRy As Double

Const c_sModuleFileName As String = "RasterBuffer"
Const c_sDLLFileName As String = "WeightsofEvidence"       ' Constant reflect file module name

Public Function OpenBuffer(ByRef rasobject As IUnknown) As Boolean
    On Error GoTo ErrorHandler
14:     If TypeOf rasobject Is IRasterLayer Then
15:         Set raslayer = rasobject
16:         Set pRaster = RasterUtils.GetDatasetRaster(raslayer)
17:     Else
18:         Err.Raise vbObjectError + 513, "RasterBuffer", "Argument not a rasterlayer"
19:     End If
        
21:     Set pRasProps = pRaster
        Select Case pRasProps.PixelType
        'VB does not support unsigned short, unsigned long, unsigned char, char, and
        ' complex and 1-, 2-, & 4-bit rasters
        'ArcObjects does support them, do Identify interface delivers a string numeric value.
            Case PT_SHORT, PT_LONG
27:             pNoDataValue = pRasProps.NoDataValue(0)
            Case PT_USHORT, PT_ULONG
29:                 pNoDataValue = 0 'Avoid Automation error
            Case PT_UCHAR
31:             pNoDataValue = 0 'Avoid Automation error
            Case PT_CHAR
33:             pNoDataValue = -128 'Avoid Automation error
            Case PT_FLOAT, PT_DOUBLE, PT_COMPLEX, PT_DCOMPLEX
35:             pNoDataValue = pRasProps.NoDataValue(0)
            Case Else 'other types: complex and 1-, 2-, & 4-bit rasters
37:             pNoDataValue = pRasProps.NoDataValue(0)
38:     End Select
'49:     MsgBox "Raster properties: " & vbCrLf & _
'        "Pixel type = " & pRasProps.PixelType & vbCrLf & _
'        "NoData value = " & pNoDataValue
42:     Set pIdentify = raslayer
43:     OpenBuffer = True
      Exit Function
ErrorHandler:
  HandleError True, "OpenBuffer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
47:     OpenBuffer = False
End Function

Public Function CellValue(ByRef pnt As IPoint) As Variant
        On Error GoTo ErrorHandler
52:     CellValue = GetValIdentify(pnt)
        Exit Function
ErrorHandler:
        HandleError True, "CellValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
56:     CellValue = Null
End Function

Public Function GetVal(ByRef pnt As IPoint) As Variant
        On Error GoTo ErrorHandler
61:     GetVal = GetValIdentify(pnt)
        Exit Function
ErrorHandler:
        HandleError True, "GetVal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
65:     GetVal = Null
End Function

Private Function GetValIdentify(ByRef mapPoint As IPoint) As Variant

     Dim pIDArray As IArray
     Dim pRastIdObj As IRasterIdentifyObj
     Dim pIdObj As IIdentifyObj
73:  Set pIDArray = pIdentify.Identify(mapPoint)

'Get the RasterIdentifyObject
76:  If Not pIDArray Is Nothing Then
77:    Set pRastIdObj = pIDArray.Element(0)
78:    Set pIdObj = pRastIdObj
79:    GetValIdentify = pIdObj.Name
80:  Else
81:    GetValIdentify = Null
82:  End If

End Function
Public Property Get rx() As Double
86:     rx = pRx
End Property

Public Property Let rx(ByVal vNewValue As Double)
90:     pRx = vNewValue
End Property

Public Property Get ry() As Double
94:     ry = pRy
End Property

Public Property Let ry(ByVal vNewValue As Double)
98:     pRy = vNewValue
End Property




