VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 1  'Persistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SDMList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Implements IPersistVariant
'Attributes
Private myList As Collection
Private myDict As SDMDictionary
Private DictState As Boolean
Property Get list() As Collection
    Set list = myList
End Property
Property Set list(ByRef newlist As Collection)
    Set myList = newlist
    DictState = False
    PropertyChanged "myList"
End Property
'Methods
Private Sub Class_Initialize()
    Set myList = New Collection
    DictState = False
End Sub
Public Sub Add(ByRef anItem As Variant)
    On Error GoTo ErrorHandler
    DictState = False
    myList.Add anItem
    Set list = myList
    Exit Sub
ErrorHandler:
    'Duplicate error OK
End Sub      'Add
Public Function Clone() As SDMList
    Dim newlist As New SDMList
    On Error GoTo 2
1:  If newlist.merge(Me) Is Nothing Then Err.Raise 33333
    GoTo 3
    On Error GoTo ErrorHandler
2:  newlist.MergeObj Me
3:  Set Clone = newlist
    Exit Function
ErrorHandler:
    MsgBox "Can't Clone list", , "SDMList"
End Function
Public Function Count() As Long
    Count = myList.Count
End Function 'Count
Public Sub Clear()
    DictState = False
    Set myList = New Collection
End Sub 'Empty
Public Function FindObj(ByRef anItem As Variant) As Long
        Dim i As Long
        i = 0
        Dim var As Variant
        Dim theType As Boolean
        theType = (VarType(anItem) = vbObject) Or (VarType(anItem) = vbDataObject)
        If (theType) Then
            For Each var In myList
                If (VarType(var) = VarType(anItem)) Then
                        If (anItem Is var) Then
                            FindObj = i
                            Exit Function
                        End If
                End If
                i = i + 1
            Next var
        End If
    FindObj = -1
End Function 'FindObj
Public Function FindByValue(ByRef aValue As Variant) As Long
'''    Dim i As Long
'''    If (isVariant(aValue)) Then
'''        For i = 0 To myList.Count - 1
'''            If (Not TypeOf myList.item(i + 1) Is Object ) Then
'''                If (aValue = myList.item(i + 1)) Then
'''                    FindByValue = i
'''                    Exit Function
'''                End If
'''            End If
'''        Next i
'''    End If
'''    FindByValue = -1
        If Not DictState Then indexList
        If myDict.Exists(aValue) Then
            FindByValue = myDict.Gett(aValue)
        Else
            FindByValue = -1
        End If
End Function 'FindByValue
Public Function GetVal(Index As Long) As Variant
On Error GoTo ErrorHandler
    If (Index >= 0 And Index < myList.Count) Then
        GetVal = myList.item(Index + 1)
        Exit Function
    End If
    GetVal = Null
    Exit Function
ErrorHandler:
    GetVal = Null
End Function 'GetMtd
Public Function getObj(Index As Long) As IUnknown
    If (Index >= 0 And Index < myList.Count) Then
        'MsgBox VarType(myList.item(index + 1))
        Set getObj = myList.item(Index + 1)
        Exit Function
    End If
    Set getObj = Nothing
End Function 'GetMtd
Public Sub Insert(ByRef anItem As Variant)
    DictState = False
    If myList.Count = 0 Then
        myList.Add anItem
    Else
        myList.Add anItem, , 1
    End If
End Sub 'Insert
Public Function merge(ByRef newlist As SDMList) As SDMList
    On Error GoTo ERH
    DictState = False
    Dim i As Long
    For i = 0 To newlist.Count - 1
        Dim val As Variant
        val = newlist.GetVal(i)
        If IsNull(val) Then Err.Raise vbObjectError + 1
        myList.Add val
    Next i
    Set merge = Me
    Exit Function
ERH:
    Set merge = Nothing
End Function 'Merge
Public Function MergeObj(ByRef newlist As SDMList) As SDMList
    DictState = False
    Dim i As Long
    For i = 0 To newlist.Count - 1
        myList.Add newlist.getObj(i)
    Next i
    Set MergeObj = Me
End Function 'Merge
Public Sub Remove(Index As Long)
    DictState = False
    If (Index >= 0 Or Index < myList.Count) Then
        myList.Remove Index + 1
    End If
End Sub 'Remove
Public Function RemoveDuplicates() As SDMList
'Ordered output
''    Dim ints() As Variant
''    ReDim ints(myList.Count - 1)
''    Dim i As Long
''    For i = 0 To myList.Count - 1
''        ints(i) = myList.item(i + 1)
''    Next i
''    HeapSort.RemoveDuplicates ints, myList.Count
    Set RemoveDuplicates = New SDMList
''    For i = 0 To myList.Count - 1
''        RemoveDuplicates.Add ints(i)
''    Next i
''    Exit Function
'Unordered output
'>>>>>>Variant lists only
    Dim listIn As SDMList
    Set listIn = Me
    If listIn.Count = 0 Then Exit Function
    Dim n As Long
    RemoveDuplicates.Add listIn.list.item(1)
    For n = 2 To listIn.Count
        Select Case VarType(listIn.list.item(n))
            Case vbString, vbInteger, vbLong, vbDouble, vbSingle, vbBoolean, vbByte, vbDecimal
                Dim nextOne As Variant
                nextOne = listIn.list.item(n)
                If RemoveDuplicates.FindByValue(nextOne) = -1 Then
                    RemoveDuplicates.Add nextOne
                End If
            Case Else
'>>>>>>>>>>>>> Doesn't keep Objects
'                Dim nextObj As IUnknown
'                Set nextObj = listIn.list.Item(n)
'                If RemoveDuplicates.FindObj(nextObj) = -1 Then
'                RemoveDuplicates.Add listIn.list.item(n)
'                End If
        End Select
    Next n
    DictState = False
End Function 'RemoveDuplicates
Public Sub RemoveObj(ByRef anItem As Variant)
    DictState = False
    Dim found As Long
    found = Me.FindObj(anItem)
    If (found <> -1) Then
        Me.Remove found
        Exit Sub
    End If
End Sub 'RemoveObj
Public Sub RemoveValue(ByRef anItem As Variant)
    DictState = False
    Dim ifound As Long
    ifound = Me.FindByValue(anItem)
    If (ifound <> -1) Then
        Me.Remove ifound
        Exit Sub
    End If
End Sub 'RemoveObj
Public Sub SetIt(Index As Long, ByRef anItem As Variant)
    DictState = False
    myList.Add anItem, , , Index + 1
    myList.Remove Index + 1
End Sub 'SetMtd
Public Sub ShuffleObj(ByRef anItem As IUnknown, index0 As Long)
    DictState = False
    Dim Index As Long
    If (index0 < 1) Then
        Index = 1
    ElseIf (index0 > Me.Count) Then
        Index = Me.Count
    Else
        Index = index0
    End If
    Dim ifound As Long
        ifound = Me.FindObj(anItem)
    If (ifound <> -1) Then
        Me.Remove ifound
        If (Index = Me.Count + 1) Then
            myList.Add anItem, , , Me.Count
        Else
            myList.Add anItem, , Index
        End If
    End If
End Sub 'Shuffle
Public Sub Shuffle(ByRef anItem As Variant, index0 As Long)
    DictState = False
    Dim Index As Long
    If (index0 < 1) Then
        Index = 1
    ElseIf (index0 > Me.Count) Then
        Index = Me.Count
    Else
        Index = index0
    End If
    Dim ifound As Long
        ifound = Me.FindByValue(anItem)
    If (ifound <> -1) Then
        Me.Remove ifound
        If (Index = Me.Count + 1) Then
            myList.Add anItem, , , Me.Count
        Else
            myList.Add anItem, , Index
        End If
    End If
End Sub 'Shuffle
Public Function SortInsert(Ascending As Boolean) As SDMList
    DictState = False
    'Sorts all-variant lists only
    Dim listIn As SDMList
    Set listIn = Me
    Dim newlist As New SDMList
    Dim theVal As Variant
    Dim Order As Integer
    If (Ascending) Then
        Order = -1
    Else
        Order = 1
    End If
    newlist.Add listIn.GetVal(0)
    Dim compareType As Integer
    If (VarType(listIn.GetVal(0)) = vbString) Then compareType = vbString
    Dim i As Long
    For i = 1 To listIn.Count - 1
        theVal = listIn.GetVal(i)
        Dim n As Long
        For n = 0 To newlist.Count - 1
            Dim newVal As Variant
            newVal = newlist.GetVal(n)
            Select Case compare(theVal, newVal, compareType)
                Case Order:
                     If (n = 0) Then
                         newlist.Insert theVal
                     Else
                         newlist.Add theVal
                         newlist.Shuffle theVal, n + 1
                     End If
                     GoTo Next1
                Case 0:
                     If (n = 0) Then
                         newlist.Insert theVal
                     Else
                        newlist.Insert theVal
                        newlist.Shuffle theVal, n + 1
                     End If
                     GoTo Next1
                Case Default:
            End Select
        Next n
        newlist.Add theVal
Next1:
    Next i
    Set SortInsert = newlist
End Function
Public Function Sort(Ascending As Boolean) As SDMList
    DictState = False
    Dim ints() As Variant
    ReDim ints(myList.Count - 1)
    Dim i As Long
    For i = 0 To myList.Count - 1
        ints(i) = myList.item(i + 1)
    Next i
    MergeSort.MergeSort ints, myList.Count
    Set Sort = New SDMList
    If Ascending Then
        For i = 0 To myList.Count - 1
            Sort.Add ints(i)
        Next i
    Else
        For i = myList.Count - 1 To 0 Step -1
            Sort.Add ints(i)
        Next i
    End If
End Function

Private Function compare(theVal As Variant, newVal As Variant, compareType As Integer) As Integer
    If (compareType = vbString) Then
        compare = StrComp(theVal, newVal, vbTextCompare)
    Else
        If (theVal < newVal) Then
            compare = -1
        ElseIf (theVal = newVal) Then
            compare = 0
        Else
            compare = 1
        End If
    End If
End Function

Private Sub Class_Terminate()
    Set myList = Nothing
End Sub

Public Function asString() As String
    If myList.Count = 0 Then
        asString = "List is Empty!"
        Exit Function
    End If
    If ((VarType(myList.item(1)) = vbObject) Or (VarType(myList.item(1)) = vbDataObject)) Then
        asString = "Object list count = " & myList.Count
        Exit Function
    End If
    asString = ""
    Dim item As Variant
    For Each item In myList
        asString = asString & item & vbCrLf
    Next item
End Function

Public Sub AddArray(ByRef anArray As Variant)
    DictState = False
    Set myDict = Nothing
    If (VarType(anArray) < vbArray) Then
        Exit Sub
    End If
    Dim arg As Variant
    For Each arg In anArray
        list.Add arg
    Next arg
End Sub

Public Function isEmpty() As Boolean
    isEmpty = myList.Count = 0
End Function

Private Sub Class_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Count", myList.Count
    Dim i As Long
    For i = 1 To myList.Count
        PropBag.WriteProperty "item" & i, myList.item(i), Null
    Next i

End Sub
Private Sub Class_ReadProperties(PropBag As PropertyBag)
    Dim Count As Long
    Count = PropBag.ReadProperty("Count", Null)
    Dim i As Long
    For i = 1 To Count
        myList.Add PropBag.ReadProperty("item" & i, Null)
    Next i

End Sub

Private Property Get IPersistVariant_ID() As esriSystem.IUID
    IPersistVariant_ID.Value = "SDMExtension.SDMList"
End Property

Private Sub IPersistVariant_Load(ByVal Stream As esriSystem.IVariantStream)
    Dim Count As Long
    Count = Stream.Read
    Dim i As Long
    For i = 1 To Count
        myList.Add Stream.Read
    Next i

End Sub

Private Sub IPersistVariant_Save(ByVal Stream As esriSystem.IVariantStream)
    MsgBox "Writing properties: " & Me.Count
    Stream.Write "Count"
    Dim i As Long
    For i = 1 To myList.Count
        Stream.Write myList.item(i)
    Next i

End Sub
'
Private Sub indexList()
    Set myDict = New SDMDictionary
    DictState = True
    If myList.Count = 0 Then Exit Sub
    Dim n As Long
    Dim v As Variant
    For Each v In myList
        myDict.Add v, n
        n = n + 1
    Next v
End Sub

