VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SDMListeners"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Event UpdateEvt(ByRef ctl As Object)

Private stateDict As Object 'Declare a Listener State dictionary
Private listDict As Object 'Declare a object/listeners dictionary
Private broadcaster As Object

Property Get getBroadcasters() As Object
    Set getBroadcasters = listDict
End Property

Property Get getListState() As Object
    Set getListState = stateDict
End Property

Public Sub AddListener(ByRef ctl As Object, ByRef listener As Object)
    On Error GoTo errorhandler
    Dim Listeners As Collection
    If (listDict.Exists(ctl)) Then
        Set Listeners = listDict.Item(ctl)
        Listeners.Add listener
    Else
        Set Listeners = New Collection
        Listeners.Add listener
        listDict.Add ctl, Listeners
    End If
    StartListening listener
   'MsgBox "adding Listener: " & listener.Name & " to " &  ":" & stateDict.gett(ctl)
   Exit Sub
errorhandler:
    MsgBox Err.Source & " AddListener:" & " " & Err.Description
End Sub

Public Sub BroadcastUpdate(ByRef ctl As Object)
    On Error GoTo errorhandler
    Dim Listeners As Collection
    If (listDict.Exists(ctl)) Then
        Set Listeners = listDict.Item(ctl)
        Dim listener As Object
        Set broadcaster = ctl
        For Each listener In Listeners
            'If (IsListening(listener)) Then
                'MsgBox "broadcasting update to: " & listener.Parent.Name & "." & listener.Name & "_Update" & " by " & ctl.Name
                Update listener
            'End If
        Next listener
    'MsgBox "broadcasting update: " & " " & listDict.Item(ctl).Count
    End If
   Exit Sub
errorhandler:
    MsgBox Err.Source & " BroadcastUpdate:" & " " & Err.Description
End Sub

Public Sub ChangedListeners(ByRef ctl As Object)
    On Error GoTo errorhandler
    'Use after SetListeners, AddListener, RemoveListener
    'Do multiple broadcasts
    Err.Raise vbObjectError, "SDMListeners", "ChangedListeners Method not implemented"
errorhandler:
    MsgBox Err.Source & " ChangedListeners: " & " " & Err.Description
End Sub

Public Function GetBroadcaster() As Object
    'What Object is updating me?
    On Error GoTo errorhandler
    Set GetBroadcaster = broadcaster
   Exit Function
errorhandler:
    MsgBox Err.Source & " GetBroadcaster: " & broadcaster.Name & " " & Err.Description
End Function

Public Function GetListeners(ByRef ctl As Object) As Collection
    On Error GoTo errorhandler
    'MsgBox ctl.Parent.Name & "." & ctl.Name, vbOKOnly, "Getlisteners"
    If (listDict.Exists(ctl)) Then
        Set GetListeners = listDict.Item(ctl)
    Else
        Set GetListeners = New Collection
    End If
   Exit Function
errorhandler:
    MsgBox Err.Source & " GetListeners: " & " " & Err.Description
End Function

Public Function IsListening(ByRef ctl As Object) As Boolean
    On Error GoTo errorhandler
    If (stateDict.Exists(ctl)) Then
        IsListening = stateDict.Item(ctl)
        Exit Function
    Else
        IsListening = False
    End If
   Exit Function
errorhandler:
    MsgBox Err.Source & " IsListening: " & " " & Err.Description
End Function

Public Sub RemoveListener(ByRef ctl As Object, ByRef listener As Object)
    On Error GoTo errorhandler
    Dim Listeners As Collection
    If (listDict.Exists(ctl)) Then
        Set Listeners = listDict.Item(ctl)
        Listeners.Remove listener
    End If
    stateDict.Remove ctl
   Exit Sub
errorhandler:
    MsgBox Err.Source & " RemoveListener: " & " " & Err.Description
End Sub

Public Sub SetListeners(ByRef ctl As Object, ByRef Listeners As Variant)
    On Error GoTo errorhandler
    Dim listener As Object
    If (TypeOf Listeners Is Collection) Then
        For Each listener In Listeners
            AddListener ctl, listener
        Next
    ElseIf (IsArray(Listeners)) Then
        Dim i As Integer
        For i = 0 To 99
            Set listener = Listeners(i)
            AddListener ctl, listener
        Next i
    Else
        Err.Raise vbObjectError, "SetListeners", "Listeners must be a Collection or Array"
    End If
Here:     StartListening ctl
    'MsgBox "SetListeners:" & " " & listDict.Item(ctl).Count
    Exit Sub
errorhandler:
    If (Err.Number = 9) Then
        Resume Here
    End If
    MsgBox Err.Source & " SetListeners:" & " " & Err.Description & " " & Err.Number
End Sub

Public Sub StartListening(ByRef ctl As Object)
    On Error GoTo errorhandler
    If (stateDict.Exists(ctl)) Then
        stateDict.Item(ctl) = True
    Else
        stateDict.Add ctl, True
    End If
    'MsgBox "StartListening: " & ctl.Name & " " & stateDict.Item(ctl)
   Exit Sub
errorhandler:
    MsgBox Err.Source & " StartListening: " & " " & Err.Description
End Sub

Public Sub StopListening(ByRef ctl As Object)
    On Error GoTo errorhandler
    If (stateDict.Exists(ctl)) Then
        stateDict.Item(ctl) = False
    Else
        stateDict.Add ctl, False
    End If
   Exit Sub
errorhandler:
    MsgBox Err.Source & " StopListening: " & " " & Err.Description
End Sub

Public Sub Update(ByRef ctl As Object)
    On Error GoTo errorhandler
    If (Not stateDict.Exists(ctl)) Then
        stateDict.Add ctl, True
    End If
    'MsgBox "Update: " & ctl.Parent.Name & "." & _
    '        ctl.Name & " is listening: " & IsListening(ctl)
    If (IsListening(ctl)) Then
        RaiseEvent UpdateEvt(ctl)
    End If
   Exit Sub
errorhandler:
    MsgBox Err.Source & " Update: " & " " & Err.Description
End Sub

Private Sub Class_Initialize()
    Set listDict = CreateObject("Scripting.Dictionary") 'Create a listdictionary
    Set stateDict = CreateObject("Scripting.Dictionary") 'Create a listdictionary
    Set broadcaster = Nothing
End Sub

Private Sub Class_Terminate()
    'MsgBox "terminating Listeners: " & listDict.Count & " " & stateDict.Count
    Set listDict = Nothing
    Set stateDict = Nothing
    Set broadcaster = Nothing
End Sub

Public Function findByName(Name As String) As Object
    Dim names As Variant
    Let names = Split(Name, ".")
    Dim ctl As Object
    For Each ctl In listDict
        If (ctl.Name = names(1) And ctl.Parent.Name = names(0)) Then
            Set findByName = ctl
            Exit Function
        End If
    Next
    For Each ctl In stateDict
        If (ctl.Name = names(1) And ctl.Parent.Name = names(0)) Then
            Set findByName = ctl
            Exit Function
        End If
    Next
    Set findByName = Nothing
End Function

