VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SDMTableUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "C:\MyJava\ARC-SDM\VBScripts\SDMTableUtils.cls"


Public Sub AddTable(dir As String, tablename As String, ByRef pApp As IApplication)
    Dim pMxDoc As IMxDocument
    Dim pMap As IMap
    Dim pTable As ITable
    Dim pTableCollection As ITableCollection
    
11:     Set pMxDoc = pApp.Document
12:     Set pMap = pMxDoc.FocusMap
13:     Set pTableCollection = pMap
14:     Set pTable = OpenTable(dir, tablename)
    If (pTable Is Nothing) Then Exit Sub
16:     pTableCollection.AddTable pTable
17:     pMxDoc.UpdateContents
End Sub

Public Function OpenTable(strWorkspace As String, strTableName As String) As ITable
    On Error GoTo ErrorHandler
    'Dim line As Integer
    
    Dim pShpWorkspaceName As IWorkspaceName
    Dim pDatasetName As IDatasetName
    Dim pName As IName
    'Create the workspace name object
28:     Set pShpWorkspaceName = New WorkspaceName
29:     pShpWorkspaceName.PathName = strWorkspace
30:     pShpWorkspaceName.WorkspaceFactoryProgID = _
        "esriDataSourcesFile.shapefileworkspacefactory.1"
    'Create the table name object
33:     Set pDatasetName = New tablename
34:     pDatasetName.Name = strTableName
35:     Set pDatasetName.WorkspaceName = pShpWorkspaceName
    'Open the table
37:     Set pName = pDatasetName
38:     Set OpenTable = pName.Open
    Exit Function
ErrorHandler:
41:     Set OpenTable = Nothing
End Function

Public Function CreateTable(sName As String, strWorkspace As String, _
                        ByRef fieldsDesc As Collection) As ITable
    On Error GoTo ErrorHandler
    Dim line As Integer
    
    'Create the workspace name object
    Dim pFeatWorkSpace As IFeatureWorkspace
51:     Set pFeatWorkSpace = Me.CreateWorkSpaceObject(strWorkspace)
52:     If (pFeatWorkSpace Is Nothing) Then
53:         Set CreateTable = Nothing
        Exit Function
55:     End If
    
    'Create fields
    Dim pTable As ITable
    Dim pField As IField
    Dim pFieldInfo As IFieldInfo
    Dim pfields As IFields
    Dim pFieldEdit As IFieldEdit
    Dim pFieldsEdit As IFieldsEdit
64:     Set pfields = New Fields
65:     Set pFieldsEdit = pfields
66:     pFieldsEdit.FieldCount = fieldsDesc.Count + 1

    'Create Object ID Field
69:     Set pField = New Field
70:     Set pFieldEdit = pField
71:     Set pFieldInfo = pField

73:     With pFieldEdit
74:         .Editable = True
75:         .Name = "OBJECTID"
76:         .AliasName = "OID"
77:         .Type = esriFieldTypeOID
78:         .Required = True
79:     End With
80:     pFieldInfo.Visible = False
    
82:     Set pFieldsEdit.Field(0) = pField

    Dim i As Integer
    Dim fieldDesc As Variant
86:     For i = 1 To fieldsDesc.Count
87:         Let fieldDesc = fieldsDesc.item(i)
88:         Set pField = New Field
89:         Set pFieldEdit = pField
        With pFieldEdit
            .Editable = True
            .Name = fieldDesc(0)
            .Type = fieldDesc(1)
            .AliasName = fieldDesc(4)
            If fieldDesc(1) = esriFieldTypeString Or _
               fieldDesc(1) = esriFieldTypeInteger Then
                .Length = fieldDesc(2)
            Else
                .Precision = fieldDesc(2)
                .Scale = fieldDesc(3)
                .IsNullable = fieldDesc(5)
                .DefaultValue = Null
            End If
        End With
101:         Set pFieldsEdit.Field(i) = pField
102:     Next i
    
    'Create table
105:     Set pTable = pFeatWorkSpace.CreateTable(sName, pfields, _
                    Nothing, Nothing, "")
                        
108:     Set CreateTable = pTable
    Exit Function
ErrorHandler:
111:     MsgBox Err.Description & "-Line:" & line & vbCrLf & sName & " table not created", vbCritical, "SDMTableUtils"
112:         Set CreateTable = Nothing
End Function

Public Function MakeField(ByRef fieldDesc As Variant) As IField
    Dim pField As IField
    Dim pFieldEdit As IFieldEdit
    
119:     Set pField = New Field
120:     Set pFieldEdit = pField
121:     With pFieldEdit
122:         .Name = fieldDesc(0)
123:         .Type = fieldDesc(1)
124:         .Length = fieldDesc(2)
125:         .Precision = fieldDesc(3)
126:         If (fieldDesc(4) <> "") Then
127:         .AliasName = fieldDesc(4)
128:         End If
129:     End With
130:     Set MakeField = pField
End Function

Public Function CreateWorkSpaceObject(strWorkspace As String) As IFeatureWorkspace
    'Create the workspace name object
135:     If (strWorkspace = "") Then
136:         Set CreateWorkSpaceObject = Nothing
        Exit Function
138:     End If
    Dim pShpWorkspaceName As IWorkspaceName
140:     Set pShpWorkspaceName = New WorkspaceName
141:     pShpWorkspaceName.PathName = strWorkspace
142:     pShpWorkspaceName.WorkspaceFactoryProgID = _
        "esriDataSourcesFile.shapefileworkspacefactory.1"
    Dim pFeatWorkSpace As IFeatureWorkspace
145:     Set pFeatWorkSpace = _
        pShpWorkspaceName.WorkspaceFactory.OpenFromFile(strWorkspace, 0)
147:     Set CreateWorkSpaceObject = pFeatWorkSpace
End Function

Public Sub RemoveTable(saTable As IStandaloneTable, ByRef pApp As IApplication)
    Dim pMxDoc As IMxDocument
    Dim pMap As IMap
    Dim pTable As ITable
    Dim pTableCollection As IStandaloneTableCollection
    
156:     Set pMxDoc = pApp.Document
157:     Set pMap = pMxDoc.FocusMap
158:     Set pTableCollection = pMap
    Dim aTable As IStandaloneTable
    Dim i As Long
161:     For i = 0 To pTableCollection.StandaloneTableCount - 1
162:         Set aTable = pTableCollection.StandaloneTable(i)
163:         If (aTable Is saTable) Then
164:             pTableCollection.RemoveStandaloneTable aTable
165:             pMxDoc.UpdateContents
            Exit Sub
167:         End If
168:     Next i
    
End Sub





