VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_AddBearing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gBr_AddBearing"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub AddBearing()
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  AddBearing
''
'' Title: Adds a field to polylines, containing the bearing
''
'' Topics:  GeoData
''
'' Description:  For each polyline feature, uses the endpoints of
'' the line to calculate the bearing of the line from North
'
'' Requires:  the view must be the active document, with one active
'' theme containing polylines
''
'' Self:
''
'' Returns:
''
'' Written by:  Robyn Gallagher
''===========================================================
'theView = av.GetActiveDoc
'diag = av.FindDialog("gBr")
'themeName = diag.FindByName("cbx_Thm").GetCurrentValue
Dim themeName As String
37: themeName = gBr.cbx_Thm.Text
'theTheme = theView.FindTheme(themeName)
Dim theTheme As IFeatureLayer
40: Set theTheme = WOETableUtils.FindLayerByName(themeName)
'If (theTheme = nil) Then
If theTheme Is Nothing Then Exit Sub
'  return Nil
'End
''Check if polyline theme
'If (theTheme.Is(FTheme).Not) Then
'  return Nil
'End

'themeVTab = theTheme.GetFTab
Dim themeVTab As ITable
52: Set themeVTab = theTheme
'shapeField = themeVTab.FindField("Shape")
Dim shapeField As Long
55: shapeField = theTheme.FeatureClass.FindField(theTheme.FeatureClass.ShapeFieldName)
'themeType = shapeField.GetType
Dim themetype As esriGeometryType
58: themetype = theTheme.FeatureClass.ShapeType
'if (themeType <> #FIELD_SHAPELINE) then
60: If themetype <> esriGeometryMultipoint And _
        themetype <> esriGeometryLine And _
        themetype <> esriGeometryPolyline Then
'  MsgBox.Error("Active theme must be polyline theme","")
64:     MsgBox "Selected layer must be Line geometry", vbCritical, c_sModuleFileName
'  return nil
        Exit Sub
'End
68: End If
''brng = diag.GetControlPanel.GetSelected.GetName = "radBr"
'edit_state = themeVTab.IsEditable
''make sure table is editable and that fields can be added
'If (themeVTab.CanEdit) Then
'  themeVTab.SetEditable (True)
    Dim pWksEdit As IWorkspaceEdit
75: Set pWksEdit = FeatureUtils.startEditing(FileDialog.getProjectDir)
'  if ((themeVTab.CanAddFields).Not) then
'    MsgBox.Error("Can't add fields to the table."+NL+"Check write permission.",
'    " Can't add bearing")
'    return nil
'  End
'Else
'  MsgBox.Error("Can't modify the feature table."+NL+
'  "Check write permission.","Can't add bearing")
'  return nil
'End
''Check if field named "Bearing" exists
    Dim fldName As String
88: If gBr.radAz.Value Then
89:     fldName = "SDMAzimuth"
90: ElseIf gBr.radBr.Value Then
91:     fldName = "SDMBearing"
92: End If
'bearing_exists = (themeVTab.FindField("Bearing") <> nil)
Dim bearing_exists As Boolean
95: bearing_exists = theTheme.FeatureClass.FindField(fldName) > -1
'If (bearing_exists) Then
97: If bearing_exists Then
'  if (MsgBox.YesNo("Overwrite existing field?",
'  "Bearing field already exists", false)) then
100:     If MsgBox("Overwrite existing field? " & fldName, vbYesNo, c_sModuleFileName) = vbYes Then
'    'if ok to overwrite, delete the field as it may not be defined
'    'as required by this script (eg., created from another script).
'    If (bearing_exists) Then
104:         If bearing_exists Then
'      themeVTab.RemoveFields({themeVTab.FindField("Bearing")})
                 Dim dfld As esrigeodatabase.IField
107:             Set dfld = theTheme.FeatureClass.Fields.Field(theTheme.FeatureClass.FindField(fldName))
108:             theTheme.FeatureClass.DeleteField dfld
'    End
110:         End If
'  Else
112:     Else
'    return nil
            Exit Sub
'  End  'if (MsgBox...)
116:     End If
'End  'if
118: End If 'if brg field exists
'bField = Field.Make ("Bearing",#FIELD_Long,4,0)
Dim bField As Variant
121: bField = Array(fldName, esriFieldTypeInteger, 4, 0, fldName, False)
Dim fldsdesc As New SDMUtilities.SDMList
123: fldsdesc.AddArray Array(bField)
'themeVTab.AddFields({bField})
125: WOETableUtils.AddFields themeVTab, fldsdesc
''loop over the polylines
'For Each r In themeVTab
Dim fcurs As IFeatureCursor
129: Set fcurs = theTheme.FeatureClass.Update(Nothing, False)
Dim r As IFeature
131: Set r = fcurs.NextFeature
Dim nNullLines As Long
133: nNullLines = 0
Dim pProgbar As IStepProgressor
135: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
136: pProgbar.Position = 0
137: SDMGlobals.SDMStatusBar.ShowProgressBar "Adding " & fldName, 1, theTheme.FeatureClass.FeatureCount(Nothing), 1, True
138: Do While Not r Is Nothing
139:     If r.Shape.IsEmpty Then GoTo nextR
'  'Get line end-point coordinates
'>>>>>>>>>>>> Section below replaced with another algorithm
'  nextLine = themeVTab.ReturnValue(shapeField, r).asList
'  linestartX = nextLine.Get(0).Get(0).GetX
'  linestartY = nextLine.Get(0).Get(0).GetY
'  n = nextLine.Get(0).Count - 1
'  lineendX = nextLine.Get(0).Get(n).GetX
'  lineendY = nextLine.Get(0).Get(n).GetY
'  dx = lineendX - linestartX
'  dy = lineendY - linestartY
'  ' work out the bearing
'  'if (brng) then
'    If (dx = 0) Then
'      If (dy > 0) Then
'        bearing = 0
'      Else
'        bearing = 180
'      End
'    'elseif (dy=0) then
'    Else
'      t=(dy/dx).ATan.asDegrees
'      If (dx > 0) Then
'        bearing = 90 - t
'      Else
'        bearing = 270 - t
'      End
'    End
'    themeVTab.SetValueNumber(bField,r,bearing.Round)
'  'else
'  'end
'End
'>>>>>>>>>>>>>>>>>>> End of Section replaced
'>>>> The azimuth of a multipoint line is the
'>>>>> geometrical mean of length-wtd azimuths of its segments
'>>>>> the segments are assumed to be well behaved:
'>>>>> connected segments diverge at less than acute angles
'>>>>> the line does not intersect itself
'>>>>> the line does not represent a significant part of a closed arc
'>>>>> this algorithm calculates the map azimuth, not the geodetic azimuth.
         Dim pntColl As IPointCollection
180:     Set pntColl = r.Shape
         Dim nvtx As Long
         Dim segm As ILine
183:     Set segm = New esriGeometry.Line
         Dim totlen As Double
185:     totlen = 0
         Dim totWtdAngl As Double
187:     totWtdAngl = 0
'>>>>>  What about a line porpoising about angle = 180/-180
        Dim PI As Double
190:         PI = 4# * Atn(1#)
191:     For nvtx = 1 To pntColl.PointCount - 1
             Dim fromVtx As IPoint
193:         Set fromVtx = pntColl.Point(nvtx - 1)
             Dim toVtx As IPoint
195:         Set toVtx = pntColl.Point(nvtx)
196:         segm.FromPoint = fromVtx
197:         segm.ToPoint = toVtx
198:         If Not segm.IsClosed Then
                 Dim segAngl As Double
200:             segAngl = segm.Angle * 180 / PI
                 Dim seglen As Double
202:             seglen = segm.Length
203:             totlen = totlen + seglen
204:             totWtdAngl = totWtdAngl + seglen * segAngl
205:         End If
206:     Next nvtx
         Dim angl As Double
208:     If totlen > 0 Then
209:         angl = totWtdAngl / totlen
'Transform angl to azimuth/bearing coord system
             Dim tangl As Double
212:         tangl = 90 - angl
213:         If gBr.radBr.Value Then
                 Dim brg As Double
215:             If tangl >= 90 Then
216:                 brg = tangl - 180
217:             ElseIf tangl < -90 Then
218:                 brg = tangl + 180
219:             Else
220:                 brg = tangl
221:             End If
222:             r.Value(theTheme.FeatureClass.FindField(fldName)) = Fix(brg)
223:        ElseIf gBr.radAz.Value Then
                Dim azm As Double
225:            azm = tangl
226:            If tangl < 0 Then
227:                azm = 180 + azm
228:            Else
229:                azm = tangl
230:            End If
231:            r.Value(theTheme.FeatureClass.FindField(fldName)) = Fix(azm)
232:        End If
233:     Else
234:        r.Value(theTheme.FeatureClass.FindField(fldName)) = -9999
235:        nNullLines = nNullLines + 1
236:     End If
237:     fcurs.UpdateFeature r
nextR:
239:     Set r = fcurs.NextFeature
240:     SDMGlobals.SDMStatusBar.StepProgressBar
241: Loop
242: SDMGlobals.SDMStatusBar.HideProgressBar
''Return editing state to pre-script running state
'themeVTab.SetEditable (edit_state)
245: FeatureUtils.stopEditing pWksEdit
'diag.Close
247: If nNullLines > 0 Then MsgBox "Some Null Lines given " & fldName & " = -9999"
248: gBr.Hide
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub





