VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcLR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcLR"
Const c_sDLLFileName As String = "CalculateLogisticRegr"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcLR(Self As Variant) As Boolean
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.CalcLR
'' Topics:  Spatial Data Modeller
''
'' Description:  "Top level" script that runs the
''          scripts that write files for logistic
''          regression, runs the executable and
''          reads the results into ArcView tables.
''
'' Requires: sdmlr.exe to be in the Ext32 directory.
''
'' Self:    0 -- lstsUC -- the contents of the unique conditions table
''          1 -- lstsFreeMC -- list of free multi-class themes
''          2 -- lstMD -- list of missing data values for each theme
''          3 -- listWeightedAvgs -- list of the calculated mean, weighted by
''                                   area to be used for areas of missing data
''          4 -- unitCell -- the unit cell area in square km
''          5 -- thmUC -- the unique conditions theme
''
'' Returns: True = processing completed; False if not
'
''==============================================
''
37:   Load gLThmuc 'Initialize SDMGlobals
38:   ProgressAnimation.Show "Calculation Logistic Regression..."

'lstsUC = Self.Get(0)
Dim lstsUC As SDMUtilities.SDMList
42: Set lstsUC = Self(0)
'lstsFreeMC = Self.Get(1)
Dim lstsFreeMC As SDMUtilities.SDMList
45: Set lstsFreeMC = Self(1)
'lstMD = Self.Get(2)
Dim lstMD As SDMUtilities.SDMList
48: Set lstMD = Self(2)
'MsgBox ListUtils.ListtoString(lstMD), , "lstMD"
'listWeightedAvgs = Self.Get(3)
Dim listWeightedAvgs As SDMUtilities.SDMList
52: Set listWeightedAvgs = Self(3)
'MsgBox ListUtils.ListtoString(listWeightedAvgs), , "listWeightedAvgs"
'unitcell = Self.Get(4)
Dim unitcell As Double
56: unitcell = Self(4)
'thmUC = Self.Get(5)
Dim thmUC As IRasterLayer
59: Set thmUC = Self(5)
Dim gL As Form
61: Set gL = Self(6)
''Calculate logistic regression
''-------------------------------------------------
'res = av.Run("gSDI.WriteLRFiles",{lstsUC,lstsFreeMC,lstMD,listWeightedAvgs,unitCell,thmUC})
Dim gSDIWriteLRFiles As gSDI_WriteLRFiles
66: Set gSDIWriteLRFiles = New gSDI_WriteLRFiles
Dim res As Variant
68: res = gSDIWriteLRFiles.gSDI_WriteLRFiles(Array(lstsUC, lstsFreeMC, lstMD, listWeightedAvgs, unitcell, thmUC, gL))
69: If UBound(res) = -1 Then
70:     gSDI_CalcLR = False
         Exit Function
72: End If
'fCase = res.Get(0)
Dim fCase As String
fCase = res(0)
'nmbET = res.Get(1)
Dim nmbET As Long
78: nmbET = res(1)
'dirTmp = fCase.GetFileName.ReturnDir
Dim dirTmp As String
81: dirTmp = FileDialog.getDir(fCase)
'dirPrg = "$AVEXT".AsFileName
Dim dirPrg As String
84: dirPrg = WOETableUtils.GetTmpDir
''Run LR code
''-------------------------------------------------
'run = av.Run("gSDI.RunLRCode",{dirTmp,dirPrg})
Dim gSDIRunLRCode As gSDI_RunLRCode
89: Set gSDIRunLRCode = New gSDI_RunLRCode
Dim Run As Boolean
91: Run = gSDIRunLRCode.gSDI_RunLRCode(Array(dirTmp, dirPrg))
'If (Run = Nil) Then
93: If Not Run Then
'  return Nil
95:     gSDI_CalcLR = False
        Exit Function
'End
98: End If
'' Wait for processing

'vtbUC = av.Run("gSDI.GetVTab",{thmUC})
Dim pds As IDataset
103: Set pds = thmUC
Dim vtbUC As ITable
105: Set vtbUC = RasterUtils.GetTable(thmUC)
'If (vtbUC = Nil) Then
107: If vtbUC Is Nothing Then
'  MsgBox.Error("Error accessing attributes of unique conditions grid.","Unique Conditions")
109:     MsgBox "Error accessing attributes of unique conditions grid.", vbCritical, "Unique Conditions"
'  return Nil
111:     gSDI_CalcLR = False
    Exit Function
'End
114: End If
''nmbRecs = vtbUC.GetNumRecords
''
''i = 0
''n = nmbRecs * nmbET * 30
''n = n max 5000
''
''for each i in 0..n
''  progress = (i/n) * 100
''  doMore = av.SetStatus( progress )
''  if (not doMore) then
''    brea
''  end
''end

''Read results from LR code
''-------------------------------------------------
'av.Run("gSDI.ReadLRresults",{dirTmp,vtbUC,thmUC.GetObjectTag})
Dim gSDIReadLRresults As gSDI_ReadLRResults
133: Set gSDIReadLRresults = New gSDI_ReadLRResults
134: gSDI_CalcLR = gSDIReadLRresults.gSDI_ReadLRResults(Array(dirTmp, vtbUC, gL.Thmuc_getObjectTag, thmUC))
    'MsgBox thmUC.Name & " has joins: " & WOETableUtils.hasJoins(thmUC), , c_sModuleFileName
'return True
137: ProgressAnimation.Hide
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
    HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
142:     gSDI_CalcLR = False
End Function
