VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcOdds"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcOdds.cls"
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcOdds(ByRef Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler


'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI_CalcOdds
''
''
''Topics:  Spatial Data Modeller
''
''Description:  Calculates the weights of evidence for a single evidential theme.
''
''Requires:  The number of points located withing the evidential theme
'' class, the total number of points, the area of the evidential theme class, and the
''  total area.
''
'' Self:  List.  Run from gSDI.CalcThemeWeights
''
''Returns:  List of statistics:  W+, s(W+), W-, s(W-), Contrast, s(C), stud(C)
''==============================================
'
33: Set gSDI_CalcOdds = New SDMList
'db = Self.Get(0)        'deposits in class
    Dim db As Double
36: db = CDbl(Self(0))
'ds = Self.Get(1)        'total deposits
    Dim ds As Double
39: ds = CDbl(Self(1))
'If ((db = 0) Or (db = ds)) Then
41: If ((db = 0) Or (db = ds)) Then
'  nullNum = Number.MakeNull
        Dim nullNum As Variant
44:     nullNum = Null
'  statsList = {nullNum,nullNum,nullNum,nullNum,nullNum,nullNum,nullNum}
46:     gSDI_CalcOdds.AddArray Array(nullNum, nullNum, nullNum, nullNum, nullNum, nullNum, nullNum)
'  return statsList
    Exit Function
'End
50: End If
'b = Self.Get(2)    'unit cell area of class
    Dim b As Double
53: b = CDbl(Self(2))     'area of class in unit area dimensions
's = Self.Get(3)    'total unit area of theme (less areas of missing data)
    Dim s As Double
56: s = CDbl(Self(3))     'total area of study area in unit area dimensions, etc
'Parameters = av.FindDialog("gParam")
    Dim anlprms As AnalysisParameters.AnlParams
59: Set anlprms = New AnalysisParameters.AnlParams
    Dim Parameters As Form
61: Set Parameters = anlprms.gParamfrm
'gPUA = av.FindDialog("gPUA")
    Dim gPUA As Form
64: Set gPUA = anlprms.gPUAFrm
'asymptote = gPUA.findByName("radAsy").IsSelected
    Dim asymptote As Boolean
'asymptote = gPUA.radAsy
68: asymptote = gPUA.radasy.Value
'If (s = Nil) Then
70: If (s = 0) Then
'  return "NoArea"
72:     gSDI_CalcOdds.Add "NoArea"
    Exit Function
'End
75: End If

'statsList = List.Make
''CALCULATE W+
''-------------

'pbd = db / ds
    Dim pbd As Double
83: pbd = db / ds
'If (asymptote) Then
85: If (asymptote) Then
'  pbdb = (b / s)
        Dim pbdb As Double
88:     pbdb = b / s
'elseif ((asymptote).Not) then
90: ElseIf (Not asymptote) Then
'  pbdb = (b - db) / (s - ds)
92:     pbdb = (b - db) / (s - ds)
'End
94: End If
'ls = pbd / pbdb
    Dim ls As Double
97: ls = pbd / pbdb
'If (ls <= 0) Then
99: If (ls <= 0) Then
'  MsgBox.Warning("The unit area parameter is too large to calculate "+Nl+
'                 "the positive weights for all classes.","Analysis Parameters")
102:   MsgBox "The unit area parameter is too large to calculate " & vbCrLf & _
                 "the positive weights for all classes.", vbCritical, "gSDI_CalcOdds"
104:        gSDI_CalcOdds.Add "NoArea"
       Exit Function
'End
107: End If
'wp = ls.Ln
     Dim wp As Double
110: wp = Log(ls)
'statsList.Add (wp)
112: gSDI_CalcOdds.Add wp

''CALCULATE STANDARD DEVIATION OF W+
''----------------------------------

'vp = (1 / db) + (1 / (b - db))
     Dim vp As Double
119: vp = (1 / db) + (1 / (b - db))
'swp = vp.Sqrt
     Dim swp As Double
122: swp = Sqr(vp)
'statsList.Add (swp)
124: gSDI_CalcOdds.Add swp

''CALCULATE W-
''-----------------

'b1 = (ds - db) / ds
     Dim b1 As Double
131: b1 = (ds - db) / ds
'If (asymptote) Then
133: If asymptote Then
'  b2 = (s - b) / s
         Dim b2 As Double
136:     b2 = (s - b) / s
'elseif ((asymptote).Not) then
138: ElseIf Not asymptote Then
'  b2 = (s - b - ds + db) / (s - ds)
'140:     b2 = (s - b - ds + db) / (s - ds)
140:     b2 = 1# - ((b - db) / (s - ds)) 'Numerically better
'End
142: End If
'''Kluge to handle division by zero and logarithm of negative number
143: If b2 > 0 Then
'lm = b1 / b2
         Dim lm As Double
146:     lm = b1 / b2
'wm = lm.Ln
         Dim wm As Double
149:     wm = Log(lm)
'statsList.Add (wm)

''CALCULATE STANDARD DEVIATION OF W-
''------------------------------------

'vm = (1 / (ds - db)) + (1 / (s - b - ds + db))
         Dim vm As Double
157:     vm = (1 / (ds - db)) + (1 / (s - b - ds + db))
'swm = vm.Sqrt
         Dim swm As Double
160:     swm = Sqr(vm)
'statsList.Add (swm)
162:    gSDI_CalcOdds.Add wm
163:    gSDI_CalcOdds.Add swm

''CALCULATE CONTRAST
''-----------------

'c = wp - wm
        Dim c As Double
170:    c = wp - wm
'statsList.Add (c)
172:    gSDI_CalcOdds.Add c

''CALCULATE STUDENTIZED CONTRAST (C/s(C))
''---------------------------------------

'sc = (vp + vm).Sqrt
        Dim sc As Double
179:    sc = Sqr(vp + vm)
'statsList.Add (sc)
181:    gSDI_CalcOdds.Add sc
'stud = c / sc
        Dim stud As Double
184:    stud = c / sc
'statsList.Add (stud)
186:    gSDI_CalcOdds.Add stud
187: Else
188:     MsgBox "Error: Check weights table row with W- = -9.999999999 ", vbCritical, "Calculating Odds"
189:     gSDI_CalcOdds.Add -9.999999999
190:     gSDI_CalcOdds.Add 0#
191:     gSDI_CalcOdds.Add 0#
192:     gSDI_CalcOdds.Add 0#
193:     gSDI_CalcOdds.Add 0#
194: End If
'return statsList

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  Exit Function
ErrorHandler:
     HandleError True, "gSDI_CalcOdds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
201: gSDI_CalcOdds.Clear
202: gSDI_CalcOdds.Add "Error"
End Function

