VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcRxyLists"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcRxyLists"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcRxyLists(Self As Variant) As Variant
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
''
'' Name:  gSDI.CalcRxyLists
''
'' Topics:  Spatial Data Modeller Extension
''
'' Description:  Takes two list of ranks (assumed to be
''               integers from 1 to n, incremented by 1) and
''               The lists have the same number of elements,
''               with each pair of corresponding elements (
''               having the same position in the lists)
''               corresponding to the same area.  Ranks do
''               not have to be unqiue in the list.
''
''
'
'' Requires:
'' Self:  Two lists of rank values, integers from
''               1 to n, incremented by 1, each pair of ranks
''               corresponding to an area in a third list of
''               areas.
''
''
''
'' Returns:  List containing:
''           a list of two lists, each containing the calculated
''           R values for each rank
''           a list of two values, each the mean R value for
''           the for each list of R values
''==============================================
'
'X = 0
    Dim X As Long
48: X = 0
'Y = 1
    Dim Y As Long
51: Y = 1
'' Get arguments...
''----------------------------------------------

'lstMapXY = Self.Get(0)    ' list of two lists of values from two variables
    Dim lstMapXY As SDMUtilities.SDMList
57: Set lstMapXY = Self(0)
'lstAreas = Self.Get(1)    ' areas associated with each pair of measures
    Dim lstAreas As SDMUtilities.SDMList
60: Set lstAreas = Self(1)
'' Initialize list to hold lists of Rxy values
''----------------------------------------------
'lstRxy = {{},{}}
    Dim lstRxy As New SDMUtilities.SDMList
65: lstRxy.AddArray Array(New SDMList, New SDMList)
'lstAxy = {{},{}}
    Dim lstAxy As New SDMUtilities.SDMList
68: lstAxy.AddArray Array(New SDMList, New SDMList)
'' Create list of unique values from list of all values
'' then add list element to lstRxy list.
''----------------------------------------------
'for each i in X..Y
    Dim i As Long
74: For i = X To Y
'  cnt = lstMapXY.Get(i).Clone
    Dim cntlst As SDMList
77:     Set cntlst = lstMapXY.Clone
'  cnt.RemoveDuplicates
79:     Set cntlst = cntlst.RemoveDuplicates
'  cnt = cnt.Count
    Dim cnt As Long
82:     cnt = cntlst.Count
'End
84: Next i
''Initialize list to hold mean Rxy values
''----------------------------------------------
'meanRxy = {}
    Dim meanRxy As New SDMUtilities.SDMList
'for each i in X..Y
90: For i = X To Y
'  lstR = lstRxy.Get(i)
        Dim lstR As SDMList
93:     Set lstR = lstRxy.getObj(i)
'  lstA = lstAxy.Get(i)
        Dim lstA As SDMList
96:     Set lstA = lstAxy.getObj(i)
'  lstMap = lstMapXY.Get(i)
        Dim lstMap As SDMList
99:     Set lstMap = lstMapXY.getObj(i)
'  cntI = 0
        Dim cntI As Long
102:     cntI = 0
'  ' !!!!assumes that the values are continuous ranked integers
'  ' changing this now
'  '----------------------------------------------
'  For Each Rank In lstMap
        Dim Rank As Variant
108:     For Each Rank In lstMap.list
'    idxR = lstR.FindByValue(Rank)
        Dim idxR As Long
111:         idxR = lstR.FindByValue(CDbl(Rank))
'    If (idxR < 0) Then
113:         If idxR < 0 Then
'      lstR.Add (Rank)
115:             lstR.Add Rank
'      lstA.Add (lstAreas.Get(cntI))
117:             lstA.Add lstAreas.GetVal(cntI)
'    Else
119:         Else
'      lstA.Set(idxR,lstA.Get(idxR) + lstAreas.Get(cntI))
121:             lstA.SetIt idxR, lstA.GetVal(idxR) + lstAreas.GetVal(cntI)
'    End
123:         End If
'    'lstR.Set(rank - 1,(lstR.Get(rank - 1) + lstAreas.Get(cntI)))
'    cntI = cntI + 1
126:         cntI = cntI + 1
'  End
128:     Next Rank
'  ' Divide each value in the list by 2
'  for each cntJ in 0..(lstR.Count - 1)
         Dim cntJ As Long
132:     For cntJ = 0 To lstR.Count - 1
'    lstA.Set(cntJ,lstA.Get(cntJ) / 2)
134:         lstA.SetIt cntJ, lstA.GetVal(cntJ) / 2
'  End
136:     Next cntJ
'  ' For each element in the list from last to first,
'  ' add the sum of all values preceding it (multiplied by
'  ' two to 'restore' the values)
'  '----------------------------------------------
'  for each cntJ in (lstR.Count - 1)..1
142:     For cntJ = lstR.Count - 1 To 1 Step -1
'    for each cntL in 0..(cntJ - 1)
             Dim cntL As Long
145:         For cntL = 0 To cntJ - 1
'      lstA.Set(cntJ,lstA.Get(cntJ) + (lstA.Get(cntL) * 2))
147:             lstA.SetIt cntJ, lstA.GetVal(cntJ) + (lstA.GetVal(cntL) * 2)
'    End
149:        Next cntL
'  End
151:     Next cntJ
'  ' Calculate the average of the final values in the list
'  '----------------------------------------------
'  Sum = 0
         Dim sum As Long
156:     sum = 0
'  For Each r In lstA
         Dim r As Variant
159:     For Each r In lstA.list
'    Sum = Sum + r
161:         sum = sum + CDbl(r)
'  End
163:     Next r
'  meanRxy.Add (Sum / lstA.Count)
165:     meanRxy.Add sum / lstA.Count
'End
167: Next i

'' return lstRxy which contains two lists of values as calculated above
'' and meanRxy which contains the average value for each list
''----------------------------------------------

'return {lstRxy,lstAxy,meanRxy}
     Dim tmplst As New SDMList
174: tmplst.AddArray Array(lstRxy, lstAxy, meanRxy)
175: Set gSDI_CalcRxyLists = tmplst
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function
