VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcStudyArea"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcStudyArea"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcStudyArea(Self As Variant) As Variant
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.CalcStudyArea
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Gets the analysis mask
''          for the active view document'
''          Calculates and returns its
''          area.
''
'' Requires: That an integer grid theme be
''          set as the analysis mask for
''          a View's analysis environment.
''
'' Self:  0 -- viewA -- active view document
''
'' Returns: sa -- study area in square kilometres (number)
''==============================================
''
'viewA = Self.Get(0)
Dim AnlParms As AnalysisParameters.AnlParams
35: Set AnlParms = New AnalysisParameters.AnlParams
Dim gParam As Form
37: Set gParam = AnlParms.gParamFrm

'thmSA = av.Run("gSDI.GetMask",{viewA})
Dim thmSA As IRasterLayer
41: Set thmSA = WOETableUtils.FindLayerByName(gParam.cbxSA.Text)
'If (thmSA = Nil) Then
43: If thmSA Is Nothing Then
'  return "No Study Area theme set for the active View."
45:     MsgBox "No Study Area theme set for the active View.", vbCritical, c_sModuleFileName
46:     gSDI_CalcStudyArea = Null
        Exit Function
'End
49: End If

'vTabSA = av.Run("gSDI.GetVTab",{thmSA})
    Dim gSDIGetVTab As gSDI_GetVTab
53: Set gSDIGetVTab = New gSDI_GetVTab
    Dim vTabSA As ITable
55: Set vTabSA = gSDIGetVTab.gSDI_GetVTab(thmSA)
'If (vTabSA = Nil) Then
'  return "Unable to access study area theme attributes."
'End
59: If vTabSA Is Nothing Then
60:     Set gSDI_CalcStudyArea = Nothing
        Exit Function
62: End If
'grdSA = thmSA.GetGrid
Dim rasprops As IRasterProps
65: Set rasprops = thmSA.Raster
'fldCnt = vTabSA.FindField("Count")
Dim fldCnt As Long
68: fldCnt = vTabSA.FindField("Count")
'If (fldCnt = Nil) Then
'  return "No 'Count' field found in attribute table of Mask Theme"
'End
'sumCells = 0
Dim sumcells As Double
74: sumcells = 0
'For Each r In vTabSA
Dim curs As ICursor
77: Set curs = vTabSA.Search(Nothing, False)
Dim rw As IRow
79: Set rw = curs.NextRow
80: While Not rw Is Nothing
'  v = vTabSA.ReturnValue(fldCnt, r)
    Dim v As Double
83:     v = rw.Value(fldCnt)
'  If (v <> Number.MakeNull) Then
'    sumCells = sumCells + v
86:     sumcells = sumcells + v
'  End
'End
89: Set rw = curs.NextRow
90: Wend
'sa = (sumCells * grdSA.GetCellSize * grdSA.GetCellSize)
Dim sa As Double
93: sa = (sumcells * rasprops.MeanCellSize.X * rasprops.MeanCellSize.Y)
'return sa
95: gSDI_CalcStudyArea = sa
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
100:   gSDI_CalcStudyArea = Null
End Function
