VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcThemeWgts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcThemeWeights"
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcThemeWeights(ByRef argList As SDMList) As SDMList
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.CalcThemeWeights
''
''Topics:  Spatial Data Modeller
''
''Description:  For either an integer grid or polygon feature theme,
'' calculates a series of weights statistics for each class in a speciifed field
'' in the input theme, and writes these statistics to a table.  Optionally writes
'' the analysis parameters, and the results to a text file.  The following are
'' calculated for each class in the input theme:  area in sq. km, area in units,
'' number of points in class, W+, W- and contrast, and their standard deviations;
'' studentized contrast (contrast divided by its standard deviation).
'' Runs gSDI.MakeThmWgtTab to write table structure; runs gSDI.GetThmWgtVals
'' to determine the class in which each point in a set of points is located; runs
'' gSDI.CalcOdds to calculate statistics.
'' Run from
''
''Requires:  An evidential theme, with a field in its attribute table that
'' contains the class values to be analyzed.
''
'' Self:  List or arguments, when run from one of four scripts run on
'' the click event of four buttons on the 'Calculate Theme Weights' dialog.
''
''Returns:
''==============================================
'' GET INTEGER DEFINING MISSING DATA CLASS
''------------------------------------------
    Dim anlprms As AnalysisParameters.AnlParams
43: Set anlprms = New AnalysisParameters.AnlParams
'Parameters = av.FindDialog("gParam")
'gTW = av.FindDialog("gTW")
'gPUA = av.FindDialog("gPUA")
'missingTxt = gTW.findByName("txtMD").GetText
    Dim missingTxt As String
49: missingTxt = gTW.txtMD.Text
'if  (missingTxt.Is(String).Not) then
51: If (Not IsNumeric(missingTxt)) Then
'  MsgBox.Error("An integer value for missing data not found."+NL+
'               "Please ensure parameters are set.","Calculating Theme Weights")
54:     MsgBox "An integer value for missing data not found." & vbCrLf & _
               "Please ensure parameters are set.", vbCritical, "Calculating Theme Weights"
'  return Nil
57:     Set gSDI_CalcThemeWeights = Nothing
        Exit Function
'ElseIf (missingTxt.IsNumber) Then
60: ElseIf (IsNumeric(missingTxt)) Then
'  missing = missingTxt.AsNumber
        Dim missing As Long
63:     missing = CLng(missingTxt)
'Else
65: Else
'  MsgBox.Error("An integer value for missing data not found."+NL+
'               "Please ensure parameters are set.","Calculating Theme Weights")
68:     MsgBox "An integer value for missing data not found." & vbCrLf & _
               "Please ensure parameters are set.", vbCritical, "Calculating Theme Weights"
'  return Nil
71:     Set gSDI_CalcThemeWeights = Nothing
        Exit Function
'End
74: End If
'' GET STUDY AREA GRID NAME
''------------------------------------------
'SAName = Parameters.findByName("cbxSA").GetCurrentValue
'dim SAName as string
    Dim gParam As Form
80: Set gParam = anlprms.gParamfrm
    Dim saName As String
82: saName = gParam.cbxSA.Text
''READ ARGUMENTS...
'tabTypes = self.Get(0)          'list of table types to create
    Dim tabTypes As SDMList
86: Set tabTypes = argList.getObj(0)
'theView = self.Get(1)           'the current View document
    Dim theView As IMap
89: Set theView = argList.getObj(1)
'evidenceMap = self.Get(2)       'the evidential theme
    Dim evidenceMap As IRasterLayer
92: Set evidenceMap = argList.getObj(2)
'emField = self.Get(3)           'field containing classes
    Dim emField As IField
95: Set emField = argList.getObj(3)
'descField = self.Get(4)         'field containing class descriptors
    Dim descField As IField
98: Set descField = argList.getObj(4)
'Desc = (descField <> "<None>")    'descriptor flag
     Dim Desc As Boolean
101: Desc = (Not descField Is Nothing)
'txtFile = self.Get(5)           'write text file flag
     Dim txtFile As Boolean
104: txtFile = argList.GetVal(5)
'tmpEMGrid = self.Get(6)         'temporary evidence grid or clipped polygon theme
     Dim tmpEMGrid As IRasterLayer
107: Set tmpEMGrid = argList.getObj(6)
'wroteMD = av.Run("gSDI.WriteMissingData",{evidenceMap,missing})
     Dim gSDIWrtMsgData As gSDI_WrtMissingData
110: Set gSDIWrtMsgData = New gSDI_WrtMissingData
111: gSDIWrtMsgData.gSDI_WriteMissingData Array(evidenceMap.Name, missing)
     Dim emVTab As ITable
113: Set emVTab = argList.getObj(7)
''winList = List.Make
'
'statFile = Nil                  'text file pointer
     Dim statfile As Object
118: Set statfile = Nothing
'
'' SET DATA TYPE FLAG
''------------------------------------------
'If (evidenceMap.Is(ftheme)) Then
'  poly = True
'  tmpEMVTab = tmpEMGrid.GetFTab
'ElseIf (evidenceMap.Is(GTheme)) The
     Dim poly As Boolean
127: poly = False
''tmpEMVtab = tmpEMGrid.GetVTab
'  tmpEMVTab = av.Run("gSDI.GetVTab",{tmpEMGrid})
'End
'If (Desc) Then
     Dim fdescField As IField
'  fdescField = tmpEMVTab.FindField(descField)
'  If (fdescField = Nil) Then
'    Desc = False
'  End
'Else
150: Set fdescField = descField
'End
'148: End If
'GET VIEW DOCUMENTS' PROJECTION
'------------------------------------------
'curPrj = theView.GetProjection
     Dim curPrj As IProjection
157: Set curPrj = Nothing
''GET TRAINING POINT THEME NAME, AND FIND THEME
''------------------------------------------
'minName = Parameters.findByName("cbxTP").GetCurrentValue
     Dim minName As String
162: minName = gParam.cbxTP.Text
'if (minName.Is(String)) then
'
'  depMap = theView.FindTheme(minName)
     Dim depMap As ILayer
167: Set depMap = SDMUtil.FindLayerByName(minName)
168: If (depMap Is Nothing) Then
169:         Set depMap = Nothing
'  MsgBox.Error("Training Point theme not found.  Please make "+NL+
'               "sure the map was specified.","Training Point Theme Error")
172:         MsgBox "Training Point theme not found.  Please make " & vbCrLf & _
                   "sure the map was specified.", vbCritical, "Training Point Theme Error"
'  If (statFile <> Nil) Then
175:         If (Not statfile Is Nothing) Then
'    statFile.Close
177:             statfile.Close
'  End
179:         End If
'  return nil
181:         Set gSDI_CalcThemeWeights = Nothing
             Exit Function
'  If (depMap.Is(ftheme).Not) Then
184: ElseIf (Not TypeOf depMap Is IFeatureLayer) Then
'    MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
186:         MsgBox "The Training Point Theme must be a Feature theme.", vbCritical, "Setting Parameters"
'    If (statFile <> Nil) Then
188:         If (Not statfile Is Nothing) Then
'      statFile.Close
190:             statfile.Close
'    End
192:         End If
'    return Nil
194:         Set gSDI_CalcThemeWeights = Nothing
             Exit Function
'  End
197:     End If
'ElseIf (minName.Is(ftheme)) Then
'  depMap = minName
'
'Else
'  depMap = Nil
'  MsgBox.Error("Training Point theme not found.  Please make "+NL+
'               "sure the map was specified.","Training Point Theme Error")
'  If (statFile <> Nil) Then
'    statFile.Close
'  End
'  return nil
'End
'End If
'depFTab = depMap.GetFTab
'Dim depFTab As ITable
'Set depFTab = depMap
'shapetype = depFTab.FindField("Shape").GetType
     Dim shapetype As esriGeometryType
     Dim fdepmap As IFeatureLayer
217: Set fdepmap = depMap
218: shapetype = fdepmap.FeatureClass.shapetype
'if (shapetype <> #FIELD_SHAPEPOINT) then
220: If (shapetype <> esriGeometryPoint) Then
'  MsgBox.Error("The Training Point Theme must have a unique name.","Setting Parameters")
222:   MsgBox "The Training Point Theme must be a point theme.", vbCritical, "Setting Parameters"
'  If (statFile <> Nil) Then
224:     If (Not statfile Is Nothing) Then
'    statFile.Close
226:         statfile.Close
'  End
228:     End If
'  return Nil
230:     Set gSDI_CalcThemeWeights = Nothing
    Exit Function
'End
233: End If

''GET TRAINING POINT ATTRIBUTE TABLE...
'depFTab = depMap.GetFTab
     Dim depFTab As ITable
238: Set depFTab = depMap
''CHECK WHETHER USER SELECTED OPTION TO USE LIMITING VALUE...
''------------------------------------------
'asymptote = gPUA.FindByName("radAsy").IsSelected
     Dim gPUA As Form
243: Set gPUA = anlprms.gPUAFrm
     Dim asymptote As Boolean
245: asymptote = gPUA.radasy.Value
'if ((asymptote).Not) then
     Dim unitareastr As String
     Dim unitArea As Double 'Unit Area is sq km
249: If (Not asymptote) Then
'  'IF NOT, GET UNIT AREA...
'
'  '------------------------------------------
'  unitArea = Parameters.FindByName("txtUA").GetText
254:     unitareastr = gParam.txtUA.Text '1
'  If (unitArea = nil) Then
'    MsgBox.Error("Unable to find Unit Area.  Please make "+NL+
'                 "unit area was specified.","Unit Area Not Found")
'    If (statFile <> nil) Then
'      statFile.Close
'    End
'    return nil
'  ElseIf (unitArea.IsNumber) Then
'    unitArea = unitArea.AsNumber
264:     unitArea = CDbl(unitareastr)
'  Else
'    MsgBox.Error("Value of Unit Area is a string."+NL+
'                 "Expecting a number.","Unit Area Not Found")
'    If (statFile <> nil) Then
'      statFile.Close
'    End
'    return ni
'  End
'Else
274: Else
'  unitArea = "Limiting Value"
276:     unitareastr = "Limiting Value"
'End
278: End If
''CALL SCRIPT TO CALCULATE AREAS, DEPOSITS
''-----------------------------------
'listVals = av.Run("gSDI.GetThmWgtVals",{tmpEMGrid,emField,depFTab,curPrj,evidenceMap,descField})
     Dim gSDIGetThmWgtVals As gSDI_GetThmWgtVals
283: Set gSDIGetThmWgtVals = New gSDI_GetThmWgtVals
     Dim args As New SDMList
285: With args
286:     .Clear
287:     .Add tmpEMGrid
288:     .Add emField
289:     .Add depFTab
290:     .Add curPrj
291:     .Add evidenceMap
292:     .Add descField
293: End With
     Dim listVals As SDMList
295: Set listVals = gSDIGetThmWgtVals.gSDI_GetThmWgtVals(args)
'If (listVals = "FldNotFnd") Then
297: If (listVals Is Nothing) Then
'  MsgBox.Error("Either the field VALUE or COUNT could not be "+NL+
'               "found in "+tmpEMGrid.AsString+"'s VTab.","Evidential Theme Error")
300:     MsgBox "The attribute table could not be opened " & vbCrLf & _
               "for " & tmpEMGrid.Name, vbCritical, "Evidential Theme Error"
'  If (statFile <> nil) Then
'    statFile.Close
'  End
'  return nil
306:     Set gSDI_CalcThemeWeights = Nothing
         Exit Function
'End
309: End If
'av.ShowMsg ("Calculating weights for " + evidenceMap.GetName + "...")
311: ProgressAnimation.Show "Calculating weights for " & evidenceMap.Name & "..."
'
'GET RETURNED VALUES/LISTS OF VALUES
'------------------------------------------
'classList = listVals.Gett(0)       'list of classes (ascending order, with missing data val list)
     Dim classList As SDMList
317: Set classList = listVals.getObj(0)
'MsgBox ListtoString(classList), , "classList"
'sumCntList = listVals.Get(1)      'corresponding list of areas (vector) or cell counts (raster)
     Dim sumCntList As SDMDictionary
320: Set sumCntList = listVals.getObj(1)
'MsgBox sumCntList.AsString, , "sumCntList"
'pntCountList = listVals.Get(2)     'corresponding list of training points in class
     Dim pntCountList As SDMList
324: Set pntCountList = listVals.getObj(2)
'MsgBox pntCountList.AsString, , "pntCountList"
'totDeposits = listVals.Get(3)     'total number of training points (excludes those in missing data area)
     Dim totDeposits As Long
328: totDeposits = listVals.GetVal(3)
'totAreak = listVals.Get(4)        'total area in km (exludes areas of missing data)
     Dim totAreakm As Double
331: totAreakm = listVals.GetVal(4)
'descList = listVals.Get(5)        'list of class descriptors
     Dim descList As SDMList
334: Set descList = listVals.getObj(5)
'MsgBox descList.AsString, , "Arg descList"
     Dim descDict As New SDMDictionary
337: Set descDict = listVals.getObj(6)
'If (asymptote.Not) Then
     Dim totArea As Long
340: If (Not asymptote) Then
''CONVERT AREA IN KM TO AREA UNITS...
'  totArea = totAreak / unitArea
343:     totArea = Round(totAreakm / unitArea)
'Else
345: Else
'  totArea = totAreak
347:     totArea = Round(totAreakm)
'End
349: End If

'' FOR EACH TABLE TYPE IN LIST
''------------------------------------------
'For Each tabtype In tabtypes
     Dim tabtype As Variant
355: For Each tabtype In tabTypes.list
'  'IF TEXT FILE OPTION SELECTED, CREATE...
'  '------------------------------------------
'  If ((txtFile) And (((tabtypes.Count > 1) And (tabtype = "CaT")) Or (tabtypes.Count = 1))) Then
359:     If ((txtFile) And (((tabTypes.Count > 1) And (tabtype = "Cat")) Or _
             (tabTypes.Count = 1))) Then
'    eMapName = evidenceMap.GetName
             Dim emapname As String
363:         emapname = evidenceMap.Name
'    badCharList = {" ","\","/","|","?","<",">",":","*"}
'    For Each bc In badCharList
'      eMapName = eMapName.Substitute(bc, "_")
'    End
'    'dir = FileName.GetCWD.AsString
'    statFileName = FileDialog.Put((eMapName+".txt").AsFileName,"*.txt","Save Text File for Weights")
            Dim suffix As String
371:        suffix = UCase(Right(tabTypes.GetVal(0), 1))
            Select Case suffix
                Case "U": suffix = "_CD"
                Case "D": suffix = "_CA"
                Case "T": suffix = "_CT"
                Case Else: suffix = "_CX"
377:         End Select
             Dim statFilename As String
379:         statFilename = SDMGlobals.SDMWorkspace.PathName & "\" & emapname & suffix & ".txt"
380:         If (statFilename = "") Then
'      txtFile = False
382:             txtFile = False
'    Else
384:         Else
'      statfile = LineFile.Make(statFileName,#FILE_PERM_WRITE)
                 Dim fs As Object
387:             Set fs = SDMGlobals.SDMStatFile
388:             Set statfile = fs.CreateTextFile(statFilename, True)
'    End
390:         End If
'  End
392:     End If
''GET NAME OF EVIDENTIAL THEME, CALL SCRIPT TO MAKE THE TABLE/DBASE FILE
''------------------------------------------
'  eMapName = evidenceMap.GetName
396: emapname = evidenceMap.Name
'  theVTab = av.Run("gSDI.MakeThmWgtTab",{tabtype,eMapName,emField,fdescField,desc})
398: With args
399:     .Clear
400:     .Add tabtype
401:     .Add emapname
402:     .Add emField
403:     .Add fdescField
404:     .Add Desc
405: End With
     Dim gSDIMakeThmWgtTab As gSDI_MakeThmWgtTab
407: Set gSDIMakeThmWgtTab = New gSDI_MakeThmWgtTab
     Dim result As Collection
409: Set result = gSDIMakeThmWgtTab.gSDI_MakeThmWgtTab(args)
'  If (theVtab = "Cancel") Then
411:     If (result(1) = "Cancel") Then
'    MsgBox.Info("The creation of the Weights of Evidence"+NL+
'                "Table for "+eMapName+" was cancelled.","Cancel")
414:         MsgBox "The creation of the Weights of Evidence" & vbCrLf & _
                "Table for " + emapname + " was cancelled.", , "Cancel"
'    If (statFile <> nil) Then
417:         If (Not statfile Is Nothing) Then
'      statFile.Close
419:             statfile.Close
'    End
421:         End If
'    return "Cancel"
423:         Set gSDI_CalcThemeWeights = Nothing
             Exit Function
'  Else
        
'    If ((theVtab = "Nofield") Or (theVtab = "Nofields")) Then
428:     ElseIf ((result(1) = "Nofield") Or (result(1) = "Nofields")) Then
'      MsgBox.Error("Not able to add fields to VTab for "+NL+
'                   eMapName+".  Returning.","Processing cancelled.")
431:         MsgBox "Not able to add fields to VTab for " & vbCrLf & _
                   emapname & ".  Returning.", , "Processing cancelled."
'    If (statFile <> nil) Then
434:         If (Not statfile Is Nothing) Then
'      statFile.Close
436:             statfile.Close
'    End
438:         End If
'      return nil
440:         Set gSDI_CalcThemeWeights = Nothing
             Exit Function
'    End
'  End
444:     ElseIf (result(1) = "Exists") Then
445:         MsgBox "Table exists: Delete it!", vbCritical, "Processing cancelled"
446:     Else
        'Assign the new StandAlone table of weights
             Dim theVTab As ITable
449:         Set theVTab = result(2)

451:     End If

' If (txtFile) Then
454: If (txtFile) Then
'    If ((txtFile) And ((tabtypes.Count > 1) And (tabtype = "CaT")) Or (tabtypes.Count = 1)) Then
456:     If ((txtFile) And ((tabTypes.Count > 1) And (tabtype = "Cat")) Or (tabTypes.Count = 1)) Then
'      'IF TEXT FILE OPTION AND IS FIRST OR ONLY TABLE...
'      ' GET THE PRIOR PROBABILITY AND ITS STANDARD DEVIATION FROM THE DIALOG
'      '------------------------------------------
'      priorList = av.FindDialog("gTW").findByName("txt_Prip").GetLabel.AsTokens(" (")
             Dim txtPripLabel As String
462:         txtPripLabel = gTW.txt_Prip.Caption
             Dim OpenparenIdx As Integer
464:         OpenparenIdx = InStr(txtPripLabel, "(")
             Dim CloseParenidx As Integer
466:         CloseParenidx = InStr(txtPripLabel, ")")
             Dim priorList As New Collection
468:         priorList.Add Left(txtPripLabel, OpenparenIdx - 1)
469:         priorList.Add Mid(txtPripLabel, OpenparenIdx + 1, CloseParenidx - OpenparenIdx - 1) '"0.0017"
'      priorProb = priorList.Get(0)
             Dim priorProb As String
472:         priorProb = priorList(1)
'      sdPrior = priorList.Get(1)
             Dim sdPrior As String
475:         sdPrior = priorList(2)
'      sdPrior = sdPrior.Left(sdPrior.Count - 1)
477:         sdPrior = Left(sdPrior, Len(sdPrior) - 1)
'      'GET THEME FILE SOURCE
'      '------------------------------------------
'
'      If (poly) Then
482:         If (poly) Then
'          theSource = evidenceMap.GetFTab.GetSrcName.GetFileName.GetFullName
'
'      Else
486:         Else
'        theSource = evidenceMap.GetGrid.GetSrcName.GetFileName.GetFullName
                 Dim theSource As String
489:             theSource = evidenceMap.FilePath
'      End
491:         End If
'
'      'WRITE PARAMETERS TO TEXT FILE
'      '------------------------------------------
495:         statfile.Write Date & " " & Time & vbCrLf
'      statfile.writeElt(NL+"Name of evidential theme: "+TAB+TAB+evidenceMap.GetName)
497:         statfile.Write "Name of evidential theme: " & vbTab & vbTab & evidenceMap.Name & vbCrLf
'      statfile.writeElt("Theme source file:  "+TAB+TAB+TAB+theSource)
499:         statfile.Write "Theme source file:  " & vbTab & vbTab & vbTab & theSource & vbCrLf
'      If (poly) Then
501:         If (poly) Then
'
'      Else
504:         Else
                 Dim emType As String
506:             emType = "Integer Grid"
'      End
508:         End If
'      statfile.writeElt("Theme type: "+TAB+TAB+TAB+TAB+emType)
510:         statfile.Write "Theme type: " & vbTab & vbTab & vbTab & vbTab & emType & vbCrLf
'      statfile.writeElt("Field defining classes: "+TAB+TAB+emField.GetName)
512:         statfile.Write "Field defining classes: " & vbTab & vbTab & emField.Name & vbCrLf
'      If (desc) Then
514:         If (Desc) Then
'        statfile.writeElt("Field containing class descriptors: "+TAB+descField.GetName)
516:             statfile.Write "Field containing class descriptors: " & vbTab + descField.Name & vbCrLf
'      End
518:         End If
'      statfile.writeElt("Name of training point theme: "& vbtab& vbtab+depMap.GetName)
520:         statfile.Write "Name of training point theme: " & vbTab & vbTab & depMap.Name & vbCrLf
'      statfile.writeElt("Total no. of training points: "& vbtab& vbtab+totDeposits.asString)
522:         statfile.Write "Total no. of training points: " & vbTab & vbTab & totDeposits & vbCrLf
'      statfile.writeElt("Study Area Grid Theme:"& vbtab& vbtab + saName)
524:         statfile.Write "Study Area Grid Theme:" & vbTab & vbTab & vbTab + saName & vbCrLf
'      statfile.writeElt("Area of unit cell: "& vbtab& vbtab& vbtab+unitArea.asString+" sq. km(s)")
526:        statfile.Write "Area of unit cell: " & vbTab & vbTab & vbTab & unitArea & " sq. km(s)" & vbCrLf
'      statfile.writeElt("Missing data class: "& vbtab& vbtab& vbtab+missing.AsString)
528:        statfile.Write "Missing data class: " & vbTab & vbTab & vbTab & missing & vbCrLf
'      statfile.writeElt("Prior probability: "+TAB+TAB+TAB+priorProb)
530:        statfile.Write "Prior probability: " & vbTab & vbTab & vbTab & Format(priorProb, "0.0000") & vbCrLf
'      statfile.writeElt("Standard deviation of prior probability:"+TAB+sdPrior+NL)
532:        statfile.Write "Std Dev of prior probability:" & vbTab & vbTab & Format(sdPrior, "0.0000") & vbCrLf & vbCrLf
'      statfile.writeElt ("Total area " + totArea.SetFormat("d.dd").asString + "in units")
534:        statfile.Write "Total area = " & Format(totArea, "#####0") & " units" & vbCrLf
'      statfile.writeElt ("Total area " + totAreak.SetFormat("d.dd").asString + "in sq. kms" + NL)
536:        statfile.Write "Total area = " & Format(totAreakm, "#####0.0") & " sq. kms" + vbCrLf & vbCrLf
'end
538:     End If
'end
540: End If 'textfile

     Dim nclass As Integer
543: nclass = classList.Count - 1
'' GET LIST OF FIELDS IN WEIGHTS TABLE
''------------------------------------------
'  flist = theVTab.GetFields
     Dim flist As IFields
548: Set flist = theVTab.Fields
'
'  '********************************
'  'INITIALIZE HOLDERS FOR VALUES
'  areaList = list.Make
     Dim areaList As New SDMList
'  Area = 0
     Dim Area As Double
556: Area = 0
'  ucAreaList = list.Make
     Dim ucAreaList As New SDMList
'  ucArea = 0
     Dim ucArea As Long
561: ucArea = 0
'  depositList = list.Make
     Dim depositList As New SDMList
'  deposits = 0
     Dim deposits As Long
566: deposits = 0
'  If (tabtype = "Cat") Then
568: If (tabtype = "Cat") Then
'    If (txtFile) Then
570:         If (txtFile) Then
'      statfile.writeElt ("The following table is categorical")
572:             statfile.Write "The following table is categorical" & vbCrLf
'      statfile.writeElt ("Areas in units" + NL)
574:             statfile.Write "Areas in units" & vbCrLf & vbCrLf
'      If (desc) Then
576:             If (Desc) Then
                     Dim headings As String
578:                 headings = "Class" & vbTab + "Descrp." & vbTab + "Area" & vbTab + "Points" & vbTab + "W+" & vbTab + "s(W+)" & vbTab & _
                    "W-" & vbTab + "s(W-)" & vbTab + "C" & vbTab + "s(C)" & vbTab & "stud(C)"
'      Else
581:             Else
582:                 headings = "Class" & vbTab + "Area" & vbTab + "Points" & vbTab + "W+" & vbTab + "s(W+)" & vbTab & _
                    "W-" & vbTab + "s(W-)" & vbTab + "C" & vbTab + "s(C)" & vbTab & "stud(C)"
'      End
585:             End If
'      statfile.writeElt (headings)
587:             statfile.Writeline headings
'    End
589:         End If

'If (theVTab.StartEditingWithRecovery) Then
592:         If (True) Then
'  av.ShowMsg ("Calculating weights for " + evidenceMap.GetName + "...")
594:         SDMGlobals.SDMStatusBar.Message(0) = "Calculating weights for " & evidenceMap.Name & "..."
'  If (theVTab.CanAddRecord) Then
596:         If (True) Then
'    theVTab.BeginTransaction
'
'MsgBox sumCntList.AsString, , "sumCntList"
'MsgBox pntCountList.AsString, , "pntCountList"
                 Dim recvalsList As New SDMUtilities.SDMList
'    for each n in 0 .. nclass    'each class index
                 Dim n As Long
604:             For n = 0 To nclass
'
''GET CLASS, DESCRIPTOR, COUNT/AREA, # DEPOSITS
''------------------------------------------
'
    'Class = classList.Get(n)
                    Dim Clas As Long
611:                Clas = classList.GetVal(n)
'    If (desc) Then
613:                If (Desc) Then
'      descriptor = descList.Get(n)
                        Dim descriptor As Variant
'616:                 descriptor = descList.GetVal(n)
617:                    descriptor = descDict.Gett(Clas)
'    End
619:                End If
                    Dim Count As Long
621:                Count = sumCntList.Gett(Clas)
622:                deposits = pntCountList.GetVal(n)
    
'
'' CONVERT AREA TO KM, THEN UNITS, IF APPLICABLE
''------------------------------------------
'If (poly) Then
'  tmpArea = Count / 1000000
'Else
'  Area = tmpEMGrid.GetCellSize * tmpEMGrid.GetCellSize * Count / 1000000
                    Dim emProps As IRasterProps
632:                Set emProps = tmpEMGrid.Raster
633:                Area = (emProps.MeanCellSize.X) ^ 2 * Count / 1000000
'End
'
'If (asymptote) Then
637:                If (asymptote) Then
'  tmpucArea = tmparea
            'Dim tmpucArea As Double
640:                    ucArea = Round(Area)
'elseif ((asymptote).Not) then
642:                ElseIf (Not asymptote) Then
'  tmpucArea = tmparea / unitArea
644:                    ucArea = Round(Area / unitArea)
'End
646:                End If

'    MAKE A LIST OF THE VALUES, TUCK IN DESCRIPTOR IF APPLICABLE,
'    THEN WRITE VALUES TO TABLE...
650:                recvalsList.Clear
'    recvalsList = {class,area,ucArea,deposits}
652:                With recvalsList
653:                    .Add Clas
654:                    If (Desc) Then
655:                        .Add descriptor
656:                    End If
657:                    .Add Area
658:                    .Add ucArea
659:                    .Add deposits
660:                End With
'    If (desc) Then
662:                If (Desc) Then
'    recvalsList.Add (descriptor)
'           recvalsList.Insert descriptor
'    recvalsList.Shuffle(descriptor,1)
'    End
667:                End If
'    record = theVTab.AddRecord
                    Dim record As irow
670:                Set record = theVTab.CreateRow
'    i = 0
                    Dim i As Integer
673:                i = 1 'Field(0) i OID
'    For Each Val In recvalsList
                    Dim val As Variant
676:                For Each val In recvalsList.list
'    theVTab.SetValue (flist.Get(i),record,val)
678:                    record.Value(i) = val
'    i = i + 1
680:                    i = i + 1
'    End
682:                Next val
683:                record.Store
'    End  'for each n in 0 .. nclass
685:            Next n

'theVTab.EndTransaction
'saveEdits = True
'theVTab.StopEditingWithRecovery (saveEdits)
'Else
691:         Else
'MsgBox.Error("Unable to add records to "+theVTab.AsString+"."+NL+
'
'         "Please check file permissions.","Calculating Theme Weights")
'
'theVTab.StopEditingWithRecovery (True)
'
'If (statfile <> Nil) Then
699:             If (Not statfile Is Nothing) Then
'statfile.Close
701:                 statfile.Close
'End
703:             End If
'return Nil
705:             Set gSDI_CalcThemeWeights = Nothing
                 Exit Function
'End 'can add records
708:         End If
'Else
710:        Else
'MsgBox.Error("Unable to edit "+theVTab.AsString+".  Please"+NL+
'       "check file permissions.","Calculating Theme Weights")
'If (statfile <> Nil) Then
714:             If (Not statfile Is Nothing) Then
'statfile.Close
716:             statfile.Close
'End
718:             End If
'return Nil
720:             Set gSDI_CalcThemeWeights = Nothing
                 Exit Function
'End  ' can StartEditingWithRecovery
723:        End If

'*********************************************
'Elseif (tabtype = "Cud") then
726:     ElseIf tabtype = "CuD" Then 'Cumulative Descending
727:         If (tabTypes.Count > 1) Then
728:            If (txtFile) Then
729:                     statfile.Write vbCrLf & vbCrLf
730:            End If
731:         End If

733:         If (txtFile) Then
'      statfile.WriteElt ("The following table is cumulative, from lowest class to highest")
735:             statfile.Write "The following table is cumulative ascending" & vbCrLf
'      statfile.writeElt ("Areas in units" + NL)
737:             statfile.Write "Areas in units" & vbCrLf & vbCrLf
'      If (desc) Then
739:             If (Desc) Then
                'Dim headings As String
741:                 headings = "Class" & vbTab + "Descrp." & vbTab + "Area" & vbTab + "Points" & vbTab + "W+" & vbTab + "s(W+)" & vbTab & _
                    "W-" & vbTab + "s(W-)" & vbTab + "C" & vbTab + "s(C)" & vbTab & "stud(C)"
'      Else
744:             Else
745:                 headings = "Class" & vbTab + "Area" & vbTab + "Points" & vbTab + "W+" & vbTab + "s(W+)" & vbTab & _
                    "W-" & vbTab + "s(W-)" & vbTab + "C" & vbTab + "s(C)" & vbTab & "stud(C)"
'      End
748:             End If
'      statfile.writeElt (headings)
750:             statfile.Writeline headings
'    End
752:         End If

'If (theVTab.StartEditingWithRecovery) Then
755:         If (True) Then
'  av.ShowMsg ("Calculating weights for " + evidenceMap.GetName + "...")
757:            SDMGlobals.SDMStatusBar.Message(0) = "Calculating weights for " & evidenceMap.Name & "..."
'  If (theVTab.CanAddRecord) Then
759:            If (True) Then
'    theVTab.BeginTransaction
'
            'Dim recvalsList As New SDMList
'    for each n in 0 .. nclass    'each class index
            'Dim n As Long
765:            For n = 0 To nclass

    'Class = classList.Get(n)
            'Dim clas As long
769:             Clas = classList.GetVal(n)
'    If (desc) Then
771:             If (Desc) Then
'      descriptor = descList.Get(n)
                    'Dim descriptor As String
'773:                 descriptor = descList.GetVal(n)
775:                 descriptor = descDict.Gett(n)
'    End
777:             End If
            'Dim Count As Long
779:             Count = sumCntList.Gett(Clas)
                 Dim tmpdeposits As Long
781:             tmpdeposits = pntCountList.GetVal(n)
783:             If (Clas <> missing) Then
785:                 deposits = deposits + tmpdeposits
787:             End If
'
'' CONVERT AREA TO KM, THEN UNITS, IF APPLICABLE
''------------------------------------------
'If (poly) Then
'  tmpArea = Count / 1000000
'Else
'  Area = tmpEMGrid.GetCellSize * tmpEMGrid.GetCellSize * Count / 1000000
        'Dim emProps As IRasterProps
797:         Set emProps = tmpEMGrid.Raster
             Dim tmpArea As Double
799:         tmpArea = (emProps.MeanCellSize.X) ^ 2 * Count / 1000000
'End
'
803:         If (Clas <> missing) Then
804:             Area = Area + tmpArea
805:         End If

'If (asymptote) Then
808:         If asymptote Then
'  tmpucArea = tmparea
            'Dim tmpucArea As Double
                 Dim tmpucArea As Double
812:             tmpucArea = tmpArea
'elseif ((asymptote).Not) then
814:         ElseIf Not asymptote Then
'  tmpucArea = tmparea / unitArea

817:             tmpucArea = tmpArea / unitArea
'End
819:         End If
820:         If Clas <> missing Then
821:             ucArea = ucArea + tmpucArea
822:         End If
'    MAKE A LIST OF THE VALUES, TUCK IN DESCRIPTOR IF APPLICABLE,
'    THEN WRITE VALUES TO TABLE...
825:         recvalsList.Clear
826:         If (Clas = missing) Then
827:            With recvalsList
828:                .Add Clas
829:                If (Desc) Then
830:                    .Add descriptor
831:                End If
832:                .Add tmpArea
833:                .Add tmpucArea
834:                .Add tmpdeposits
835:            End With
836:         Else
'    recvalsList = {class,area,ucArea,deposits}
838:            With recvalsList
839:                .Add Clas
840:                If (Desc) Then
841:                    .Add descriptor
842:                End If
843:                .Add Area
844:                .Add ucArea
845:                .Add deposits
846:            End With
847:         End If
'    record = theVTab.AddRecord
             'Dim record As irow
851:         Set record = theVTab.CreateRow
'    i = 0
        'Dim i As Integer
854:         i = 1 'Field(0) i OID
'    For Each Val In recvalsList
        'Dim val As Variant
857:         For Each val In recvalsList.list
'    theVTab.SetValue (flist.Get(i),record,val)
   '>>>> field is editable
860:             record.Value(i) = val
'    i = i + 1
862:            i = i + 1
'    End
864:         Next val
865:         record.Store
'    End  'for each n in 0 .. nclass
867:     Next n

'theVTab.EndTransaction
'saveEdits = True
'theVTab.StopEditingWithRecovery (saveEdits)
'Else
873:         Else
'MsgBox.Error("Unable to add records to "+theVTab.AsString+"."+NL+
'
'         "Please check file permissions.","Calculating Theme Weights")
'
'theVTab.StopEditingWithRecovery (True)
'
'If (statfile <> Nil) Then
881:             If (Not statfile Is Nothing) Then
'statfile.Close
883:                 statfile.Close
'End
885:             End If
'return Nil
887:             Set gSDI_CalcThemeWeights = Nothing
                 Exit Function
'End 'can add records
890:         End If
'Else
892:     Else
'MsgBox.Error("Unable to edit "+theVTab.AsString+".  Please"+NL+
'       "check file permissions.","Calculating Theme Weights")
'If (statfile <> Nil) Then
'statfile.Close
'End
'return Nil
'
'End  ' can StartEditingWithRecovery
901:     End If
''GET CLASS, DESCRIPTOR, COUNT/AREA, # DEPOSITS
''------------------------------------------
'
'ElseIf (tabtype = "CuU") Then
906:     ElseIf (tabtype = "CuU") Then 'Cumulative Ascending
'If (tabTypes.Count > 1) Then
908:             If (tabTypes.Count > 1) Then
'If (txtFile) Then
910:                 If (txtFile) Then
'statfile.writeElt (NL + NL)
912:                     statfile.Write vbCrLf & vbCrLf
'End
914:                 End If
'End
916:             End If
'If (txtFile) Then
918:             If (txtFile) Then
'statfile.writeElt ("The following table is cumulative, from highest class to highest")
920:                 statfile.Writeline "The following table is cumulative descending"
'statfile.writeElt ("Areas in units" + NL)
922:                 statfile.Write "Areas in units" & vbCrLf & vbCrLf
'If (desc) Then
924:                 If (Desc) Then
'headings = ("Class"+TAB+"Descrp."+TAB+"Area"+TAB+"Points"+TAB+"W+"+TAB+TAB+"s(W+)"+TAB+TAB+
'        "W-" & vbtab &TAB+"s(W-)"+TAB+TAB+"C"+TAB+TAB+"s(C)"+TAB+TAB+"stud(C)")
927:                     headings = "Class" & vbTab & "Descrp." & vbTab & "Area" & vbTab & "Points" & vbTab & "W+" & vbTab & "s(W+)" & vbTab & _
                        "W-" & vbTab + "s(W-)" & vbTab + "C" & vbTab & "s(C)" & vbTab + "stud(C)"
'Else
930:                 Else
'headings = ("Class"+TAB+"Area"+TAB+"Points"+TAB+"W+"+TAB+TAB+"s(W+)"+TAB+TAB+
'        "W-"+TAB+TAB+"s(W-)"+TAB+TAB+"C"+TAB+TAB+"s(C)"+TAB+TAB+"stud(C)")
933:                     headings = "Class" & vbTab & "Area" & vbTab & "Points" & vbTab & "W+" & vbTab & "s(W+)" & vbTab & _
                        "W-" & vbTab & "s(W-)" & vbTab & "C" & vbTab & "s(C)" & vbTab & "stud(C)"
                'End
936:                 End If
'statfile.writeElt (headings)
938:                 statfile.Writeline headings
'End
940:             End If
    
'' REVERSE ORDER OF CLASSES, AREAS, POINTS
''------------------------------------------
                Dim nd As Long
945:            nd = classList.Count
'xClassList = classList.Clone
                Dim xClassList As SDMList
948:            Set xClassList = classList.Clone
950:            classList.Clear
951:            classList.Add xClassList.GetVal(0)
'xDescList = descList.Clone
                Dim xDescList As SDMList
955:            If (Desc) Then
956:                Set xDescList = descList.Clone
957:                descList.Clear
958:                descList.Add xDescList.GetVal(0)
959:            End If
'sumcntlist is a dictionary
'xSumCntList = sumCntList.Clone
'xPntCountList = pntCountList.Clone
                Dim xPntCntList As SDMList
966:            Set xPntCntList = pntCountList.Clone
967:            pntCountList.Clear
968:            pntCountList.Add xPntCntList.GetVal(0)
'for each e in 0 .. (nd - 1)
                Dim e As Long
971:            For e = 1 To (nd - 1)
'  'if (e < (nd - e)) then
'    place = nd - e
'    classList.Shuffle(xClassList.Get(e),place)
975:                classList.Insert xClassList.GetVal(e)
976:                If (Desc) Then
'        descList.Shuffle xDescList.GetVal(e), place
978:                    descList.Insert xDescList.GetVal(e)
979:                End If
'     sumCntList.Shuffle xSumCntList.GetVal(e), place

'     pntCountList.Shuffle xPntCntList.GetVal(e), place
983:                pntCountList.Insert xPntCntList.GetVal(e)
'  'end
'End
986:            Next e
'If (theVTab.StartEditingWithRecovery) Then
992:            If (True) Then
'  av.ShowMsg ("Calculating weights for " + evidenceMap.GetName + "...")
994:                SDMGlobals.SDMStatusBar.Message(0) = "Calculating weights for " & evidenceMap.Name & "..."
'  If (theVTab.CanAddRecord) Then
996:                If (True) Then
'    theVTab.BeginTransaction
'            'Dim recvalsList As New SDMList
'    for each n in 0 .. nclass    'each class index
            'Dim n As Long
1001:                   For n = 0 To nclass
    'Class = classList.Get(n)
            'Dim clas As long
1004:                       Clas = classList.GetVal(n)
'    If (desc) Then
1006:                       If (Desc) Then
'      descriptor = descList.Get(n)
                    'Dim descriptor As String
1009:                           descriptor = descList.GetVal(n)
'    End
1011:                       End If
            'Dim Count As Long
1013:                   Count = sumCntList.Gett(Clas)
            'Dim tmpdeposits As Long
1015:                   tmpdeposits = pntCountList.GetVal(n)
    
1017:                   If (Clas <> missing) Then
      
1019:                       deposits = deposits + tmpdeposits
    
1021:                   End If
'
'' CONVERT AREA TO KM, THEN UNITS, IF APPLICABLE
''------------------------------------------
'If (poly) Then
'  tmpArea = Count / 1000000
'Else
'  tmparea = tmpEMGrid.GetCellSize * tmpEMGrid.GetCellSize * Count / 1000000
        'Dim emProps As IRasterProps
1030:               Set emProps = tmpEMGrid.Raster
        'Dim tmpArea As Double
1032:               tmpArea = (emProps.MeanCellSize.X) ^ 2 * Count / 1000000
'MsgBox tmpArea, , "tmpArea"
'End
'
1036:               If (Clas <> missing) Then
1037:                   Area = Area + tmpArea
1038:               End If
'If (asymptote) Then
1040:         If (asymptote) Then
'  tmpucArea = tmparea
            'Dim tmpucArea As Double
1043:             tmpucArea = tmpArea
'elseif ((asymptote).Not) then
1045:         ElseIf (Not asymptote) Then
'  tmpucArea = tmparea / unitArea
1047:             tmpucArea = tmpArea / unitArea
'End
1049:         End If
1050:         If (Clas <> missing) Then
1051:             ucArea = ucArea + tmpucArea
1052:         End If
'    MAKE A LIST OF THE VALUES, TUCK IN DESCRIPTOR IF APPLICABLE,
'    THEN WRITE VALUES TO TABLE...
1056:         recvalsList.Clear
1057:         If (Clas = missing) Then
1058:           With recvalsList
1059:             .Add Clas
1060:             If (Desc) Then
1061:               .Add descriptor
1062:             End If
1063:             .Add tmpArea
1064:             .Add tmpucArea
1065:             .Add tmpdeposits
1066:           End With
1067:         Else
'    recvalsList = {class,area,ucArea,deposits}
1069:           With recvalsList
1070:             .Add Clas
1071:             If (Desc) Then
1072:               .Add descriptor
1073:             End If
1074:             .Add Area
1075:             .Add ucArea
1076:             .Add deposits
1077:           End With
1078:         End If
'MsgBox recvalsList.AsString, , "recvalslist"
'    record = theVTab.AddRecord
        'Dim record As irow
1082:         Set record = theVTab.CreateRow
'    i = 0
        'Dim i As Integer
1085:         i = 1 'Field(0) is OID
'    For Each Val In recvalsList
        'Dim val As Variant
1088:         For Each val In recvalsList.list
'    theVTab.SetValue (flist.Get(i),record,val)
1090:             record.Value(i) = val
'    i = i + 1
1092:             i = i + 1
'    End
1094:         Next val
1095:         record.Store
'    End  'for each n in 0 .. nclass
1097:     Next n
'theVTab.EndTransaction
'saveEdits = True
'theVTab.StopEditingWithRecovery (saveEdits)
'Else
1102: Else
'MsgBox.Error("Unable to add records to "+theVTab.AsString+"."+NL+
'
'         "Please check file permissions.","Calculating Theme Weights")
'
'theVTab.StopEditingWithRecovery (True)
'
'If (statfile <> Nil) Then
1110:             If (Not statfile Is Nothing) Then
'statfile.Close
1112:                 statfile.Close
'End
1114:             End If
'return Nil
1116:             Set gSDI_CalcThemeWeights = Nothing
                  Exit Function
'End 'can add records
1119:         End If
'Else
1121:     Else
'MsgBox.Error("Unable to edit "+theVTab.AsString+".  Please"+NL+
'       "check file permissions.","Calculating Theme Weights")
'If (statfile <> Nil) Then
'statfile.Close
'End
'return Nil
'
'End  ' can StartEditingWithRecovery
1130:     End If
1131: Else
1132:     MsgBox "Illegal tabtype = " & tabtype
1133:     Set gSDI_CalcThemeWeights = Nothing
          Exit Function
1135: End If  '<<<<<<<<<<<<<<< end of IF(tabtype = "CuX")

'*********************************************************
'av.ShowMsg ("Calculating weights for " + evidenceMap.GetName + "...")
1138: SDMStatusBar.Message(0) = "Calculating weights for " & evidenceMap.Name & "..."
'  flist = theVTab.GetFields
'
'  If (theVTab.StartEditingWithRecovery) Then
1142: If (True) Then
1143:     If (Desc) Then
            Dim fdescFieldIdx As Long
            Dim tokens As Variant
            Dim descFieldName As String
1147:       tokens = Split(descField.Name, ".", -1)
1148:       descFieldName = tokens(UBound(tokens))
1149:       fdescFieldIdx = theVTab.FindField(descFieldName)
'MsgBox descFieldName & ":" & fdescFieldIdx, , c_sModuleFileName
1151:     End If
'''          Dim oddsarglst As New SDMList 'For debugging
'    For Each record In theVTab
          Dim row As Long
1154:     For row = 0 To theVTab.RowCount(Nothing) - 1
1155:         Set record = theVTab.GetRow(row)
'      recvalsList = List.Make
1157:         recvalsList.Clear
'      cls = theVTab.ReturnValueNumber(flist.Get(0), record)
              Dim cls As Long
              Dim clsfldidx
1161:         clsfldidx = 1
1162:         cls = record.Value(clsfldidx)
'      recvalsList.Add (cls)
1164:         recvalsList.Add cls
'      If (desc) Then
1166:         If (Desc) Then
'        descriptor = theVTab.ReturnValue(flist.Get(1), record)
1168:             descriptor = record.Value(fdescFieldIdx)
'        recvalsList.Add (descriptor)
1170:             recvalsList.Add descriptor
'        ucNum = 3
                  Dim ucNum As Integer
1173:             ucNum = 4
'        depNum = 4
                  Dim depNum As Integer
1176:             depNum = 5
'      Else
1178:         Else
'        ucNum = 2
1180:             ucNum = 3
'        depNum = 3
1182:             depNum = 4
'      End
1184:         End If
'      ucArea = theVTab.ReturnValueNumber(flist.Get(ucNum), record)
1186:         ucArea = record.Value(ucNum)
'      recvalsList.Add (ucArea)
1188:         recvalsList.Add ucArea
'      deposits = theVTab.ReturnValueNumber(flist.Get(depNum), record)
1190:         deposits = record.Value(depNum)
'      recvalsList.Add (deposits)
1192:         recvalsList.Add deposits
'
'      If (cls = missing) Then
1195:         If (cls = missing) Then
'        nN = Number.MakeNull
                 Dim nN As Variant
1198:            nN = Null
'        oddsList = {nN,nN,nN,nN,nN,nN,nN}
                 Dim oddsList As SDMList
1201:            Set oddsList = New SDMList
1202:            oddsList.AddArray Array(nN, nN, nN, nN, nN, nN)
'      Else
1204:         Else
'        'CALCULATE EVIDENCE MAP WEIGHTS STATISTICS FOR EACH
'        'CLASS
'        '-----------------------------------
'        oddsList = av.Run("gSDI.CalcOdds",{deposits,totDeposits,ucArea,totArea})
                 Dim gSDICalcOdds As gSDI_CalcOdds
1210:            Set gSDICalcOdds = New gSDI_CalcOdds
                 Dim oddsargs As Variant
1213:            oddsargs = Array(deposits, totDeposits, ucArea, totArea)
'''oddsarglst.Clear
'''oddsarglst.AddArray oddsargs
'''MsgBox ListtoString(oddsarglst), , "Odds args: OID=" & record.Oid
1221:            Set oddsList = gSDICalcOdds.gSDI_CalcOdds(oddsargs)
'        If (oddsList = "NoArea") Then
1223:            If oddsList.GetVal(0) = "Error" Then
1224:                     MsgBox "Bad input data", vbCritical, c_sModuleFileName
1225:                     Set gSDI_CalcThemeWeights = Nothing
                          Exit Function
1227:            ElseIf oddsList.GetVal(0) = "NoArea" Then
'          MsgBox.Error("Unable to find value for total area for analysis in"+NL+
'                       "sq. km's.  Please ensure that a Study Area Grid Theme was specified","Total Area Value Not Found")
1230:                  MsgBox "Unable to find value (or zero value) for total area for analysis in" & vbCrLf & _
                       "sq. km's.  Please ensure that a Study Area Grid Theme was specified", vbCritical, "Total Area Value Not Found"
'          If (statfile <> Nil) Then
1233:                   If (Not statfile Is Nothing) Then
'            statfile.Close
1235:                       statfile
'          End
1237:                   End If
'          return nil
1239:                       Set gSDI_CalcThemeWeights = Nothing
                            Exit Function
'        End
1242:            End If
'      End
1244:     End If
'
'
'      'WRITE EACH CLASSES VALUES TO TEXT FILE, IF OPTION SELECTED
'
'      '------------------------------------------
'
'      If (txtFile) Then
1252:     If (txtFile) Then
                Dim dataLine As String
1254:           dataLine = ""
'
'        For Each rv In recvalsList
                Dim rv As Variant
1258:           For Each rv In recvalsList.list
'          If ((recvalsList.Find(rv) = 2) And (recvalsList.Count = 4)) Then
             'If ((recvalsList.FindByValue(rv) = 2) And (recvalsList.Count = 4)) Then
'            dataLine = dataLine + TAB
                 'dataLine = dataLine & vbTab
'          End
             'End If
'          if (rv.Is(String)) then
1266:             If (VarType(rv) = vbString) Then
'            dataLine = dataLine + rv + TAB
1268:                 dataLine = dataLine & rv & vbTab
'          Else
1270:             Else
'            dataLine = dataLine + rv.SetFormat("d").AsString + TAB
1272:                 dataLine = dataLine & Format(rv, "####") & vbTab
'          End
1274:             End If
'        End
1276:           Next rv
'        For Each odd In oddsList
                Dim varodd As Variant
1279:           For Each varodd In oddsList.list
'          If (oddsList.Find(odd) = 0) Then
1281:               If (oddsList.FindByValue(varodd) = 0) Then 'First One?
'            dataLine = dataLine + TAB
1283:                   dataLine = dataLine & vbTab
'          End
1285:               End If
'          If (odd.asString = "Number Null") Then
1287:               If (varodd = Null) Then
'            dataLine = dataLine + "" + TAB
1289:                 dataLine = dataLine & "" & vbTab
'          Else
1291:               Else
'            dataLine = dataLine + odd.SetFormat("d.dddd").AsString + TAB
1293:                 dataLine = dataLine & Format(varodd, "#0.###") & vbTab
'          End
1295:               End If
'        End
1297:               Next varodd
'        statfile.writeElt (dataLine)
1299:           statfile.Writeline dataLine
'      End
1301:         End If ' end of text file writing
'
'      'WRITE EACH CLASS' SET OF VALUES TO TABLE
'      '-----------------------------------
'      If (desc) Then
1306:        If (Desc) Then
'        i = 5
1308:             i = 6
'      Else
1310:        Else
'        i = 4
1312:             i = 5
'      End
1314:        End If
'      theVTab.BeginTransaction
'
'      For Each odd In oddsList
1318:        For Each varodd In oddsList.list
'        theVTab.SetValue (flist.Get(i),record,odd)
'>>>>>>>>>>>>>>  Note: varodd is sometimes NULL and Wgts fields is not Nullable
1321:                 If IsNull(varodd) Then
1322:                     record.Value(i) = 0
1323:                 Else
1324:                     record.Value(i) = varodd
1325:                 End If
'        i = i + 1
1327:             i = i + 1
'      End
1329:        Next varodd
'      theVTab.EndTransaction
1331:        record.Store
'    End
nextrow:
1334:     Next row
'    theVTab.StopEditingWithRecovery (True)
'
'  Else
1338: Else 'editing with recovery
'    MsgBox.Error("Unable to add values to "+theVTab.AsString,"Weights Table")
          Dim dataSet As IDataset
1341:     Set dataSet = theVTab
1342:     MsgBox "Unable to add values to " & dataSet.Name, vbCritical, "Weights Table"
'    If (statfile <> Nil) Then
1344:     If (Not statfile Is Nothing) Then
'      statfile.Close
1346:         statfile.Close
'    End
1348:     End If
'    return nil
1350:     Set gSDI_CalcThemeWeights = Nothing
'  End
1352: End If 'editing with recovery

'End
1355: Next tabtype
'theVTab.Deactivate
'
'theVTab = Nil
1359: Set theVTab = Nothing
'av.PurgeObjects
'
'return "OK"
1363: Set gSDI_CalcThemeWeights = New SDMList
1364: gSDI_CalcThemeWeights.Add "OK"
1365: ProgressAnimation.Hide
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  Exit Function
ErrorHandler:
  HandleError True, "gSDI_CalcThemeWeights " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
1370:   gSDI_CalcThemeWeights = Nothing
End Function


