VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcVals4Msng"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcVals4Msng"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcVals4Msng(Self As Variant) As SDMUtilities.SDMList
'MsgBox "Entering....", , c_sModuleFileName
  On Error GoTo ErrorHandler
15:   Set gSDI_CalcVals4Msng = New SDMUtilities.SDMList
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
''Name:  gSDI.CalcVals4Msng
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Calculates a weighted average for
''               filling in areas of missing data, based
''               on values found in the rest of the theme.
''
''
''
'' Requires:
''
'' Self:  List containing:
''          0 -- list of lists of values in unique conditions table
''          1 -- list of areas of each unique condition
''          2 -- integer used to define missing data
''
'' Returns:  List of weighted averages, one for each theme
''           in unique conditions table, to be used to
''           fill in areas of missing data.
''==============================================
''Get arguments
''----------------------------------------------
'lstUCVals = Self.Get(0)    'list of lists of evidence values per UC value for each evidence layer
    Dim lstUCVals As SDMUtilities.SDMList
42: Set lstUCVals = Self(0)
'MsgBox ListUtils.ListtoString(lstUCVals), , "lstUCVals"
'MsgBox lstUCVals.Count, , "lstUCVals"
'lstAreas = Self.Get(1)     'list of areas for each unique condition
    Dim lstAreas As SDMUtilities.SDMList
47: Set lstAreas = Self(1)
'MsgBox ListUtils.ListtoString(lstAreas), , "lstAreas"
'lstMD = Self.Get(2)      'missing data values for each theme
    Dim lstMD As SDMUtilities.SDMList
51: Set lstMD = Self(2)
'MsgBox ListUtils.ListtoString(lstMD), , "lstMD"
'lstMCF = Self.Get(3)    ' list of expanded values for multi-class, free data type themes
    Dim lstMCF As SDMUtilities.SDMList
55: Set lstMCF = Self(3)
'MsgBox ListUtils.ListtoString(lstMCF), , "lstMCF"
'lstThmMCF = lstMCF.Get(0)
    Dim lstThmMCF As SDMUtilities.SDMList
59: Set lstThmMCF = lstMCF.getObj(0)
''list of values corresponding to list of themes, empty of theme is not multi-class free
'lstMCFIdx = lstMCF.Get(1)    ' list of theme name and index pairs, where the index is the location of the theme values in
'                             ' in lstThmMCF (-1 if not multi-class free data type theme)
    Dim lstMCFIdx As SDMUtilities.SDMList
64: Set lstMCFIdx = lstMCF.getObj(1)
'MsgBox ListtoString(lstMCFIdx), , "lstMCFIdx"
'lstMCF = Nil
67: Set lstMCF = Nothing
'' Calculate the total area of the unique conditions
''----------------------------------------------
'totalArea = av.Run("gSDI.TotalValsInList",{lstAreas})
    Dim gSDTotalValsInList As gSDI_TotalValsInList
72: Set gSDTotalValsInList = New gSDI_TotalValsInList
    Dim totalArea As Double
74: totalArea = gSDTotalValsInList.gSDI_TotalValsInList(Array(lstAreas))
'If ((totalArea = 0) Or (totalArea = Nil)) Then
76: If totalArea = 0 Or IsNull(totalArea) Then
'  MsgBox.Error("Error in calculating total area.",Script.The.GetName)
78:     MsgBox "Error in calculating total area.", vbCritical, c_sModuleFileName
'  return Nil
80:     Set gSDI_CalcVals4Msng = Nothing
    Exit Function
'End
83: End If
'MsgBox "totalArea=" & totalArea
'' Initialize list to hold weighted averages to be calculated
''----------------------------------------------
'lstWAVals = List.Make
    Dim lstWAVals As New SDMUtilities.SDMList
'' For each list of values (from a single theme)
''----------------------------------------------
    Dim pProgbar As IStepProgressor
92: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
93: pProgbar.Position = 0
94: SDMGlobals.SDMStatusBar.ShowProgressBar "Area Wtd Values for Missing Data...", 1, lstUCVals.Count, 1, True
'k = 0
    Dim k As Long
'For Each l In lstUCVals
    Dim lst As Variant
99: For Each lst In lstUCVals.list
'  idxMCF = lstMCFIdx.Get(k).Get(1)
         Dim aList As SDMUtilities.SDMList
102:     Set aList = lstMCFIdx.getObj(k)
         Dim idxMCF As Long
104:     idxMCF = aList.GetVal(1)
'  mcf = (idxMCF > -1)
         Dim mcf As Boolean
107:     mcf = idxMCF > -1
'  nmbWA = av.Run("gSDI.CalcWeightedAvg",{l,Nil,lstAreas,lstMD.Get(k),totalArea,mcf})
         Dim gSDICalcWeightedAvg As gSDI_CalcWeightedAvg
110:     Set gSDICalcWeightedAvg = New gSDI_CalcWeightedAvg
         Dim nmbWa As SDMUtilities.SDMList
112:     Set nmbWa = gSDICalcWeightedAvg.gSDI_CalcWeightedAvg(Array(lst, Nothing, lstAreas, lstMD.GetVal(k), totalArea, mcf))
'  If (nmbWA.Is(List)) Then
'    lstWAVals.Add (nmbWA)
'  Else
'    lstWAVals.Add (Nil)
'  End
118:     If nmbWa Is Nothing Then
119:         lstWAVals.Add Nothing
120:     Else
121:         lstWAVals.Add nmbWa
122:     End If
'  k = k + 1
124:     k = k + 1
125:     SDMGlobals.SDMStatusBar.StepProgressBar
'End
127: Next lst
128: SDMGlobals.SDMStatusBar.HideProgressBar
'return lstWAVals
'MsgBox ListUtils.ListtoString(lstWAVals), , "lstWAVals"
131: Set gSDI_CalcVals4Msng = lstWAVals
'
'
'MsgBox "exiting...", , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
139:   Set gSDI_CalcVals4Msng = Nothing
End Function
