VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcWeightedAvg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcWeightedAvg"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcWeightedAvg(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
 ' MsgBox "Entering...", , c_sModuleFileName
15:     Set gSDI_CalcWeightedAvg = New SDMUtilities.SDMList
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.CalcWeightedAvg
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Takes a list of values and
''          areas and calculates a weighted
'
''          average.  Option to identify
''          areas for current values but to
''          calculate weighted average based
''          on new values.
''
'' Requires:
''
'' Self:   0 -- lstVals -- list of current values,
''                         doesn't have to be unique
''         1 -- lstValsNew -- list of new values, Nil if none
''         2 -- lstAreas -- list of areas corresponding to lstVals
''         3 -- nmbMD -- number (integer) defining missing data value
''         4 -- sumArea -- total area of areas in lstAreas
''         5 -- mcf -- Nil if not multi-class free theme, else list of unique class values
'' Returns:
''==============================================
'dTitle = Script.The.GetName
    Dim dTitle As String
42: dTitle = c_sModuleFileName
'lstVals = Self.Get(0)
    Dim lstVals As SDMUtilities.SDMList
45: Set lstVals = Self(0)
'MsgBox "lstVals=" & lstVals.asString, , c_sModuleFileName
'lstValsNew = Self.Get(1)
    Dim lstValsNew As SDMUtilities.SDMList
49: Set lstValsNew = Self(1)
'lstAreas = Self.Get(2)
    Dim lstAreas As SDMUtilities.SDMList
52: Set lstAreas = Self(2)
'MsgBox "lstAreas=" & lstAreas.asString, , c_sModuleFileName
'nmbMD = Self.Get(3)
    Dim nmbMD As Long
56: nmbMD = Self(3)
'MsgBox "nmbMD=" & nmbMD, , c_sModuleFileName
'nmbMD = av.Run("gSDI.CheckIsNumber",{nmbMD})
59: If IsNumeric(nmbMD) Then
60: ElseIf VarType(nmbMD) = vbString Then
61:     nmbMD = CLng(nmbMD)
62: Else
'If (nmbMD = False) Then
'  MsgBox.Error("Error specifying missing data integer as number.",dTitle)
65:     MsgBox "Error specifying missing data integer as number.", vbCritical, dTitle
'  return Nil
67:     Set gSDI_CalcWeightedAvg = Nothing
        Exit Function
'End
70: End If
'sumArea = Self.Get(4)
    Dim sumArea As Double
73: sumArea = Self(4)
'MsgBox "sumArea=" & sumArea
'mcf = Self.Get(5)
    Dim mcf As Boolean
77: mcf = Self(5)
'MsgBox "mcf=" & mcf
'If (mcf.Not) Then
80: If Not mcf Then  'Not MultiClass Free
'  lUnique = lstVals.Clone
        Dim lUnique As SDMUtilities.SDMList
83:     Set lUnique = lstVals.Clone
'  lUnique.RemoveDuplicates
85:     Set lUnique = lUnique.RemoveDuplicates
'  If (lstValsNew <> Nil) Then
87:     If Not lstValsNew Is Nothing Then  'Always NOTHING as input argument
'    If (lUnique.FindByValue(nmbMD) > -1) Then
89:         If lUnique.FindByValue(nmbMD) > -1 Then
'      nmbAssess = lstValsNew.Count + 1
                Dim nmbAssess As Long
92:             nmbAssess = lstValsNew.Count + 1
'    Else
94:         Else
'      nmbAssess = lstValsNew.Count
96:             nmbAssess = lstValsNew.Count
'    End
98:         End If
'    If (lUnique.Count <> nmbAssess) Then
100:         If lUnique.Count <> nmbAssess Then
'      MsgBox.Error("Error in number of values to map.",Script.The.GetName)
102:             MsgBox "Error in number of values to map.", , c_sModuleFileName
'      return Nil
104:             Set gSDI_CalcWeightedAvg = Nothing
                Exit Function
'    End
107:         End If
'  End
109:     End If
'
111: ProgressAnimation.Show "Zeroing Area sums..."
'  lstAreasSums = List.Make
         Dim lstAreasSums As New SDMUtilities.SDMList
'  For Each v In lUnique
         Dim v As Variant
116:     For Each v In lUnique.list
'    lstAreasSums.Add (0)
118:         lstAreasSums.Add 0#
'  End
120:     Next v
121: ProgressAnimation.Hide
'  ' For each value in the list,
'  ' increment the area associated with it
'  '----------------------------------------------
'  I = 0
         Dim i As Long
127:     i = 0
'  For Each v In lstVals
129: ProgressAnimation.Show "Setting Area Sums..."
130:     For Each v In lstVals.list
'    Area = lstAreas.Get(I)
             Dim Area As Double
133:         Area = lstAreas.GetVal(i)
'    idx = lUnique.FindByValue(v)
             Dim idx As Long
136:         idx = lUnique.FindByValue(v)
'    lstAreasSums.Set(idx,(lstAreasSums.Get(idx) + area))
138:         lstAreasSums.SetIt idx, (lstAreasSums.GetVal(idx) + Area)
'    I = I + 1
140:         i = i + 1
'  End
142:     Next v
143: ProgressAnimation.Hide
'  numerator = 0
         Dim numerator As Double
146:     numerator = 0#
'  denominator = sumArea
         Dim denominator As Double
149:     denominator = sumArea
    
'  ' If the current values contain the missing data
'  ' integer, decrease the denominator by its corresponding
'  ' area and remove the areas value from the area list
'  '------------------------------------------------

'  idx = lUnique.FindByValue(nmbMD)
157:     idx = lUnique.FindByValue(nmbMD)
'  If (idx > -1) Then
159:     If idx > -1 Then
'    denominator = 0
161:         denominator = 0
'    for each i in 0..(lstAreasSums.Count - 1)
163: ProgressAnimation.Show "Incrementing denominator..."
164:         For i = 0 To (lstAreasSums.Count - 1)
'      If (I <> idx) Then
166:             If i <> idx Then
'        denominator = denominator + lstAreasSums.Get(I)
168:                 denominator = denominator + lstAreasSums.GetVal(i)
'      End
170:            End If
'    End
172:         Next i
173: ProgressAnimation.Hide
'    lUnique.Remove (idx)
175:         lUnique.Remove idx
'    lstAreasSums.Remove (idx)
177:         lstAreasSums.Remove idx
'  End
179:     End If
'
'  ' If there are new values to use for average, loop
'  ' through these and calculate the average, otherwise
'  ' use the current values
'  '-----------------------------------------------
         Dim lstWeight As SDMUtilities.SDMList
'  If (lstValsNew = Nil) Then
187:     If lstValsNew Is Nothing Then
'    lstWeight = lUnique
189:         Set lstWeight = lUnique
'  Else
191:     Else
'    lstWeight = lstValsNew
193:         Set lstWeight = lstValsNew
'  End
195:     End If
    
'  I = 0
198:     i = 0

200:          ProgressAnimation.Show "Calculating numerator and denominator..."
'  For Each v In lstWeight
202:     For Each v In lstWeight.list
'    idx = lstWeight.FindByValue(v)
204:            idx = lstWeight.FindByValue(v)
'    If (v <> nmbMD) Then
206:            If v <> nmbMD Then
'      'area = lstAreasSums.Get(i)
'      Area = lstAreasSums.Get(idx)
209:                Area = lstAreasSums.GetVal(idx)
'      numerator = numerator + (v * Area)
211:                numerator = numerator + (v * Area)
'    Else
213:             Else
'    '!!!! - Do I need to assess for 0?? i.e. is this ever possible
'    '  denominator = denominator - lstAreasSums.Get(i)
'      denominator = denominator - lstAreasSums.Get(idx)
217:                denominator = denominator - lstAreasSums.GetVal(idx)
'
219:             End If
'    I = I + 1
221:             i = i + 1
'  End
223:     Next v
224:          ProgressAnimation.Hide
'  nmbWA = numerator / denominator
            Dim nmbWa As Double
227:        nmbWa = numerator / denominator
'  return {nmbWA}
229:        gSDI_CalcWeightedAvg.Add nmbWa
            Exit Function
            
'>>> Is multi-class free theme<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
'Else
234: Else 'Is MCF
'  lstValSum = List.Make
        Dim lstValSum As New SDMUtilities.SDMList
'  lstAreaSum = List.Make
        Dim lstAreaSum As New SDMUtilities.SDMList
'  I = 0
240:    i = 0
'  For Each v In lstVals
242:         ProgressAnimation.Show "Setting Area sums..."
243:    For Each v In lstVals.list
'    idxV = lstValSum.FindByValue(v)
                 Dim idxV As Long
246:             idxV = lstValSum.FindByValue(v)
'    If (idxV < 0) Then
248:             If idxV < 0 Then
'      lstValSum.Add (v)
250:                 lstValSum.Add v
'      lstAreaSum.Add (lstAreas.Get(I))
252:                 lstAreaSum.Add lstAreas.GetVal(i)
'    Else
254:             Else
'      lstAreaSum.Set(idxV,lstAreaSum.Get(idxV) + lstAreas.Get(i))
256:                 lstAreaSum.SetIt idxV, lstAreaSum.GetVal(idxV) + lstAreas.GetVal(i)
'    End
258:             End If
'    I = I + 1
260:             i = i + 1
'  End
262:    Next v
263:         ProgressAnimation.Hide

'  lstNmbWA = List.Make
        Dim lstNmbWA As New SDMUtilities.SDMList
'  idxV = lstValSum.FindByValue(nmbMD)
268:    idxV = lstValSum.FindByValue(nmbMD)
'  If (idxV > -1) Then
270:    If idxV > -1 Then
'    lstValSum.Remove (idxV)
272:             lstValSum.Remove idxV
'    areaMD = lstAreaSum.Get(idxV)
                 Dim areaMD As Double
275:             areaMD = lstAreaSum.GetVal(idxV)
'    sumArea = sumArea - areaMD
277:             sumArea = sumArea - areaMD
'  Else
279:    Else
'    return {}
281:             gSDI_CalcWeightedAvg.Clear
                 Exit Function
'  End
284:    End If
'
'MsgBox ListUtils.ListtoString(lstValSum), , "lstValSum"

'  I = 0
289:     i = 0
'  For Each v In lstValSum
291:          ProgressAnimation.Show "Making list of Wtd Ave..."
292:     For Each v In lstValSum.list
'    vb0 = 1
             Dim vb0 As Long
295:         vb0 = 1
'    area0 = lstAreaSum.Get(I)
             Dim area0 As Double
298:         area0 = lstAreaSum.GetVal(i)
'    vb1 = 0
             Dim vb1 As Double
301:         vb1 = 0
'    area1 = sumArea - area0
             Dim area1 As Double
304:         area1 = sumArea - area0
'
'    numerator = (vb0 * area0) + (vb1 * area1)
307:         numerator = (vb0 * area0) + (vb1 * area1)
'    wa = numerator / sumArea
             Dim wa As Double
310:         wa = numerator / sumArea
'    lstNmbWA.Add (wa)
312:         lstNmbWA.Add wa
'    I = I + 1
314:         i = i + 1
'  End
316:     Next v
317:          ProgressAnimation.Hide
'MsgBox ListUtils.ListtoString(lstNmbWA), , "lstNmbWA"
'  return lstNmbWA
320:     Set gSDI_CalcWeightedAvg = lstNmbWA
'End
322: End If 'not MCF
'MsgBox "Exiting...", , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
328:   Set gSDI_CalcWeightedAvg = Nothing
End Function
