VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CalcWeights"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CalcWeights"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_CalcWeights(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'''MsgBox "Entering....", , c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:    gSDI.CalcWeights
''
'' Topics:  Spatial Data Modeller
'' Description:  Calculates weights and
''          variances for input themes and
''          writes values to dBase files.
''
'' Requires:
'
'' Self:    0 -- lstsUC -- the unique conditions tables as read into lists
''          1 -- lstFlds -- list of fields containing input values from each theme
'>>>>>>>>> 1 -- lstFlds -- list of Generalized Tables of each themes
''          2 -- lstMD -- list of integer values defining areas of missing data in each theme
''          3 -- expert -- flag for expert weights
''
'' Returns:  vTabW -- the vTab containing weights
''           vTabV -- the vTab containing variances
''           rW -- reference to the last record in the vTabW
''==============================================
''
'' Get arguments
''----------------------------------------------
''asymptote = False
    Dim asymptote As Boolean
40: asymptote = False
''lstsUC = self.Get(0)
    Dim lstsUC As SDMUtilities.SDMList
43: Set lstsUC = Self(0)
'MsgBox "lstsUC:" & vbCrLf & lstsUC.AsString, , c_sModuleFileName
''lstsvals = lstsUC.Get(0)      ' values in UC
    Dim lstsvals As SDMUtilities.SDMList
47: Set lstsvals = lstsUC.getObj(0)
''lstTNames = lstsUC.Get(1)     ' list of theme names
    Dim lstTNames As SDMUtilities.SDMList
50: Set lstTNames = lstsUC.getObj(1)
''lstAreas = lstsUC.Get(2)      ' list of area values
    Dim lstAreas As SDMUtilities.SDMList
53: Set lstAreas = lstsUC.getObj(2)
'MsgBox "lstAreas:" & vbCrLf & lstAreas.AsString, , c_sModuleFileName
''lstPnts = lstsUC.Get(3)       ' list of # points
    Dim lstPnts As SDMUtilities.SDMList
57: Set lstPnts = lstsUC.getObj(3)
'MsgBox "lstPnts:" & vbCrLf & lstPnts.AsString, , c_sModuleFileName
'List of Temporary evidence rasters
    Dim tmpRastList As SDMUtilities.SDMList
61: Set tmpRastList = lstsUC.getObj(lstsUC.Count - 1)
'''62: If tmpRastList Is Nothing Then
'''63:     MsgBox "tmpRastList Is Nothing", , c_sModuleFileName
'''64: Else
'''65:     MsgBox "tmpRastList:" & vbCrLf & ListtoString(tmpRastList), , c_sModuleFileName
'''73: End If
''lstsUC = Nil
'56: Set lstsUC = Nothing
''lstFlds = self.Get(1)
    Dim lstFlds As SDMUtilities.SDMList
71: Set lstFlds = Self(1)
'MsgBox "lstflds: " & vbCrLf & lstFlds.AsString, , c_sModuleFileName
''lstMD = self.Get(2)
    Dim lstMD As SDMUtilities.SDMList
75: Set lstMD = Self(2)
''expert = self.Get(3)
'expert = av.FindDialog("gParam").findByName("radExpt").IsSelected
    Dim anlParms As AnalysisParameters.AnlParams
79: Set anlParms = New AnalysisParameters.AnlParams
    Dim gParam As Form
81: Set gParam = anlParms.gParamfrm
    Dim expert As Boolean
83: expert = gParam.radExpt.Value
    Dim thmUC As IRasterLayer
85: Set thmUC = Self(4)
'lstStrFlds = List.Make
    Dim lstStrFlds As New SDMUtilities.SDMList
'For Each f In lstFlds
    Dim fvar As Variant
90: For Each fvar In lstFlds.list
'  lstStrFlds.Add (f.GetAlias)
92:     lstStrFlds.Add CStr(fvar)
'End
94: Next fvar
'nmbNull = Number.MakeNull
'Dim nmbNull As Double
'84: nmbNull = Null
'viewActive = av.GetActiveDoc
    Dim viewActive As IMap
100: Set viewActive = SDMGlobals.SDMMap
'If (expert.Not) Then
102: If Not expert Then
'  ' Get the training point vtab
'  '----------------------------------------------
'  vTabTP = av.Run("gSDI.GetTPVTab",{viewActive})
        Dim gSDIGetTPVTab As gSDI_GetTPVTab
107:     Set gSDIGetTPVTab = New gSDI_GetTPVTab
        Dim thmTP As IFeatureLayer
109:    Set thmTP = gSDIGetTPVTab.gSDI_GetTPVTab(viewActive)
'  if (vTabTP.Is(String)) then
111:    If thmTP Is Nothing Then
'    MsgBox.Error(vTabTP,"Training Point Theme Error")
113:         MsgBox "Training Point Theme Error", vbCritical, c_sModuleFileName
'    return Nil
115:         Set gSDI_CalcWeights = Nothing
             Exit Function
'  End
118:    End If
        Dim vTabTP As ITable
120:    Set vTabTP = thmTP
'End
122: End If
' Get the study area grid theme
'----------------------------------------------
'thmSA = viewActive.GetExtension(AnalysisEnvironment).GetMask
     Dim thmSAName As String
127: thmSAName = gParam.cbxSA.Text
     Dim thmSA As IRasterLayer
129: Set thmSA = SDMGlobals.SDMUtil.FindLayerByName(thmSAName)
'If (thmSA = Nil) Then
131: If thmSA Is Nothing Then
'  MsgBox.Error("The study area grid theme is not set.  Please check your parameters.","Parameter Error")
133:     MsgBox "The study area grid theme is not set.  Please check your parameters.", vbCritical, c_sModuleFileName
'  return Nil
135:     Set gSDI_CalcWeights = Nothing
    Exit Function
'End
138: End If
'grdSA = thmSA
     Dim grdSA As IRaster
141: Set grdSA = RasterUtils.GetDatasetRaster(thmSA)
'' Get total points, study area
''----------------------------------------------
'If (expert.Not) Then
145: If Not expert Then
'   sumPnts = av.Run("gSDI.GetTotalPoints",{vTabTP,grdSA,viewActive})
        Dim gSDIGetTotalPoints As gSDI_GetTotalPoints
148:     Set gSDIGetTotalPoints = New gSDI_GetTotalPoints
        Dim sumPnts As Long
150:     sumPnts = gSDIGetTotalPoints.gSDI_GetTotalPoints(Array(thmTP, thmSA, viewActive))
151:     If sumPnts = 0 Then
152:         MsgBox "No points selected in gSDI_GetTotalPoints", vbCritical, c_sModuleFileName
153:         Set gSDI_CalcWeights = Nothing
            Exit Function
155:     End If
'End
157: End If
'sumArea = av.Run("gSDI.GetTotalArea",{thmSA})
     Dim gSDIGetTotalArea As gSDI_GetTotalArea
160: Set gSDIGetTotalArea = New gSDI_GetTotalArea
     Dim sumArea As Double
162: sumArea = gSDIGetTotalArea.gSDI_GetTotalArea(Array(thmSA))
'If (sumArea = Nil) Then
164: If IsNull(sumArea) Then
'  MsgBox.Error("The study area grid theme must have an attribute table.","Parameter Error")
166:     MsgBox "Can't get total area", vbCritical, c_sModuleFileName
'  return Nil
168:     Set gSDI_CalcWeights = Nothing
         Exit Function
'End
171: End If
'' Retrieve the unit area
''----------------------------------------------
'If (expert) Then
175: If expert Then
'  asymptote = True
177:     asymptote = True
'  unitArea = Nil
         Dim unitArea As Variant
180:     unitArea = Null
'Else
182: Else
'  unitArea = av.FindDialog("gParam").findByName("txtUA").GetText
184:     unitArea = gParam.txtUA.Text
'  If (unitArea.IsNumber) Then
186:     If IsNumeric(unitArea) Then
'    unitArea = unitArea.AsNumber
188:         unitArea = CDbl(unitArea)
'  Else
190:     Else
'    MsgBox.Error("Error reading parameter, Unit Area.","Parameter Error")
192:         MsgBox "Error reading parameter, Unit Area.", vbCritical, c_sModuleFileName
'    return Nil
194:         Set gSDI_CalcWeights = Nothing
             Exit Function
'  End
197:     End If
'End
199: End If
'If (asymptote) Then
201: If asymptote Then
'  sumArea = sumArea / 1000000
203:     sumArea = sumArea / 1000000
'Else
205: Else
'  sumArea = sumArea / 1000000 / unitArea
207:    sumArea = sumArea / 1000000 / unitArea
'End
209: End If
'If (expert.Not) Then
211: If Not expert Then
'  prbPrior = sumPnts / sumArea
         Dim prbPrior As Double
214:     prbPrior = sumPnts / sumArea
'End
216: End If
'' Prompt user for file names, make file
''----------------------------------------------
'statfile = Nil
     Dim statfile As Variant
221: statfile = Null
'strDef = fileName.GetCWD.MakeTmp("woe", "dbf")
''part0 = strDef.AsString.AsTokens(".").Get(0)
''part1 = part0.Right(part0.Count - 3)
''tdefname = ("woe"+part1+".txt").AsFileName
''txtfileName = FileDialog.Put(tdefname,"*.txt","Weights of Evidence Text Report Option (Cancel to Skip)"
''if (txtFileName = Nil) then
'  txtFile = False
     Dim txtFile As Boolean
230: txtFile = False
''else
''  txtFile = True
''end

'strDef = fileName.GetCWD.MakeTmp("woe", "dbf")
     Dim strDef As IFileName
237: Set strDef = New fileName
238: strDef.path = FileDialog.getProjectDir & "\" & thmUC.Name & "_woe.dbf"
'fnW = FileDialog.Put(strDef, "*.dbf", "Weights of Evidence Table")
     Dim fnw As Variant
241: fnw = FileDialog.GetSaveFileName("Weights of Evidence Table", FileDialog.getDir(strDef.path), FileDialog.GetFileName(strDef.path))
'If (fnW = Nil) Then
243: If IsNull(fnw) Or IsEmpty(fnw) Then
'  return Nil
245:     Set gSDI_CalcWeights = Nothing
         Exit Function
'End
248: End If
'strDefV = fileName.GetCWD.MakeTmp("woevar", "dbf")
     Dim strDefV As IFileName
251: Set strDefV = New fileName
252: strDefV.path = FileDialog.getProjectDir & "\" & thmUC.Name & "_woevar.dbf"
'fnVar = FileDialog.Put(strDefV, "*.dbf", "Variances of Weights Table")
     Dim fnVar As Variant
255: fnVar = FileDialog.GetSaveFileName("Variances of Weights Table", FileDialog.getDir(strDefV.path), FileDialog.GetFileName(strDefV.path))
'If (fnVar = Nil) Then
257: If IsNull(fnVar) Or IsEmpty(fnVar) Then
'  return Nil
259:     Set gSDI_CalcWeights = Nothing
        Exit Function
'End
262: End If
263: ProgressAnimation.Show "Creating WOE and WOEVar tables..."
'' Make fields and add to files
''----------------------------------------------
     Dim fldval As Variant
267: fldval = Array("Value", esriFieldTypeInteger, 12, 0, "", False)
'fld0 = Field.Make("Evidence Theme",#FIELD_CHAR,100,0)
     Dim fld0 As Variant
270: fld0 = Array("Evidence_T", esriFieldTypeString, 50, 0, "Generalized Theme", False)
     Dim fld0a As Variant
272: fld0a = Array("Evidence_N", esriFieldTypeString, 50, 0, "Evidence Theme", False)
'fld1 = Field.Make("Class Field",#FIELD_CHAR,100,0)
     Dim fld1 As Variant
275: fld1 = Array("Class_Fiel", esriFieldTypeString, 50, 0, "Generalization Table", False)
     Dim fieldsDesc As New Collection
277: fieldsDesc.Add fldval
278: fieldsDesc.Add fld0a
279: fieldsDesc.Add fld0
280: fieldsDesc.Add fld1
'vTabW = VTab.MakeNew(fnW, dBase)
'vTabW.AddFields({fld0,fld1})
     Dim vTabw As ITable
284: Set vTabw = WOETableUtils.CreateTable(CStr(fnw(0)), CStr(fnw(1)), fieldsDesc, CBool(fnw(2)))
'>>>> Add new SATable to map
286: WOETableUtils.AddTable SDMGlobals.SDMPrjDir, CStr(fnw(0)), SDMGlobals.SDMApp
287: WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnw(0))), fieldsDesc
     Dim fldVVal As Variant
289: fldVVal = Array("Value", esriFieldTypeInteger, 12, 0, "", False)
'fldV0 = Field.Make("Evidence Theme",#FIELD_CHAR,100,0)
     Dim fldV0 As Variant
292: fldV0 = Array("Evidence_T", esriFieldTypeString, 50, 0, "Generalized Theme", False)
     Dim fldV0a As Variant
294: fldV0a = Array("Evidence_N", esriFieldTypeString, 50, 0, "Evidence Theme", False)
'fldV1 = Field.Make("Class Field",#FIELD_CHAR,100,0)
     Dim fldV1 As Variant
297: fldV1 = Array("Class_Fiel", esriFieldTypeString, 50, 0, "Generalization Table", False)
298: Set fieldsDesc = New Collection
299: fieldsDesc.Add fldVVal
300: fieldsDesc.Add fldV0a
301: fieldsDesc.Add fldV0
302: fieldsDesc.Add fldV1
'vTabV = VTab.MakeNew(fnVar, dBase)
'vTabV.AddFields({fldV0,fldV1})
     Dim vTabV As ITable
306: Set vTabV = WOETableUtils.CreateTable(CStr(fnVar(0)), CStr(fnVar(1)), fieldsDesc, CBool(fnVar(2)))
'>>>> Add new SATable to map
308: WOETableUtils.AddTable SDMGlobals.SDMPrjDir, CStr(fnVar(0)), SDMGlobals.SDMApp
309: WOETableUtils.SetAliases FileDialog.GetBaseName(CStr(fnVar(0))), fieldsDesc
'' Make list of unique classes, for all themes
'' and make a field to accommodate values for each
''----------------------------------------------
'lstClssAll = List.Make
     Dim lstClssAll As New SDMUtilities.SDMList
'For Each l In lstsvals
     Dim lobj As Variant
317: For Each lobj In lstsvals.list
'  l1 = l.Clone
         Dim l As SDMUtilities.SDMList
320:     Set l = lobj
         Dim l1 As SDMUtilities.SDMList
322:     Set l1 = l.Clone
'  l1.RemoveDuplicates
324:     Set l1 = l1.RemoveDuplicates
'  lstClssAll = l1.Merge(lstClssAll)
326:     Set lstClssAll = l1.merge(lstClssAll)
'End
328: Next lobj
'lstClssAll.RemoveDuplicates
330: Set lstClssAll = lstClssAll.RemoveDuplicates
'lstClssAll.Sort (True)
332: Set lstClssAll = lstClssAll.Sort(True)
'lstFldsW = List.Make
     Dim lstFldsW As New SDMUtilities.SDMList
'lstFldsV = List.Make
     Dim lstFldsV As New SDMUtilities.SDMList
'For Each n In lstClssAll
     Dim n As Variant
339: For Each n In lstClssAll.list
'  fldW = Field.Make("W"+n.asString,#FIELD_DOUBLE,10,4)
         Dim fldW As Variant
342:     fldW = Array("W" & CStr(n), esriFieldTypeDouble, 10, 4, "", False)
'  lstFldsW.Add (fldW)
344:     lstFldsW.Add fldW
'  fldV = Field.Make("V"+n.asString,#FIELD_DOUBLE,10,4)
         Dim fldV As Variant
347:     fldV = Array("V" & CStr(n), esriFieldTypeDouble, 10, 4, "", False)
'  lstFldsV.Add (fldV)
349:     lstFldsV.Add fldV
'End
351: Next n

'' Add special fields to weights table
''----------------------------------------------
'lstFldsW.Add(Field.Make("Contrast*",#FIELD_DOUBLE,10,4))
356: lstFldsW.Add (Array("Contrast*", esriFieldTypeDouble, 10, 4, "", False))
'lstFldsW.Add(Field.Make("Confidence",#FIELD_DOUBLE,10,4))
358: lstFldsW.Add (Array("Confidence", esriFieldTypeDouble, 10, 4, "", False))
'vTabW.AddFields (lstFldsW)
360: WOETableUtils.AddFields vTabw, lstFldsW
'vTabV.AddFields (lstFldsV)
362: WOETableUtils.AddFields vTabV, lstFldsV
363: ProgressAnimation.Hide
'If (expert) Then
365: If expert Then
'  ' Prompt the user for the number of
'  ' training points to use
'  '----------------------------------

'  strTP = MsgBox.Input("Specify the number of notional training" + NL +
'                       "points you would like to use:","Expert Weights of Evidence","100")
         Dim inputOK As Boolean
373:     inputOK = False
374:     While Not inputOK
            Dim strTP As String
376:        strTP = InputBox("Specify the number > 0 of notional training" & vbCrLf & _
                              "points you would like to use:", "Expert Weights of Evidence", "100")
'  if (strTP.Is(String).Not) then
379:        If Len(strTP) = 0 Then  'Cancel pressed or value set to ""
'    return Nil
381:             Set gSDI_CalcWeights = Nothing
                 Exit Function
'  Else
384:        ElseIf Not IsNumeric(strTP) Then
'    While (strTP.IsNumber.Not)
'      strTP = MsgBox.Input("Specify the number of notional training" + NL +
'                            "points you would like to use:","Expert Weights of Evidence","100")
388:              inputOK = False
'      if (strTP.Is(String).Not) then
'        return Nil
'      End
'    End
'  End
394:        ElseIf CLng(strTP) = 0 Then
395:             inputOK = False
396:        Else
397:             inputOK = True
398:        End If
399:     Wend
'End
401: End If 'end of expert
'
'' Add a record for each theme
''----------------------------------------------
     Dim fldVidx As Long
406: fldVidx = vTabw.FindField("Value")
     Dim fld0idx As Long
408: fld0idx = vTabw.FindField("Evidence_T")
     Dim fld0aidx As Long
410: fld0aidx = vTabw.FindField("Evidence_N")
     Dim fld1idx As Long
412: fld1idx = vTabw.FindField("Class_Fiel")
     Dim fldVVidx As Long
414: fldVVidx = vTabV.FindField("Value")
     Dim fldV0idx As Long
416: fldV0idx = vTabV.FindField("Evidence_T")
     Dim fldV0aidx As Long
418: fldV0aidx = vTabw.FindField("Evidence_N")
     Dim fldV1idx As Long
420: fldV1idx = vTabV.FindField("Class_Fiel")
'i = 0
     Dim i As Long
423: i = 0

'MsgBox "expert=" & expert, , c_sModuleFileName
'MsgBox "lstTNames" & vbCrLf & lstTNames.asString, , c_sModuleFileName
'MsgBox "lstStrFlds" & vbCrLf & lstStrFlds.asString, , c_sModuleFileName
     Dim pProgbar As IStepProgressor
429: Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
430: pProgbar.Position = 0
431: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing evidence layers...", 1, lstTNames.Count, 1, True
'For Each t In lstTNames
     Dim t As Variant
434: For Each t In lstTNames.list
'  rW = vTabW.AddRecord
         Dim rW As irow
437:     Set rW = vTabw.CreateRow
'  rV = vTabV.AddRecord
         Dim rV As irow
440:     Set rV = vTabV.CreateRow
441:     rW.Value(fldVidx) = i + 1
'  strFld = lstStrFlds.Get(i)
         Dim tokens As Variant
444:     tokens = Split(lstStrFlds.GetVal(i), ".")
         Dim strFld As String
446:     strFld = tokens(0)
447:     tokens = Split(strFld, "_")
         Dim itok As Long
         Dim names() As Variant
         ReDim names(UBound(tokens) - 1)
451:     For itok = 1 To UBound(tokens)
452:        names(itok - 1) = tokens(itok)
453:     Next itok
         Dim tName As String
455:     tName = Join(names, "_")
'  vTabW.SetValue(fld0,rW,t)
457:     rW.Value(fld0idx) = CStr(t)
458:     rW.Value(fld0aidx) = tName
'  vTabW.setValue(fld1,rW,strFld)
460:     rW.Value(fld1idx) = strFld
461:     rV.Value(fldVVidx) = i + 1
'  vTabV.SetValue(fldV0,rV,t)
463:     rV.Value(fldV0idx) = CStr(t)
464:     rV.Value(fldV0aidx) = tName
'  vTabV.SetValue(fldV1,rV,strFld)
466:     rV.Value(fldV1idx) = strFld
'
         Dim ras As IRaster
         Dim thm As IRasterLayer
470:     If tmpRastList Is Nothing Then
471:        Set thm = Nothing
'479: MsgBox "tmpRastList is Nothing: tmp is Nothing", , c_sModuleFileName
473:     ElseIf tmpRastList.IsEmpty Then
474:        Set thm = Nothing
'482: MsgBox "tmpRastList.IsEmpty: thm is Nothing", , c_sModuleFileName
476:     ElseIf i > tmpRastList.Count - 1 Then
477:        Set thm = Nothing
'485: MsgBox "i > tmpRastList.Count - 1: thm is Nothing", , c_sModuleFileName
479:     Else
480:        Set ras = tmpRastList.getObj(i)
481:        If ras Is Nothing Then
482:            Set thm = Nothing
'496: MsgBox tmpRastList.GetVal(i) & ": ras is Nothing", , c_sModuleFileName
484:        Else
485:            Set thm = New RasterLayer
486:            thm.CreateFromRaster ras
'500: MsgBox thm.Name, , c_sModuleFileName
488:        End If
489:     End If


'  If (expert) Then
493:     If expert Then  ' EXPERT MODE
'    thm = viewActive.FindTheme(t)
'    If (thm = Nil) Then
496:        If thm Is Nothing Then
'      Continue
498:            GoTo nextT
'    End
500:        End If
'    lstVals = lstsvals.Get(i)
            Dim lstVals As SDMUtilities.SDMList
503:        Set lstVals = lstsvals.getObj(i)
'    missing = lstMD.Get(i)
            Dim missing As Long
506:        missing = lstMD.GetVal(i)
'    lstLst = av.Run("gExprt.Run",{lstVals,lstAreas,thm,missing,strTP})
            Dim gExprtRun As gExprt_Run
509:        Set gExprtRun = New gExprt_Run
            Dim lstLst As SDMUtilities.SDMList
511:        Set lstLst = gExprtRun.gExprt_Run(Array(lstVals, lstAreas, thm, missing, strTP, tName))
'    if (lstLst.Is(String)) then
'      MsgBox.Error(lstLst,"Stopping Calculation of expert weights")
'      return Nil
'    ElseIf (lstLst = Nil) Then
516:        If lstLst Is Nothing Then
517:                Unload gExprt
518:                MsgBox "Stopping Calculation of expert weights: " & vbCrLf, vbCritical, c_sModuleFileName
'      If (statfile <> Nil) Then
520:                If Not IsNull(statfile) Then statfile.Close
'        statfile.Close
'      End
'      return Nil
524:                 Set gSDI_CalcWeights = Nothing
                     Exit Function
'    End
527:        End If
'    lstValsSum = lstLst.Get(0)
            Dim lstValsSum As SDMUtilities.SDMList
530:        Set lstValsSum = lstLst.getObj(0)
'    lstAreasSum = lstLst.Get(1)
            Dim lstAreasSum As SDMUtilities.SDMList
533:        Set lstAreasSum = lstLst.getObj(1)
'    lstTPSum = lstLst.Get(2)
            Dim lstTPSum As SDMUtilities.SDMList
536:        Set lstTPSum = lstLst.getObj(2)
''    sumPnts = lstLst.Get(3)
''    ttlPnts = lstLst.Get(3)
'    sumPnts = strTP.AsNumber
'            Dim sumPnts As Long
541:        sumPnts = CLng(strTP)
'    ttlPnts = strTP.AsNumber
            Dim ttlpnts As Long
544:        ttlpnts = CLng(strTP)
'    'lstLst = av.Run("gExprt.Run",{tmpEMGrid,emField,evidenceMap,"<None>"})
'    '{classList,sumCntLst,pntCountList,totDeposits,totArea,descList2}
'    If (lstLst = "FldNotFnd") Then
''      MsgBox.Error("Either the field VALUE or COUNT could not be "+NL+
''                   "found in "+tmpEMGid.AsString+"'s VTab.","Evidential Theme Error")
'      If (statfile <> Nil) Then
'        statfile.Close
'      End
'      return Nil
'    ElseIf (lstLst = "Cancelled") Then
'      If (statfile <> Nil) Then
'        statfile.Close
'      End
'      return Nil
'    End
'  Else '>>> End of expert mode
561:     Else 'NOT EXPERT
'    ttlPnts = 0
563:        ttlpnts = 0
'    ttlArea = 0
            Dim ttlarea As Double
566:        ttlarea = 0
'    lstVals = lstsvals.Get(i)
568:        Set lstVals = lstsvals.getObj(i)
'    lstValsSum = lstVals.Clone
570:        Set lstValsSum = lstVals.Clone
'    lstValsSum.RemoveDuplicates
572:        Set lstValsSum = lstValsSum.RemoveDuplicates
'    lstTPSum = List.Make
574:        Set lstTPSum = New SDMUtilities.SDMList
'    lstAreasSum = List.Make
576:        Set lstAreasSum = New SDMUtilities.SDMList
'    For Each v In lstValsSum
            Dim v As Variant
579:        For Each v In lstValsSum.list
'      lstTPSum.Add (0)
581:            lstTPSum.Add 0
'      lstAreasSum.Add (0)
583:            lstAreasSum.Add 0
'    End
585:        Next v

'    missing = lstMD.Get(i)
588:        missing = lstMD.GetVal(i)
'    J = 0
          Dim J As Long
591:      J = 0
'    For Each v In lstVals
593:      For Each v In lstVals.list
'      If (v <> missing) Then
595:         If CLng(v) <> missing Then
'        idx = lstValsSum.FindByValue(v)
                 Dim idx As Long
598:             idx = lstValsSum.FindByValue(CLng(v))
'        lstTPSum.Set(idx,lstTPSum.Get(idx) + lstPnts.Get(j))
600:             lstTPSum.SetIt idx, lstTPSum.GetVal(idx) + lstPnts.GetVal(J)
'        lstAreasSum.Set(idx,lstAreasSum.Get(idx) + lstAreas.get(j))
602:             lstAreasSum.SetIt idx, lstAreasSum.GetVal(idx) + lstAreas.GetVal(J)
'        ttlPnts = ttlPnts + lstPnts.Get(J)
604:             ttlpnts = ttlpnts + lstPnts.GetVal(J)
'        ttlArea = ttlArea + lstAreas.Get(J)
606:             ttlarea = ttlarea + lstAreas.GetVal(J)
'      End
608:          End If
'      J = J + 1
610:          J = J + 1
'    End
612:      Next v
'  End     'if not (expert)
614: End If
615: If ttlpnts = 0 Then
616:     MsgBox "Total Points: ttlpnts = 0", , c_sModuleFileName
617:     Set gSDI_CalcWeights = Nothing
         Exit Function
619: End If
'
'  J = 0
622: J = 0
'  lstWgt = List.Make
     Dim lstWgt As SDMUtilities.SDMList
625: Set lstWgt = New SDMUtilities.SDMList
'  lstVar = List.Make
     Dim lstVar As SDMUtilities.SDMList
628: Set lstVar = New SDMUtilities.SDMList
'
'   pProgbar.Position = 0
'   SDMGlobals.SDMStatusBar.ShowProgressBar "Process value sums...", 1, lstValsSum.Count, 1, True

'  For Each v In lstValsSum
     Dim hasMissing As Boolean 'For Expert wts index
635:      hasMissing = False
636: For Each v In lstValsSum.list
'    'progress = ((j + 1)/(lstVals.Count) * 100)
''    doMore = av.SetStatus( progress )
'    ' GET THE CLASS AND CORRESPONING NUMBER OF DEPOSITS,
'    ' NUMBER OF PIXELS (COUNT)
'    '-------------------------------------------------
'    If (v = missing) Then
643:     If CLng(v) = missing Then
'      wp = 0
             Dim wp As Double
646:         wp = 0
'      vp = 0
             Dim vp As Double
649:         vp = 0
650:              hasMissing = True
'    Else
652:     Else
'      nmbTP = lstTPSum.Get(J)
             Dim nmbTP As Long
655:         nmbTP = lstTPSum.GetVal(J)
'      Area = lstAreasSum.Get(J) / 1000000
             Dim Area As Double
658:         Area = lstAreasSum.GetVal(J) / 1000000
'      If (asymptote) Then
660:         If asymptote Then
'        ucArea = Area
                    Dim ucArea As Double
663:                ucArea = Area
'      elseif ((asymptote).Not) then
665:         ElseIf Not asymptote Then
'        ucArea = Area / unitArea
667:                ucArea = Area / unitArea
'      End
669:         End If
'
'      'CALCULATE WEIGHT FOR CLASS
'      '----------------------------------
'Expert mode has calculated Wts in gExprt table
'But not for missing data which is taken care of above
675:         If expert Then 'Expert Mode has own Wts
                 Dim JJ As Long
677:             If hasMissing Then JJ = J - 1 Else JJ = J
678:             If gExprt.wtxt(JJ).Text = "" Then
679:                    wp = 0#
680:             Else
681:                    wp = CDbl(gExprt.wtxt(JJ).Text)
682:             End If
683:             vp = 0
684:         Else  'End of Expert mode
'      db = nmbTP
                 Dim db As Double
687:             db = nmbTP
'      ds = ttlPnts
                 Dim ds As Double
690:             ds = ttlpnts
'      If (db = 0) Then
692:             If db = 0 Then
'        db = 0.01
694:                 db = 0.01
'      ElseIf (db = ds) Then
696:             ElseIf db = ds Then
'        db = db - 0.01
698:                db = db - 0.01
'      End
700:             End If
'      b = ucArea
                 Dim b As Double
703:             b = ucArea
'      If (asymptote) Then
705:             If asymptote Then
'         s = sumArea
                     Dim s As Double
708:                 s = sumArea
'        's = sumArea / 1000000   'parameters.FindByName("txl_StdArea").GetLabel
'        's = ttlArea / 1000000
'      Else
712:             Else
'        's = sumArea / 1000000 / unitArea   'parameters.FindByName("txt_Totuarea").GetLabel
'        s = ttlArea / 1000000 / unitArea
715:                 s = ttlarea / 1000000 / unitArea
'      End
717:             End If
'      If (s = Nil) Then
719:             If s = 0 Then
'        If (statfile <> Nil) Then
721:                 If Not IsNull(statfile) Then
'          statfile.Close
723:                    statfile.Close
'        End
725:                 End If
'        return "NoArea"
727:                 Set gSDI_CalcWeights = New SDMUtilities.SDMList
728:                 gSDI_CalcWeights.Add "NoArea"
                     Exit Function
'      End
731:             End If
'      'CALCULATE W+
'      '-------------
'
'      pbd = db / ds
                 Dim pbd As Double
737:             If db > 0 And ds > 0 Then
738:                pbd = db / ds
739:             Else
740:                pbd = 0.001
741:             End If
'      if ((asymptote).Not) then
743:             If Not asymptote Then
'        pbdb = (b - db) / (s - ds)
                    Dim pbdb As Double
746:                If b - db > 0 And s - ds > 0 Then
747:                 pbdb = (b - db) / (s - ds)
748:                Else
749:                 pbdb = 10
750:                End If
'      ElseIf (asymptote) Then
752:             ElseIf asymptote Then
'        pbdb = (b / s)
754:                 If b > 0 And s > 0 Then
755:                    pbdb = b / s
756:                 Else
757:                    pbdb = 10
758:                 End If
'      End
760:             End If
'      ls = pbd / pbdb
762:             If pbdb = 0 Then
                     Dim msg As String
764:                 msg = "b=" & b & vbCrLf & "s=" & s & vbCrLf & _
                        "db=" & db & vbCrLf & "ds=" & ds & vbCrLf & _
                        "pbd=" & pbd & vbCrLf & "pbdb=" & pbdb
767:                 MsgBox "Bad W+ calculation. pbdb=0" & vbCrLf & msg, vbCritical, c_sModuleFileName
768:                 Set gSDI_CalcWeights = Nothing
                     Exit Function
770:             End If
                 Dim ls As Double
772:             ls = pbd / pbdb
'      wp = ls.Ln
774:             wp = Log(ls)
'
'      'CALCULATE VARIANCE OF W+
'      '------------------------
'      vp = (1 / db) + (1 / (b - db))
779:             If db = 0 Or (b - db) = 0 Then
780:                 msg = "Bad Variance of W+ calculation" & vbCrLf & _
                        "One of the following values will cause a division by zero!" & vbCrLf & _
                        "U.C. area: b=" & b & vbCrLf & _
                        "No. Training Points: db=" & db & " and b-db=" & b - db & vbCrLf & _
                        "Aborting weights calculation."
785:                 MsgBox msg, vbExclamation, c_sModuleFileName
786:                 Set gSDI_CalcWeights = Nothing
                     Exit Function
788:             End If
789:             vp = (1 / db) + (1 / (b - db))
'
791:         End If 'End of Non-Expert mode

'      lstWgt.Add (wp)
794:         lstWgt.Add wp
'      lstVar.Add (vp)
796:         lstVar.Add vp
'
'      vTabW.SetValue(vTabW.FindField("W"+v.AsString),rW,wp)
799:         rW.Value(vTabw.FindField("W" & CStr(v))) = wp
'      vTabV.SetValue(vTabV.FindField("V"+v.asString),rV,vp)
801:         rV.Value(vTabV.FindField("V" & CStr(v))) = vp
'    End
803:     End If 'End of not missing value
'    J = J + 1
805:     J = J + 1
'  End
'     SDMGlobals.SDMStatusBar.StepProgressBar
808: Next v
'     SDMGlobals.SDMStatusBar.HideProgressBar
'
'  If (lstWgt.Count > 1) Then
         Dim lstCtrst As SDMUtilities.SDMList
813:     Set lstCtrst = New SDMUtilities.SDMList
814:     If lstWgt.Count > 1 Then
'    lstCtrst = lstWgt.Clone
816:         Set lstCtrst = lstWgt.Clone
'    lstCtrst.Sort (True)
818:         Set lstCtrst = lstCtrst.Sort(True)
'  End
820:     End If
'  If (lstCtrst.IsEmpty.Not) Then
822:     If (Not lstCtrst.IsEmpty) Then
'    wMax = lstCtrst.Get(lstCtrst.Count - 1)
            Dim wMax As Double
825:         wMax = lstCtrst.GetVal(lstCtrst.Count - 1)
'    wMin = lstCtrst.Get(0)
            Dim wMin As Double
828:         wMin = lstCtrst.GetVal(0)
'    vMax = lstVar.Get(lstWgt.FindByValue(wMax))
            Dim vMax As Double
831:         vMax = lstVar.GetVal(lstWgt.FindByValue(wMax))
'    vMin = lstVar.Get(lstWgt.FindByValue(wMin))
            Dim vMin As Double
834:         vMin = lstVar.GetVal(lstWgt.FindByValue(wMin))
'    Contrast = wMax - wMin
            Dim Contrast As Double
837:        Contrast = wMax - wMin
'    sc = (vMax + vMin).Sqrt
            Dim sc As Double
840:        sc = Sqr(Abs(vMax + vMin)) 'Handle negative contrasts
'    confidence = Contrast / sc
            Dim confidence As Double
843:        If sc = 0 Then
844:                 confidence = -1
845:        Else
846:                 confidence = Contrast / sc
847:        End If
'    vTabW.SetValue(vTabW.FindField("Contrast_"),rW,contrast)
            Dim CnFldIdx As Long
850:        CnFldIdx = vTabw.FindField("Contrast*")
851:        rW.Value(CnFldIdx) = Contrast
'    vTabW.SetValue(vTabW.FindField("Confidence"),rW,confidence)
            Dim CfFldIdx As Long
854:        CfFldIdx = vTabw.FindField("Confidence")
855:        rW.Value(CfFldIdx) = confidence
'  End
857:     End If
'  i = i + 1
859:     i = i + 1
'End
861:     rW.Store
862:     rV.Store
863:     SDMGlobals.SDMStatusBar.StepProgressBar
nextT:
865: Next t 'end of evidence layer processing loop
866: SDMGlobals.SDMStatusBar.HideProgressBar
'' Add record to weights table to hold # points/study area
''----------------------------------------------
'rW = vTabW.AddRecord
870: Set rW = vTabw.CreateRow
'Set name of training pts layer
     Dim fldIdx As Long
873: fldIdx = 3
874: If Not expert Then
875:     rW.Value(fldIdx) = thmTP.Name
876: Else
877:     rW.Value(fldIdx) = "<Expert_mode>"
878: End If
'vTabW.SetValue(vTabW.GetFields.Get(2),rW,sumPnts)
880: fldIdx = 4
881: rW.Value(fldIdx) = sumPnts
'sumArea = (sumArea * 100).Round / 100
883: sumArea = Round(sumArea, 2)
'vTabW.SetValue(vTabW.GetFields.Get(3),rW,sumArea)
885: fldIdx = 5
886: rW.Value(fldIdx) = sumArea
'If (expert.Not) Then
888: If Not expert Then
'  vTabW.SetValue(vTabW.GetFields.Get(4),rW,prbPrior)
890:     fldIdx = 6
891:     rW.Value(fldIdx) = prbPrior
'End
893: End If
894: rW.Store
'
'lstChr = {"W","V"}
     Dim lstChr As Variant
898: lstChr = Array("W", "V")
'k = 0
     Dim k As Long
901: k = 0
'for each vt in {vTabW,vTabV}
     Dim tabArray As Variant
904: tabArray = Array(vTabw, vTabV)
905: pProgbar.Position = 0
906: SDMGlobals.SDMStatusBar.ShowProgressBar "Processing tables...", 1, lstTNames.Count, 1, True
     Dim vtVar As Variant
908: For Each vtVar In tabArray
         Dim vt As ITable
910:     Set vt = vtVar
'  Chr = lstChr.Get(k)
         Dim Chr As String
913:     Chr = lstChr(k)
'  If (k = 0) Then
915:     If k = 0 Then
'    nmbR = vt.GetNumRecords - 1
        Dim nmbR As Long
918:         nmbR = vt.RowCount(Nothing)
'  Else
920:     Else
'    nmbR = vt.GetNumRecords
922:         nmbR = vt.RowCount(Nothing)
'  End
924:     End If
'
'  i = 0
927:     i = 0
'  For Each r In vt
         Dim curs As ICursor
930:     Set curs = vt.Update(Nothing, True)
         Dim r As irow
932:     Set r = curs.NextRow
933:     While Not r Is Nothing
'    If (i < nmbR) Then
935:         If i < nmbR Then
'      lstVals = lstsvals.Get(i)
937:             Set lstVals = lstsvals.getObj(i)
'      For Each f In vt.GetFields
                 Dim pfields As IFields
                 Dim f As IField
941:             Set pfields = vt.Fields
942:             For i = 0 To (pfields.FieldCount - 1)
943:                 Set f = pfields.Field(i)
'        strF = f.GetName
                     Dim strF As String
946:                 strF = f.Name
'        nmbF = strF.Right(strF.Count - 1)
                     Dim nmbF As String
949:                 nmbF = Right(strF, Len(strF) - 1)
'        If ((f.GetName.Left(1) = Chr) And (nmbF.IsNumber)) Then
951:                 If (Left(f.Name, 1) = Chr) And IsNumeric(nmbF) Then
'          If (lstVals.FindByValue(nmbF.AsNumber) < 0) Then
953:                     If lstVals.FindByValue(CLng(nmbF)) < 0 Then
'            vt.SetValue(f,r,nmbNull)
955:                         r.Value(i) = Empty
'          End
957:                     End If
'        End
959:                 End If
'      End
961:             Next i
'    Else
963:         Else
'      lstFlds = vt.GetFields
'      for each j in 5..(lstFlds.Count - 1)
966:             For J = 5 To vt.Fields.FieldCount - 1
'        vt.SetValue(lstFlds.Get(j),r,nmbNull)
968:                 r.Value(J) = Empty
'      End
970:             Next J
'    End
972:         End If
'    i = i + 1
974:         i = i + 1
'  End
976:         Set r = curs.NextRow
977:     Wend
'  vt.SetEditable (False)
'  vt.Flush
'  vt.Refresh
'  k = k + 1
982:     k = k + 1
'End
984:     SDMGlobals.SDMStatusBar.StepProgressBar
985: Next vtVar 'end processing tables
986:     SDMGlobals.SDMStatusBar.HideProgressBar
    
     Dim saColl As IStandaloneTableCollection
     Dim pMxDoc As IMxDocument
990: Set pMxDoc = SDMGlobals.SDMDoc

     Dim fs As Object
993: Set fs = CreateObject("Scripting.FileSystemObject")
'tabW = Table.Make(vTabW)
     Dim tabW As IStandaloneTable
996: Set tabW = New StandaloneTable
997: Set tabW.Table = vTabw
'tabW.SetName (vTabW.GetBaseTableFilename.GetBaseName)
999: tabW.Name = fs.GetBaseName(fnw(0))
'saColl.AddStandaloneTable tabW
'tabV = Table.Make(vTabV)
      Dim tabV As IStandaloneTable
1003: Set tabV = New StandaloneTable
1004: Set tabV.Table = vTabw
'tabV.SetName (vTabV.GetBaseTableFilename.GetBaseName)
1006: tabV.Name = fs.GetBaseName(fnVar(0))
'saColl.AddStandaloneTable tabV
'strSrcW = vTabW.GetBaseTableFilename.GetFullName
      Dim strSrcW As String
1010: strSrcW = fs.buildpath(fnw(1), fnw(0))
'strSrcV = vTabV.GetBaseTableFilename.GetFullName
      Dim strSrcV As String
1013: strSrcV = fs.buildpath(fnVar(1), fnVar(0))
1014: Set fs = Nothing

'>>>>> Save comments in ARCSDM commanditem "Spatial Data Modeller"
'mnuSDM = av.Run("gSDI.GetSDMMenu",{})
''''Dim gSDIGetSDMMenu As gSDI_GetSDMMenu
''''909: Set gSDIGetSDMMenu = New gSDI_GetSDMMenu
''''Dim mnuSDM As ICommandItem
''''911: Set mnuSDM = gSDIGetSDMMenu.gSDI_GetSDMMenu
'''''If (mnuSDM.Is(Menu)) Then
''''913: If Not mnuSDM Is Nothing Then
'''''  Comments = mnuSDM.GetTag
''''    Dim comments As String
''''916:     comments = mnuSDM.Tag
'''''  lstCmts = Comments.AsTokens("*")
''''    Dim lstCmts As Variant
''''919:     lstCmts = Split(comments, "*")
'''''  If (lstCmts.Count = 2) Then
''''921:     If UBound(lstCmts) = 1 Then
'''''    nmThmUC = lstCmts.Get(0)
''''        Dim nmThmUC As String
''''924:         nmThmUC = lstCmts(0)
'''''    rest = lstCmts.Get(1)
''''        Dim rest As String
''''927:         rest = lstCmts(1)
'''''  Else
''''929:     Else
'''''    nmThmUC = ""
''''931:         nmThmUC = ""
'''''    rest = Comments
''''933:         rest = comments
'''''  End
''''935:     End If
'''''  srcThmUC = rest.Extract(11)
''''937:     tokens = Split(rest)
''''    Dim srcThmUC As String
''''939:     If UBound(tokens) > 10 Then
''''940:         srcThmUC = tokens(11)
''''941:     End If
'''''  comments = comments + NL + "Associated Files:" + NL +
'''''             "    Weights Table:  " + tabW.GetName + " (Source: " + strSrcW + ")" + vbcrlf +
'''''             "    Variances Table:  " + tabV.GetNAme + " (Source: " + strSrcV + ")" + vbcrlf
''''945:     comments = comments & vbCrLf & "Associated Files:" & vbCrLf & _
''''             "    Weights Table:  " & tabW.Name & " (Source: " & strSrcW & ")" & vbCrLf & _
''''             "    Variances Table:  " & tabV.Name & " (Source: " & strSrcV & ")" & vbCrLf
'''''  mnuSDM.SetTag (Comments)
''''949:     mnuSDM.Tag = comments
'''''End
''''951: End If

'>>>>> Save comments in table tabW
''''Dim cmtsW As String
'''''cmtsW = "Generated by: Arc-SDM - Calculate Response Theme" + vbcrlf +
'''''        "Weights Table" + vbcrlf +
'''''        "Base Table Filename: " + strSrcW + vbcrlf +
'''''        vbcrlf + "Associated Files:" + vbcrlf +
'''''        "    Unique Conditions Theme:" + nmThmUC + " (Source: " + srcThmUC + ")" + vbcrlf +
'''''        "    Variances Table:" + tabV.GetName + " (Source: " + strSrcV + ")"
''''959: cmtsW = "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf & _
''''        "Weights Table" & vbCrLf & _
''''        "Base Table Filename: " & strSrcW & vbCrLf & _
''''        vbCrLf & "Associated Files:" & vbCrLf & _
''''        "    Unique Conditions Theme:" & nmThmUC & " (Source: " & srcThmUC & ")" & vbCrLf & _
''''        "    Variances Table:" & tabV.Name & " (Source: " & strSrcV & ")"
''''
'''''tabW.SetComments (cmtsW)

'>>>>> Save comments in table tabV
''''Dim cmtsV As String
'''''cmtsV = "Generated by: Arc-SDM - Calculate Response Theme" + NL +
'''''        "Variances Table" + NL +
'''''        "Base Table Filename: " + strSrcV + NL +
'''''        NL + "Associated Files:" + NL +
'''''        "    Unique Conditions Theme: " + nmThmUC + " (Source: " + srcThmUC + ")" + NL +
'''''        "    Weights Table: " + tabW.GetName + " (Source: " + strSrcW + ")"
''''976: cmtsV = "Generated by: Arc-SDM - Calculate Response Theme" & vbCrLf & _
''''        "Variances Table" & vbCrLf & _
''''        "Base Table Filename: " + strSrcV & vbCrLf & _
''''        vbCrLf + "Associated Files:" & vbCrLf & _
''''        "    Unique Conditions Theme: " + nmThmUC + " (Source: " + srcThmUC + ")" & vbCrLf & _
''''        "    Weights Table: " + tabW.Name + " (Source: " + strSrcW + ")"
''''
'''''tabV.SetComments (cmtsV)

'return {vTabW,vTAbV,rW}
1098: Set gSDI_CalcWeights = New SDMUtilities.SDMList
1099: gSDI_CalcWeights.AddArray Array(vTabw, vTabV, rW)
1100: If expert Then gExprt.Hide
'989: MsgBox "exiting...", , c_sModuleFileName
'
'
'
''<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
    HandleError True, "CalcWeights " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
1109:     Set gSDI_CalcWeights = Nothing
1110: If expert Then Unload gExprt
End Function





