VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_CumulativeFreq"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_CumulativeFreq.cls"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_CumulativeFreq()
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.CumulativeFreq
''
''
''Topics:  Spatial Data Modeller
''
''Description:  Creates a table based on the area and posterior
'' probability values found in the attribute table of a response theme (unique
'' conditions table).  Sorts and writes the posterior probabilities to a table,
'' sums the associated areas cumulatively and writes them to the same table.
'' Creates an XY chart based on the values in the table.   Adds the chart and table
'' to the project.
''
''Requires:  An active response theme (created with the SDM
'' extension)
''
'' Self:  Cumulative Frequency tool inthe View GUI.
''
''Returns:
''==============================================
'av.UseWaitCursor
'dTitle = "Cumulative Frequency"
37: Const dTitle As String = "Cumulative Frequency"
'' GET THE VIEW, AND ITS ACTIVE THEME
''------------------------------------------
'theView = av.GetActiveDoc
41: Set SDMGlobals.SDMApp = New AppRef
    Dim pMxDoc As IMxDocument
43: Set pMxDoc = SDMGlobals.SDMApp.Document
44: Set SDMGlobals.SDMMap = pMxDoc.FocusMap
'If (theView.Is(View).Not) Then
'  MsgBox.Error("The active document must be a View.",dTitle)
'  return Nil
'End
'activeThemes = theView.GetActiveThemes
    If SDMGlobals.SDMMap.LayerCount = 0 Then Exit Sub
    Dim allThemes As IEnumLayer
52: Set allThemes = SDMGlobals.SDMMap.layers
    Dim theme As ILayer
54: Set theme = allThemes.Next
    Dim activethemes As New SDMUtilities.SDMList
56: While (Not theme Is Nothing)
57:     If theme.Valid Then _
                If UCase(theme.Name) Like "SDM*" Then _
                    activethemes.Add theme
60:     Set theme = allThemes.Next
61: Wend
'If (activeThemes.IsEmpty) Then
'  Self.SetEnabled (False)
'  return Nil
'End
66: If activethemes.IsEmpty Then
67:     MsgBox "No response themes are active.", vbCritical, dTitle
         Exit Sub
69: End If

'responseTheme = activeThemes.Get(0)
    Dim respThmVar As Variant
    Dim responseTheme As ILayer
    Dim nat As Long
75: For nat = 0 To activethemes.Count - 1
76:     Set responseTheme = activethemes.getObj(nat)
77:     ListDialogSDM.lbx_list.AddItem responseTheme.Name
78: Next nat
79: ListDialogSDM.Message = "Select a model theme"
80: ListDialogSDM.Title = dTitle
81: ListDialogSDM.doModal
    Dim strTheme As String
83: strTheme = ListDialogSDM.getValue
'  If (strAlias = Nil) Then
    If strTheme = "" Then Exit Sub
'    return Nil
'  End

89: Set responseTheme = WOETableUtils.FindLayerByName(strTheme)

'' VERIFY THAT IT IS BASIC TYPE FOR RESPONSE THEME
''------------------------------------------
'If (responseTheme.Is(Gtheme).Not) Then
94: If Not TypeOf responseTheme Is IRasterLayer Then
'  MsgBox.Error("Active theme is not a response theme.",dTitle)
96:     MsgBox "Active theme is not a response theme.", vbCritical, dTitle
'  return Nil
          Exit Sub
'ElseIf (responseTheme.GetGrid.IsInteger.Not) Then
100: Else
            Dim rLayer As IRasterLayer
102:    Set rLayer = responseTheme
            Dim rasprops As IRasterProps
104:    Set rasprops = rLayer.Raster
            Dim dispTbl As IDisplayTable
106:         If Not TypeOf responseTheme Is IDisplayTable Then
107:             MsgBox "Not a valid response theme.  Select another.", vbExclamation, c_sModuleFileName
                 Exit Sub
109:         End If
110:    Set dispTbl = responseTheme
        Dim respVTab As ITable
112:    Set respVTab = dispTbl.DisplayTable
113:    If Not rasprops.IsInteger Then
'  MsgBox.Error("Active theme is not a response theme.",dTitle)
115:          MsgBox "Selected theme is not an integer response theme.", vbCritical, dTitle
'  return Nil
                Exit Sub
'End
119:  End If
        
          Dim fldsVTab As SDMUtilities.SDMList
122:    Set fldsVTab = WOETableUtils.getFieldsNames(respVTab)
123:    If (WOETableUtils.FindLikeByValue(fldsVTab, "*Post_Prob") = -1 And _
            WOETableUtils.FindLikeByValue(fldsVTab, "*LRPostProb") = -1 And _
            WOETableUtils.FindLikeByValue(fldsVTab, "*RBFLN*") = -1 And _
            WOETableUtils.FindLikeByValue(fldsVTab, "*Pat*") = -1 And _
            WOETableUtils.FindLikeByValue(fldsVTab, "*PNN") = -1) And _
            (WOETableUtils.FindLikeByValue(fldsVTab, "*Area_sqm") = -1) _
         Then
129:        MsgBox "Active theme must be joined to an Area table and a WOFE or Neural Network result table.", vbCritical, dTitle
              Exit Sub
131:    End If
132: End If

'respVTab = av.Run("gSDI.GetVTab",{responseTheme})

'' THEN CHECK FOR RESPONSE THEME FIELDS
''------------------------------------------
''fNList = {"Trngpoints","Area_sqm","Post_prob","Post_logit","Sum_weight","Uncertaint","LRPostProb"}
''
''goodFlds = 0
''
''for each f in fNList
''  responseVTab = av.Run("gSDI.GetVTab",{responseTheme})
''  if (responseVTab = Nil) then
''    return Nil
''  end
''  if (responseVTab.FindField(f) = Nil) then
''    msgbox.Error("Active theme is not a response theme.",dTitle)
''    return NIl
''  else
''    goodFlds = goodFlds + 1
''  end
''end
''

''if (goodFlds <> fNList.Count) then
''  MsgBox.Error("Active theme is not a response theme.",dTitle)
''  return Nil
''end
'' FIND THE AREA AND PROBABILITY FIELDS,
'' START READING IN VALUES FROM TABLE AND
'' STORING IN LISTS
''------------------------------------------
'lstFldOK = List.make
Dim lstFldOK As New SDMUtilities.SDMList
'probField = respVTab.FindField("Post_prob")
Dim probFieldidx As Long
168: probFieldidx = WOETableUtils.FindLikeByValue(fldsVTab, "*Post_Prob")
'If (probField.Is(Field)) Then
170: If probFieldidx > -1 Then
'  lstFldOK.Add (probField)
172:     lstFldOK.Add respVTab.Fields.Field(probFieldidx)
'End
174: End If
'fldPrbLR = respVTab.FindField("LRPostProb")
     Dim fldPrbLR As Long
177: fldPrbLR = WOETableUtils.FindLikeByValue(fldsVTab, "*LRPostProb")
'If (fldPrbLR.Is(Field)) Then
179: If fldPrbLR > -1 Then
'  lstFldOK.Add (fldPrbLR)
181:     lstFldOK.Add respVTab.Fields.Field(fldPrbLR)
'End
183: End If
     Dim rbflnMmshp As Long
185: rbflnMmshp = WOETableUtils.FindLikeByValue(fldsVTab, "*RBFLN*")
'If (probField.Is(Field)) Then
187: If rbflnMmshp > -1 Then
'  lstFldOK.Add (probField)
189:     lstFldOK.Add respVTab.Fields.Field(rbflnMmshp)
'End
191: End If
     Dim pnn As Long
192: pnn = WOETableUtils.FindLikeByValue(fldsVTab, "*PNN")
'If (probField.Is(Field)) Then
194: If pnn > -1 Then
'  lstFldOK.Add (probField)
196:     lstFldOK.Add respVTab.Fields.Field(pnn)
'End
198: End If
     Dim n As Long
200: n = 0
     Dim fldPatN As Long
202: Do
203:    n = n + 1
204:    fldPatN = WOETableUtils.FindLikeByValue(fldsVTab, "*Pat" & n)
'If (probField.Is(Field)) Then
206:    If fldPatN > -1 Then
'  lstFldOK.Add (probField)
208:        lstFldOK.Add respVTab.Fields.Field(fldPatN)
'End
210:    End If
211: Loop While fldPatN > -1

213: ListDialogSDM.lbx_list.Clear
'If (lstFldOK.Count > 1) Then
215: If lstFldOK.Count > 0 Then
'  lstAlias = List.make
        Dim lstAlias As New SDMUtilities.SDMList
'  For Each f In lstFldOK
        Dim f As Variant
220:    For Each f In lstFldOK.list
             Dim fld As esrigeodatabase.IField
222:         Set fld = f
'    lstAlias.Add (f.GetAlias)
224:         lstAlias.Add fld.AliasName
225:         ListDialogSDM.lbx_list.AddItem fld.AliasName
'  End
227:    Next f
228: End If
'  strAlias = MsgBox.ListAsString(lstAlias, "Select one field to plot against cumulative area:", dTitle)
230:     ListDialogSDM.Message = "Select one field to plot against cumulative area:"
231:     ListDialogSDM.Title = dTitle
232:     ListDialogSDM.doModal
         Dim strAlias As String
234:     strAlias = ListDialogSDM.getValue
'  If (strAlias = Nil) Then
         If strAlias = "" Then Exit Sub
'    return Nil
'  End
'
'  lstFldOK = List.make
241:         lstFldOK.Clear
'  fld = respVTab.FindField(strAlias)
             Dim fldIdx As Long
244:         fldIdx = WOETableUtils.FindLikeByValue(fldsVTab, "*" & strAlias)
'  If (fld.Is(Field)) Then
246:         If fldIdx > -1 Then
247:             Set fld = respVTab.Fields.Field(fldIdx)
'    lstFldOK.Add (fld)
249:             lstFldOK.Add fld
'  End
251:         End If
'  If (lstFldOK.IsEmpty) Then
        If lstFldOK.IsEmpty Then Exit Sub
'    return Nil
'  End
'End
'' GET THE ATTRIBUTE TABLE AND ITS VTAB
'
''------------------------------------------
'
'responseTheme.EditTable
'respTab = av.GetActiveDoc
'If (respTab.Is(Table)) Then
'  If (respTab.GetName <> ("Attributes Of " + responseTheme.GetName)) Then
'    respTab = av.GetProject.FindDoc("Attributes Of " + responseTheme.GetName)
'    If (respTab = Nil) Then
'      MsgBox.Error("Couldn't find the attribute table for "+Nl+
'                   "the active response theme.",dTitle)
'      return Nil
'    End
'  End
'Else
'  respTab = av.GetProject.FindDoc("Attributes Of " + responseTheme.GetName)
'  If (respTab = Nil) Then
'    MsgBox.Error("Couldn't find the attribute table for "+Nl+
'                 "the active response theme.",dTitle)
'    return Nil
'  End
'End

Dim ValueIdx As Long
282: ValueIdx = WOETableUtils.FindLikeByValue(fldsVTab, "*Value")
Dim valueFld As esrigeodatabase.IField
284: Set valueFld = respVTab.Fields.Field(ValueIdx)
'AreaFieldIdx = respVTab.FindField("Area_sqm")
Dim AreaFieldIdx As Long
287: AreaFieldIdx = WOETableUtils.FindLikeByValue(fldsVTab, "*Area_sqm")
Dim AreaField As esrigeodatabase.IField
289: Set AreaField = respVTab.Fields.Field(AreaFieldIdx)
'If (AreaFieldIdx.Is(Field).Not) Then
'  MsgBox.Error("Could not find field " + AreaFieldIdx.GetAlias + " in response theme attribute table. Quitting.",dTitle)
'  return Nil
'End

'totalArea = 0
Dim totalArea As Double
297: totalArea = 0
Dim valueList As New SDMUtilities.SDMList
'areaList = List.make
Dim arealist As New SDMUtilities.SDMList
'numRecs = respVTab.GetNumRecords
Dim numRecs As Long
303: numRecs = respVTab.RowCount(Nothing)
'i = 0
Dim i As Long
306: i = 0
'lstList = List.make
Dim lstList As New SDMUtilities.SDMList
'For Each f In lstFldOK
310: For Each f In lstFldOK.list
'  lstList.Add (List.make)
312:     lstList.Add New SDMUtilities.SDMList
'End
314: Next f
'If (respTab.GetWin.IsOpen.Not) Then
'  respTab.GetWin.Open
'  respTab.Sort(lstFldOK.Get(0),True)
'Else
'  respTab.Sort(lstFldOK.Get(0),True)
320: Set fld = lstFldOK.getObj(0)
Dim pTableSort As ITableSort
322: Set pTableSort = SortTable(respVTab, lstFldOK.getObj(0), False)
'End
Dim pStatusBar As esriSystem.IStatusBar
Dim pProgbar As IStepProgressor

327: Set SDMGlobals.SDMStatusBar = SDMGlobals.SDMApp.StatusBar
328: Set pStatusBar = SDMGlobals.SDMStatusBar
329: Set pProgbar = pStatusBar.ProgressBar

331: pProgbar.Position = 0
332: pStatusBar.ShowProgressBar "Processing...", 0, pTableSort.Table.RowCount(Nothing), 1, True

Dim srtcurs As ICursor
335: Set srtcurs = pTableSort.Rows
Dim r As irow
337: Set r = srtcurs.NextRow
'for each r in 0 .. (numRecs - 1)
339: While Not r Is Nothing
340:     pStatusBar.StepProgressBar
'  rec = respTab.ConvertRowToRecord(r)
         Dim rec As Long
343:     rec = r.OID
'  for each i in 0..(lstFldOK.Count - 1)
345:     For i = 0 To lstFldOK.Count - 1
'    f = lstFldOK.Get(i)
347:         Set fld = lstFldOK.getObj(i)
'    probList = lstList.Get(i)
             Dim problist As SDMUtilities.SDMList
350:         Set problist = lstList.getObj(i)
'    probList.Add (respVTab.ReturnValue(f, rec))
             Dim respVTabRow As irow
353:         Set respVTabRow = respVTab.GetRow(rec)
354:         problist.Add respVTabRow.Value(WOETableUtils.FindLikeByValue(fldsVTab, "*" & fld.Name))
'    lstList.Set(i,probList)
356:         lstList.SetIt i, problist
'  End
358:     Next i
359:     valueList.Add respVTabRow.Value(ValueIdx)
'  Area = respVTab.ReturnValue(AreaFieldIdx, rec)
         Dim area As Double
362:     area = respVTabRow.Value(AreaFieldIdx)
'  areaList.Add (Area)
364:     arealist.Add area
'  totalArea = totalArea + Area
366:     totalArea = totalArea + area
'
'End
369:     Set r = srtcurs.NextRow
370: Wend
371: pStatusBar.HideProgressBar
'cAreaList = List.make
Dim cAreaList As New SDMUtilities.SDMList
'intArea = 0
Dim intArea As Double
376: intArea = 0
'for each a in (areaList.Count - 1) .. 0 by -1
378: pProgbar.Position = 0
379: pStatusBar.ShowProgressBar "Processing...", 0, arealist.Count, 1, True
Dim a As Long
381: For a = (arealist.Count - 1) To 0 Step -1
'  intArea = intArea + ((areaList.Get(a) / totalArea) * 100)
383:     intArea = intArea + ((arealist.GetVal(a) / totalArea) * 100)
'  cAreaList.Insert (intArea)
385:     cAreaList.Insert intArea
'End
387:     pStatusBar.StepProgressBar
388: Next a
389: pStatusBar.HideProgressBar
'freqVTab = Nil
'For Each l In lstList
Dim lst As SDMUtilities.SDMList
Dim l As Variant
394: For Each l In lstList.list
395:     Set lst = l
'  If (cAreaList.Count <> l.Count) Then
    If cAreaList.Count <> lst.Count Then Exit Sub
'    return Nil
'  End
'End
401: Next l
'' MAKE A NEW DBASE FILE, ADD FIELDS AND
'' WRITE VALUES FROM LISTS
''------------------------------------------
'freqFName = fileName.GetCWD.MakeTmp("Freq", "dbf")
Dim freqFName As IFileName
407: Set freqFName = FileDialog.MakeTmp("Freq", "dbf")
'freqVTab = VTab.MakeNew(freqFName, dBASE)
Dim freqVTab As ITable
'lstFldNew = List.make
Dim lstFldNew As New SDMUtilities.SDMList
'For Each probField In lstFldOK
Dim newProbFd As New SDMUtilities.SDMList
414: newProbFd.Add Array("Value", valueFld.Type, valueFld.Length, valueFld.Precision, "", False)
415: pProgbar.Position = 0
416: pStatusBar.ShowProgressBar "Processing...", 0, lstFldOK.Count, 1, True
Dim probField As Variant
418: For Each probField In lstFldOK.list
419:     Set fld = probField
'  newProbFd = Field.make(probField.GetName, probField.GetType, probField.GetWidth, probField.GetPrecision)
         Dim tokens As Variant
422:     tokens = Split(fld.Name, ".")
423:     If UBound(tokens) = 1 Then
            Dim fldName As String
425:        fldName = tokens(1)
426:     Else
427:        fldName = fld.Name
428:     End If
429:     newProbFd.Add Array(fldName, fld.Type, fld.Length, fld.Precision, fld.AliasName, False)
'  newProbFd.SetAlias (probField.GetAlias)
'  lstFldNew.Add (newProbFd)
432:     lstFldNew.Add newProbFd
'End
434:     pStatusBar.StepProgressBar
435: Next probField
436: pStatusBar.HideProgressBar

438: Set freqVTab = WOETableUtils.CreateTable(FileDialog.GetFileName(freqFName.path), _
                                        FileDialog.getDir(freqFName.path), newProbFd.list, False)
440: newProbFd.Remove 0 'remove Value field from this list
'newAreaFd = Field.make("PercntArea", AreaFieldIdx.GetType, 6, 2)
Dim newAreaFD As Variant
443: newAreaFD = Array("PercntArea", AreaField.Type, 6, 2, "% Cumulative Area", False)
'newAreaFd.SetAlias ("% Cumulative Area")
'lstFldNew.Add (newAreaFd)
446: lstFldNew.Add newAreaFD
'If (freqVTab.StartEditingWithRecovery) Then
'  If (freqVTab.CanAddFields) Then
'    freqVTab.AddFields (lstFldNew)
      Dim newlst As New SDMUtilities.SDMList
451:  newlst.Add newAreaFD
452: WOETableUtils.AddFields freqVTab, newlst
'  Else
'    MsgBox.Error("Cannot add fields to "+freqFName+Nl+
'                 "Please check file permissions.",dTitle)
'    freqVTab.StopEditingWithRecovery (True)
'    return NIl
'  End

460: pProgbar.Position = 0
461: pStatusBar.ShowProgressBar "Processing...", 0, cAreaList.Count, 1, True
'  for each i in 0..(cAreaList.Count - 1)
463:     For i = 0 To cAreaList.Count - 1
'    If (freqVTab.CanAddRecord) Then
'      rec = freqVTab.AddRecord
            Dim newRow As irow
467:        Set newRow = freqVTab.CreateRow
'    Els
'      MsgBox.Error("Cannot add a record to "+freqFName+NL+
'                 "Please check file permissions.",dTitle)
'      freqVTab.StopEditingWithRecovery (True)
'      return Nil
'    End
'    for each j in 0..(lstFldNew.Count - 2)
             Dim j As Long
476:         For j = 0 To lstFldNew.Count - 2
477:             pStatusBar.StepProgressBar
'      probList = lstList.Get(j)
479:             Set problist = lstList.getObj(j)
'      fldNew = lstFldNew.Get(j)
                 Dim fldNewlst As SDMUtilities.SDMList
482:             Set fldNewlst = lstFldNew.getObj(j)
                 Dim fldnew As Variant
484:             fldnew = fldNewlst.GetVal(0)
'      prob = probList.Get(i)
                Dim prob As Double
487:            If Not IsNull(problist.GetVal(i)) Then
488:                prob = CDbl(problist.GetVal(i))
'      freqVTab.SetValue(fldNew,rec,prob)
490:                newRow.Value(freqVTab.FindField(CStr(fldnew(0)))) = prob
491:             End If
'    End
493:         Next j
'    Area = cAreaList.Get(i)
495:         area = cAreaList.GetVal(i)
'    freqVTab.SetValue(newAreaFd,rec,area)
497:         newRow.Value(freqVTab.FindField(newAreaFD(0))) = area
498:         newRow.Value(freqVTab.FindField("Value")) = valueList.GetVal(i)
499:         newRow.Store
'  End
501:         pStatusBar.StepProgressBar
502:     Next i
503:     pStatusBar.HideProgressBar
'  freqVTab.StopEditingWithRecovery (True)
'
'Else
'  MsgBox.Error("Unable to edit "+freqFName+NL+
'               "Please check file permissions.",dTitle)
'  return Nil
'End
'freqVTab.Flush
'freqVTab.Refresh
'' MAKE TABLE DOC
''------------------------------------------
'freqTab = Table.make(freqVTab)
'freqTab.SetName (freqFName.GetBaseName)
Dim freqSATable As IStandaloneTable
518: Set freqSATable = WOETableUtils.CreateStandAloneTable(freqVTab, FileDialog.GetBaseName(freqFName.path))
Dim saTableColl As IStandaloneTableCollection
520: Set saTableColl = SDMGlobals.SDMMap
521: saTableColl.AddStandaloneTable freqSATable
522: newProbFd.Add newAreaFD
523: WOETableUtils.SetAliases freqSATable.Name, newProbFd.list
524: MsgBox "Added table " & freqSATable.Name, vbInformation, dTitle
525: pMxDoc.UpdateContents
'' BUILD CHART BASED ON TABLE
''------------------------------------------
'chartType = #CHARTDISPLAY_XYSCATTER
'
'lstFldNew.Shuffle(newAreaFd,0)
'
'newChart = Chart.make(freqVTab, lstFldNew)
'ncDisplay = newChart.GetChartDisplay
'
'ncDisplay.SetMaxDataPoints (freqVTab.GetNumRecords * 2)
'
'ncDisplay.SetType (chartType)
'
'ncDisplay.setMark(#CHARTDISPLAY_MARK_DOT)
'
''ncDisplay.setMark(#CHARTDISPLAY_MARK_SMALLSQUARE)
'
'ncDisplay.SetSeriesColor (0, Color.GetRed)
'
'ncDisplay.setSeriesColor (1, Color.GetRed)
'
''newChart.SetSeriesFromRecords(False)
'
'newChart.SetSeriesFromRecords (True)
'
'newChart.SetRecordLabelField (newAreaFd)
'
'newChart.GetTitle.SetName ("Posterior Probability vs. % Cumulative Area for " + responseTheme.GetName + " (" + freqFName.GetBaseName + ")")
'
'newChart.SetName (newChart.GetTitle.GetName)
'
'theXAxis = newChart.GetXAxis
'
'theXAxis.SetCrossValue (0)
'
'theXAxis.SetBoundsMin (0)
'
'theXAxis.SetName (newAreaFd.GetAlias)
'
'theXAxis.SetLabelVisible (True)
'
'theYAxis = newChart.GetYAxis
'
'theYAxis.SetName (newChart.GetSeriesLabel(0))
'
'theYAxis.SetLabelVisible (True)
'
'theMinY = theYAxis.GetBoundsMin
'
'If (theMinY > 0) Then
'
'  theYAxis.SetCrossValue (0)
'
'End
'
'newChart.GetChartLegend.SetVisible (False)
'
'av.GetProject.AddDoc (newChart)
'
'respTab.GetWin.Close
'
'newChart.GetWin.Open
588: makeChart freqSATable, lstFldNew, "PercntArea", CStr(fldnew(0)), pMxDoc
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Function SortTable(ByRef pTable As ITable, ByRef pField As esrigeodatabase.IField, ascending As Boolean) As ITableSort
Dim pTableSort As ITableSort
597: Set pTableSort = New TableSort
Dim pQueryFilter As IQueryFilter
599: Set pQueryFilter = New QueryFilter
600: pQueryFilter.whereclause = ""
601: With pTableSort
602:   .Fields = pField.Name
603:   .ascending(pField.Name) = ascending
604:   Set .QueryFilter = Nothing
605:   Set .Table = pTable
606: End With

608: pTableSort.Sort Nothing
609: Set SortTable = pTableSort
End Function

Private Sub makeChart(saTbl As IStandaloneTable, lstFldNew As SDMList, XName As String, YName As String, ByRef pMxDoc As IMxDocument)
  On Error GoTo ErrorHandler


'' BUILD CHART BASED ON TABLE
''------------------------------------------
'chartType = #CHARTDISPLAY_XYSCATTER
'
'lstFldNew.Shuffle(newAreaFd,0)
'
'newChart = Chart.make(freqVTab, lstFldNew)
Dim newChart As IDataGraph
624: Set newChart = New DataGraph
625: With newChart
626:     Set .Table = saTbl
627:         .Name = "Graph of " & saTbl.Name
        Dim fldliststr As String
        Dim i As Long
        Dim fldNewlst As SDMList
        Dim fldnew As Variant
632:     For i = 0 To lstFldNew.Count - 2
633:         Set fldNewlst = lstFldNew.getObj(i)
634:         fldnew = fldNewlst.GetVal(0)
635:         fldliststr = fldliststr & CStr(fldnew(0))
636:         If i < lstFldNew.Count - 2 Then fldliststr = fldliststr & ","
637:     Next i
638:     .FieldSet1 = fldliststr
639:     .FieldSet2 = XName
640:     .SeriesByRecord = True
641:     .UseSelectedSet = True
642: End With

Dim gfxTix As IDataGraphTicks
645: Set gfxTix = newChart
646: With gfxTix
647:     .TickEvery = 1
648:     .Ticks = esriDataGraphTicksXY
649:     .TickStyle = esriDataGraphTickStyleThrough
650: End With

Dim XaxisFldName As String
653: XaxisFldName = XName
Dim XaxisFld As esrigeodatabase.IField
655: Set XaxisFld = saTbl.Table.Fields.Field(saTbl.Table.FindField(XaxisFldName))

Dim YaxisFldName As String
658: YaxisFldName = YName
Dim YaxisFld As esrigeodatabase.IField
660: Set YaxisFld = saTbl.Table.Fields.Field(saTbl.Table.FindField(YaxisFldName))

Dim gfxProps As IDataGraphProperties
663: Set gfxProps = newChart
664: With gfxProps
82:     'If gCht.lbx_Wtc.SelCount = 1 Then
666:     .Title = "Area vs Probability"
84:     'ElseIf gCht.lbx_Wtc.SelCount > 1 Then
        'Dim title As String
86:     '    For i = 0 To gCht.lbx_Wtc.ListCount - 1
87:     '        If gCht.lbx_Wtc.Selected(i) Then
88:     '            If title = "" Then
89:     '                title = saTblName & " " & gCht.lbx_Wtc.list(i)
90:     '            Else
91:     '                title = title & "," & gCht.lbx_Wtc.list(i)
92:     '            End If
93:     '        End If
94:     '    Next i
95:     '        .title = title
96:     'End If
680:     .SubTitle = "% Cumulative Area" 'XaxisFld.AliasName
98:     'If gCht.rbt_Lin Then
682:     .GraphType = esriDataGraphTypeLine
683:    .GraphSubtype = esriDataGraphSubtypeLine2DMarkers
101:     'ElseIf gCht.rbt_Bar Then
102:     '.GraphType = esriDataGraphTypeBar
103:     '.GraphSubtype = esriDataGraphSubtypeColumn2DSimple
104:     'End If
688:     .ShowDataLabels = False
689:     .ShowLegend = True
690:     .LegendPosition = esriDataGraphLegendPositionUC
691: End With

Dim dataGXAxis As IDataGraphAxis
694: Set dataGXAxis = newChart
695: dataGXAxis.YAxisStyle = esriDataGraphAxisStyleVariableOrigin
'ncDisplay = newChart.GetChartDisplay
'
'ncDisplay.SetMaxDataPoints (freqVTab.GetNumRecords * 2)
'
'ncDisplay.SetType (chartType)
'
'ncDisplay.setMark(#CHARTDISPLAY_MARK_DOT)
'
''ncDisplay.setMark(#CHARTDISPLAY_MARK_SMALLSQUARE)
'
'ncDisplay.SetSeriesColor (0, Color.GetRed)
'
'ncDisplay.setSeriesColor (1, Color.GetRed)
'
''newChart.SetSeriesFromRecords(False)
'
'newChart.SetSeriesFromRecords (True)
'
'newChart.SetRecordLabelField (newAreaFd)
'
'newChart.GetTitle.SetName ("Posterior Probability vs. % Cumulative Area for " + responseTheme.GetName + " (" + freqFName.GetBaseName + ")")
'
'newChart.SetName (newChart.GetTitle.GetName)
'
'theXAxis = newChart.GetXAxis
'
'theXAxis.SetCrossValue (0)
'
'theXAxis.SetBoundsMin (0)
'
'theXAxis.SetName (newAreaFd.GetAlias)
'
'theXAxis.SetLabelVisible (True)
'
'theYAxis = newChart.GetYAxis
'
'theYAxis.SetName (newChart.GetSeriesLabel(0))
'
'theYAxis.SetLabelVisible (True)
'
'theMinY = theYAxis.GetBoundsMin
'
'If (theMinY > 0) Then
'
'  theYAxis.SetCrossValue (0)
'
'End
'
'newChart.GetChartLegend.SetVisible (False)
'
'av.GetProject.AddDoc (newChart)
'
'respTab.GetWin.Close
'
'newChart.GetWin.Open
'
Dim gfxColl As IDataGraphs
753: Set gfxColl = pMxDoc
754: gfxColl.Add newChart

Dim gfxWin As IDataGraphWindow
757: Set gfxWin = New DataGraphWindow
758: Set gfxWin.DataGraph = newChart
759: Set gfxWin.Application = SDMGlobals.SDMApp
760: gfxWin.PutPosition 100, 100, 800, 500
761: If Not gfxWin.IsVisible Then gfxWin.Show True


  Exit Sub
ErrorHandler:
  HandleError False, "makeChart " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


