VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GenRandomPoints"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GenRandomPoints"
Const c_sDLLFileName As String = "CalculateNeuralNetwork"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GenRandomPoints(Self As Variant) As IFeatureClass
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.GenRandomPoints
'' Topics:  Spatial Data Modeller
''
'' Description:  Generates a set of random
''          points. Developed to generate
''          points in areas of low probability
''          to be used as a training point setA
''          for RBFLN neural network.
''          User is prompted to specify a theme,
''          field containing values and upper
''          limit.
''
'' Requires:  Grid theme with suitable
''          values for determining locations
''          of points.
''
'' Self:    0 -- viewA -- active view document
''          1 -- thmSrc -- theme with source values
''          2 -- strFldSrc -- name of field containing values (if integer gtheme)
''          3 -- cutoff -- upper theshold value for
''                         locations in which to generate points
''          4 -- cntPnts -- number of points to generat
''
'' Returns:
''==============================================
'
'av.ShowMsg ("Generating random points...")
43: SDMGlobals.SDMStatusBar.Message(0) = "Generating random points..."
'av.UseWaitCursor
'dTitle = Script.The.GetName
Dim dTitle As String
47: dTitle = c_sModuleFileName
'' Get arguments
''----------------------------------------------
'viewA = Self.Get(0)
Dim viewA As IMap
52: Set viewA = Self(0)
'prjCrnt = viewA.GetProjection
    Dim prjCrnt As ISpatialReference
55: Set prjCrnt = viewA.SpatialReference
'thmSrc = Self.Get(1)
    Dim thmSrc As IRasterLayer
58: Set thmSrc = Self(1)
'grdSrc = thmSrc.GetGrid
'If (grdSrc.IsInteger) Then
'  vTabSrc = av.Run("gSDI.GetVTab",{thmSrc})
'  If (vTabSrc = Nil) Then
    Dim dispTbl As IDisplayTable
64: Set dispTbl = thmSrc
    Dim vTabSrc As ITable
66: Set vTabSrc = dispTbl.DisplayTable
67: If vTabSrc Is Nothing Then
'    return Nil
69:     Set gSDI_GenRandomPoints = Nothing
        Exit Function
'  End
72: End If
'Else
'  vTabSrc = "FP"
'End
'av.ShowMsg ("Generating random points...")
'av.UseWaitCursor
'' Depending on grid type, get VTab and Field
''----------------------------------------------
'If (vTabSrc = "FP") Then
'  strFldSrc = "Value"
'Else
'  strFldSrc = Self.Get(2)
    Dim strFldSrc As String
85: strFldSrc = Self(2)
'  fldPP = vTabSrc.FindField(strFldSrc)
    Dim fldPP As Long
88: fldPP = vTabSrc.FindField(strFldSrc)
'  If (fldPP = Nil) Then
'    MsgBox.Error("Field " + strFldSrc + " not found in attribute table of " + thmSrc.GetName + ".","Parameter Error"
'    return Nil
'  End
'  fldVal = vTabSrc.FindField("Value")
    Dim fldval As Long
95: fldval = vTabSrc.FindField("Value")
'  If (fldVal = Nil) Then
'    MsgBox.Error("Field Value not found in attribute table of " + thmSrc.GetName + ".","Parameter Error"
'    return Nil
'  End
'End
'cutoff = Self.Get(3)
Dim cutoff As Double
103: cutoff = Self(3)
'if (cutoff.Is(String)) then
'  If (cutoff.IsNumber) Then
'    cutoff = cutoff.AsNumber
'  Else
'    return Nil
'  End
'End
'cntPnts = Self.Get(4)
Dim cntpnts As Long
113: cntpnts = Self(4)
'' Make pair of lists to lookup probabilities
'' associated with grid values (uc numbers, typically)
''----------------------------------------------
'If (vTabSrc <> "FP") Then
'If vTabSrc <> "FP" Then
'  lstval = List.Make
        Dim lstval As New SDMUtilities.SDMList
'  lstPP = List.Make
        Dim lstPP As New SDMUtilities.SDMList
'  For Each r In vTabSrc
        Dim curs As ICursor
125:     Set curs = vTabSrc.Search(Nothing, False)
        Dim rw As IRow
127:     Set rw = curs.NextRow
128:     While Not rw Is Nothing
'   lstval.Add (vTabSrc.ReturnValue(fldVal, r))
130:         lstval.Add rw.Value(fldval)
'   lstPP.Add (vTabSrc.ReturnValue(fldPP, r))
132:         lstPP.Add rw.Value(fldPP)
133:         Set rw = curs.NextRow
'  End
135:     Wend
''''End
'''End If
'' Get grid extents to obtain min and ma
'' values for point coordinates
''----------------------------------------------
'grdSrc = thmSrc.GetGrid
Dim gSDIGetMask As gSDI_getMask
143: Set gSDIGetMask = New gSDI_getMask
Dim grdMask As IGeoDataset
145: Set grdMask = gSDIGetMask.gSDI_getMask
Dim extSrc As IEnvelope
147: Set extSrc = grdMask.Extent
'x0 = extSrc.GetLeft
Dim x0 As Double
150: x0 = extSrc.XMin
'X1 = extSrc.GetRight
Dim width As Double
153: width = extSrc.width
'y0 = extSrc.GetBottom
Dim y0 As Double
156: y0 = extSrc.YMin
'Y1 = extSrc.GetTop
Dim height As Double
159: height = extSrc.height

'' Generate random x and y values, find
'' the associated grid cell value, and
'' corresponding att value if necessary
'' If value is less than the cutoff value,
'' add to list
''----------------------------------------------
'
'lstNDTP = List.Make
Dim lstNDTP As New SDMUtilities.SDMList
'i = 1
Dim i As Long
172: i = 0
'av.ShowMsg ("Generating random points...")
''av.UseWaitCursor
'curStatus = 0
     Dim pStatusBar As IStatusBar
     Dim pProgbar As IStepProgressor

179: Set pStatusBar = SDMGlobals.SDMStatusBar
180: Set pProgbar = pStatusBar.ProgressBar

182: pProgbar.Position = 0
183: pStatusBar.ShowProgressBar "Generating random points...", 1, cntpnts, 1, True
  
     Dim rasBlk As IRasterBuffer
186: Set rasBlk = New IRasterBuffer
187: If Not rasBlk.OpenBuffer(thmSrc) Then
188:    MsgBox "Illegal integer raster type", , c_sModuleFileName
189:    Set gSDI_GenRandomPoints = Nothing
        Exit Function
191: End If
192: If gRP.chkRand.Value = 1 Then Randomize
'While (lstNDTP.Count < cntPnts)
        Dim n As Long
195:  While lstNDTP.Count < cntpnts
196:         n = n + 1
197:         If (n Mod cntpnts) = 0 Then
198:            pProgbar.Position = 0
199:            pStatusBar.ShowProgressBar lstNDTP.Count & " random points so far...", 1, cntpnts, 1, True
                'If n = cntpnts Then
201:                     If (lstNDTP.Count = 0) Then
202:                    If MsgBox(lstNDTP.Count & " random points in " & n & "tries.  Continue?", vbYesNo, c_sModuleFileName) = vbNo Then
203:                        Set gSDI_GenRandomPoints = Nothing
204:                        pStatusBar.HideProgressBar
                            Exit Function
206:                         End If
207:                     End If
                'End If
209:         End If '  X = Number.MakeRandom(x0, X1)
         Dim X As Double
211:     X = x0 + Rnd * width
'  Y = Number.MakeRandom(y0, Y1)
        Dim Y As Double
214:     Y = y0 + Rnd * height
'  pnt = Point.Make(X, Y)
         Dim pnt As IPoint
217:     Set pnt = New Point
218:     pnt.PutCoords X, Y
'  Val = grdSrc.CellValue(pnt, prjCrnt)
         Dim val As Variant
221:     val = rasBlk.CellValue(pnt)
'  av.ShowMsg ("Generating point " + i.AsString)
'  av.UseWaitCursor
'  If (Val <> Number.MakeNull) Then
225:     If IsNull(val) Then
226:     ElseIf CStr(val) = "NoData" Then
227:     Else
'    If (vTabSrc = "FP") Then
'        If vTabSrc = "FP" Then
'      If (Val <= cutoff) Then
'            If Val <= cutoff Then
'        lstNDTP.Add (pnt)
'                lstNDTP.Add pnt
'        i = i + 1
'                i = i + 1
'      End
'            End If
'    Else
'       else
'      idx = lstVal.FindByValue(Val)
            Dim idx As Long
242:        idx = lstval.FindByValue(CLng(val))
'MsgBox X & "," & Y & ": " & Val & "; i=" & i & "; idx=" & idx, , c_sModuleFileName
'      If (idx > -1) Then
245:        If idx > -1 Then
'        pp = lstPP.Get(idx)
                  Dim pp As Double
248:            pp = lstPP.GetVal(idx)
'        If (pp <= cutoff) Then
250:            If pp <= cutoff Then
'          lstNDTP.Add (pnt)
252:                lstNDTP.Add pnt
'          i = i + 1
'                i = i + 1
'        End
256:            End If
'      End
258:        End If
'    End
'        End If
'  End
262:     End If
'End
264:     pStatusBar.StepProgressBar
265: Wend
'av.ShowMsg ("")
267:   pStatusBar.HideProgressBar
'' Make a point FTheme from the list of points
'' and return it
''----------------------------------------------
'strFN = FileName.GetCWD.MakeTmp("ndtp", "dbf")
Dim strFN As IFileName
273: Set strFN = FileDialog.MakeTmp("NDTP", "dbf")
Dim dirName As String
275: dirName = FileDialog.getDir(strFN.path)
Dim fileName As String
277: fileName = FileDialog.GetFileName(strFN.path)
'fnNDTP = FileDialog.Put(strFN, "*.dbf", "Non-deposit Training Point Theme")
     Dim fnNDTP As Variant
280: fnNDTP = FileDialog.GetSaveFileName("Non-deposit Training Point Theme", dirName, fileName)
'If (fnNDTP = Nil) Then
282: If IsEmpty(fnNDTP) Then
'  return Nil
284:     Set gSDI_GenRandomPoints = Nothing
            Exit Function
'End
287: End If
'ftabNDTP = FTab.MakeNew(fnNDTP, Point)
'fldID = Field.Make("ID",#FIELD_LONG,5,0)
Dim fldID As Variant
291: fldID = Array("ID", esriFieldTypeInteger, 5, 0, "", False)
Dim fldList As New SDMUtilities.SDMList
293: fldList.Add fldID
'fTabNDTP.AddFields({fldID})
Dim fTabNDTP As IFeatureClass
296: Set fTabNDTP = FeatureUtils.CreatePointFeatureClass(CStr(fnNDTP(1)), CStr(fnNDTP(0)), SDMGlobals.SDMMap.SpatialReference, fldList)
'fldShp = ftabNDTP.FindField("Shape")
Dim fldShp As String
299: fldShp = fTabNDTP.FindField("Shape")
'If (fldShp = Nil) Then
301: If fldShp = -1 Then
'  MsgBox.Error("Error creating theme of non-deposit training points.",Script.The.GetName)
303:     MsgBox "Error creating theme of non-deposit training points.", vbCritical, c_sModuleFileName
'  ftabNDTP.SetEditable (False)
'  return Nil
    Exit Function
'End
308: End If
Dim fldIDIdx As Long
310: fldIDIdx = fTabNDTP.FindField("ID")

Dim sShpName As String
313: sShpName = fTabNDTP.ShapeFieldName
Dim pFlds As IFields
315: Set pFlds = fTabNDTP.Fields
Dim lGeomIndex As Long
317: lGeomIndex = pFlds.FindField(sShpName)

'  For Each pnt In lstNDTP
Dim pdataSet As IDataset
321: Set pdataSet = fTabNDTP
Dim pWorkspace As IWorkspace
323: Set pWorkspace = pdataSet.Workspace
Dim pWorkspaceEdit As IWorkspaceEdit
325: Set pWorkspaceEdit = pWorkspace
326: pWorkspaceEdit.startEditing False
327: pWorkspaceEdit.StartEditOperation

Dim vPnt As Variant
330: i = 0
331: For Each vPnt In lstNDTP.list
332:     Set pnt = vPnt
'  r = ftabNDTP.AddRecord
         Dim r As IFeature
335:     Set r = fTabNDTP.CreateFeature
'  fTabNDTP.SetValue(fldShp,r,pnt)
337:     Set r.Shape = pnt
'  fTabNDTP.SetValue(fldID,r,i)
339:     r.Value(fldIDIdx) = i
'  i = i + 1
341:     i = i + 1
'End
343:     r.Store
344: Next vPnt
'ftabNDTP.SetEditable (False)
346: pWorkspaceEdit.StopEditOperation
347: pWorkspaceEdit.stopEditing True

'ftabNDTP.Flush
'thmNDTP = FTheme.Make(ftabNDTP)
'Dim pDataSet As IDataset
352: Set pdataSet = fTabNDTP
Dim pFeatWKS As IFeatureWorkspace
354: Set pFeatWKS = pdataSet.Workspace
Dim pFeatLayer As IFeatureLayer
356: Set pFeatLayer = New FeatureLayer
357: Set pFeatLayer.FeatureClass = pFeatWKS.OpenFeatureClass(pdataSet.Name)
358: pFeatLayer.Name = pdataSet.Name
'comments = "Generated by: Arc-SDM - Generate Random Training Points" + NL +
'           "Source: " + thmNDTP.GetSrcName.GetFileName.GetFullName + NL + NL +
'           "Points generated randomly in areas of " + thmSrc.GetName + ", " + strFldSrc + " (Source: " +
'           thmSrc.GetSrcName.GetFileName.GetFullName ") with values lower than " + cutoff.AsString + "." + NL
'thmNDTP.SetComments (Comments)
'viewA.AddTheme (thmNDTP)
365: If pFeatLayer.Valid Then SDMGlobals.SDMMap.AddLayer pFeatLayer
'av.ClearMsg
'return thmNDTP
368: Set gSDI_GenRandomPoints = fTabNDTP
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
373: Set gSDI_GenRandomPoints = Nothing
End Function
