VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetFreeMCThemes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_GetFreeMCThemes"
Const c_sDLLFileName As String = "CalculateResponse"
' Constant reflect file module name

'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetFreeMCThemes(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
'   MsgBox "entering...", , c_sModuleFileName
17: Set gSDI_GetFreeMCThemes = New SDMUtilities.SDMList
18: ProgressAnimation.Show "Getting free MC Themes..."
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.GetFreeMCThemes
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Assesses the unique condition values
''               for each input theme and returns
''               a list of the unique values
''               and a list of indeces for all themes,
''               indicating whether the theme if free, multi-class
''               and if so, its position in the list of themes.
''               If the user has not previously specified
''               the data type of the theme, they are prompted
''               with a dialog.
'' Requires:
'' Self:         Argument list including:
''               0 -- unique conditions theme lists
''               1 -- the integer value that defines missing dada
''
'' Returns:      List containing list of unqiue values for
''               each free, multi-class theme; list of
''               indeces giving the location of each free,
''               multi-class theme in the list of all themes.
''
''==============================================
''Arguments:
''----------------------------------------------
'lstsUC = Self.Get(0)   'unique conditions theme lists
    Dim lstsUC As SDMUtilities.SDMList
48: Set lstsUC = Self(0)
'lstsvals = lstsUC.Get(0)
    Dim lstsvals As SDMUtilities.SDMList
51: Set lstsvals = lstsUC.getObj(0)
'MsgBox ListUtils.ListtoString(lstsvals), , "lstsVals"
'lstTNames = lstsUC.Get(1)
    Dim lstTNames As SDMUtilities.SDMList
55: Set lstTNames = lstsUC.getObj(1)
'MsgBox ListUtils.ListtoString(lstTNames), , "lstTNames"
''missing = self.Get(1)   'integer defining missing data
'lstMD = Self.Get(1)
    Dim lstMD As SDMUtilities.SDMList
60: Set lstMD = Self(1)
'MsgBox ListUtils.ListtoString(lstMD), , "lstMD"
'' Read datatypes into dictionary called _dataDict
''----------------------------------------------
'av.Run("gSDI.ReadDataTypes",{})
    Dim gSDIReadDataTypes As gSDI_ReadDataTypes
66: Set gSDIReadDataTypes = New gSDI_ReadDataTypes
67: gSDIReadDataTypes.gSDI_ReadDataTypes
'''MsgBox SDMGlobals.SDMdataDict.asString, , "SDMDataDict"
'catThemes = {}          ' list to hold categorical themes
    Dim catThemes As New SDMUtilities.SDMList
'checkTNames = {}        ' list to hold names of themes to check with user
    Dim checkTNames As New SDMUtilities.SDMList
'pdTypes = {}            ' list to hold data type default strings for message box
    Dim pdTypes As New SDMUtilities.SDMList
'checkThemes = {}         ' list to hold references to themes to be checked
    Dim checkThemes As New SDMUtilities.SDMList
77: checkThemes.Clear
'numOther = 0
    Dim numOther As Long
'''MsgBox ListtoString(lstTNames), , "lstTNames"
'''MsgBox gL.RasterSrcDict.asString, , "gL.RasterSrcDict"
'''MsgBox SDMGlobals.SDMdataDict.asString, , "SDMGlobals.SDMdataDict"
'For Each t In lstTNames
    Dim t As Variant
85: For Each t In lstTNames.list
'MsgBox "t=[" & t & "]"
87:         If Trim(t) = "" Then GoTo nextT
            Dim tName As String
89:         tName = Trim(t)
'  dType = _dataDict.Get(t.BasicTrim("","_"))
            Dim srcName As String
92:         srcName = DictGettAnyCase(tName, gL.RasterSrcDict)
90:         Dim dType As String
94:         dType = DictGettAnyCase(srcName, SDMGlobals.SDMdataDict)
'MsgBox tName & ", " & srcName & ", " & dType
'  If (dType = Nil) Then
97:         If dType = "" Then
'     checkTNames.Add (t.BasicTrim("", "_"))
99:             checkTNames.Add srcName
'     pdTypes.Add ("Free")
101:             pdTypes.Add "Free"
'     checkThemes.Add (t)
103:             checkThemes.Add srcName
'  ElseIf (dType = "Free") Then
105:        ElseIf dType = "Free" Then
'    catThemes.Add (t)
107:            catThemes.Add srcName
'  Else
109:        Else
'    numOther = numOther + 1
111:            numOther = numOther + 1
'  End
113:        End If
'End
nextT:
116: Next t
'MsgBox numOther, , "numOther"
'MsgBox ListUtils.ListtoString(checkThemes), , "checkThemes"
'MsgBox ListUtils.ListtoString(catThemes), , "catThemes"
''****** want to make dialog with radio buttons
'
'If (checkThemes.IsEmpty.Not) Then
123: If Not checkThemes.IsEmpty Then
'  dataTypes = av.Run("gDT.Run",{checkThemes})
        Dim gDTRun As gDT_Run
126:    Set gDTRun = New gDT_Run
127:    gDTRun.gDT_Run (Array(checkThemes))
'  gDT = av.FindDialog("gDT")
'  If (gDT.findByName("btnCan").GetTag = "True") Then
130:     If gDT.btnCan.Tag = "True" Then
'    return Nil
            'returning empty sdmlist
133:          gSDI_GetFreeMCThemes.Clear
                Exit Function
'  End
136:     End If
'  lstCPs = gDT.FindByClass(ControlPanel)
'  For Each cp In lstCPs
         Dim gSDIWriteDataTypes As gSDI_WriteDataTypes
140:     Set gSDIWriteDataTypes = New gSDI_WriteDataTypes
         Dim ncp As Long
142:     For ncp = 0 To gDT.lblThm.Count - 1
'    strCP = cp.GetName.Left(4)
'    If ((strCP.Left(2) = "cp") And (cp.FindByClass(RadioButton).IsEmpty.Not)) Then
'      strTName = gDT.findByName("lbl_" + strCP.Right(1)).GetLabel
'      rbn = cp.GetSelected
'      If (rbn.GetName.Left(3) = "rb1") Then
148:         If gDT.radFree(ncp).Value Then
'        dt = "Free"
                   Dim dt As String
151:             dt = "Free"
'        catThemes.Add (strTName)
153:             catThemes.Add gDT.lblThm(ncp).Caption
'      Else
155:         Else
'        dt = "Ordered"
157:             dt = "Ordered"
'      End
159:         End If
'      av.Run("gSDI.WriteDataTypes",{strTName.BasicTrim("","_"),dt})
161:         gSDIWriteDataTypes.gSDI_WriteDataTypes Array(gDT.lblThm(ncp), dt)
'    End
'  End
164:     Next ncp
'End
166: End If
''Initialize lists
''----------------------------------------------
'
'catMCLists = List.Make    'list of lists of values in multi-class categorical themes
Dim catMCLists As New SDMUtilities.SDMList
'catMCFields = List.Make   'list of fields in UC table for multi-class categorical themes
Dim catMCfields As New SDMUtilities.SDMList
'lstMCMissing = List.Make
Dim lstMCMissing As New SDMUtilities.SDMList
'Dim emptyList As SDMUtilities.SDMList
'For Each cT In lstTNames
Dim cT As Variant
179: For Each cT In lstTNames.list
'MsgBox "cT=[" & cT & "]", , c_sModuleFileName
'  If (catThemes.FindByValue(cT) > -1) Then
182:     If catThemes.FindByValue(DictGettAnyCase(CStr(cT), gL.RasterSrcDict)) > -1 Then
'    idx = lstTNames.FindByValue(cT)
             Dim idx As Long
185:         idx = lstTNames.FindByValue(cT)
'    If (idx > -1) Then
187:         If idx > -1 Then
'      catMCLists.Add (lstsvals.Get(idx))
189:             catMCLists.Add lstsvals.getObj(idx)
'      lstMCMissing.Add (lstMD.Get(idx))
191:             lstMCMissing.Add lstMD.GetVal(idx)
'    End
193:         End If
'  Else
195:     Else
'    catMCLists.Add({})
''''         Set emptyList = New SDMUtilities.SDMList
198:         catMCLists.Add New SDMUtilities.SDMList
'    lstMCMissing.Add (Nil)
200:         lstMCMissing.Add Null
'  End
202:     End If
'End
204: Next cT
'MsgBox ListUtils.ListtoString(catMCLists), , "catMCLists"
'MsgBox ListUtils.ListtoString(lstMCMissing), , "lstMCMissing"
If catMCLists.IsEmpty Then Exit Function
'catMCThemes = {}    'list of multi-class categorical themes
     Dim catMCThemes As New SDMUtilities.SDMList
'catMCLists2 = catMCLists.Clone   ' clone list for looping
     Dim catMCLists2 As SDMUtilities.SDMList
212: Set catMCLists2 = ListUtils.Clone(catMCLists)

'For Each valList In catMCLists2
     Dim listIdx As Long
     Dim vValList As Variant
217: For Each vValList In catMCLists2.list
         Dim ValList As SDMList
219:     Set ValList = vValList
'MsgBox ListtoString(ValList), , "ValList"
'  If (valList.IsEmpty.Not) Then
222:     If Not ValList.IsEmpty Then
'    listIdx = catMCLists.Find(valList)
224:         listIdx = ListUtils.FindObj(vValList, catMCLists)
'    valList2 = valList.Clone
             Dim valList2 As SDMUtilities.SDMList
227:         Set valList2 = ValList.Clone
'    valList2.RemoveDuplicates
229:         Set valList2 = valList2.RemoveDuplicates
'    valList2.Sort (True)
231:         Set valList2 = valList2.Sort(True)
'    missing = lstMCMissing.Get(listIdx)
             Dim missing As Long
234:         missing = lstMCMissing.GetVal(listIdx)
'    if (((valList2.FindByValue(missing) > -1) and (valList2.Count > 3)) or
'        ((valList2.FindByValue(missing) < 0) and (valList2.Count > 2))) then
237:         If (((valList2.FindByValue(missing) > -1) And (valList2.Count > 3)) Or _
                ((valList2.FindByValue(missing) < 0) And (valList2.Count > 2))) Then
'     'catMCThemes.Add(catThemes.Get(listIdx))
'      catMCThemes.Add (lstTNames.Get(listIdx))
241:             catMCThemes.Add lstTNames.GetVal(listIdx)
'      catMCLists.Set(listIdx,valList2)
243:             catMCLists.SetIt listIdx, valList2
'    Else
245:          Else
'      'catMCLists.RemoveObj(valList)
'      catMCLists.Set(listIdx,{})
248:             catMCLists.SetIt listIdx, New SDMList
'    End
250:          End If
'  End
252:     End If
'End
254: Next vValList

'mcIndeces = {}      ' index of each theme for its position in list of multi-class cat. theme (-1 if not a member)
     Dim mcIndeces As New SDMUtilities.SDMList
     Dim tmplist As SDMUtilities.SDMList
'For Each t In lstTNames
'MsgBox ListtoString(catMCThemes), , "Count"
261: For Each t In lstTNames.list
'MsgBox "t=" & t, , c_sModuleFileName
'  idx = catMCThemes.FindByValue(t)
264:     idx = catMCThemes.FindByValue(t)
'  mcIndeces.Add({t,idx})
266:     Set tmplist = New SDMList
267:     tmplist.AddArray Array(t, idx)
268:     mcIndeces.Add tmplist
'End
270: Next t
'return {catMCLists,mcIndeces}
'MsgBox "catMCLists:" & vbCrLf & catMCLists.AsString, , c_sModuleFileName
'MsgBox "mcIndeces:" & vbCrLf & mcIndeces.AsString, , c_sModuleFileName
274: gSDI_GetFreeMCThemes.AddArray Array(catMCLists, mcIndeces)
'MsgBox ListUtils.ListtoString(gSDI_GetFreeMCThemes)
'245: MsgBox "exiting...", , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
278: ProgressAnimation.Hide
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
282:   gSDI_GetFreeMCThemes.Clear
End Function

Private Function DictGettAnyCase(key As String, dict As SDMUtilities.SDMDictionary) As Variant
    Dim k As Variant
287:     For Each k In dict.ReturnKeys
288:         If StrComp(CStr(k), key, vbTextCompare) = 0 Then
            DictGettAnyCase = dict.Gett(CStr(k))
            Exit Function
291:         End If
292:     Next k
    DictGettAnyCase = Empty
End Function

