VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_GetThmWgtVals"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text

Const c_sModuleFileName As String = "gSDI_GetThmWgtVals.cls"
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_GetThmWgtVals(ByRef Self As SDMList) As SDMList
  On Error GoTo ErrorHandler
  
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.GetThmWgtVals
''        getwvals.ave
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Determines the class of a polygon or grid
''               theme that each point of a set of points falls in.
''               Calculates the area of each class.
''               Calcualates the total area and total number of
''               deposits for the current evidential theme,
''               excluiding any areas where data area missing.
''
'' Requires:
''
''
''
''
'' Self:  List passed from gSDI.CalcThemeWeights or gSDI.CalcCombinedWeights
''        List contains:  temporary evidential theme (tempEM); polygon flag (poly)
''                        evidential class field (emField); training point
''                        attribute table(depFTab); projection of active View (curPrj);
''                        evidential theme (eMap); descriptor field name (descName)
''
'' Returns:  List of lists:  list of classes found in evidential theme (classList);
''                           list of areas of each class (sumCntList);
''                           list of number of points falling in each class (pntCountList);
''                           number of deposits in evidential theme (excluding missing data areas) (totDeposits);
''                           total area of evidential theme (excluding missing data areas) (totArea)
''                           list of class descriptors (descList2)
''======================================================================
''GET USER'S MISSING DATA VALUE
''------------------------------------------
'missingTxt = av.FindDialog("gTW").findByName("txtMD").GetText
    Dim missingTxt As String
52: missingTxt = gTW.txtMD.Text
'if  (missingTxt.Is(String).Not) then
'  MsgBox.Error("An integer value for missing data not found."+NL+
'               "Please ensure parameters are set.","Data Generalization")
'  return Nil
'ElseIf (missingTxt.IsNumber) Then
58: If (IsNumeric(missingTxt)) Then
'  missing = missingTxt.AsNumber
        Dim missing As Long
61:     missing = CLng(missingTxt)
'Else
63: Else
'  MsgBox.Error("An integer value for missing data not found."+NL+
'               "Please ensure parameters are set.","Data Generalization")
66:     MsgBox "An integer value for missing data not found." & vbCrLf & _
               "Please ensure parameters are set.", vbCritical, "Data Generalization"
'  return nil
69:     Set gSDI_GetThmWgtVals = Nothing
        Exit Function
'End
72: End If
'tmpEmap = self.Get(0)               'ftheme or grid passed as evidence map
    Dim tmpEmap As IRasterLayer
75: Set tmpEmap = Self.getObj(0)
'If (tmpEmap.Is(FTheme)) Then
'  poly = True
'ElseIf (tmpEmap.Is(GRID)) Then
'  poly = False
    Dim poly As Boolean 'not implemented
81: poly = False
'End
'emfield = self.Get(1)                    'field in theme vtab defining classes
    Dim emField As IField
85: Set emField = Self.getObj(1) 'Belongs to emVTab below
'depFTab = self.Get(2)
    Dim depFTab As ITable
88: Set depFTab = Self.getObj(2)
'curPrj = self.Get(3)
    Dim curPrj As IProjection
91: Set curPrj = Self.getObj(3)
'eMap = self.Get(4)
    Dim eMap As IRasterLayer
94: Set eMap = Self.getObj(4)
'descName = self.Get(5)
    Dim descField As IField
97: Set descField = Self.getObj(5) 'Belongs to emapVTab below
    Dim Desc As Boolean
99: Desc = Not descField Is Nothing

'This is relQueryTable of tmpEmap above
     Dim emapVTab As ITable
103: If TypeOf eMap Is IDisplayTable Then
        Dim dsptbl As IDisplayTable
105:    Set dsptbl = eMap
106:    Set emapVTab = dsptbl.DisplayTable
107: Else
        Dim GetVTab As gSDI_GetVTab
109:    Set GetVTab = New gSDI_GetVTab
110:    Set emapVTab = GetVTab.gSDI_GetVTab(eMap)
111: End If
     
     Dim emVTab As ITable
'102: Set emVTab = WOETableUtils.JoinTables(tmpEmap, "Value", emapVTab, "Value")
116: Set emVTab = tmpEmap
118: If (emVTab Is Nothing) Or (emField Is Nothing) Then
119:     Err.Description = "Evidence layer is Nothing"
120:     Err.Raise vbObjectError
121: End If

'av.ShowMsg ("Calculating weights for " + eMap.GetName + "...")
'
'' FOR POLYGON THEME, MAKE A POINT IN POLYGON JOIN BETWEEN THEME
'' AND TRAINING POINT THEME
'' DETERMINE CLASSES, AREAS, NUMBER OF POINTS
'If (poly) Then
129: If (poly) Then
' Not implemented
131: ElseIf (Not poly) Then
''  FOR GRID THEME, GET CLASS POINT FALLS IN
'' TOTAL CLASSES, POINTS, AREAS
'  emVTab = tmpEmap.GetVTab
'  emTable = Table.Make(emVTab)
'  If (emTable.GetWin.IsOpen.Not) Then
'    emTable.GetWin.Minimize
'    emTable.GetWin.Open
'    emTable.GetWin.Minimize
'  End
'    Dim emTableView As ITableView
'    Set emTableView = New TableView
'    Dim emTable As TableView
'    Set emTable = emVTab
'    Set emTableView.Table = emTable
'    Dim atagrect As tagRECT
'    atagrect.Top = 100
'    atagrect.Left = 100
'    atagrect.Right = 500
'    atagrect.bottom = 300
    'emTableView.Show 0, atagrect, True
'  emfield = emVTab.FindField(emfield.asString)
      Dim emFieldidx As Integer
154:  emFieldidx = emVTab.FindField(emField.Name)
'  emTable.Sort(emField,False)
156: If Desc Then
         Dim descFieldidx As Long
158:     descFieldidx = emapVTab.FindField(descField.Name)
159:     If descFieldidx = -1 Then
160:        MsgBox "Can't find descriptor field " & descField.Name, , c_sModuleFileName
161:        Set gSDI_GetThmWgtVals = Nothing
            Exit Function
163:     End If
164: End If
'  'FIND THE VALUE AND COUNT FIELDS (ASSUMED
'  'TO EXIST IN EVERY INTEGER GRID VTAB)
'  '-----------------------------------------
'
'  valField = emVTab.FindField("Value")
     Dim valFieldidx As Integer
171: valFieldidx = emVTab.FindField("Value")
     Dim valField As IField
173: Set valField = emVTab.Fields.Field(valFieldidx)
'  countField = emVTab.FindField("Count")
     Dim countFieldidx As Integer
176: countFieldidx = emVTab.FindField("Count")
     Dim countField As IField
178: Set countField = emVTab.Fields.Field(countFieldidx)
'  If ((countField = Nil) Or (valField = Nil)) Then
180: If ((countFieldidx = -1) Or (valFieldidx = -1)) Then
'    return "FldNotFnd"
182:    Set gSDI_GetThmWgtVals = Nothing
        Exit Function
'  End
185: End If
'  'MAKE LISTS/DICTIONARIES TO HOLD VALUES
'  '-----------------------------------------
'  valClassD = Dictionary.Make(emVTab.GetNumRecords)  'dictionary linking class values to pixel values
         Dim valClassD As New SDMDictionary
'  valueList = list.Make          'list of pixel values
         Dim valueList As New SDMList
'  classList = list.Make          'list of corresponding class values
         Dim classList As New SDMList
'  If (Desc) Then
195:     If (Desc) Then
'    descList = list.Make           'list of descriptions of class values
            Dim descList As New SDMList
'    descList2 = list.Make          'aggregated list of descriptions
            'Dim descList2 As New SDMList
            Dim descDict As New SDMDictionary
'  End
202:     End If
'  countList = list.Make            'count of each pixel value
         Dim countList As New SDMList
'  totArea = 0                    'aggregate count of pixels
         Dim totArea As Long
207:     totArea = 0
'  ' FOR EACH RECORD IN THE EVIDENCE MAP ATTRIBUTE TABLE
'  ' CREATE THE LIST OF VALUES
'  '-------------------------------------------------
'   reclimit = emVTab.GetNumRecords - 1
'  for each i in 0 .. recLimit
'>>>>>>>> row no and row oid are not the same <<<<<<<
     Dim curs As ICursor
215: Set curs = emVTab.Search(Nothing, False)
     Dim emTblRow As irow
217: Set emTblRow = curs.nextrow
221: While Not emTblRow Is Nothing
'    record = emTable.ConvertRowToRecord(i)
'    valu = emVTab.ReturnValue(valField, record)
             Dim valu As Long
225:         valu = emTblRow.Value(valFieldidx)
'    clas = emVTab.ReturnValue(emfield, record)
             Dim Clas As Variant
228:         Clas = emTblRow.Value(emFieldidx)
'    If ((valu = missing) And (clas.IsNull)) Then
230:         If ((valu = missing) And IsNull(Clas)) Then
'      clas = missing
232:             Clas = missing
233:         ElseIf IsNull(Clas) Then
234:            MsgBox "Cannot generate Weights table from evidence layer" & _
                    " because a joined table has Null values", vbCritical, c_sModuleFileName
236:             Set gSDI_GetThmWgtVals = Nothing
                 Exit Function
238:         Else
239:             Clas = CLng(Clas)
'    End
241:         End If
'    If (Desc) Then
243:        If Desc And valu <> missing Then
'      descriptor = emVTab.ReturnValue(descField, record)
                Dim Qfilt As IQueryFilter
246:            If Qfilt Is Nothing Then Set Qfilt = New QueryFilter
247:            Qfilt.WhereClause = "VALUE = " & CStr(valu)
                Dim jSelSet As ISelectionSet
249:            Set jSelSet = emapVTab.Select(Qfilt, esriSelectionTypeIDSet, esriSelectionOptionOnlyOne, Nothing)
250:            jSelSet.IDs.Reset
                Dim jRow As irow
251:            Set jRow = emapVTab.GetRow(jSelSet.IDs.Next)
                Dim descriptor As Variant
253:            descriptor = jRow.Value(descFieldidx)
254:            If IsNull(descriptor) Then descriptor = "Null"
'    End
256:        End If
'    Count = emVTab.ReturnValue(countField, record)
            Dim Count As Long
259:        Count = emTblRow.Value(countFieldidx)
'    valClassD.Add(valu,clas)
261:        valClassD.Add valu, Clas
'    valueList.Add (valu)
263:        valueList.Add valu
'    classList.Add (clas)
265:        classList.Add Clas
'    If (Desc) Then
267:        If Desc Then
'      If (clas = missing) Then
269:            If (Clas = missing) Then
'        descList.Add ("Missing Data")
271:                descList.Add "Missing Data"
272:                descDict.Add Clas, "Missing Data"
'      Else
274:            Else
'        descList.Add (descriptor)
276:                descList.Add descriptor
277:                descDict.Add Clas, descriptor
'      End
279:            End If
'    End
281:        End If
'    countList.Add (Count)
283:        countList.Add Count
'    If (clas <> missing) Then
285:        If (Clas <> missing) Then
'      totArea = totArea + Count
287:            totArea = totArea + Count
'    End
289:        End If
'  End
291:         Set emTblRow = curs.nextrow
292: Wend
'
'MsgBox valClassD.AsString, , "valClassD"
'MsgBox valueList.AsString, , "valueList"
'MsgBox classList.AsString, , "ClassList"
'297: MsgBox descList.asString, , "DescList"
'MsgBox countList.AsString, , "CountList"
''MAKE classList A LIST OF UNIQUE ELEMENTS
''-----------------------------------------
'  classCheck = classList.Clone
     Dim classCheck As SDMList
303: Set classCheck = classList.Clone
'  classList.RemoveDuplicates
305: Set classList = classList.RemoveDuplicates
'MsgBox classList.AsString, , "No Dupes ClassList"
'  'MAKE A LIST TO HOLD THE SUM OF COUNT VALUES
'  'ASSOCIATED WITH EACH ELEMENT IN THE CLASS LIST
'  '-----------------------------------------
'  sumCntLst = list.Make
    Dim sumCntLst As New SDMDictionary
'
'  'IF THE NUMBER OF VALUE EQUALS THE NUMBER
'  'OF VALUES, THE LISTS OF VALUES AND COUNTS
'  'CAN BE USED.  OTHERWISE...
'  '-----------------------------------------
'  If (valClassD.Count > classList.Count) Then
318:     If (valClassD.Count > classList.Count) Then
'
'    'INITIALIZE LIST TO HOLD SUMS OF COUNTS
'    '-----------------------------------------
'    For Each uCls In classList
        Dim uCls As Variant
324:    For Each uCls In classList.list
'      sumCntLst.Add (0)
326:             sumCntLst.Add uCls, 0&

'    End
329:    Next uCls
'    'CHECK EACH UNIQUE CLASS AGAINST THE
'    'CLASS ASSOCIATED WITH EACH VALUE AND
'    'IF EQUAL, INCREMENT THE ASSOCIATED SUM
'    'COUNTER
'    '-----------------------------------------
'    nvalue = valueList.Count - 1
        Dim nvalue As Long
337:         nvalue = valueList.Count - 1
'    nclass = classList.Count - 1
        Dim nclass As Long
340:         nclass = classList.Count - 1
'
'    for each c in 0 .. nclass
        Dim c As Long
344:         For c = 0 To nclass
'      Class = classList.Get(c)
'            Dim Clas As Long
347:             Clas = classList.GetVal(c)
'      for each v in 0 .. nvalue
                 Dim v As Long
350:             For v = 0 To nvalue
'        valkey = valueList.Get(v)
                     Dim valkey As Variant
353:                 valkey = valueList.GetVal(v)
'        valu = valClassD.Get(valkey)
355:                 valu = valClassD.Gett(valkey)
'        If (valu = Class) Then
357:                 If (valu = Clas) Then
'          sumCntLst.Set(c,sumCntLst.Get(c) + countList.Get(v))
359:                     sumCntLst.SetIt Clas, (sumCntLst.Gett(Clas) + countList.GetVal(v))
'        End
361:                 End If
'      End
363:             Next v
'    End
365:         Next c
'  Else
367:     Else
'    sumCntLst = countList
369:         sumCntLst.Clear
370:         For v = 0 To countList.Count - 1
371:             sumCntLst.Add classList.GetVal(v), countList.GetVal(v)
372:         Next v
'  End
374:     End If
'MsgBox sumCntLst.AsString, , "sumCntLst"
'  ' MAKE AGGREGATED LIST OF DESCRIPTORS
'  '------------------------------------------
'  If (Desc) Then
379:     If Desc Then
'    For Each Cls In classList
             Dim cls As Variant
382:         For Each cls In classList.list
'      clsIndx = classCheck.FindByValue(Cls)
                 Dim clsIndx As Long
385:             clsIndx = classCheck.FindByValue(CLng(cls))
'      Description = descList.Get(clsIndx)
                 Dim Description As Variant
388:             Description = descList.GetVal(clsIndx)
'      descList2.Add (Description)
384:             'descList2.Add Description
'    End
392:         Next cls
'  End
394:     End If
'  'MAKE A LIST TO HOLD DEPOSIT POINTS AND
'  'THEIR ASSOCIATED CLASSES
'  '-----------------------------------------
'  pntClassList = list.Make
         Dim pntClassList As New SDMList
'  totDeposits = 0
         Dim totDeposits As Long
402:     totDeposits = 0
'
'  'GET ALL POINT DEPOSIT OBJECTS AND ADD THEM TO A LIST
'  'FIND THE PIXEL THAT THE POINT FALLS IN AND ADD ITS
'  'CLASS TO A SECOND LIST
'  '-----------------------------------------
        Dim eMapProps As IRasterProps
409:    Set eMapProps = tmpEmap.Raster
        Dim rasBuf As IRasterBuffer
411:    Set rasBuf = New IRasterBuffer
412:    If Not rasBuf.OpenBuffer(tmpEmap) Then
413:        Set gSDI_GetThmWgtVals = Nothing
            Exit Function
415:    End If
416:    rasBuf.OpenBuffer tmpEmap
'  For Each record In depFTab
         Dim shapeFldidx As Long
419:     shapeFldidx = depFTab.Fields.FindField("Shape")
         Dim irow As Long
         Dim tblSel As ITableSelection
422:     Set tblSel = depFTab
423:     If (tblSel.SelectionSet.Count = 0) _
            Then tblSel.SelectRows Nothing, esriSelectionResultNew, False
'MsgBox tblSel.SelectionSet.Count, , "Selected deposits count"
         Dim Oid As Long
         Dim Oids As IEnumIDs
428:     Set Oids = tblSel.SelectionSet.IDs  'All masked TPs if masking was used
429:     Oids.Reset
430:     Oid = Oids.Next
         Dim record As irow
432:     While Oid <> -1
433:            Set record = depFTab.GetRow(Oid)
'    pnt = depFTab.ReturnValue(depFTab.FindField("Shape"), record)
                Dim point As IPoint
436:            Set point = record.Value(shapeFldidx)
'    pntCls = tmpEmap.CellValue(pnt, curPrj)
                Dim pntCls As Variant
439:            pntCls = rasBuf.CellValue(point) 'Assume project projectionMsgBox pntCls, , "rasBuf.CellValue"
'    If (pntCls.IsNull.Not) Then
441:            If Not IsNull(pntCls) Then
442:                If pntCls = "NoData" Then
                        'Inside of extent but in NoData cell
444:                         pntCls = missing
                        'MsgBox "Found NoData cell under training point", , c_sModuleFileName
446:                ElseIf IsNumeric(pntCls) Then
447:                    If CLng(pntCls) < missing Then
448:                        MsgBox "Value at Point(" & Oid & "): " & point.X & "," & point.Y & ": " & pntCls & " <= missing data value: " & missing & vbCrLf & _
                            "Check the project's ""Data Types of Evidential Themes"" table for appropriate values."
450:                         Set gSDI_GetThmWgtVals = Nothing
                            Exit Function
452:                    End If
453:                End If
'                MsgBox record.Oid & ", " & point.X & ", " & point.Y & " Value is " & pntCls & vbCrLf & _
'                ", " & rasBuf.CellValue(point)
'      pntClassList.Add (pntCls)
457:                    pntClassList.Add CLng(pntCls)
'      'if (pntCls <> missing) then
'      totDeposits = totDeposits + 1
460:                    totDeposits = totDeposits + 1
'    End
462:            End If
'  End
464:            Oid = Oids.Next
465:        Wend
     'MsgBox pntClassList.asString, , "Point Class list"
     'MsgBox totDeposits, , "totDeposits"
' If pntClassList.count = 0 Then
'     Set gSDI_GetThmWgtVals = Nothing
'    Exit Function
' Else
'     MsgBox pntClassList.AsString, , "Point Class list"
' End If
'  'MAKE AND INITIALIZE A LIST OF POINT-CLASS COUNTS
'  '-----------------------------------------
'  pntCountList = list.Make
            Dim pntCountList As New SDMList
'  For Each Cls In classList
479:        For Each cls In classList.list
'    pntCountList.Add (0)
481:            pntCountList.Add 0&
'  End
483:        Next cls
'MsgBox pntCountList.AsString, , "Point count list"
'
'  'FIND THE CLASS IN classList THAT EQUALS
'  'EACH POINT CLASS, AND INCREMENT THE COUNTE
'  'IN THE CORRESPONDING LOCATION OF THE
'  'pntCountList
'  '-----------------------------------------
'
'  nclass = classList.Count - 1
493:     nclass = classList.Count - 1
'
'  For Each pntVal In pntClassList
         Dim pntVal As Variant
497:     For Each pntVal In pntClassList.list
'    pntCls = valClassD.Get(pntVal)
499:         pntCls = CLng(valClassD.Gett(pntVal))
'    If (pntCls = missing) Then
501:         If (pntCls = missing) Then
'      totDeposits = totDeposits - 1
503:             totDeposits = totDeposits - 1
'    End
505:         End If
'    for each n in 0 .. nclass
             Dim n As Long
508:         For n = 0 To nclass
'      Cls = classList.Get(n)
510:             cls = classList.GetVal(n)
'      If (Cls = pntCls) Then
512:             If CLng(cls) = CLng(pntCls) Then
'        pntCountList.Set(n,pntCountList.Get(n) + 1)
514:                 pntCountList.SetIt n, CLng(pntCountList.GetVal(n)) + 1
'        Break
516:                 GoTo next2
'      End
518:             End If
'    End
520:        Next n
'  End
next2:
523:     Next pntVal
'MsgBox pntCountList.AsString, , "Point count list"
525:     If pntCountList.Count = 0 Then
526:         Set gSDI_GetThmWgtVals = Nothing
             Exit Function
528:     End If
'  totArea = (totArea * tmpEmap.GetCellSize * tmpEmap.GetCellSize) / 1000000
530:     totArea = (totArea * eMapProps.MeanCellSize.X ^ 2) / 1000000
'  av.GetProject.RemoveDoc (emTable)
'End
535: End If
'If (Desc.Not) Then
537: If (Not Desc) Then
'  descList2 = {}
         'descList2.Clear
'End
541: End If
''MOVE MISSING DATA VALUE TO THE END OF THE LISTS
''------------------------------------------
'missingDex = classList.FindByValue(missing)
     Dim missingDex As Long
546: missingDex = classList.FindByValue(CStr(missing))
'If (missingDex <> -1) Then
548: If (missingDex <> -1) Then
'  classList.Shuffle(classList.Get(missingDex),classList.Count)
550:     classList.Shuffle classList.GetVal(missingDex), classList.Count
'  sumCntLst.Shuffle(sumCntLst.Get(missingDex),sumCntLst.Count)
'  sumCntLst is a dictionary
'  pntCountList.Shuffle(pntCountList.Get(missingDex),pntCountList.Count)
554:     pntCountList.Shuffle pntCountList.GetVal(missingDex), pntCountList.Count
'  If (Desc) Then
556:     If (Desc) Then
'    descList2.Shuffle(descList2.Get(missingDex),descList2.Count)
             'descList2.Shuffle descList2.getVal(missingDex), descList2.count
'  End
560:     End If
'End
562: End If
''RETURN THE NEEDED LISTS FOR FURTHER PROCESSING
''-----------------------------------------
'listOfLists = {classList,sumCntLst,pntCountList,totDeposits,totArea,descList2}
'return listOfLists
567: Set gSDI_GetThmWgtVals = New SDMList
568: With gSDI_GetThmWgtVals
569:         .Add classList
570:         .Add sumCntLst
571:         .Add pntCountList
572:         .Add totDeposits
573:         .Add totArea
574:         .Add descList
575:         .Add descDict
576:     End With
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, "gSDI_GetThmWgtVals " & c_sModuleFileName & vbCrLf & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
581:     Set gSDI_GetThmWgtVals = Nothing
End Function

Private Function getDescriptorsFromEvTab(ByRef emVTab As ITable, ValFldName As String, DescFldName As String, missingVal As Long) As SDMDictionary
  On Error GoTo ErrorHandler
  'MsgBox (emVTab Is Nothing) & "," & ValFldName & "," & DescFldName & "," & missingVal, , "getDescriptorsFromEvTab"
    Dim valdesc As New SDMDictionary
588:     valdesc.Add missingVal, "Missing"
    Dim qry As IQuery
    Dim curs As ICursor
    Dim validx As Long
592:     If emVTab Is Nothing Then
593:         getDescriptorsFromEvTab = valdesc
        Exit Function
595:     End If
    'MsgBox emVTab.Fields.FieldCount, , "emVTab field count"
'    Dim list As New SDMList
'    Dim n As Long
'    For n = 0 To emVTab.Fields.FieldCount - 1
'        list.Add emVTab.Fields.Field(n).Name
'    Next n
'    MsgBox list.AsString, , "emVTab fields"
603:     validx = emVTab.FindField(ValFldName)
604:     If validx = -1 Then
605:         getDescriptorsFromEvTab = valdesc
        Exit Function
607:     End If
         Dim DescIdx As Long
609:     DescIdx = emVTab.FindField(DescFldName)
610:     If DescIdx = -1 Then
611:         getDescriptorsFromEvTab = valdesc
        Exit Function
613:     End If
614:     Set curs = emVTab.Search(Nothing, False)
         Dim row As irow
616:     Set row = curs.nextrow
617:     While (Not row Is Nothing)
            Dim data As Variant
619:         data = row.Value(validx)
            Dim Desc As Variant
621:         Desc = row.Value(DescIdx)
622:         If IsNull(data) Then
623:            valdesc.Add 0, "NoData"
624:         Else
625:            valdesc.Add CLng(data), Desc
626:         End If
627:         Set row = curs.nextrow
628:     Wend
629:     Set getDescriptorsFromEvTab = valdesc
'MsgBox valdesc.AsString, , "Return values"

  Exit Function
ErrorHandler:
  HandleError False, "getDescriptorsFromEvTab " & c_sModuleFileName & vbCrLf & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
635:   Set getDescriptorsFromEvTab = valdesc
End Function

