VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeTempEM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_MakeTempEM.cls"
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeTempEM(ByRef argArray As Variant) As IRasterLayer
  On Error GoTo ErrorHandler


Dim errline As String
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
' Name:  gSDI.MakeTempEM
'Topics:  Spatial Data Modelle
'Description:  Makes a temporary grid that
'  is the portion of an evidential theme
'  extracted by the study area grid them that
'  has been set as the Analysis Environment mask.
'  Actual weights calculatiions are performed on the
'  extracted grid
'
'Requires:
'
' Self:  List from calling script, either gSDI.CalcThemeWts
'   or gSDI.CalcCombined
'
'Returns: the temporary evidential theme grid (tmpEMGrid)
'==============================================
Dim evidenceMap As IRasterLayer
35: Set evidenceMap = argArray(0)

'>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
''Set the working directory to the path of the project
''------------------------------------------------------
'theProject = av.GetProject
'prjFileName = theProject.GetFileName
'If (prjFileName <> Nil) Then
'  projectDir = prjFileName.ReturnDir
'  prjWorkDir = theProject.GetWorkDir
'  System.SetEnvVar("HOME",projectDir.AsString )
'End
    Dim prjFileName As String
48: prjFileName = SDMGlobals.SDMWorkspace.PathName
''MAKE TEMPORARY EVIDENCE MAP THAT EXCLUDES NO DATA AREA OF BASE MAP
''-------------------------------
'emGrid = evidenceMap.GetGrid
    Dim emGrid As IRaster
53: Set emGrid = evidenceMap.Raster
    Dim emGDS As IGeoDataset
'Set emGDS = emGrid
'MsgBox emGDS.extent.Width & "," & emGDS.extent.Height & ",", , "EM"

'If (emGrid.HasError) Then
'  MsgBox.Error("The Evidential Theme Grid, "+evidenceMap.GetName+" has an error.",
'               "Spatial Data Modeller"
'  return "Error"
'End
'baseMap = theView.GetExtension(AnalysisEnvironment).GetMask
    Dim gSDIGetMask As AnalysisParameters.gSDI_getMask
65: Set gSDIGetMask = New AnalysisParameters.gSDI_getMask
    Dim baseMap As IGeoDataset
67: Set baseMap = gSDIGetMask.gSDI_getMask
'If (baseMap = Nil) Then
69: If (baseMap Is Nothing) Then
'  return "NoBM"
71:     Set gSDI_MakeTempEM = Nothing
'End
73: End If
'bmGrid = baseMap.GetGrid
'If (bmGrid.HasError) Then
'  MsgBox.Error("The Study Area Grid Theme, "+baseMap.GetName+" has an error.",
'               "Spatial Data Modeller")
'  return "Error"
'End

    Dim spatUtil As SDMUtilities.SpatialAnalystUtil
82: Set spatUtil = New SDMUtilities.SpatialAnalystUtil
    Dim ae As IRasterAnalysisEnvironment
84: Set ae = SDMGlobals.SDMRAEnvironment
85: ae.SetAsNewDefaultEnvironment

'missing = av.FindDialog("gTW").FindByName("txtMD").GetText
    Dim missing As Variant
89: missing = gTW.txtMD.Text
'If ((missing = "") Or (missing.IsNumber.Not)) Then
91: If ((missing = "") Or (Not IsNumeric(missing))) Then
'  MsgBox.Warning("The calculation of uncertainty due to missing data"+NL+
'                 "may be inaccurate if "+evidenceMap.GetName+" contains"+NL+
'                 "'No Data' values within the study area.","Spatial Data Modeller")
95:     MsgBox "The calculation of uncertainty due to missing data" & vbCrLf & _
                 "may be inaccurate if " + evidenceMap.Name + " contains" & vbCrLf & _
                 "'No Data' values within the study area.", , "Spatial Data Modeller"
'  tmpEMGrid = emGrid.ExtractByMask(bmGrid)
         Dim extractOp As IExtractionOp
100:     Set extractOp = New RasterExtractionOp
    'Dim emGDS As IGeoDataset
102:     Set emGDS = emGrid
         Dim tmpEMGrid As IGeoDataset
104:     Set tmpEMGrid = extractOp.Raster(emGDS, baseMap)
'  If (tmpEMGrid.HasError) Then
'    MsgBox.Warning("Temporary grid extracted from "+evidenceMap.GetName+" has error.",
'                 "Spatial Data Modeller")
'  End
'Else
110: Else
'  missing = missing.AsNumber
112:     missing = CDbl(missing)
         Dim rasMkrOp As IRasterMakerOp
114:     Set rasMkrOp = New RasterMakerOp
         Dim rasMkrOpEnv As IRasterAnalysisEnvironment
116:     Set rasMkrOpEnv = rasMkrOp
117:     Set rasMkrOpEnv.Mask = ae.Mask
118:     rasMkrOpEnv.SetExtent esriRasterEnvValue, ae.Mask
119:     rasMkrOpEnv.SetCellSize esriRasterEnvValue, emGrid
120:     Set rasMkrOpEnv.OutWorkspace = ae.OutWorkspace
121:     Set rasMkrOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
         Dim missingGrid0 As IGeoDataset
123:     Set missingGrid0 = rasMkrOp.MakeConstant(missing, True)
    
         Dim condOp As IConditionalOp
126:     Set condOp = New RasterConditionalOp
         Dim condOpEnv As IRasterAnalysisEnvironment
128:     Set condOpEnv = rasMkrOp
129:     Set condOpEnv.Mask = ae.Mask
130:     condOpEnv.SetExtent esriRasterEnvValue, ae.Mask
131:     condOpEnv.SetCellSize esriRasterEnvMinOf
132:     Set condOpEnv.OutWorkspace = ae.OutWorkspace
133:     Set condOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
''  If (missingGrid.HasError) Then
'    MsgBox.Warning("The calculation of uncertainty due to missing data"+NL+
'                 "may be inaccurate if "+evidenceMap.GetName+" contains"+NL+
'                 "'No Data' values within the study area.","Spatial Data Modeller")
'    tmpEMGrid = emGrid.ExtractByMask(bmGrid)
'    If (tmpEMGrid.HasError) Then
'      MsgBox.Warning("Temporary grid extracted from "+evidenceMap.GetName+" has error.",
'                   "Spatial Data Modeller")
'    End
'  Else
'    tmpEMGrid = emGrid.Merge({missingGrid})
'  End
'>>>>> Kluge Merge
         Dim logOp As ILogicalOp
150:     Set logOp = New RasterMathOps
         Dim logOpEnv As IRasterAnalysisEnvironment
152:     Set logOpEnv = rasMkrOp
153:     Set logOpEnv.Mask = ae.Mask
154:     logOpEnv.SetExtent esriRasterEnvValue, ae.Mask
155:     logOpEnv.SetCellSize esriRasterEnvMinOf
156:     Set logOpEnv.OutWorkspace = ae.OutWorkspace
157:     Set logOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
         On Error Resume Next
159:     Err.Clear
160:     Set tmpEMGrid = condOp.Con(logOp.IsNull(emGrid), missingGrid0, emGrid)
'    If (tmpEMGrid.HasError) Then
162:     If Err.Number <> 0 Then
'    MsgBox.Warning("Temporary grid extracted from "+evidenceMap.GetName+" has error.",
'                 "Spatial Data Modeller")
165:         MsgBox "Temporary grid extracted from " & evidenceMap.Name & " has error.", , "Spatial Data Modeller"
'    End
167:     End If
         On Error GoTo ErrorHandler
         Dim rasprops As IRasterProps
170:     Set rasprops = tmpEMGrid
''>>>>> End of kluge
'End
173: End If
'return tmpEMGrid
175: Set gSDI_MakeTempEM = New RasterLayer
176: gSDI_MakeTempEM.CreateFromRaster tmpEMGrid
Exit Function
ErrorHandler:
  HandleError True, "gSDI_MakeTempEM " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
180:    Set gSDI_MakeTempEM = Nothing
End Function

