VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeTmpGrid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_MakeTmpGrid"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeTmpGrid(ByRef Self As Variant) As IRaster
  On Error GoTo ErrorHandler
'14:   MsgBox "entering...", , c_sModuleFileName
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.MakeTmpGrid
'' Topics: Spatial Data Modeller
'' Description:  Makes a temporary grid theme
''        from an evidential theme that has
''        the following characteristics:
''        - its names is the same as the evidential theme
''        - it is written to the ~sdmtemp directory
''        - areas outside the analysis mask have
''          a value of "No Data"
''        - "No Data" cells in the evidential theme that
''          lie within the analysis mask are assigned the
''          missing data integer
''        - cell values contain the analysis class values
'>>>>> Not evidence layer values but reclassed evidence values!!!!
''
''
'' Requires:
''
'' Self:  0 - g -- the evidential theme
''        1 - idx -- (not currently in use)
''        2 - recField -- field containing class values
''        3 - typ -- char indicating whether polygon feature theme ("P") or grid theme ("G')
''        4 - missing -- missing data integer
''        5 - name -- name of evidential theme
''
'' Returns:
''==============================================
'g = Self.Get(0)
    Dim g As IRasterLayer
45: Set g = Self(0)
'idx = Self.Get(1)
    Dim idx As Long
48: idx = Self(1)
'recField = Self.Get(2)
    Dim recField As IField
51: Set recField = Self(2)
'typ = Self.Get(3)
    Dim typ As String
54: typ = Self(3)
'missing = Self.Get(4)
    Dim missing As Long
57: missing = Self(4)
'name = Self.Get(5)
    Dim Name As String
60: Name = Self(5)
    Dim grVTab As ITable
62: Set grVTab = Self(6) 'Join-table: evMap + evMap-evMap-CT
'Debug.Print TypeOf grVTab Is IRelQueryTable
    Dim genTableName As String
65: genTableName = Self(7)
'fnCWD = FileName.GetCWD
'61: MsgBox "got args...", , c_sModuleFileName
'Dim pApp As IApplication
'63: Set pApp = SDMGlobals.SDMApp
'Dim saExt As IExtension
'65: Set saExt = pApp.FindExtensionByName("Spatial Analyst")
    Dim raEnv As IRasterAnalysisEnvironment
73: Set raEnv = SDMGlobals.SDMRAEnvironment
    Dim fnCWD As IWorkspace
'72: MsgBox "RA OutWorkSpace: " & raEnv.OutWorkspace.PathName, , c_sModuleFileName
76: Set fnCWD = raEnv.OutWorkspace
'dirTmp = av.Run("gSDI.GetTmpDir",{})
'Dim gSDIGetTmpDir As gSDI_GetTmpDir
'75: Set gSDIGetTmpDir = New gSDI_GetTmpDir
    Dim dirTmp As IWorkspace
81: Set dirTmp = gSDI_GetTmpDir
'if (dirTmp.Is(String)) then
'  MsgBox.Error(dirTmp,"Error getting SDI temporary directory.")
'  return Nil
'End
'dirTmp.SetCWD
87: Set raEnv.OutWorkspace = dirTmp
'84: MsgBox "got outworkspace...", , c_sModuleFileName
'grVTab = av.Run("gSDI.GetVTab",{g})
'If (grVTab.Is(VTab).Not) Then
'  return "Error"
'End
'''grVTab = g.GetVTab
''
''if (grVTab = Nil) then
''  built = g.BuildVAT
''  if (built.Not) then
''    MsgBox.Error("An attribute table for temporary grid, "+g.GetName+", could"+NL
''                 "could not be found or built.","Unique Conditions")
''    return "Error
''  else
''    grVTab = g.GetVTab
''    if (grVTab = Nil) then
''    MsgBox.Error("An attribute table for temporary grid, "+g.GetName+", could"+NL+
''                 "could not be found or built.","Unique Conditions")
''    return "Error"
''    end
''  end
''end
'grFields = grVTab.GetFields
'''     Dim grFields As IFields
'''113: Set grFields = grVTab.Fields
'valField = grVTab.FindField("Value")
'''     Dim valField As Long
'''116: valField = grVTab.FindField("Value")
'recList = List.Make
'''     Dim recList As New SDMUtilities.SDMList
'If (typ = "P") Then
'''     Dim rclsField As IField
'''121: If typ = "P" Then
'  rclsField = grVTab.FindField("Value")
'''         Dim indx As Long
'''124:     indx = grVTab.FindField("Value2")
'  If (rclsField = nil) Then
'''126:     If indx = -1 Then
'    return nil
'''128:         Set gSDI_MakeTmpGrid = Nothing
'''             Exit Function
'  End
'''131:     End If
'''132:     Set rclsField = grVTab.Fields.Field(idx)
'Else
'''134: Else
'  rclsField = grFields.Get(indx)
'''135:     indx = grFields.FindField(recField.Name)
'''137:     Set rclsField = grFields.Field(indx)
'End
'''139: End If
'For Each record In grVTab
'''     Dim curs As ICursor
'''141: Set curs = grVTab.Search(Nothing, False)
'''     Dim record As irow
'''143: Set record = curs.NextRow
'''145: While Not record Is Nothing
'  minVal = grVTab.ReturnValue(valField, record)
'''         Dim minval As Long
'''148:     minval = record.Value(valField)
'  maxVal = minVal
'''         Dim maxval As Long
'''151:     maxval = minval
'  reclass = Classification.Make(minVal, maxVal)
'  reclass.SetLabel (grVTab.ReturnValue(rclsField, record).asString)
'  recList.Add (reclass)
'''155:     Set record = curs.NextRow
'''156: Wend

'Set up analysisenvironment
     Dim raMask As IGeoDataset
159: Set raMask = raEnv.Mask
     Dim rasprops As IRasterProps
161: Set rasprops = raMask
     Dim cellsize As Double
'173: raEnv.GetCellSize esriRasterEnvValue, cellsize
'174: MsgBox "raCellsize: " & cellsize, , c_sModuleFileName
     Dim raext As IEnvelope
'176: raEnv.GetExtent esriRasterEnvValue, raExt
167:      ProgressAnimation.Hide
     Dim rasOps As IRasterMakerOp
169: Set rasOps = New RasterMakerOp
     Dim rasOpEnv As IRasterAnalysisEnvironment
171: Set rasOpEnv = rasOps
172: Set rasOpEnv.Mask = raEnv.Mask
173: rasOpEnv.SetExtent esriRasterEnvValue, raEnv.Mask
174: rasOpEnv.SetCellSize esriRasterEnvValue, RasterUtils.GetDatasetRaster(g)
175: Set rasOpEnv.OutWorkspace = raEnv.OutWorkspace
176: Set rasOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference

'missingGrid = missing.AsGrid
     On Error Resume Next
180: Err.Clear
     Dim missingGrid0 As IGeoDataset
182: Set missingGrid0 = rasOps.MakeConstant(CDbl(missing), True)
'If (missingGrid.HasError) Then
184: If missingGrid0 Is Nothing Or Err.Number <> 0 Then
'  MsgBox.Error("","Unique Conditions"
186:         MsgBox "Error: " & Err.Description, vbCritical, c_sModuleFileName
187:         Err.Clear
188:         Set gSDI_MakeTmpGrid = Nothing
             Exit Function
'End
191: End If
     On Error GoTo ErrorHandler

194: Set rasprops = missingGrid0

''aGrid.ReclassByClassList (aFieldName, aClassList, noData)
''because base map set, dont' have to extract by study area later
'tmpGrid = g.ReclassByClassList(valField.asString, recList, False)
     On Error Resume Next
200: Err.Clear
     Dim tmpGrid1 As IRasterLayer
202: Set tmpGrid1 = RasterAEUtils.MakeReclassRaster(grVTab, g, genTableName, raEnv.Mask)
203: If tmpGrid1 Is Nothing Then
204:     Set gSDI_MakeTmpGrid = Nothing
         Exit Function
206: End If
'If (tmpGrid.HasError) Then
208: If Err.Number <> 0 Then
'  MsgBox.Error("Temporary grid from, "+g.GetDataSetName+", has an error. ",
'               "Unique Conditions")
211:     MsgBox "Temporary grid1 from " & Name & " has an error: " & Err.Description, vbCritical, c_sModuleFileName
212:     Err.Clear
213:     Set gSDI_MakeTmpGrid = Nothing
         Exit Function
'End
216: End If
     On Error GoTo ErrorHandler

'tmpGrid = tmpGrid.Merge({missingGrid})
     Dim tmpGrid As IRaster
     Dim newTGFString As String
     Dim CWD As String
223: CWD = Left(raEnv.OutWorkspace.PathName, Len(raEnv.OutWorkspace.PathName) - 1)
     Dim fName As IFileName
225: Set fName = WOETableUtils.MakeTmpDir(CWD, Name & "_mrg", "")
     Dim tokens As Variant
227: tokens = Split(fName.path, "\")
228: newTGFString = tokens(UBound(tokens))
     Dim mgLayer As IRasterLayer
230: Set mgLayer = New RasterLayer
231: mgLayer.CreateFromRaster missingGrid0
232: mgLayer.Name = "MissingGrid0"
'>>>>> Kluge for Merge
         Dim condOp As IConditionalOp
235:     Set condOp = New RasterConditionalOp
         Dim conOpEnv As IRasterAnalysisEnvironment
237:     Set conOpEnv = condOp
238:     Set conOpEnv.Mask = raEnv.Mask
239:     conOpEnv.SetExtent esriRasterEnvValue, raEnv.Mask
240:     conOpEnv.SetCellSize esriRasterEnvMinOf
241:     Set conOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
242:     Set conOpEnv.OutWorkspace = raEnv.OutWorkspace
243:     conOpEnv.DefaultOutputRasterPrefix = "SDMTemp"

         Dim missingGrid As IGeoDataset
246:     Set missingGrid = condOp.Con(raEnv.Mask, missingGrid0, raEnv.Mask)
         Dim logOp As ILogicalOp
248:     Set logOp = New RasterMathOps
         Dim logOpEnv As IRasterAnalysisEnvironment
250:     Set logOpEnv = condOp
251:     Set logOpEnv.Mask = raEnv.Mask
252:     logOpEnv.SetExtent esriRasterEnvValue, raEnv.Mask
253:     logOpEnv.SetCellSize esriRasterEnvMinOf
254:          logOpEnv.DefaultOutputRasterPrefix = "SDMTemp"
255:     Set logOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
256:     Set logOpEnv.OutWorkspace = raEnv.OutWorkspace
         On Error Resume Next
258:     Err.Clear
259:     Set tmpGrid = condOp.Con(logOp.IsNull(tmpGrid1.Raster), missingGrid, tmpGrid1.Raster)
260:     Set rasprops = tmpGrid 'This executes the grid operations
'>>>>> End Kluge
'If (tmpGrid.HasError) Then
263: If (tmpGrid Is Nothing) Or Err.Number <> 0 Then
'  MsgBox.Error("Temporary grid from, "+g.GetDataSetName+", has an error.",
'               "Unique Conditions")
266:        MsgBox "Temporary grid from " & Name & " has an error: " & Err.Description, vbCritical, _
            c_sModuleFileName
268:        Err.Clear
269:        Set gSDI_MakeTmpGrid = Nothing
            Exit Function
'End
272: End If
     On Error GoTo ErrorHandler
274: Err.Clear
'252: Set rasProps = tmpGrid

'newTGFString = name
'badCharList = {" ","\","/","|","?","<",">",":","*","."}
'For Each ch In badCharList
'  newTGFString = newTGFString.Substitute(ch, "_")
'End
'If (newTGFString.Count > 13) Then
'  newTGFString = newTGFString.Right(13)
'End
''newTGFn = (dirTmp.AsString + "/" + newTGFString).AsFileName
'newTGFn = (newTGFString).AsFileName
'tmpGrid.Rename (newTGFn)

''  Grid.DeleteDataSet(newTGFn)
'
''  renamed = Grid.RenameDataSet(tmpGrid.GetSrcName.GetFileName,newTGFn)
'
'fnCWD.SetCWD
'
     Dim raColl As IRasterBandCollection
296: Set raColl = tmpGrid
     Dim raBand As IRasterBand
298: Set raBand = raColl.item(0)
     Dim gRDataSet As IRasterDataset
300: Set gRDataSet = raBand
     Dim gDataSet As IDataset
302: Set gDataSet = gRDataSet
303: gDataSet.BrowseName = g.Name & "BN"
304: If gDataSet.CanRename Then gDataSet.Rename (g.Name & "RN")
'return tmpGrid
306: Set gSDI_MakeTmpGrid = tmpGrid
'MsgBox "Exiting: " & g.Name, , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
312:   Set gSDI_MakeTmpGrid = Nothing
End Function

''''Private Function merge(OutRasName As String, OutRasWSName As String, ByRef grid1 As IRasterLayer, ByRef grid2 As IRasterLayer, _
''''            cellsize As Double) As IRaster
''''    On Error GoTo ErrorHandler
''''    'Cocreate the geometric processing object
''''        Dim pProc As IRasterGeometryProc
''''330:     Set pProc = New RasterGeometryProc
''''    'cocreate the new empty raster
''''        Dim pRas As IRaster
''''333:     Set pRas = New Raster
''''    'Q I the raster for IRasterBandCollection
''''        Dim pRasBC As IRasterBandCollection
''''336:     Set pRasBC = pRas
''''        Dim pRasterDataset As IRasterDataset
''''    'open the first dataset and add its bands to the raster
''''        Dim fp As String
''''340:     fp = grid1.FilePath
''''        Dim fs As Object
''''342:     Set fs = CreateObject("Scripting.FileSystemObject")
''''343:     Set pRasterDataset = OpenRasterDataset(fs.getParentFolderName(fp), fs.GetFileName(fp))
''''344:     pRasBC.AppendBands pRasterDataset
''''    'open the second dataset and add its bands to the raster
''''346:     fp = grid2.FilePath
''''347:     Set pRasterDataset = OpenRasterDataset(fs.getParentFolderName(fp), fs.GetFileName(fp))
''''348:     pRasBC.AppendBands pRasterDataset
''''    'merge the datasets,creating a new dataset named merged
''''        Dim outRas As IRaster
''''        On Error Resume Next
''''352:    Set outRas = pProc.merge(OutRasName, SetRasterWorkspace(OutRasWSName), "GRID", cellsize, Nothing, pRasBC)
''''353:    If Err.Number > 0 Then
''''354:         Err.Clear
''''355:         Set merge = Nothing
''''            Exit Function
''''357:     End If
''''        On Error GoTo 0
'''''>>>>> ESRI recommended fix to generate a valid output raster
''''360:         Set pRasBC = Nothing
''''361:         Set pRasterDataset = Nothing
'''''>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
''''363:     Set merge = outRas
''''364:     Set fs = Nothing
''''        Dim rasprops As IRasterProps
''''366:    Set rasprops = outRas
'''''354:    MsgBox rasProps.Width & "," & rasProps.Height & vbCrLf & _
'''''             rasProps.IsInteger & vbCrLf & _
'''''             rasProps.MeanCellSize.X, , c_sModuleFileName & "-Merge"
''''Exit Function
''''ErrorHandler:
''''  HandleError True, c_sModuleFileName & ":Merge " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
''''373:   Set merge = Nothing
''''End Function
'''Private Function OpenRasterDataset(sPath As String, sRasterName As String) As IRasterDataset
'''  On Error GoTo ErrorHandler
'''
'''    'Return RasterDataset Object given a file name and its directory
'''    Dim pWSFact As IWorkspaceFactory
'''    Dim pRasterWS As IRasterWorkspace
'''
'''382:     Set pWSFact = New RasterWorkspaceFactory
'''383:     If pWSFact.IsWorkspace(sPath) Then
'''384:         Set pRasterWS = pWSFact.OpenFromFile(sPath, 0)
'''385:         Set OpenRasterDataset = pRasterWS.OpenRasterDataset(sRasterName)
'''386:     End If
'''
'''
'''  Exit Function
'''ErrorHandler:
'''  HandleError False, "OpenRasterDataset " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
'''End Function

'''Private Function SetRasterWorkspace(sPath As String) As IWorkspace
'''    ' This function returns a raster workspace object given the path.
'''    ' The path needs to contain raster data.
'''    Dim pWSF As IWorkspaceFactory
'''398:     Set pWSF = New RasterWorkspaceFactory
'''399:     If pWSF.IsWorkspace(sPath) Then
'''400:         Set SetRasterWorkspace = pWSF.OpenFromFile(sPath, 0)
'''401:     End If
'''End Function

Private Function gSDI_GetTmpDir() As IWorkspace
On Error GoTo ErrorHandler
'' gSDI.GetTmpDir
'
'sepChr = av.Run("gSDI.GetSeparatorChar", Array())
'Dim gsdiGetSepChar As gSDI_GetSepChar
'Set gsdiGetSepChar = New gSDI_GetSepChar
     Dim sepChr As String
402: sepChr = "\" 'gsdiGetSepChar.gSDI_GetSeparatorChar
'dirPrjct = av.Run("gSDI.GetProjectDir",{})
     Dim getPrjDir As gSDI_getProjectDir
405: Set getPrjDir = New gSDI_getProjectDir
     Dim dirPrjct As String
407: dirPrjct = getPrjDir.gSDI_getProjectDir
'If (dirPrjct = Nil) Then
409: If (dirPrjct = "") Then
'  MsgBox.Error("SDI requires a temporary directory to which you have write permission.  Please ensure that your project file has been saved and/or that you have a temporary directory specified via your operating system.",
'  "Error writing temporary files")
412:     MsgBox "SDI requires a temporary directory to which you have write permission.  Please ensure that your project file has been saved and/or that you have a temporary directory specified via your operating system.", vbCritical, "Error writing temporary files"
'  return Nil
414:     Set gSDI_GetTmpDir = Nothing
         Exit Function
'End
417: End If
'strTmpDir = dirPrjct.GetFullName + sepChr + "~sdmtemp"
     Dim strTmpDir As String
420: strTmpDir = dirPrjct & sepChr & "~sdmtemp"
'if (File.Exists((strTmpDir).AsFileName).Not) then
     Dim fs As Object
423: Set fs = CreateObject("Scripting.FileSystemObject")
424: If (Not fs.folderExists(strTmpDir)) Then
'  dirTmpName = av.Run("gSDI.MakeTempDir",{dirPrjct})
         Dim MakeTmpDir As gSDI_MakeTempDir
427:     Set MakeTmpDir = New gSDI_MakeTempDir
         Dim dirTmpName As String
429:     dirTmpName = MakeTmpDir.gSDI_MakeTempDir(Array(dirPrjct))
'  if (File.Exists((strTmpDir).AsFileName).Not) then
431:     If (Not fs.folderExists(strTmpDir)) Then
'    MsgBox.Error("Unable to find or create " + strTmpDir + ".  Please create " + vbcrlf +
'                 "manually before running function again.","Temporary Directory")
434:         MsgBox "Unable to find or create " & strTmpDir & ".  Please create " & vbCrLf & _
                 "manually before running function again.", vbCritical, "Temporary Directory"
'    return Nil
437:         Set gSDI_GetTmpDir = Nothing
'  Else
439:     Else
'    dirTmp = strTmpDir.AsFileName
             Dim dirTmp As String
442:         dirTmp = strTmpDir
'  End
444:     End If
'Else
446: Else
'  dirTmp = strTmpDir.AsFileName
448:     dirTmp = strTmpDir
'End
450: End If
'return dirTmp
     Dim rasWSFact As IWorkspaceFactory
453: Set rasWSFact = New RasterWorkspaceFactory
454: Set gSDI_GetTmpDir = rasWSFact.OpenFromFile(strTmpDir, 0)
Exit Function

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function






