VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MakeUniqCondits"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Private anlParms As AnalysisParameters.AnlParams
Private gParam As Variant
Const c_sModuleFileName As String = "gSDI_MakeUniqueConditions"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MakeUniqueConditions(ByRef Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler

'17:   MsgBox "entering " & c_sModuleFileName
18:   Set gSDI_MakeUniqueConditions = New SDMUtilities.SDMList

20: SDMGlobals.SDMStatusBar.Message(0) = "Starting Unique Conditions..."
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name: gSDI.MakeUniqueConditions
''
''Topics:  Spatial Analyst; Spatial Data Modeller
'
''Description:  Creates a unique conditions grid and
''  attribute table from a set of evidential themes.
''  Polygon evidential themes are first converted to
''  grids. All are then combined using the .Combine request
''  in spatial Analyst.
''  Forms the basis of the response theme and is also the
''  basis for running a pair-wise test for conditional
''  independence on a set of evidential themes.
''
''Requires:
''
'' Self:  List from calling script, either gSDI.Final or
''  gSDI.MakeCITab
''
''Returns:  Unique conditions grid (ucGrid)
''==============================================
'' GET THE VIEW...
''--------------------------------------------
'theView = av.GetActiveDoc
    Dim theView As IMap
46: Set theView = SDMGlobals.SDMUtil.getMap
'' ...AND THE STUDY AREA GRID...
''--------------------------------------------
'baseMap = theView.GetExtension(AnalysisEnvironment).GetMask
    Dim gSDIGetMask As gSDI_getMask
51: Set gSDIGetMask = New gSDI_getMask
    Dim baseMap As IGeoDataset
53: Set baseMap = gSDIGetMask.gSDI_getMask
'If (baseMap = nil) Then
55: If baseMap Is Nothing Then
'  return "NoBM"
57:     gSDI_MakeUniqueConditions.Add "No Base Map"
        Exit Function
'End
60: End If
'57: MsgBox "Basemap OK", , c_sModuleFileName
''...THEN THE ARGUMENTS...
''--------------------------------------------
'tList = Self.Get(0)
    Dim tList As SDMUtilities.SDMList
66: Set tList = Self(0)
'saTblList = Self.Get(1)
    Dim saTblList As SDMUtilities.SDMList
69: Set saTblList = Self(1)
'lstMD = Self.Get(2)
    Dim lstMD As SDMUtilities.SDMList
72: Set lstMD = Self(2)
'lstClp = self.Get(3)
    Dim lstClp As SDMUtilities.SDMList
75: Set lstClp = Self(3)
'ttypeList = Self.Get(4)
    Dim ttypeList As SDMUtilities.SDMList
78: Set ttypeList = Self(4)
''callingScript = Self.Get(5)
    Dim noTP As Boolean
    Dim gSDINoTP As gSDI_NoTP
82: Set gSDINoTP = New gSDI_NoTP
83: noTP = gSDINoTP.gSDI_NoTP
84: Set gSDINoTP = Nothing
'
''''''' Calculate maximum number of unique conditions
''''''' to warn user if large
'''''''----------------------------------------------
''''''ucMx = 1
'''''Dim ucMx As Long
'''''91: ucMx = 1
''''''i = 0
'''''Dim i As Long
'''''94: i = 0
'''''Dim t As ILayer
'''''Dim tidx As Long
''''''For Each t In tList
'''''98: For tidx = 0 To tList.Count - 1
'''''99:     Set t = tList.GetObj(tidx)
''''''  If (t.Is(GTheme)) Then
''''''    vTb = av.Run("gSDI.GetVTab",{t})
'''''    Dim vTb As ITable
'''''103:     Set vTb = t
''''''    If (vTb = Nil) Then
''''''      Continue
''''''    End
''''''  ElseIf (t.Is(FTheme)) The
''''''    vTb = t.GetFTab
''''''  End
''''''  lstVl = List.Make
'''''    Dim lstVl As New SDMUtilities.SDMList
'''''    Dim curs As ICursor
'''''113:     Set curs = vTb.Search(Nothing, False)
'''''    Dim r As irow
'''''115:     Set r = curs.NextRow
''''''  For Each r In vTb
'''''117:     While Not r Is Nothing
''''''    v = vTb.ReturnValue(FldList.Get(i), r)
'''''        Dim v As Variant
'''''        Dim Fldidx As Long
'''''121:         Fldidx = vTb.FindField("Value")
'''''122:         v = r.Value(Fldidx)
''''''    If (v.IsNull.Not) Then
'''''124:         If Not IsNull(v) Then lstVl.Add v
''''''      lstVl.Add (v)
''''''    End
'''''127:         Set r = curs.NextRow
''''''  End
'''''129:     Wend
''''''  lstVl.RemoveDuplicates
'''''131:     Set lstVl = lstVl.RemoveDuplicates
''''''  If (lstVl.Count > 0) Then
'''''133:     If lstVl.Count > 0 Then ucMx = ucMx * lstVl.Count
''''''    ucMx = ucMx * lstVl.Count
''''''  End
''''''
''''''  i = i + 1
'''''138:     i = i + 1
''''''End
'''''140: Next tidx
''''''Dim cntnu As Variant
''''''cntnu = MsgBox.YesNo("A unique conditions table with up to " + ucMx.AsString + " records will be created.  Continue?", "Unique Conditions", True)
''''''140: cntnu = MsgBox("A unique conditions table with up to " & ucMx & " records will be created.  Continue?", vbYesNo, c_sModuleFileName)
''''''If (cntnu.Not) Then
''''''142: If cntnu <> vbYes Then
''''''  return Nil
''''''144:     Set gSDI_MakeUniqueConditions = Nothing
''''''    Exit Function
''''''End
''''''147: End If

'''''>>>>> Begin shunt around Merge & Combine Problems
'' CREATE A UNIQUE CONDITIONS GRID NAME
''-------------------------------------
'defname = FileName.GetCWD.MakeTmp("sdmuc", "")
'curPrj = theView.GetProjection
     Dim curPrj As ISpatialReference
158: Set curPrj = Nothing
'If (noTP.Not) Then
160: If Not noTP Then
'  vTabTP = av.Run("gSDI.GetTPVTab",{theView})
         Dim thmTP As IFeatureLayer
163:     Set SDMGlobals.SDMUtil.setAPP = SDMGlobals.SDMApp
         Dim TPName As String
165:     TPName = gParam.cbxTP.Text
166:     Set thmTP = SDMGlobals.SDMUtil.FindLayerByName(TPName)
'  if (vTabTP.Is(String)) then
'    MsgBox.Error(vTabTP,"Training Point Theme Error")
'    return NIl
'  End
'Else
172: Else
'  vTabTP = Nil
174:         Set thmTP = Nothing
'End
176: End If
'' CONVERT ANY POLYGON THEMES TO GRIDS AND ADD
'' TO TEMPORARY GRID LIST
''--------------------------------------------
'i = 0
     Dim i As Long
182: i = 0
'grList = List.Make
     Dim grList As New SDMUtilities.SDMList
'For Each t In tList
     Dim t1 As IRasterLayer
     Dim nt As Long
188: For nt = 0 To tList.Count - 1
189:     Set t1 = tList.getObj(nt)
'  If (ttypeList.Get(i) = "P") Then
191:     If ttypeList.GetVal(i) = "P" Then
'    fld = saTblList.Get(tList.Find(t))
'    missing = lstMD.Get(tList.Find(t))
'    gt = av.Run("gSDI.Poly2Grid",{t,fld,missing,theView,vTabTP,}
'    If (gt.Is(Grid).Not) Then
'      MsgBox.Error("An error occurred converting " + t.GetName + " to a grid.","Unique Conditions")
'      return Nil
'    ElseIf (gt.HasError) Then
'      MsgBox.Error("An error occurred converting " + t.GetName + " to a grid.","Unique Conditions")
'      return Nil
'    End
'    grList.Add (gt)
'  Else
204:     Else
'    If (t.GetGrid.HasError) Then
'      MsgBox.Error("An error was found in grid of theme "+t.GetName+".",
'                   "Unique Conditions")
'      return "Error"
'    End
'    grList.Add (t.GetGrid)
211:         grList.Add t1
'  End
213:     End If
'  i = i + 1
215: i = i + 1
'End
217: Next nt
'MsgBox grList.AsString, , c_sModuleFileName

'tmpGRList = {}
     Dim tmpGRList As New SDMUtilities.SDMList
'' MAKE RECLASSED GRIDS FOR THOSE USER WANTS TO
'' VALUES OTHER THAN IN THE VALUE FIELD
''----------------------------------------------
'For Each g In grList
     Dim defltMousePtr As Long
     defltMousePtr = gL.MouseIcon
     gL.MousePointer = vbHourglass
     ProgressAnimation.Show "Reclassing grids..."
     Dim tmpRastList As New SDMList
     Dim pRBCollection As IRasterBandCollection
231: Set pRBCollection = New Raster

     Dim g As IRasterLayer
     Dim ng As Long
235: For ng = 0 To grList.Count - 1
237:     Set g = grList.getObj(ng)
'  idx = grList.Find(g)
         Dim idx As Long
240:     idx = ng
'  md = lstMD.Get(idx)
         Dim md As Variant
243:     md = lstMD.GetVal(idx)
'  t = tList.Get(idx)
         Dim t2 As ILayer
246:     Set t2 = tList.getObj(idx)
'  tmpGrid = av.Run("gSDI.MakeTmpGrid",{g,idx,saTblList.Get(idx),ttypeList.Get(idx),lstMD.Get(idx),tList.Get(idx).GetName})
         Dim saTbl As IStandaloneTable
         Dim saTblVar As Variant
250:     saTblVar = Split(saTblList.GetVal(idx), ".")
         Dim saTblName As String
252:     saTblName = saTblVar(0)
253:     Set saTbl = SDMGlobals.SDMUtil.FindStandAloneTableByName(saTblName)
254:     If WOETableUtils.hasJoins(g) Then WOETableUtils.UnJoinAll g
255:     If Not WOETableUtils.isJoined(g, saTbl) Then
256:             WOETableUtils.joinTableToLayer g, "Value", saTbl, "Value"
257:     End If
         Dim pDispTbl As IDisplayTable
259:     Set pDispTbl = g
         Dim gTab As ITable
261:     Set gTab = pDispTbl.DisplayTable
         Dim genFldIdx As Long
263:     genFldIdx = gTab.FindField(saTbl.Name & ".Value2")
264:     If genFldIdx = -1 Then
265:        MsgBox "Generalization attribute ""Value2"" not found in Generalization table: " & saTbl.Name, vbCritical, c_sModuleFileName
266:        gSDI_MakeUniqueConditions.Add "Error"
            Exit Function
268:     End If
         Dim recField As IField
270:     Set recField = gTab.Fields.Field(genFldIdx)
         Dim Args As Variant
272:     Args = Array(g, idx, recField, ttypeList.GetVal(idx), lstMD.GetVal(idx), t2.Name, gTab, saTbl.Name)
         Dim gSDIMakeTmpGrid As gSDI_MakeTmpGrid
274:     Set gSDIMakeTmpGrid = New gSDI_MakeTmpGrid
         Dim tmpGrid As IRaster
276:     Set tmpGrid = gSDIMakeTmpGrid.gSDI_MakeTmpGrid(Args)
277:     If tmpGrid Is Nothing Then
278:         MsgBox "tmpGrid raster not valid", vbCritical, c_sModuleFileName
279:         gSDI_MakeUniqueConditions.Add "Error"
             Exit Function
281:     End If

'  tmpGRList.Add (tmpGrid)
        Dim tmpGridLayer As IRasterLayer
285:    Set tmpGridLayer = New RasterLayer
286:    tmpGridLayer.CreateFromRaster tmpGrid
'286:    SDMGlobals.SDMMap.AddLayer tmpGridLayer 'Add intermediate temp grid
288:    tmpRastList.Add tmpGrid
        Dim inputRasBandColl As IRasterBandCollection
290:    Set inputRasBandColl = tmpGrid
291:    pRBCollection.AppendBand inputRasBandColl.item(0)
292:    gL.RasterSrcDict.Add tmpGridLayer.Name, g.Name
'End
294: Next ng
297: ProgressAnimation.Hide
298: gL.MousePointer = defltMousePtr
'MsgBox "Finished collecting unique conditions grids", , c_sModuleFileName
'' TAKE THE FIRST GRID TO SEND REQUEST TO,
'' IE COMBINE IT WITH OTHERS TO MAKE UNIQUE CONDITIONS GRID
''---------------------------------------------------------
'firstGrid = tmpGRList.Get(0)
'tmpGRList.Remove (0)
'ucGrid = firstGrid.Combine(tmpGRList)
304: ProgressAnimation.Show "Combining..."
     Dim ucGrid As IGeoDataset
306: Set ucGrid = CombineThem(pRBCollection)
'If (ucGrid.HasError) The
308: If ucGrid Is Nothing Then
'  MsgBox.Error("The Unique Conditions grid, "+ucGrid.GetSrcName.AsString+", has an error.  Quitting.","Calculating Response Theme")
310:    MsgBox "The Unique Conditions grid has an error.  Quitting.", , "Calculating Response Theme"
'  return "Error"
312:     Set gSDI_MakeUniqueConditions = Nothing
313:     ProgressAnimation.Hide
         Exit Function
'End
316: End If
317: ProgressAnimation.Hide
'if (ucGridName.Is(String).Not) then
'  ucGrid.Rename (ucGridName)
'End
'thmUC = GTheme.Make(ucGrid)
     Dim ucGridRas As IRaster
323: Set ucGridRas = ucGrid
     Dim thmUC As IRasterLayer
325: Set thmUC = New RasterLayer
326: thmUC.CreateFromRaster ucGridRas
327: If Not thmUC.Valid Then
328:     Set thmUC = Nothing
329:     MsgBox "Combined layer not valid!", vbCritical, c_sModuleFileName
330:     Set gSDI_MakeUniqueConditions = Nothing
         Exit Function
332: Else
'       MsgBox "Got valid rasterlayer: " & thmUC.Name
334: End If

'Save evidence layer-sdmtemp relationships in layer description
     Dim lyrDesc As ILayerGeneralProperties
338: Set lyrDesc = thmUC
339: lyrDesc.LayerDescription = gL.RasterSrcDict.asString & vbCrLf & "Do not write above this line."

'ucGridName = SourceManager.PutDataSet(Grid, "Unique Conditions grid", defname, True)
'''338: thmUC.Name = "SDMUC" & RasterUtils.getSDMUCName(thmUC)

'If (ucGridName = nil) Then
'  return nil
'End

348: SDMGlobals.SDMMap.AddLayer thmUC 'Add Response layer

'added = av.Run("gSDI.Add2UCTab",{thmUC,vTabTP,curPrj})
     Dim gSDIAdd2UCTab As gSDI_Add2UCTab
352:  Set gSDIAdd2UCTab = New gSDI_Add2UCTab
     Dim joinTable As ITable
354: Set joinTable = gSDIAdd2UCTab.gSDI_Add2UCTab(Array(thmUC, thmTP, curPrj))
'if (added.Is(String)) then
356: If joinTable Is Nothing Then
'  MsgBox.Error(added,"Error appending to grid attribute table.")
358:   MsgBox "Error creating Unique Conditions Join table.", vbCritical, c_sModuleFileName
'  return Nil
360:     Set gSDI_MakeUniqueConditions = Nothing
    Exit Function
'End
363: End If
'theView.AddTheme(thmUC)

'return {ucGrid,baseMap}
367: gSDI_MakeUniqueConditions.Clear
368: gSDI_MakeUniqueConditions.Add thmUC
369: gSDI_MakeUniqueConditions.Add baseMap
370: gSDI_MakeUniqueConditions.Add joinTable
371: gSDI_MakeUniqueConditions.Add tmpRastList
'MsgBox "tmpRastList" & vbCrLf & ListtoString(tmpRastList), , c_sModuleFileName
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

Exit Function

ErrorHandler:
  HandleError True, "Calculate Response" & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
379:   Set gSDI_MakeUniqueConditions = Nothing
End Function


Private Sub Class_Initialize()
384:     Set anlParms = New AnalysisParameters.AnlParams
385:     Set gParam = anlParms.gParamfrm
End Sub

Private Function CombineThem(ByRef pRBCollection As IRasterBandCollection) As IGeoDataset
  On Error GoTo ErrorHandler
'>>>>> Warning.....
'>>>>> The Combine method ESRI ArcObjects for ArcGIS 8.3 has unknown hard-coded limitations
'>>>>> on the number of input rasters and number of resulting unique values.
'>>>>> The limitations at any instant may also be controlled by available CPU
'>>>>> resources.
'>>>>>
' Get the document raster analysis environment
     Dim raEnv As IRasterAnalysisEnvironment
398: Set raEnv = SDMGlobals.SDMRAEnvironment

' Create the RasterLocalOp object
     Dim pLocalOp As ILocalOp
402: Set pLocalOp = New RasterLocalOp
     Dim LocalOpEnv As IRasterAnalysisEnvironment
404: Set LocalOpEnv = pLocalOp
405: Set LocalOpEnv.Mask = raEnv.Mask
406: LocalOpEnv.SetExtent esriRasterEnvValue, raEnv.Mask
407: LocalOpEnv.SetCellSize esriRasterEnvMinOf
408: Set LocalOpEnv.OutWorkspace = SDMGlobals.SDMUtil.openShapeFileWorkspace(WOETableUtils.getProjectDir)
409: Set LocalOpEnv.OutSpatialReference = SDMGlobals.SDMMap.SpatialReference
410: LocalOpEnv.DefaultOutputRasterPrefix = "SDMUC"
     Dim pInputDataset As IGeoDataset
412: Set pInputDataset = pRBCollection

' Calls the method
     Dim ucGrid As IGeoDataset
416: Set ucGrid = pLocalOp.Combine(pInputDataset)
417: Set CombineThem = ucGrid
     Exit Function

ErrorHandler:
421:     MsgBox "Combine Operation Error: " & Err.Number & "=" & Err.Description, vbCritical, c_sModuleFileName
422:     MsgBox "Your model has too many evidence layers or" & vbCrLf & _
                "has produced too many unique conditions.", vbCritical, c_sModuleFileName
424:     Set CombineThem = Nothing
End Function

Private Function createRDSFromRBColl(sPath As String, sInRasters As Variant, sOutName As String, PCS As Long) As String
    ' sPath: path for input and output
    ' sInRasters: input rasters
    ' sOutName: name of output raster
    ' PCS: code for Projected Coordinate System, like 54008 is Sinusodial
    
    ' Create RasterWorkspace
            Dim pRWS As IRasterWorkspace
            Dim pWSF As IWorkspaceFactory
436:     Set pWSF = New RasterWorkspaceFactory
            If Not pWSF.IsWorkspace(sPath) Then Exit Function
438:     Set pRWS = pWSF.OpenFromFile(sPath, 0)

    ' Open RasterDataset and get default raster
            Dim pRasBandCol As IRasterBandCollection
442:     Set pRasBandCol = New Raster
            Dim inputRasBandColl As IRasterBandCollection
444:     Set inputRasBandColl = sInRasters(0)
445:     pRasBandCol.AppendBand inputRasBandColl.item(0)
    
447:     Set inputRasBandColl = sInRasters(1)
448:     pRasBandCol.AppendBand inputRasBandColl.item(0)
    
    ' SaveAs the projected raster
            Dim pds As IDataset
452:     Set pds = pRasBandCol.SaveAs(sOutName, pRWS, "GRID")
453:     createRDSFromRBColl = pds.Workspace.PathName & "\" & pds.BrowseName
End Function



