VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_MapDiffs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_MapDiffs"
Const c_sDLLFileName As String = "SDMAccessories"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_MapDiffs(Self As Variant) As Boolean
  On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:    gSDI.MapDiffs
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Classifies data in the
''      selected fields as 20 quantiles.
''      Creates a grid of the rank differences.
''
'' Requires:
'
'' Self:   0, 1 -- two theme, field pairs
''
'' Returns:  True when complete
''==============================================
'' Get arguments
''----------------------------------------------
'viewA = Self.Get(0)
Dim viewA As IMap
33: Set viewA = Self(0)
'tfPair0 = Self.Get(1).Get(0)
Dim tfPairLst As SDMUtilities.SDMList
36: Set tfPairLst = Self(1)
Dim tfPair0 As Variant
38: tfPair0 = tfPairLst.GetVal(0)
'tfPair1 = Self.Get(1).Get(1)
Dim tfPair1 As Variant
41: tfPair1 = tfPairLst.GetVal(1)
'thm0 = tfPair0.Get(0)
Dim thm0 As IRasterLayer
44: Set thm0 = tfPair0(0)
'thm1 = tfPair1.Get(0)
Dim thm1 As IRasterLayer
47: Set thm1 = tfPair1(0)
'fld0 = tfPair0.Get(1)
Dim fld0 As esrigeodatabase.IField
50: Set fld0 = tfPair0(1)
'fld1 = tfPair1.Get(1)
Dim fld1 As esrigeodatabase.IField
53: Set fld1 = tfPair1(1)
54: If MsgBox("You have selected two layers and an attribute field from each." & vbCrLf & _
       "1. [" & thm0.Name & "-" & fld0.AliasName & "]" & vbCrLf & _
       "2. [" & thm1.Name & "-" & fld1.AliasName & "]" & vbCrLf & _
       "Are you ready to proceed?", vbYesNo, "Mapping differences") = vbNo Then
58:     gSDI_MapDiffs = False
    Exit Function
60: End If
'' Get or make view to hold difference maps
''----------------------------------------------
'viewDiff = av.FindDoc("Mapped Result Differences")
Dim viewDiff As IGroupLayer
65: Set viewDiff = WOETableUtils.FindLayerByName("Mapped Result Differences")
'If (viewDiff.Is(View).Not) Then
67: If viewDiff Is Nothing Then
'  viewDiff = View.Make
69:     Set viewDiff = New GroupLayer
'  viewDiff.SetName ("Mapped Result Differences")
71:     viewDiff.Name = "Mapped Result Differences"
'  If (viewA.Is(View)) Then
'    viewDiff.SetUnits (viewA.GetUnits)
'  End
75:     SDMGlobals.SDMMap.AddLayer viewDiff
76:     SDMGlobals.SDMMap.MoveLayer viewDiff, SDMGlobals.SDMMap.LayerCount - 2
'End
78: End If

'' Make quantile classification for each theme
''----------------------------------------------
'>>>> Conversion note
'>>>> Quantile Classifications are done within ReclassFromClassList

'''''Dim gSDIMakeQuantiles As gSDI_MakeQuantiles
'''''96: Set gSDIMakeQuantiles = New gSDI_MakeQuantiles
''''''clsQ0 = av.Run("gSDI.MakeQuantiles",{thm0,fld0,20})
'''''Dim clsQ0 As SDMUtilities.SDMList
'''''99: Set clsQ0 = gSDIMakeQuantiles.gSDI_MakeQuantiles(Array(thm0, fld0, 20))
'''''100: If clsQ0.IsEmpty Then
'''''101:     gSDI_MapDiffs = False
'''''    Exit Function
'''''103: End If
'clsQ1 = av.Run("gSDI.MakeQuantiles",{thm1,fld1,20})
'''''Dim clsQ1 As SDMUtilities.SDMList
'''''106: Set clsQ1 = gSDIMakeQuantiles.gSDI_MakeQuantiles(Array(thm1, fld1, 20))
'''''107: If clsQ1.IsEmpty Then
'''''108:     gSDI_MapDiffs = False
'''''    Exit Function
'''''110: End If
'''112: If Not ClassifyRenderCountsMatch(thm0, thm1) Then
'''113:     MsgBox "Number of Quantile intervals for [" & thm0.Name & "-" & fld0.AliasName & "] and " & _
'''            "number of Quantile intervals for [" & thm1.Name & "-" & fld1.AliasName & "] are not the same.", vbExclamation, "Getting Quantile Breaks"
'''115:     gSDI_MapDiffs = False
'''        Exit Function
'''117: End If
'' Prompt user for grid name and location
''----------------------------------------------
'strDiff = fileName.GetCWD.MakeTmp("diff", "")
Dim CWD As IFileName
111: Set CWD = FileDialog.GetCWD
Dim FN As IFileName
113: Set FN = FileDialog.MakeTmp("diff", "dbf")
'srcGrd = SourceManager.PutDataSet(GRID, "Result Differences Grid", strDiff, True)
Dim srcGrd As Variant
116: srcGrd = FileDialog.GetSaveFileName("Result Differences Table", FileDialog.getDir(FN.path), FileDialog.GetFileName(FN.path))
'If (srcGrd = Nil) Then
118: If IsEmpty(srcGrd) Then
'  If (viewDiff.GetThemes.IsEmpty) Then
        Dim viewDiffComp As ICompositeLayer
121:    Set viewDiffComp = viewDiff
122:    If viewDiffComp.Count = 0 Then
'    av.GetProject.RemoveDoc (viewDiff)
124:         SDMGlobals.SDMMap.DeleteLayer viewDiff
'  End
126:     End If
'  return Nil
128:     gSDI_MapDiffs = False
         Exit Function
'End
131: End If

'' Make grid of differences between reclassified grids
''----------------------------------------------
'ot0 = thm0.getObjectTag
     Dim ot0 As SDMUtilities.SDMList
137: Set ot0 = gC.ObjectTag(thm0.Name)
'fp0 = False
     Dim fp0 As Boolean
140: fp0 = False
'If (ot0.Is(List)) Then
142: If Not ot0 Is Nothing Then
'    If (ot0.Get(0) = "fp") Then
144:         If ot0.GetVal(0) = "fp" Then
'      fp0 = True
146:             fp0 = True
'    End
148:         End If
'  End
150:  End If
'End
'
'If (fp0) Then
154: If fp0 Then
'  strThm0 = ot0.Get(1)
         Dim strThm0 As String
157:     strThm0 = ot0.GetVal(1)
'Else
159: Else
'  strThm0 = thm0.GetName
161:     strThm0 = thm0.Name
'End
163: End If
'ot1 = thm1.getObjectTag
Dim ot1 As Variant
166: Set ot1 = gC.ObjectTag(thm1.Name)
'fp1 = False
Dim fp1 As Boolean
169: fp1 = False
'If (ot1.Is(List)) Then
171: If Not ot1 Is Nothing Then
172: If TypeOf ot1 Is SDMUtilities.SDMList Then
'  If (ot1.Count = 2) Then
174:     If UBound(ot1) = 1 Then
'    If (ot1.Get(0) = "fp") Then
176:         If ot1(0) = "fp" Then
'      fp1 = True
178:             fp1 = True
'    End
180:         End If
'  End
182:     End If
'End
184: End If
185: End If
'If (fp1) Then
187: If fp1 Then
'  strThm1 = ot1.Get(1)
    Dim strThm1 As String
190:     strThm1 = ot1(1)
'Else
192: Else
'  strThm1 = thm1.GetName
194:     strThm1 = thm1.Name
'End
196: End If
'strThm0 = strThm0.Left(8)
198: strThm0 = Left(strThm0, 8)
'strThm1 = strThm1.Left(8)
200: strThm1 = Left(strThm1, 8)
'If (strThm0 = strThm1) Then
202: If strThm0 = strThm1 Then
'  strThm0 = strThm0 + "1"
204:     strThm0 = strThm0 & "1"
'  strThm1 = strThm1 + "2"
206:     strThm1 = strThm1 & "2"
'End
208: End If
'strThm0 = av.Run("gSDI.SubstituteBadChars",{strThm0})
'strThm1 = av.Run("gSDI.SubstituteBadChars",{strThm1})
'fnCWD = fileName.GetCWD
'dirTmp = av.Run("gSDI.GetTmpDir",{})
'if (dirTmp.Is(String)) then
'  MsgBox.Error(dirTmp,"Error getting SDI temporary directory.")
'  return Nil
'End
'dirTmp.SetCWD

'grd0 = thm0.GetGrid.ReclassByClassList(fld0.GetName, clsQ0, True)
     Dim rasDS0 As IGeoDataset
221: Set rasDS0 = ReclassByClassList.ReclassByClassList(thm0, fld0.Name, True)
222: If rasDS0 Is Nothing Then
223:     gSDI_MapDiffs = False
         Exit Function
225: End If
     Dim grd0 As IRasterLayer
227: Set grd0 = New RasterLayer
228: grd0.CreateFromRaster rasDS0
'grd0.Rename (strThm0.AsFileName)
     Dim tmpDS0 As IDataset
231: Set tmpDS0 = grd0
232: If tmpDS0.CanRename Then tmpDS0.Rename strThm0

'grd1 = thm1.GetGrid.ReclassByClassList(fld1.GetName, clsQ1, True)
     Dim rasDS1 As IGeoDataset
236: Set rasDS1 = ReclassByClassList.ReclassByClassList(thm1, fld1.Name, True, UBound(gC.breaks))
237: If rasDS1 Is Nothing Then
238:     gSDI_MapDiffs = False
         Exit Function
240: End If
     Dim grd1 As IRasterLayer
242: Set grd1 = New RasterLayer
243: grd1.CreateFromRaster rasDS1
'grd1.Rename (strThm1.AsFileName)
     Dim tmpDS1 As IDataset
246: Set tmpDS1 = grd1
247: If tmpDS1.CanRename Then tmpDS1.Rename strThm1

249: SDMGlobals.SDMStatusBar.Message(0) = "Combining remap layers..."
'grdDiff = grd0.Combine({grd1})
     Dim grdDiff As IGeoDataset
252: Set grdDiff = RasterAEUtils.Combine(grd0, grd1)
253: If grdDiff Is Nothing Then
254:     MsgBox "Combine action not valid.", vbCritical, c_sModuleFileName
255:     gSDI_MapDiffs = False
         Exit Function
257: End If

      Dim pProgbar As IStepProgressor
      Dim pStatusBar As esriSystem.IStatusBar
261:  Set pStatusBar = SDMGlobals.SDMStatusBar
262:  Set pProgbar = pStatusBar.ProgressBar
263:  pProgbar.Position = 0
264:  SDMGlobals.SDMStatusBar.Message(0) = "Creating table..."

'grdDiff.Rename (srcGrd)
Dim grdDiffLyr As IRasterLayer
268: Set grdDiffLyr = New RasterLayer
269: grdDiffLyr.CreateFromRaster grdDiff
Dim tmpDS2 As IDataset
271: Set tmpDS2 = grdDiffLyr
272: If tmpDS2.CanRename Then tmpDS2.Rename srcGrd(0)
'fldDiff = Field.Make("RnkDffrnce",#FIELD_LONG,4,0)
'fldDiff.SetAlias ("Rank Difference")
Dim fldVal As Variant
276: fldVal = Array("Value", esriFieldTypeInteger, 12, 0, "Value", False)
Dim fldDesc As New Collection
278: fldDesc.Add fldVal
Dim fldDiff As Variant
280: fldDiff = Array("RnkDffrnce", esriFieldTypeInteger, 4, 0, "Rank Difference", False)
281: fldDesc.Add fldDiff

'vTabDiff = av.Run("gSDI.GetVTab",{grdDiff})
Dim vtabdiff As ITable
285: Set vtabdiff = grdDiffLyr
'If (vTabDiff = Nil) Then
'  MsgBox.Error("Error encountered creating difference grid or its attribute table.","Map Differences")
'  If (viewDiff.GetThemes.IsEmpty) Then
'    av.GetProject.RemoveDoc (viewDiff)
'  End
'  return Nil
'End
'
'fldGrd0 = vTabDiff.GetFields.Get(2)
Dim fldGrd0 As Long
296: fldGrd0 = 3
'fldGrd1 = vTabDiff.GetFields.Get(3)
Dim fldgrd1 As Long
299: fldgrd1 = 4
'vTabDiff.SetEditable (True)
Dim editWKS As IWorkspaceEdit
302: Set editWKS = FeatureUtils.startEditing(WOETableUtils.getProjectDir)
'vTabDiff.AddFields({fldDiff})
Dim vtabdiff2 As ITable
305: Set vtabdiff2 = WOETableUtils.CreateTable(FileDialog.GetFileName(FN.path), FileDialog.getDir(FN.path), fldDesc, False)
'For Each r In vTabDiff
Dim fldDiffidx As Long
308: fldDiffidx = vtabdiff2.FindField(CStr(fldDiff(0)))
Dim valIdx As Long
310: valIdx = vtabdiff.FindField("Value")
Dim curs As ICursor
312: Set curs = vtabdiff.Search(Nothing, False)
Dim r As irow
314: Set r = curs.NextRow
315:   pStatusBar.ShowProgressBar "Creating table...", 0, r.Table.RowCount(Nothing), 1, True
316: While Not r Is Nothing
'  vTabDiff.SetValue(fldDiff,r,(vTabDiff.ReturnValue(fldGrd0,r) - (vTabDiff.ReturnValue(fldGrd1,r))))
         Dim r0 As irow
319:     Set r0 = vtabdiff2.CreateRow
320:     r0.Value(valIdx) = r0.OID + 1
321:     r0.Value(fldDiffidx) = r.Value(fldGrd0) - r.Value(fldgrd1)
'End
323:     r0.Store
324:     Set r = curs.NextRow
325:     pStatusBar.StepProgressBar
326: Wend
327: pStatusBar.HideProgressBar
'vTabDiff.SetEditable (False)
329: FeatureUtils.StopEditing editWKS
'vTabDiff.Flush
     Dim vTabDiffSA As IStandaloneTable
332: Set vTabDiffSA = WOETableUtils.CreateStandAloneTable(vtabdiff2, FileDialog.GetBaseName(FN.path))
     Dim saTblColl As IStandaloneTableCollection
334: Set saTblColl = SDMGlobals.SDMMap
335: saTblColl.AddStandaloneTable vTabDiffSA
336: WOETableUtils.SetAliases vTabDiffSA.Name, fldDesc
'' Set grid name and add to view
''----------------------------------------------
'thmDiff = GTheme.Make(grdDiff)
Dim thmDiff As IRasterLayer
341: Set thmDiff = New RasterLayer
342: thmDiff.CreateFromRaster grdDiff
'thmDiff.SetName ("Difference Between " + fld0.GetAlias + " and " + fld1.GetAlias)
344: thmDiff.Name = "Difference Between " & fld0.AliasName & " and " & fld1.AliasName
'comments = "Generated by: Arc-SDM - Compare Results" + NL +
'           "Source: " + thmDiff.GetSrcName.GetFileName.GetFullName + NL + NL +
'           "Themes (fields) compared: " + NL
'Comments = Comments + thm0.GetName + " (" + fld0.GetAlias + ") (Source: " + thm0.GetSrcName.GetFileName.GetFullName + ")" + NL
'Comments = Comments + thm1.GetName + " (" + fld1.GetAlias + ") (Source: " + thm1.GetSrcName.GetFileName.GetFullName + ")" + NL
'thmDiff.SetComments (Comments)
'viewDiff.AddTheme (thmDiff)
352: viewDiff.Add thmDiff
     Dim pMxDoc As IMxDocument
354: Set pMxDoc = SDMGlobals.SDMDoc
355: pMxDoc.UpdateContents

'' Make classifications for legend
''----------------------------------------------
' Create classfy renderer and QI RasterRenderer interface
     Dim pClassRen As IRasterClassifyColorRampRenderer
361: Set pClassRen = New RasterClassifyColorRampRenderer
362: pClassRen.ClassField = "RnkDffrnce"
     Dim pRasRen As IRasterRenderer
364: Set pRasRen = pClassRen

' Set raster for the render and update
     Dim nRanks As Long
368: nRanks = vtabdiff2.RowCount(Nothing)
369: If nRanks > 19 Then nRanks = 19
370: Set pRasRen.Raster = thmDiff.Raster
371: pClassRen.ClassCount = nRanks
372: pRasRen.Update

    ' Create a color ramp to use
     Dim pRamp As IAlgorithmicColorRamp
376: Set pRamp = New AlgorithmicColorRamp
     Dim myRed As IColor
378: Set myRed = New RgbColor
379: myRed.RGB = vbRed
380: pRamp.ToColor = myRed
     Dim myBlue As IColor
382: Set myBlue = New RgbColor
383: myBlue.RGB = vbBlue
384: pRamp.FromColor = myBlue
385: pRamp.Size = nRanks
386: pRamp.CreateRamp True

' Create symbol for the classes
     Dim pFSymbol As IFillSymbol
390: Set pFSymbol = New SimpleFillSymbol
' loop through the classes and apply the color and label
'lstClasses = List.Make
'lstSymKey = List.Make
     Dim i As Long
     Dim c As Long
396:   pProgbar.Position = 0
397:   pStatusBar.ShowProgressBar "Symbolizing...", 0, nRanks, 1, True
'for each i in -18..19 by 2
399: For i = -(nRanks - 1) To nRanks Step 2
400:    pStatusBar.StepProgressBar
401:     pFSymbol.Color = pRamp.Color(c)
402:     pClassRen.Symbol(c) = pFSymbol
'  If (i = -18) Then
404:     If i = -(nRanks - 1) Then
'    c = Classification.Make(-19, i + 1)
'    c.SetLabel (strThm0 + " < " + strThm1 + " by 18 Ranks"
407:        pClassRen.Label(c) = strThm0 & " < " & strThm1 & " by 18 Ranks"
'    lstClasses.Add (c)
'    lstSymKey.Add (-1)
'  ElseIf (i < 0) Then
411:     ElseIf i < 0 Then
'    c = Classification.Make(i, i + 1)
'    c.SetLabel (strThm0 + " < " + strThm1 + " by " + i.Abs.asString + " Ranks")
414:         pClassRen.Label(c) = strThm0 & " < " & strThm1 & " by " & Abs(i) & " Ranks"
'    lstClasses.Add (c)
'    lstSymKey.Add (-1)
'  ElseIf (i = 0) Then
418:     ElseIf i = 0 Then
'    c = Classification.Make(i, i)
'    c.SetLabel (strThm0 + " = " + strThm1)
421:         pClassRen.Label(c) = strThm0 & " = " & strThm1
'    lstClasses.Add (c)
'    lstSymKey.Add (0)
'  ElseIf (i > 0) Then
425:     ElseIf i > 0 Then
'    c = Classification.Make(i - 1, i)
'    c.SetLabel (strThm0 + " > " + strThm1 + " by " + i.asString + " Ranks")
428:         pClassRen.Label(c) = strThm0 & " > " & strThm1 & " by " & i & " Ranks"
'    lstClasses.Add (c)
'    lstSymKey.Add (1)
'  End
432:     End If
433:     c = c + 1
'End
435: Next i
436: pStatusBar.HideProgressBar
'' Make a default legend, then get
'' its classifications and update with
'' the ones created previously
''----------------------------------------------
'nmbClss = lstClasses.Count
'lgndDiff = thmDiff.GetLegend
'lgndDiff.Interval(thmDiff,"RnkDffrnce",nmbClss)
'lstC = lgndDiff.GetClassifications
'j = 0
'For Each i In lstC
'  lstC.Set(j,lstClasses.Get(j))
'  j = j + 1
'  If (j > (lstClasses.Count - 1)) Then
'    Break
'  End
'End
    
' Update the renderer and plug into layer
455: pRasRen.Update
'>>>>> Don't bother:  Can't programmatically classify raster on joined field
'''462: Set thmDiff.Renderer = pClassRen
'''463: pMxDoc.ActiveView.Refresh
'''464: pMxDoc.UpdateContents
'' Symbolize legend, update and set theme visible
''----------------------------------------------
'lgndDiff.DisplayNoDataClass (True)
''clrRmp = SymbolList.GetPreDefined(#SYMLIST_TYPE_COLORRAMP).Get(22)
''lgndDiff.GetSymbols.RampSavedColors(clrRmp)
'theSymbols = lgndDiff.GetSymbols
'i = 0
'rmp0 = List.Make
'rmp1 = List.Make
'For Each s In theSymbols
'  Key = lstSymKey.Get(i)
'  If (Key = -1) Then
'    rmp0.Add (s)
'  ElseIf (Key = 0) Then
'    rmp0.Add (s)
'    rmp1.Add (s)
'  ElseIf (Key = 1) Then
'    rmp1.Add (s
'  End
'  i = i + 1
'  If (i >= lstSymKey.Count) Then
'    Break
'  End
'End
'rmp0 = SymbolList.FromList(rmp0)
'rmp1 = SymbolList.FromList(rmp1)
'cm = Color.Make
'cm.SetRGBList({200,200,200})
'rmp0.RampColors(Color.GetBlue,cm)
'rmp1.RampColors(cm,Color.GetRed)
''c0 = Color.Make
''c0.SetRGBList({0,0,255})
''cm = Color.Make
''cm.SetRGBList({250,250,250})
''rmp0.RampColors(c0,Color.GetRed)
''c1 = Color.Mak
''c1.setRGBList({255,0,0})
''rmp1.RampColors(Color.GetRed,c1)
'lstSymNew = rmp0.Merge(rmp1)
'lstSymNew.RemoveDuplicates
'i = 0
'For Each s In theSymbols
'  s.SetColor (lstSymNew.Get(i).GetColor)
'  i = i + 1
'  If (i >= lstSymNew.Count) Then
'    Break
'  End
'End
'If (lstC.IsEmpty) Then
'  theSymbols.Get(lgndDiff.GetClassifications.Count - 1).GetColor.SetTransparent (True)
'Else
'  theSymbols.Get(lstC.Count - 1).GetColor.SetTransparent (True)
'En
'lgndDiff.DisplayNoDataClass (False)
'thmDiff.UpdateLegend
'thmDiff.SetVisible (True)
'fnCWD.SetCWD
'return True
518: WOETableUtils.joinTableToLayer thmDiff, "Value", vTabDiffSA, "Value"

520: gSDI_MapDiffs = True
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
525:   gSDI_MapDiffs = False
End Function

Private Function ClassifyRenderCountsMatch(pRen1 As IRasterLayer, pRen2 As IRasterLayer) As Boolean
  On Error GoTo ErrorHandler

    Dim pRen1ClassInfo As IRasterRendererClassInfo
532:     Set pRen1ClassInfo = pRen1.Renderer
    Dim pRen2ClassInfo As IRasterRendererClassInfo
534:     Set pRen2ClassInfo = pRen2.Renderer
535:     ClassifyRenderCountsMatch = pRen1ClassInfo.ClassCount = pRen2ClassInfo.ClassCount
  Exit Function
ErrorHandler:
  HandleError False, "ClassifyRenderCountsMatch " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
539:     ClassifyRenderCountsMatch = False
End Function


