VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_ReadUC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text
Const c_sModuleFileName As String = "gSDI_ReadUC"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_ReadUC(Self As Variant) As SDMUtilities.SDMList
  On Error GoTo ErrorHandler
15:     Set gSDI_ReadUC = New SDMUtilities.SDMList
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.ReadUC
'' Topics:  Spatial Data Modeller
'' Description:  Reads a unique conditions table
''               as created by SDM into
''               a list of lists (2D array) and
''               three 1D array
'' Requires:
'' Self:         A unique conditions grid theme.
'' Returns:      2D array of value
''               List of field (theme) names.
''               List of areas.
''               List of number of training points.
''==============================================
''thmUC = av.GetActiveDoc.GetActiveThemes.Get(0)
'' Get the UC theme
''----------------------------------------------
    Dim progBar As IStepProgressor
34: Set progBar = SDMGlobals.SDMStatusBar.ProgressBar
'thmUC = Self.Get(0)
    Dim thmUC As IRasterLayer
37: Set thmUC = Self(0)
'' Get UCVTab, return Nil if error reported in script
''----------------------------------------------
'vTabUC = av.Run("gSDI.GetVTab",{thmUC})
    Dim vTabUC As ITable
42: Set vTabUC = Self(1)
'MsgBox "vTabUC field names:" & vbCrLf & WOETableUtils.getFieldsNames(vTabUC).AsString, , c_sModuleFileName
'If (vTabUC = Nil) Then
'  return Nil
'End
47: If vTabUC Is Nothing Then
48:     MsgBox "vTabUC is Nothing", , c_sModuleFileName
49:     gSDI_ReadUC.Add "No RelQueryTable found"
        Exit Function
51: ElseIf TypeOf vTabUC Is IRelQueryTable Then
'    MsgBox "vTabUC is RelQueryTable", , c_sModuleFileName
53: ElseIf TypeOf vTabUC Is ITable Then
54:     MsgBox "vTabUC is Table", , c_sModuleFileName
55:     gSDI_ReadUC.Add "No RelQueryTable found"
        Exit Function
57: Else
58:     MsgBox "vTabUC is something else", , c_sModuleFileName
59:     gSDI_ReadUC.Add "No RelQueryTable found"
        Exit Function
61: End If
'' Get all fields in VTab, initialize list to
'' hold 'theme' fields and their names
''----------------------------------------------
'lstFlds = vTabUC.GetFields
    Dim lstFlds As New SDMUtilities.SDMList
    Dim nf As Long
68: For nf = 0 To vTabUC.Fields.FieldCount - 1
69:     lstFlds.Add vTabUC.Fields.Field(nf)
70: Next nf
'MsgBox thmUC.Name & vbCrLf & ListtoString(WOETableUtils.getFieldsNames(vTabUC)), , c_sModuleFileName
'lstUCTNames = List.Make
    Dim lstUCTNames As New SDMUtilities.SDMList
'lstUCTFields = List.Make
    Dim lstUCTFields As New SDMUtilities.SDMList
'fldarea = Nil          'field containing areas
    Dim fldarea As IField
78: Set fldarea = Nothing
'fldPnts = Nil          'field containing number of training points
    Dim fldpnts As IField
81: Set fldpnts = Nothing
'''    Dim fldFMs As IField
'''83: Set fldFMs = Nothing
'' Loop through each field...
''----------------------------------------------
'For Each f In lstFlds
    Dim relQryTbl As IRelQueryTable
88: Set relQryTbl = Self(1)
    Dim SrcOIDFldName As String
    Dim tokens As Variant
91: If relQryTbl.SourceTable.HasOID Then
92:     SrcOIDFldName = relQryTbl.SourceTable.OIDFieldName
93:     tokens = Split(SrcOIDFldName, ".")
94:     SrcOIDFldName = tokens(UBound(tokens))
95: End If
    Dim DestOIDFldName As String
97: If relQryTbl.SourceTable.HasOID Then
98:     DestOIDFldName = relQryTbl.DestinationTable.OIDFieldName
99:     tokens = Split(DestOIDFldName, ".")
100:    DestOIDFldName = tokens(UBound(tokens))
101: End If
102: progBar.Position = 0
103: SDMGlobals.SDMStatusBar.ShowProgressBar "Reading UC table...", 1, lstFlds.Count, 1, True
104: For nf = 0 To lstFlds.Count - 1
         Dim f As IField
106:     Set f = lstFlds.getObj(nf)
'  fname = f.GetName
108:     tokens = Split(f.Name, ".")
         Dim fName As String
110:     fName = tokens(UBound(tokens))
'  If ((fname = "Value") Or (fname = "Count")) Then
'    Continue
'  ElseIf (fname = "Area_sqm") Then
114:     If fName Like "*Area_sqm" Then
'    fldarea = f
116:         Set fldarea = f
'  ElseIf (fname = "Trngpoints") Then
118:     ElseIf fName Like "*TrngPoints" Then
'    fldPnts = f
120:         Set fldpnts = f
'    Break
122:         Exit For
123:     ElseIf fName Like "Sdmtemp*" Then
'    lstUCTNames.Add (fname)
125:         lstUCTNames.Add Mid(fName, InStr(1, fName, "SDMTemp", vbTextCompare))
'    lstUCTFields.Add (f)
127:         lstUCTFields.Add nf ' field index
'  End
129:     End If
'End
131: SDMGlobals.SDMStatusBar.StepProgressBar
132: Next nf
133: SDMGlobals.SDMStatusBar.HideProgressBar
'MsgBox "lstUCTNames:" & vbCrLf & lstUCTNames.asString, , c_sModuleFileName
'MsgBox "lstUCTFields:" & vbCrLf & lstUCTFields.asString, , c_sModuleFileName
'If area or training point fields not found, return area
''----------------------------------------------
'If (fldarea = Nil) The
139: If fldarea Is Nothing Then
'  return "No area field found in unique conditions table."
141:     gSDI_ReadUC.Add "No area field found in unique conditions table."
        Exit Function
'End
144: End If
'!!!!
''if (fldPnts = Nil) then
''  return "No training point field found in unqiue conditions table."
''end
' Initialize list to hold lists of values
'----------------------------------------------
'arryUCVals = List.Make
     Dim arryUCVals As New SDMUtilities.SDMList
'for each t in 0..(lstUCTnames.Count - 1)
154: progBar.Position = 0
155: SDMGlobals.SDMStatusBar.ShowProgressBar "Initing value list...", 1, lstUCTNames.Count, 1, True
     Dim tt As Long
157: For tt = 0 To lstUCTNames.Count - 1
         Dim newList As SDMUtilities.SDMList
159:     Set newList = New SDMUtilities.SDMList
'  arryUCVals.Add (List.Make)
161:     arryUCVals.Add newList
'End
163:    SDMGlobals.SDMStatusBar.StepProgressBar
164: Next tt
165: SDMGlobals.SDMStatusBar.HideProgressBar
'' Initialize lists to hold area, # training points
''----------------------------------------------
'lstAreas = List.Make
    Dim lstAreas As New SDMUtilities.SDMList
''if (fldPnts <> Nil) then
'  lstPnts = List.Make
    Dim lstPnts As New SDMUtilities.SDMList
'    Dim lstFMs As New SDMUtilities.SDMList
''end
'' Loop through reach record in the UC table
'' adding values to the lists
''----------------------------------------------
178:   progBar.Position = 0
179:   SDMGlobals.SDMStatusBar.ShowProgressBar "Reading UC table...", 1, vTabUC.RowCount(Nothing), 1, True
'MsgBox "lstUCTFields:" & vbCrLf & lstUCTFields.asString, , c_sModuleFileName
     Dim r As irow
'For Each r In vTabUC
     Dim curs As ICursor
184: Set curs = vTabUC.Search(Nothing, False)
185: Set r = curs.NextRow
186: While Not r Is Nothing
'  lstNum = 0
         Dim lstNum As Long
189:     lstNum = 0
'  For Each t In lstUCTFields
         Dim t As Variant
192:     For Each t In lstUCTFields.list
'    arryUCVals.Set(lstNum,arryUCVals.Get(lstNum).Add(vTabUC.ReturnValue(t,r)))
             Dim tmplist As SDMUtilities.SDMList
195:         Set tmplist = arryUCVals.getObj(lstNum)
196:         tmplist.Add r.Value(CLng(t))
'MsgBox lstNum & ". tmplist:" & vbCrLf & tmplist.asString, , c_sModuleFileName
         'arryUCVals.SetIt lstNum, tmplist
'    lstNum = lstNum + 1
200:         lstNum = lstNum + 1
'  End
202:     Next t
'MsgBox "arryUCVals:" & vbCrLf & arryUCVals.asString, , c_sModuleFileName
'  lstAreas.Add (vTabUC.ReturnValue(fldarea, r))
205:     lstAreas.Add r.Value(vTabUC.FindField(fldarea.Name))
'  If (fldPnts <> Nil) Then
207:     If Not fldpnts Is Nothing Then
'    lstPnts.Add (vTabUC.ReturnValue(fldPnts, r))
'MsgBox "fldpnts.name=" & fldpnts.Name & " " & vTabUC.FindField(fldpnts.Name) _
            & "=" & r.Value(vTabUC.FindField(fldpnts.Name)), , c_sModuleFileName
211:         lstPnts.Add r.Value(vTabUC.FindField(fldpnts.Name))
'  End
213:     End If
'''219:     If Not fldFMs Is Nothing Then
'''220:         lstFMs.Add r.Value(vTabUC.FindField(fldFMs.Name))
'''221:     End If
'End
218:     Set r = curs.NextRow
219:     SDMGlobals.SDMStatusBar.StepProgressBar
220: Wend
221: SDMGlobals.SDMStatusBar.HideProgressBar
'return {arryUCVals,lstUCTNames,lstAreas,lstPnts}
'MsgBox "arryUCVals=" & arryUCVals.Count, , c_sModuleFileName
224: gSDI_ReadUC.Add arryUCVals
225: gSDI_ReadUC.Add lstUCTNames
226: gSDI_ReadUC.Add lstAreas
227: gSDI_ReadUC.Add lstPnts
'''233: gSDI_ReadUC.Add Nothing
'MsgBox "lstFMs: " & vbCrLf & ListUtils.ListtoString(lstFMs), , c_sModuleFileName

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
235:    Set gSDI_ReadUC = Nothing
End Function
