VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RespAtPoints"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_ResponseAtPoints"
Const c_sDLLFileName As String = "CalculateResponse"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Public Sub gSDI_ResponseAtPoints(Self As Variant)
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.ResponseAtPoints
''
''Topics:  Spatial Data Modeller; Spatial Analyst
''
''Description:  Determines which unique condition of a unique conditions grid,
''  each point in a point theme is located in, and therefore the posterior
''  probability, posterior logit, etc at tha location.
''  Writes a unqiue record id to the point theme attribute table.
''  Write this and the points coordinates to a new table, then
''  writes the statistics at the point location to the new table.
''  Adds the table to the current project, is based on a dbase file
''  with default name Pntrsp#.dbf
''
''Requires:
''
'' Self:  Associate Responses with Point Theme menu item.
''
''Returns:
''==============================================
'
'If (System.IsShiftKeyDown) Then
'  docURL = "sdmassoc.htm"
'  If (docURL.Count > 0) Then
'    av.Run("gSDI.Help", {docURL})
'  End
'  return Nil
'End
'
44: If SDMGlobals.SDMApp Is Nothing Then Set SDMGlobals.SDMApp = New AppRef
45: If SDMGlobals.SDMDoc Is Nothing Then Set SDMGlobals.SDMDoc = SDMGlobals.SDMApp.Document
46: If SDMGlobals.SDMMap Is Nothing Then
    Dim pMxDoc As IMxDocument
48:     Set pMxDoc = SDMGlobals.SDMDoc
49:     Set SDMGlobals.SDMMap = pMxDoc.FocusMap
50: End If
'dTitle = "Responses at Points"
Dim dTitle As String
53: dTitle = "Responses at Points"
'' GET ACTIVE DOC AND MAKE SURE ITS A VIEW DOCUMENT
''------------------------------------------
'theView = av.GetActiveDoc
'''''Dim pApp As New AppRef
'''''Dim pMxDoc As IMxDocument
'''''Set pMxDoc = pApp.Document
'''''Dim theView As IMap
'''''51: Set theView = pMxDoc.FocusMap
'If (theView.Is(View).Not) Then
'  MsgBox.Error("The active document must be a View.","Point Theme")
'  return Nil
'End

'' CHECK WHETHER THE SCRIPT IS BEING CALLED FROM
'' THE DIALOG OR THE WofE.Final script
''------------------------------------------
'If (self.Is(LabelButton)) Then
71: If TypeOf Self Is CommandButton Then
'  'IF DIALOG, GET POINT AND PROBABILITY THEMES FROM DIALOG
'  '------------------------------------------
'  ptpDiag = self.GetDialog
'  pntTName = ptpDiag.findByName("cbx_Pt").GetCurrentValue
        Dim pntTName As String
77:     pntTName = gPRT.cbx_Pt.Text
'  pntTheme = theView.FindTheme(pntTName)
        Dim pntTheme As IFeatureLayer
80:     Set pntTheme = WOETableUtils.FindLayerByName(pntTName)
'  If (pntTheme = Nil) Then
82:     If pntTheme Is Nothing Then
'    MsgBox.Error("The point theme '"+pntTName+"' could not"+NL+
84:         MsgBox "The point featurelayer '" + pntTName + "' could not" & vbCrLf & _
            "be found in the current Map.", vbCritical, "Point Theme"
'                 "be found in the current View.","Point Theme")
'    return Nil
        Exit Sub
'  End
90:     End If
'  prbTName = ptpDiag.findByName("cbx_Prb").GetCurrentValue
        Dim prbTName As String
93:     prbTName = gPRT.cbx_Prb.Text
'  prbTheme = theView.FindTheme(prbTName)
        Dim prbTheme As IRasterLayer
96:     Set prbTheme = WOETableUtils.FindLayerByName(prbTName)
'  If (prbTheme = Nil) Then
98:     If prbTheme Is Nothing Then
'    MsgBox.Error("The response theme '"+prbTName+" could not"+NL+
'                 "be found in the current View.","Response Theme")
101:         MsgBox "The response theme '" & prbTName & "' could not" & vbCrLf & _
                 "be found in the current View.", vbCritical, "Response Theme"
'    return Nil
        Exit Sub
'  End
106:     End If
'ElseIf (self.Is(List)) Then
108: ElseIf VarType(Self) = vbArray + vbVariant Then
'  'IF THE SCRIPT, GET THE "ARGUMENTS"
'  '------------------------------------------
'  pntTheme = self.Get(0)
    'Dim pntTheme As IFeatureLayer
113: Set pntTheme = Self(0)
'  prbTheme = self.Get(1)
    'Dim prbTheme As IRasterLayer
116: Set prbTheme = Self(1)
'End 'is dialog or script
118: End If
     Dim dataSet As IDataset
120: Set dataSet = pntTheme
''GET THE VIEW'S PROEJCTION
''------------------------------------------
'curPrj = theView.GetProjection
'''''Dim curPrj As ISpatialReference
'''''119: Set curPrj = theView.SpatialReference
'' GET THE ATTRIBUTE TABLE OF THE POINT THEME AND LOOK FOR
'' A RECORDID FIELD
'' ESSENTIALLY YOU WANT TO OVERWRITE IT TO ENSURE THAT THE VALUES (RECORDID'S)
'' AREA UNIQUE
''------------------------------------------
'pntFTab = pntTheme.GetFtab
     Dim pntFTab As ITable
133: Set pntFTab = pntTheme
'idField = pntFTab.FindField("RecordID")
    Dim idFieldidx As Long
136: idFieldidx = pntFTab.FindField("RecordID")
'If (idField <> Nil) Then
138: If idFieldidx <> -1 Then
'  if (MsgBox.YesNo("A field called 'RecordID' exists in the"+Nl+
'                   "attribute table of point theme "+pntTheme.GetName+"'."+NL+
'                   "Do you want to overwrite it?",dTitle,True).Not) then
142:     If MsgBox("A field called 'RecordID' exists in the" & vbCrLf & _
                   "attribute table of point theme " + pntTheme.Name + "'." & vbCrLf & _
                   "Do you want to overwrite it?", vbYesNo, dTitle) = vbNo Then
'    return Nil
                    Exit Sub
'  End
148:     End If
'Else
150: Else
'  'IF NOT FOUND, CREATE A NEW FIELD
'  '-----------------------------------------
'  idField = Field.Make("RecordID",#FIELD_LONG,5,0)
        Dim idField As New SDMUtilities.SDMList
155:    idField.Add Array("RecordID", esriFieldTypeInteger, 5, 0, "", False)
'  If (pntFTab.StartEditingWithRecovery) Then
         Dim wrkSpaceEdit As IWorkspaceEdit
158:     Set wrkSpaceEdit = FeatureUtils.startEditing(dataSet.Workspace.PathName)
'    If (pntFTab.CanAddFields) Then
'      pntFTab.AddFields({idField})
161:     WOETableUtils.AddFields pntFTab, idField
'    End
'  End
'  pntFTab.StopEditingWithRecovery (True)
165:     FeatureUtils.stopEditing wrkSpaceEdit
166:     idFieldidx = pntFTab.FindField("RecordID")
'End
168: End If
'>>> Check that point featurelayer has an OID field
170: If Not pntTheme.FeatureClass.HasOID Then
171:     MsgBox "Feature layer " & pntTheme.Name & " does not have ObjectID field!" & vbCrLf & _
           "Aborting.", vbCritical, c_sModuleFileName
         Exit Sub
174: End If
'' WRITE THE RECORD NUMBERS TO THE RECORDID FIELD
''------------------------------------------
'If (pntFTab.StartEditingWithRecovery) Then
178:     Set wrkSpaceEdit = FeatureUtils.startEditing(dataSet.Workspace.PathName)
'  For Each record In pntFTab
         Dim pFeatCurs As IFeatureCursor
181:     Set pFeatCurs = pntTheme.FeatureClass.Update(Nothing, False)
         Dim pFeat As IFeature
183:     Set pFeat = pFeatCurs.NextFeature
184:     While Not pFeat Is Nothing
'    pntFTab.SetValue(idField,record,record)
186:         pFeat.Value(idFieldidx) = pFeat.OID
187:         pFeatCurs.UpdateFeature pFeat
'  End
189:         Set pFeat = pFeatCurs.NextFeature
190:     Wend
'  pntFTab.StopEditingWithRecovery (True)
192:     FeatureUtils.stopEditing wrkSpaceEdit
'Else
'  MsgBox.Error("Unable to edit "+pntFTab.AsString+"."+NL+
'               "Please check file permissions.",dTitle)
'  return Nil
'End
'pntFTab.Flush

'' MAKE A NEW .dBASE FILE, AND ADD SEVERAL FIELDS TO IT
'pntLnkFileName = fileName.GetCWD.MakeTmp("Pntrsp", "dbf")
202: FileDialog.SetCurDir WOETableUtils.getProjectDir
Dim pntLnkFileName As String
204: pntLnkFileName = FileDialog.MakeTmp("Pntrsp", "dbf").path
'pntLnkVTab = VTab.MakeNew(pntLnkFileName, dBASE)
    Dim pntLnkVTab As ITable
'fieldlist = List.Make
    Dim fieldList As New SDMUtilities.SDMList
'recIDFld = Field.Make("RecordID",#FIELD_LONG,5,0)
'fieldlist.Add (recIDFld)
211: fieldList.Add Array("RecordID", esriFieldTypeInteger, 5, 0, "", False)
'
'' MAKE AN X AND Y FIELD TO HOLD THE COORDINATES OF EACH POINT
'' IN THE POINT THEME (ENABLES USE OF TABLE AS POINT EVENT THEME)
''------------------------------------------
'xFld = Field.Make("X",#FIELD_DOUBLE,14,5)
Dim xFld As Variant
218: xFld = Array("X", esriFieldTypeDouble, 14, 5, "TngPtX", False)
'fieldlist.Add (xFld)
220: fieldList.Add xFld
'yFld = Field.Make("Y",#FIELD_DOUBLE,14,5)
Dim yFld As Variant
223: yFld = Array("Y", esriFieldTypeDouble, 14, 5, "TrgPtY", False)
'fieldlist.Add (yFld)
225: fieldList.Add yFld
'isInt = prbTheme.GetGrid.IsInteger
Dim rasprops As IRasterProps
228: Set rasprops = prbTheme.Raster
Dim isInt As Boolean
230: isInt = rasprops.IsInteger
'If (isInt) Then
232: If isInt Then
'  lstFld = av.Run("gSDI.GetResponseFields",{prbTheme})
        Dim gSDIGetResponseFields As gSDI_GetRespFields
235:     Set gSDIGetResponseFields = New gSDI_GetRespFields
        Dim lstFld As SDMUtilities.SDMList
237:     Set lstFld = gSDIGetResponseFields.gSDI_GetResponseFields(Array(prbTheme))
'  If (lstFld.Is(List).Not) Then
239:     If lstFld Is Nothing Then
'    MsgBox.Error("No response fields found in theme.",dTitle)
241:         MsgBox "No response fields found in theme.", vbCritical, dTitle
'    return Nil
             Exit Sub
'  ElseIf (lstFld.IsEmpty) Then
245:     ElseIf lstFld.IsEmpty Then
'    MsgBox.Error("No response fields found in theme.",dTitle)
247:         MsgBox "No response fields found in theme.", vbCritical, c_sModuleFileName
'    return Nil
             Exit Sub
'  End
251:     End If
'  prbVTab = av.Run("gSDI.GetVTab",{prbTheme})
        Dim prbVTab As ITable
254:    If TypeOf prbTheme Is IDisplayTable Then
            Dim dispTbl As IDisplayTable
256:        Set dispTbl = prbTheme
257:        Set prbVTab = dispTbl.DisplayTable
258:    Else
259:        Set prbVTab = prbTheme
260:    End If
'  If (prbVTab.Is(VTab).Not) Then
262:         If prbVTab Is Nothing Then
'    MsgBox.Error("Error occurred reading attribute table of " + prbTheme.GetName + ".",dTitle)

265:             MsgBox "Error occurred reading attribute table of " & prbTheme.Name + ".", vbCritical, c_sModuleFileName
'    return Nil
            Exit Sub
'  End
269:         End If
'  lstFldPrb = List.Make
     Dim lstFldPrb As New SDMUtilities.SDMList
'  For Each fA In lstFld
     Dim fA As Variant
274: For Each fA In lstFld.list
'    f = prbVTab.FindField(fA)
        Dim f As IField
        Dim fidx As Long
278:    fidx = prbVTab.FindField(CStr(fA))
'    If (f.Is(Field)) Then
280:    If fidx <> -1 Then
281:            Set f = prbVTab.Fields.Field(fidx)
        
'      lstFldPrb.Add (f)
284:            lstFldPrb.Add f
'    End
286:    End If
'  End
288: Next fA
'  If (lstFldPrb.IsEmpty) Then
290:     If lstFldPrb.IsEmpty Then
'    MsgBox.Error("Error reading attribute table of " + prbTheme.GetName + ".",dTitle)
292:         MsgBox "Error reading attribute table of " & prbTheme.Name & ".", vbCritical, c_sModuleFileName
'    return Nil
        Exit Sub
'  End
296:     End If
'  For Each f In lstFldPrb
        Dim fv As Variant
299:     For Each fv In lstFldPrb.list
300:         Set f = fv
'    fNew = Field.Make(f.GetName, f.GetType, f.GetWidth, f.GetPrecision)
             Dim tokens As Variant
303:         tokens = Split(f.Name, ".")
             Dim fName As String
305:         fName = tokens(UBound(tokens))
             Dim fNew As Variant
307:         fNew = Array(fName, f.Type, f.Length, f.Precision, f.AliasName, False)
'    fNew.SetAlias (f.GetAlias)
'    fieldlist.Add (fNew)
310:         fieldList.Add fNew
'  End
312:     Next fv
'Else
314: Else
'  fNew = Field.Make("Value",#FIELD_DOUBLE,10,6)
'  fNew.SetAlias ("Value (" + prbTheme.GetName + ")")
317:     fNew = Array("Value", esriFieldTypeDouble, 10, 6, "Value (" & prbTheme.Name & ")", False)
'  fieldlist.Add (fNew)
319:     fieldList.Add fNew
'End
321: End If
'
'' START EDITING THE NEW TABLE...
'pntLnkVTab.SetEditable (True)
325: Set wrkSpaceEdit = FeatureUtils.startEditing(FileDialog.getDir(pntLnkFileName))
'If (pntLnkVTab.IsEditable.Not) Then
'  MsgBox.Error("Unable to edit new table " + pntLnkVTab.GetBaseTableFileName.GetFullName + ".","File Edit Error")
'  return Nil
'End

'If (pntLnkVTab.CanAddFields) Then
'  'ADD THE FIELDS...
'  pntLnkVTab.AddFields (fieldlist)
     Dim CWD As String
335: CWD = SDMGlobals.SDMPrjDir
336: Set pntLnkVTab = WOETableUtils.CreateTable(FileDialog.GetFileName(pntLnkFileName), CWD, fieldList.list, False)
'Else
'  MsgBox.Error("Unable to add fields to new table '"+pntLnkFileName.GetBaseName+"'."+NL+
'               "Please check file permissions.","File Edit Error")
'  return Nil
'End

'nulNumb = Number.MakeNull
     Dim nulNumb As Variant
345: nulNumb = Empty 'Cannot assign NULL to a DBase table+
'For Each record In pntFTab
     Dim recIDFldidx As Long
348: recIDFldidx = pntLnkVTab.FindField("RecordID")
     Dim xFldidx As Long, yFldidx As Long
350: xFldidx = pntLnkVTab.FindField("X")
351: yFldidx = pntLnkVTab.FindField("Y")
     Dim idFldIdx As Long
353: idFldIdx = pntFTab.FindField("RecordID")
     Dim rasBuf As IRasterBuffer
355: Set rasBuf = New IRasterBuffer
356: If Not rasBuf.OpenBuffer(prbTheme) Then
357:         MsgBox "Input layer not an integer raster", vbCritical, c_sModuleFileName
        Exit Sub
359:      End If

361: Set pFeatCurs = pntTheme.FeatureClass.Search(Nothing, False)
362: Set pFeat = pFeatCurs.NextFeature

'Set up progress bar
     Dim pStatusBar As IStatusBar
     Dim pProgbar As IStepProgressor
     Dim pApp As IApplication
368:   Set pApp = SDMGlobals.SDMApp
369:   Set SDMGlobals.SDMStatusBar = pApp.StatusBar
370:   Set pProgbar = SDMGlobals.SDMStatusBar.ProgressBar
371:   pProgbar.Position = 0
372:   SDMGlobals.SDMStatusBar.ShowProgressBar "Processing...", 0, pntTheme.FeatureClass.FeatureCount(Nothing) - 1, 1, True
  
374: While Not pFeat Is Nothing
'  If (pntLnkVTab.CanAddRecord) Then
'    'ADD A RECORD...
'    newRec = pntLnkVTab.AddRecord
         Dim newRec As irow
379:     Set newRec = pntLnkVTab.CreateRow
'
'    ' GET THE RECORDID FROM THE POINT ATTRIBUTE TABLE
'    ' AND WRITE TO NEW TABLE
'    idVal = pntFTab.ReturnValue(idField, record)
         Dim idval As Long
385:     idval = pFeat.Value(idFieldidx)
'    pntLnkVTab.SetValue(recIDFld,newRec,idVal)
387:     newRec.Value(recIDFldidx) = idval
'    ' GET THE POINT'S COORDINATES AND WRITE TO NEW TABLE
'    aPoint = pntFTab.ReturnValue(pntFTab.FindField("Shape"), record)
        Dim aPoint As IPoint
391:     Set aPoint = pFeat.Shape
'    pntLnkVTab.SetValue(xFld,newRec,aPoint.GetX)
393:     newRec.Value(xFldidx) = aPoint.X
'    pntLnkVTab.SetValue(yFld,newRec,aPoint.GetY)
395:     newRec.Value(yFldidx) = aPoint.Y
'    ' QUERY THE RESPONSE THEME FOR THE NUMBER OF THE
'    ' UNIQUE CONDITION THE POINT FALLS IN
'    probRecNo = prbTheme.GetGrid.CellValue(aPoint, curPrj)
         Dim cellVal As Variant
400:     cellVal = rasBuf.CellValue(aPoint)
'    If (isInt) Then
402:     If isInt Then
'      If (probRecNo.IsNull.Not) Then
404:         If (Not IsNull(cellVal)) Then
405:            If (CStr(cellVal) <> "NoData") Then
'        ' SELECT THE CORRESPONDING RECORD For the Cell Value IN THE
'        ' RESPONSE THEME'S ATTRIBUTE TABLE
'        selBM = prbVTab.GetSelection
'        selBM.ClearAll
'        qstring = "[Value] = " + probRecNo.AsString
                    Dim qflt As IQueryFilter
412:                Set qflt = New QueryFilter
413:                qflt.whereclause = "Value = " & CStr(cellVal)
'        prbVTab.Query(qstring,selBM,#VTAB_SELTYPE_NEW)
'        selBM = prbVTab.GetSelection
                    Dim selBM As ISelectionSet
417:                Set selBM = dispTbl.SelectDisplayTable(qflt, esriSelectionTypeSnapshot, esriSelectionOptionOnlyOne, dataSet.Workspace)
'        If (selBM.Count > 0) Then
419:                If selBM.Count > 0 Then
                        Dim selIDs As IEnumIDs
421:                    Set selIDs = selBM.IDs
'          prbRec = selBM.GetNextSet(-1)
                        Dim prbRec As irow
424:                    Set prbRec = prbVTab.GetRow(selIDs.Next)
'          for each i in 3..(fieldList.Count - 1)
                        Dim i As Long
427:                    For i = 3 To fieldList.Count - 1
'            fNew = fieldlist.Get(i)
429:                        fNew = fieldList.GetVal(i)
                            Dim fNewidx As Long
431:                        fNewidx = pntLnkVTab.FindField(CStr(fNew(0)))
'            fOld = lstFldPrb.Get(i - 3)
                            Dim fOld As IField
434:                        Set fOld = lstFldPrb.getObj(i - 3)
                            Dim fOldidx As Long
436:                        fOldidx = prbVTab.FindField(fOld.Name)
'            ' GET THE VALUES AND WRITE THEM TO THE NEW TABLE
                            Dim val As Variant
'            val = prbVTab.ReturnValue(fOld, prbRec) '
440:                        val = prbRec.Value(fOldidx)
441:                        If IsNull(val) Then
442:                            MsgBox "Problem with table join(s) on evidence layer.", vbCritical, c_sModuleFileName
                                Exit Sub
444:                        End If
'            pntLnkVTab.SetValue(fNew,newRec,val)
446:                        newRec.Value(fNewidx) = CDbl(val)
'          End
448:                    Next i
'        End   'selBM.Count > 0
450:                End If
'      Else
452:            Else
'        For Each f In fieldlist
                    Dim ff As Variant
455:                For Each ff In fieldList.list
'          pntLnkVTab.SetValue(f,newRec,nulNumb)
                    
458:                    fidx = pntLnkVTab.FindField(CStr(ff(0)))
459:                    newRec.Value(fidx) = Empty
'        End
461:                Next ff
'      End
463:            End If
464:         End If
'    Else
466:     Else 'Not Int
467:         fidx = pntLnkVTab.FindField(CStr(fNew(0)))
'      If (probRecNo.IsNull) Then
469:         If Not IsNull(cellVal) Then
470:            If cellVal <> "NoData" Then
471:                newRec.Value(fidx) = CDbl(cellVal)
472:            Else
'        probRecNo = nulNumb
474:                newRec.Value(fidx) = Empty
475:            End If
476:         Else
477:            newRec.Value(fidx) = Empty
'      End
479:         End If
'      pntLnkVTab.SetValue(fNew,newRec,probRecNo)
'    End
482:     End If
483:     newRec.Store
'  Else
'    MsgBox.Error("Unable to add a record to new table '"+pntLnkFileName.GetBaseName+"'."+NL+
'
'               "Please check file permissions.","File Edit Error")
'
'    return Nil
'
'  End  'CanAddNewRecord
'
'End
494:    Set pFeat = pFeatCurs.NextFeature
495:    SDMGlobals.SDMStatusBar.StepProgressBar
496: Wend
497: SDMGlobals.SDMStatusBar.HideProgressBar
'' SAVE THE EDITS
''------------------------------------------
'pntLnkVTab.SetEditable (False)
501: FeatureUtils.stopEditing wrkSpaceEdit
'' CLEAR THE SELECTION
''------------------------------------------
'selBM = pntLnkVTab.GetSelection
'selBM.ClearAll
'pntLnkVTab.SetSelection (selBM)
'pntBM = pntFTab.GetSelection
'pntBM.ClearAll
'pntFTab.SetSelection (pntBM)
'' UPDATE THE CHANGES TO THE TABLE
''------------------------------------------
'pntLnkVTab.Flush
'pntLnkVTab.Refresh
'' MAKE A TABLE DOCUMENT OUT OF THE NEW .dBASE TABLE
''------------------------------------------
'
'pTab = Table.Make(pntLnkVTab)
Dim pTab As IStandaloneTable
519: Set pTab = New StandaloneTable
520: Set pTab.Table = pntLnkVTab
Dim saColl As IStandaloneTableCollection
522: Set saColl = SDMGlobals.SDMMap
523: saColl.AddStandaloneTable pTab
'pTab.SetName (pntLnkFileName.GetBaseName)
'comments = "Generated by:  Arc-SDM - Associate Responses with Point Theme" + NL +
'
'           "Table Filename:  " + pntLnkFileName.GetFullName + NL +
'
'           NL +
'
'           "Associated Files: " + NL +
'
'           "    Response Theme:  " + prbTheme.GetName + " (Source: " + prbTheme.GetSrcName.GetFileName.GetFullName + ")" + NL +
'
'           "    Point Theme:  " + pntTheme.GetName + " (Source: " + pntTheme.GetSrcName.GetFileName.GetFullName + ")" +NL
'
'pTab.SetComments (comments)
'
'' IF SCRIPT WAS CALLED FROM THE DIALOG, CLOSE THE DIALOG
'If (self.Is(LabelButton)) Then
541: If TypeOf Self Is CommandButton Then
'  self.GetDialog.Close
543:     Unload gPRT
'End
545: End If
'MsgBox.Info("A table, " + pntLnkFileName.GetBaseName + ", containing the responses from " + prbTheme.GetName + NL +
'            "at selected points in " + pntTName + " has been added to your project.","Responses at Points")
548: MsgBox "A table, " & FileDialog.GetBaseName(pntLnkFileName) & ", containing the responses from " & prbTheme.Name & vbCrLf & _
    "at selected points in " & pntTheme.Name & " has been added to your project.", vbInformation, "Response at Points"

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

