VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_RunLRCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_RunLRCode"
Const c_sDLLFileName As String = "CalculateLogisticRegr"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_RunLRCode(Self As Variant) As Boolean
  On Error GoTo ErrorHandler

'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.RunLRCode
''
'' Topics:  Spatial Data Modeller
''
'' Description:  Writes a batch file that changes
''   to the ESRI extension directory and runs
''   logisic regression program (sdmlr.exe), then
''   executes the batch file.
'
'' Requires:
''
'' Self:    0 -- dirTmp -- directory for batch file
''          1 -- dirPrg -- directory for lr program
''
'' Returns:
''==============================================
'sepChr = av.Run("gSDI.GetSeparatorChar",{})
'dirTmp = Self.Get(0)
Dim dirTmp As String
dirTmp = Self(0)
'dirProg = Self.Get(1)
'strDrive = dirProg.GetFullName.AsTokens(sepChr).Get(0)
''strExe = "sdilr1.exe"
'strExe = "sdmlr.exe"
'strProgFN = dirProg.GetFullName + sepChr + strExe
'dirDflt = fileName.GetCWD
'strDrive.AsFileName.SetCWD
'If (file.Exists(strProgFN.AsFileName).Not) Then
'  MsgBox.Error("The file " + strProgFN + " could not be found.","File Not Found")
'  return Nil
'End
Dim LRHome As String
LRHome = GetSetting("SDMExtension", "Globals", "LogisticRegressionHome", "")

If LRHome = "" Then
    If FileDialog.ExistsFilename("C:\Program Files\ArcSDMExtension\sdmlr.exe") Then
        LRHome = "C:\Program Files\ArcSDMExtension"
        SaveSetting "SDMExtension", "Globals", "LogisticRegressionHome", LRHome
    End If
End If
    
If LRHome = "" Then
    LRHome = Environ("LRHOME")
    If Len(LRHome) = 0 Then
        LRHome = returnFolderName("Find folder with sdmlr.exe", "C:\Program Files\ArcSDMExtension", "sdmlr.exe")
        If LRHome = "" Then
            MsgBox "sdmlr.exe not found." & vbCrLf & "Running Logistic Regression is cancelled.", vbExclamation, c_sModuleFileName
            gSDI_RunLRCode = False
            Exit Function
        Else
            SaveSetting "SDMExtension", "Globals", "LogisticRegressionHome", LRHome
        End If
    End If
End If
    Dim strProgFN As String
    strProgFN = LRHome & "\sdmlr.exe"
'If (File.Exists(strProgFN.AsFileName).Not) Then
    If Not FileDialog.ExistsFilename(strProgFN) Then
'  MsgBox.Error("The file " + strProgFN + " could not be found.","File Not Found")
        MsgBox "Logistic Regression program ='' " & strProgFN & "'' could not be found."", vbCritical, c_sModuleFileName"
        DeleteSetting "SDMExtension", "Globals", "LogisticRegressionHome"
'  return Nil
        gSDI_RunLRCode = False
        Exit Function
'End
    End If
''fnBat = (dirTmp.GetFullName + sepChr + "sdilr1.bat").AsFileName
'fnBat = (dirTmp.GetFullName + sepChr + "sdmlr.bat").AsFileName
'fBat = LineFile.Make(fnBat,#FILE_PERM_WRITE)
    Dim fBat As Object
    Set fBat = FileDialog.CreateWriteLineFile(dirTmp & "\sdmlr.bat")
'If (fBat.Is(LineFile).Not) Then
'  MsgBox.Error("Unable to create file " + fnBat + ".","File Error")
'  return Nil
'End
'elt = fBat.WriteElt(strDrive)
fBat.writeline FileDialog.getDriveName(FileDialog.getProjectDir)
'elt = fBat.WriteElt("cd " + dirProg.GetFullName)
fBat.writeline "CD " & FileDialog.getProjectDir & "\~sdmtemp"
'if (System.GetOSVariant = #SYSTEM_OSVARIANT_MSW95) then
'  elt = fBat.WriteElt("start /minimize sdmlr.exe")
'elseif (System.GetOSVariant = #SYSTEM_OSVARIANT_MSWNT) then
'  elt = fBat.WriteElt("sdmlr.exe")
fBat.writeline """" & strProgFN & """"
'End
'fBat.Close
fBat.Close
'if (System.GetOSVariant = #SYSTEM_OSVARIANT_MSW95) then
'  strEx = "start /minimize " + fnBat.AsString
'elseif (System.GetOSVariant = #SYSTEM_OSVARIANT_MSWNT) then
'  strEx = fnBat.AsString
'End
'av.UseWaitCursor
'System.ExecuteSynchronous (strEx)
Dim TaskID As Long
Err.Clear
On Error Resume Next
TaskID = Shell(dirTmp & "\sdmlr.bat", vbMaximizedFocus) ' Run LR
'dirDflt.SetCWD
'return True
If Err.Number = 0 Then MsgBox "Wait for SDMLR.EXE to finish. Then click OK", vbOKOnly, c_sModuleFileName
gSDI_RunLRCode = Err.Number = 0
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function
ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
  gSDI_RunLRCode = False
End Function
Public Function returnFolderName(tTitle As String, prjDir As String, tabFilename As String) As String
  On Error GoTo ErrorHandler

    Dim fileDlg As CommonDialog
11:     Set fileDlg = FileDialog2.CommonDialog1
12:     fileDlg.DialogTitle = tTitle
13:     fileDlg.InitDir = prjDir
14:     fileDlg.fileName = tabFilename
15:     fileDlg.DefaultExt = "exe"
16:     fileDlg.Filter = "Executable (*.exe)|*.exe"
17:     fileDlg.CancelError = True
18:     fileDlg.Flags = cdlOFNPathMustExist
19:     fileDlg.ShowOpen
20:         If IsEmpty(fileDlg.fileName) Then
21:             returnFolderName = ""
                Exit Function
23:         End If
        Dim fs As Object
25:     Set fs = CreateObject("Scripting.FileSystemObject")
        Dim aDir As String
29:     aDir = fs.getParentFolderName(fileDlg.fileName)
41:     returnFolderName = aDir
  Exit Function
ErrorHandler:
45:     If Err.Number = cdlCancel Then
46:         returnFolderName = Empty
        Exit Function
48:     End If
  HandleError True, "returnFolderName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
  returnFolderName = ""
End Function


