VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_WriteDataTypes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Option Compare Text
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_WriteDataTypes"       ' Constant reflect file module name
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Function gSDI_WriteDataTypes(ByRef Self As Variant) As Boolean

On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' Name:  gSDI.WriteDataTyp
''
''Topics:  Spatial Data Modeller; Spatial Analyst
''
''Description:  Writes the theme name and
''  the user specified data type (either free or
''  ordered) to a table called Data Type of Weights
''  Themes for future reference by scripts
''  Creates the table if it doesn't yet exist.
''
''Requires:
''
'' Self:  gSDI.CalcThemeWts
''
''Returns:
''==============================================
'strTab = "Data Types of Evidential Themes"
35: If (SDMGlobals.SDMUtil Is Nothing) Then
36:         Set SDMGlobals.SDMUtil = New SDMUtilities.SDMUtils
37: End If
Dim strTab As String
39: strTab = SDMGlobals.SDMMap.Name & "_Data Types of Evidential Themes"
'emap = self.Get(0)
Dim eMap As String
42: eMap = Self(0)
'if (eMap.Is(String).Not) then
'  emap = emap.GetName
'End
'>>>>> Keep intermediate raster files and Empty names from cluttering the table
47: If Trim(eMap) = "" Or UCase(Trim(eMap)) Like "SDM*" Or UCase(Trim(eMap)) Like "RASTER*" Then
48:     gSDI_WriteDataTypes = True
        Exit Function
50: End If
'dType = self.Get(1)
Dim dType As String
53: dType = Self(1)
'woeThmsTab = av.FindDoc(strTab)
Dim woeThmsTab As IStandaloneTable
56: Set woeThmsTab = WOETableUtils.FindStandAloneTableByName(strTab, SDMGlobals.SDMMap)
'If (woeThmsTab <> nil) Then
58: If (Not woeThmsTab Is Nothing) Then
'  If (woeThmsTab.Is(Table)) Then
'    theVTab = woeThmsTab.GetVTab
        Dim theVTab As ITable
62:     Set theVTab = woeThmsTab.Table
'    emField = theVTab.FindField("E_Theme")
        Dim emField As IField
        Dim emFieldidx As Long
66:     emFieldidx = theVTab.FindField("E_Theme")
67:     Set emField = theVTab.Fields.Field(emFieldidx)
'    DataField = theVTab.FindField("Data_Type")
        Dim dataFieldidx As Long
70:     dataFieldidx = theVTab.FindField("Data_Type")
        Dim DataField As IField
72:     Set DataField = theVTab.Fields.Field(dataFieldidx)
'  End
'ElseIf (woeThmsTab = nil) Then
75: Else 'not in the TOC
'  dirPrj = av.Run("gSDI.GetProjectDir",{})
        Dim dirPrj As String
78:     dirPrj = WOETableUtils.getProjectDir
'  charSep = av.Run("gSDI.GetSeparatorChar",{})
        Dim gsdiGetSepChar As gSDI_GetSepChar
81:     Set gsdiGetSepChar = New gSDI_GetSepChar
        Dim charsep As String
83:     charsep = gsdiGetSepChar.gSDI_GetSeparatorChar
        Dim tabFilename As String
85:     tabFilename = strTab
'  If (dirPrj.Is(FileName).Not) Then
87:     If (dirPrj = "") Then
'    tabFileName = "$HOME/sdmthms.dbf".AsFilename.GetFullName.AsFileName
89:         dirPrj = Environ("HOME")
'  Else
91:     Else
'    tabFileName = (dirPrj.AsString + charSep + "sdmthms.dbf").AsFileName
'        dirprj = dirprj
'  End
95:     End If
'  'MAKE A VTAB WITH SPECIFIED FILE NAME
'
'  ' IF CAN'T ADD FIELDS, RETURN
'
'  '----------------------------------
'
'  theVTab = VTab.MakeNew(tabFileName, dBASE)
        Dim sdmTabUtils As SDMTableUtils
104:     Set sdmTabUtils = New SDMTableUtils
'  If (theVTab.CanAddFields.Not) Then
'
'    return "Nofields"
'
'  End
'
'
'
'  'MAKE FIELDS
'
'  '----------------------------------
'
'  fieldList = List.Make
         Dim fieldList As Collection
119:     Set fieldList = New Collection
'  emField = Field.Make("E_Theme",#FIELD_CHAR,100,0)
'  fieldList.Add (emField)
122:     fieldList.Add (Array("E_Theme", esriFieldTypeString, 32, 0, "Evidence Theme", False))
'  dataField = Field.Make("Data_Type",#FIELD_CHAR,15,0)
'  fieldList.Add (DataField)
125:     fieldList.Add (Array("Data_Type", esriFieldTypeString, 12, 0, "Data Type", False))
'  fldMD = Field.Make("MissingData",#FIELD_LONG,10,0)
'  fieldList.Add (fldMD)
128:     fieldList.Add (Array("MissngData", esriFieldTypeInteger, 12, 0, "Missing Data Value", False))
'  ' ADD FIELDS TO THE VTAB
'
'  '----------------------------------
'
'  If (theVTab.CanEdit) Then
'
'     If (theVTab.StartEditingWithRecovery) Then
'
'       If (theVTab.CanAddFields) Then
'
'        theVTab.BeginTransaction
'
'        theVTab.AddFields (fieldList)
'
'        theVTab.EndTransaction
'
'      Else
'
'        return "Nofields"
'
'      End
'
'      saveEdits = True
'
'      theVTab.StopEditingWithRecovery (saveEdits)
'
'    End

         Dim aTable As IStandaloneTable
    
159:     Set aTable = SDMUtil.FindStandAloneTableByName(tabFilename)
160:     If (Not aTable Is Nothing) Then
            Dim TableUtils As SDMTableUtils
162:         Set TableUtils = New SDMTableUtils
163:         TableUtils.RemoveTable aTable, SDMApp
164:     End If
         Dim fs As Object
166:     Set fs = CreateObject("Scripting.FileSystemObject")
167:     If (fs.FileExists(dirPrj & "\" & tabFilename & ".dbf")) Then
168:         fs.DeleteFile dirPrj & "\" & tabFilename & ".dbf", True
169:     End If
        'MsgBox "Creating " & dirPrj & "\" & tabfilename, , "gSDI_WrtDataTypes"
171:     Set theVTab = WOETableUtils.CreateTable(tabFilename, dirPrj, fieldList, False)
172:     If (theVTab Is Nothing) Then
173:         MsgBox "Can't create MissingData Table", vbCritical, c_sModuleFileName
174:         gSDI_WriteDataTypes = False
            Exit Function
176:     End If

'  Else
'    return "Nofields"
'  End
'  theTable = Table.Make(theVTab)
'  theTable.SetName (strTab)
'  av.GetProject.AddDoc (theTable)
184:     sdmTabUtils.AddTable dirPrj, tabFilename & ".dbf", SDMApp
185:     WOETableUtils.SetAliases tabFilename, fieldList
'End
187: End If 'End of adding new table
'dataBM = theVTab.GetSelection
'theVTab.Query("(["+emField.AsString+"] = "+eMap.Quote+")",dataBM,#VTAB_SELTYPE_NEW)
     Dim Qfilt As IQueryFilter
191: Set Qfilt = New QueryFilter
192: With Qfilt
193:         .WhereClause = "E_Theme = '" & eMap & "'"
194: End With

     Dim editOk As Boolean
     Dim pWorkspace As String
198: pWorkspace = WOETableUtils.getProjectDir
     Dim pWorkspaceEdit As IWorkspaceEdit
200: Set pWorkspaceEdit = FeatureUtils.startEditing(pWorkspace)
     Dim curs As ICursor
202: Set curs = theVTab.Update(Qfilt, False)
     Dim pRow As irow
204: Set pRow = curs.NextRow

'If (dataBM.Count = 0) Then
207: If pRow Is Nothing Then
'
'  If (theVTab.CanEdit) Then
'    If (theVTab.StartEditingWithRecovery) Then
'      If (theVTab.CanAddRecord) Then
'        theVTab.BeginTransaction
'        record = theVTab.AddRecord
             Dim record As irow
215:         Set record = theVTab.CreateRow
'        theVTab.SetValue(emField,record,eMap)
217:         record.Value(1) = eMap
'        theVTab.SetValue(dataField,record,dType)
219:         record.Value(2) = dType
220:         record.Value(3) = -99
221:         record.Store
'        theVTab.EndTransaction
'
'      End
'
'      theVTab.StopEditingWithRecovery (True)
'
'    End
'
'  End
'
'Else
233: Else
'  If (theVTab.CanEdit) Then
'
'    If (theVTab.StartEditingWithRecovery) Then
'
'      record = dataBM.GetNextSet(-1)
'
''
'      theVTab.SetValue(dataField,record,dType)
242:     pRow.Value(2) = dType
243:     pRow.Store
'
'      theVTab.StopEditingWithRecovery (True)
'
'    End
'
'  End
'
'End
252: End If

254: FeatureUtils.StopEditing pWorkspaceEdit
'
'
'
'dataBM.ClearAll
'
'theVTab.Flush

'
'return nil
'
265: gSDI_WriteDataTypes = True
'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Function

ErrorHandler:
    HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
271:     pWorkspaceEdit.AbortEditOperation
272:   gSDI_WriteDataTypes = False
End Function

