VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_WrtMissingData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "gSDI_WriteMissingData"       ' Constant reflect file module name
Const c_sDLLFileName As String = "CalcThemeWeights"       ' Constant reflect file module name
'Private ObjectTag As Object
'Property Set setObjectTag(anObject As Object)
'    Set ObjectTag = anObject
'End Property
'Property Get getObjectTag() As Object
'    Set getObjectTag = ObjectTag
'End Property

Sub gSDI_WriteMissingData(ByRef Self As Variant)

On Error GoTo ErrorHandler
'PUT THE IMPLEMENTATION HERE >>>>>>>>>>>>>
'' gSDI.WriteMissingData
''
''Topics:  Spatial Data Modeller; Spatial Analyst
''
''Description:  Writes the theme name and
''  the user specified data type (either free or
''  ordered) to a table called Data Type of Weights
''  Themes for future reference by scripts
''  Creates the table if it doesn't yet exist.
''
''Requires:
''
'' Self:  gSDI.CalcThemeWts
''
''Returns:
''==============================================
'strTab = "Data Types of Evidential Themes"
Dim strTab As String
35: strTab = SDMGlobals.SDMMap.Name & "_Data Types of Evidential Themes"
'emap = self.Get(0)
Dim eMap As String
38: eMap = Self(0)
'if (eMap.Is(String).Not) then
'  emap = emap.GetName
'End
'>>>>> Keep intermediate raster files and Empty names from cluttering the table
43: If Trim(eMap) = "" Or UCase(Trim(eMap)) Like "SDMTEMP*" Then Exit Sub
'dType = self.Get(1)
Dim missing As Double
46: missing = Self(1)
'MsgBox "Modifying missing data: " & eMap & ", " & missing
'woeThmsTab = av.FindDoc(strTab)
Dim woeThmsTab As IStandaloneTable
50: Set woeThmsTab = WOETableUtils.FindStandAloneTableByName(strTab)
'If (woeThmsTab <> nil) Then
52: If (Not woeThmsTab Is Nothing) Then 'In the Map
'  If (woeThmsTab.Is(Table)) Then
'    theVTab = woeThmsTab.GetVTab
        Dim theVTab As ITable
56:     Set theVTab = woeThmsTab.Table
'    emField = theVTab.FindField("E_Theme")
        Dim emField As IField
        Dim emFieldidx As Long
60:         emFieldidx = theVTab.FindField("E_Theme")
61:         Set emField = theVTab.Fields.Field(emFieldidx)
'    DataField = theVTab.FindField("Data_Type")
        Dim dataFieldidx As Long
64:     dataFieldidx = theVTab.FindField("Data_Type")
        Dim DataField As IField
66:     Set DataField = theVTab.Fields.Field(dataFieldidx)
'    fldMD = theVtab.findField("MissngData")
        Dim fldMDidx As Long
69:     fldMDidx = theVTab.FindField("MissngData")
        Dim fldMD As IField
71:     Set fldMD = theVTab.Fields.Field(fldMDidx)
'  End
'ElseIf (woeThmsTab = nil) Then
74: Else 'not in the map
'  dirPrj = av.Run("gSDI.GetProjectDir",{})
    Dim getPrjDir As gSDI_getProjectDir
77:     Set getPrjDir = New gSDI_getProjectDir
    Dim dirPrj As String
79:     dirPrj = getPrjDir.gSDI_getProjectDir
'   dirPrj = SDMUtil.getDir(dirPrj, "Select Folder for Data Types Table")
'  charSep = av.Run("gSDI.GetSeparatorChar",{})
'
'  If (dirPrj.Is(FileName).Not) Then
84:     If (dirPrj = "") Then
'    tabFileName = "$HOME/sdmthms.dbf".AsFilename.GetFullName.AsFileName
        Dim tabFilename As String
87:         dirPrj = Environ("TEMP") '& charsep & "sdmthms.dbf"
'  Else
'     Else
'    tabFileName = (dirPrj.AsString + charSep + "sdmthms.dbf").AsFileName
'
'  End
93:     End If
'  'MAKE A VTAB WITH SPECIFIED FILE NAME
'
'  ' IF CAN'T ADD FIELDS, RETURN
'
'  '----------------------------------
'
'  theVTab = VTab.MakeNew(tabFileName, dBASE)
'  If (theVTab.CanAddFields.Not) Then
'    return "Nofields"
'  End
'
'  'MAKE FIELDS
'  '----------------------------------
'  fieldList = List.Make
    Dim fieldList As Collection
109:     Set fieldList = New Collection
'  emField = Field.Make("E_Theme",#FIELD_CHAR,100,0)
'  fieldList.Add (emField)
112:     fieldList.Add (Array("E_Theme", esriFieldTypeString, 32, 0, "Evidence Theme", False))
'  dataField = Field.Make("Data_Type",#FIELD_CHAR,15,0)
'  fieldList.Add (DataField)
115:     fieldList.Add (Array("Data_Type", esriFieldTypeString, 12, 0, "Data Type", False))
'  fldMD = Field.Make("MissingData",#FIELD_LONG,10,0)
'  fieldList.Add (fldMD)
118:     fieldList.Add (Array("MissngData", esriFieldTypeInteger, 12, 0, "Missing Data Value", False))
'  ' ADD FIELDS TO THE VTAB
'
'  '----------------------------------
'
'  If (theVTab.CanEdit) Then
'
'     If (theVTab.StartEditingWithRecovery) Then
'
'       If (theVTab.CanAddFields) Then
'
'        theVTab.BeginTransaction
'
'        theVTab.AddFields (fieldList)
'
'        theVTab.EndTransaction
'
'      Else
'
'        return "Nofields"
'
'      End
'
'      saveEdits = True
'
'      theVTab.StopEditingWithRecovery (saveEdits)
'
'    End
        Dim TableUtils As SDMTableUtils
147:     Set TableUtils = New SDMTableUtils
        Dim aTable As IStandaloneTable
149:     Set aTable = SDMUtil.FindStandAloneTableByName(strTab)
150:     If (Not aTable Is Nothing) Then
151:         TableUtils.RemoveTable aTable, SDMApp
152:     End If
         Dim fs As Object
154:     Set fs = CreateObject("Scripting.FileSystemObject")
155:     If (fs.FileExists(dirPrj & "\" & strTab & ".dbf")) Then _
                        fs.DeleteFile dirPrj & "\" & strTab & ".dbf", True
157:        Set theVTab = WOETableUtils.CreateTable(strTab, dirPrj, fieldList, False)
158:        If (theVTab Is Nothing) Then
159:            MsgBox "Can't create MissingData Table", vbCritical, c_sModuleFileName
                Exit Sub
161:        End If
'  Else
'
'    return "Nofields"
'
'  End
'
'
'
'  theTable = Table.Make(theVTab)
'
'  theTable.SetName (strTab)
'
'  av.GetProject.AddDoc (theTable)
175:     WOETableUtils.AddTable dirPrj, strTab, SDMApp
176:     WOETableUtils.SetAliases strTab, fieldList
'End
178: End If
'dataBM = theVTab.GetSelection
'theVTab.Query("(["+emField.AsString+"] = "+eMap.Quote+")",dataBM,#VTAB_SELTYPE_NEW)
'If (dataBM.Count = 0) Then
182: emFieldidx = theVTab.Fields.FindField("E_Theme")
183: fldMDidx = theVTab.Fields.FindField("MissngData")
184: If (theVTab.RowCount(Nothing) = 0) Then 'No rows in table
'  If (theVTab.CanEdit) Then
'
'    If (theVTab.StartEditingWithRecovery) Then
'
'      If (theVTab.CanAddRecord) Then
'
'        theVTab.BeginTransaction
             Dim record As irow
193:         Set record = theVTab.CreateRow
'        record = theVTab.AddRecord
'        theVTab.SetValue(emField,record,eMap)
196:         record.Value(emFieldidx) = LCase(eMap)
'        theVTab.SetValue(dataField,record,dType)
198:         record.Value(fldMDidx) = missing
199:         record.Store
'        theVTab.EndTransaction
'
'      End
'
'      theVTab.StopEditingWithRecovery (True)
'
'    End
'
'  End
'
'Else
211: Else
'  If (theVTab.CanEdit) Then
'
'    If (theVTab.StartEditingWithRecovery) Then
'
'      record = dataBM.GetNextSet(-1)
            Dim qry As IQueryFilter
218:        Set qry = New QueryFilter
219:        qry.WhereClause = "E_Theme = '" & eMap & "'"
            Dim curs As ICursor
221:        Set curs = theVTab.Search(qry, False)
222:        Set record = curs.NextRow
223:        If (record Is Nothing) Then
224:            Set record = theVTab.CreateRow
225:            record.Value(emFieldidx) = eMap
226:        End If
'      theVTab.BeginTransaction
'
'      theVTab.SetValue(dataField,record,dType)
230:         record.Value(fldMDidx) = missing
'      theVTab.EndTransaction
232:         record.Store
'      theVTab.StopEditingWithRecovery (True)
'
'    End
'
'  End
'
'End
240: End If 'data rows = 0
'
'
'dataBM.ClearAll
'
'theVTab.Flush
'
'return nil
'

'<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Exit Sub

ErrorHandler:
  HandleError True, c_sDLLFileName & " " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

