VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "gSDI_getProjectDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Const c_sModuleFileName As String = "gSDI_getProjectDir"       ' Constant reflect file module name

Function gSDI_getProjectDir() As String
On Error GoTo ErrorHandler
' Name:  gSDI.GetProjectDir

' Topics:  Spatial Data Modeller

' Description:  Gets the project
'               directory.  If there is no project
'               directory (the project file has not
'               yet been saved) or the directory is
'               read-only, gets
'               the windows temp directory or
'               users home directory.
'
'
'
' Requires:
'
' Self:        empty list
'
' Returns:     directory (filename)

'=============================================
' Try to get the project directory
'----------------------------------------------
    Dim ProjectDir As String
    Dim pTemplates As ITemplates
    Dim lTempCount As Long
    Dim strDocPath As String
33: If SDMGlobals.SDMApp Is Nothing Then
34:     Set SDMGlobals.SDMApp = New AppRef
35: End If
36:     Set pTemplates = SDMGlobals.SDMApp.Templates
37:     lTempCount = pTemplates.Count
    ' The document is always the last item
39:     strDocPath = pTemplates.item(lTempCount - 1)
    Dim fs As Object
41:     Set fs = CreateObject("Scripting.FileSystemObject")
42:     If (fs.GetExtensionName(strDocPath) = "tmp") _
        Then SDMGlobals.SDMApp.SaveAsDocument
44:     ProjectDir = fs.getParentFolderName(strDocPath)
    
46:     If (ProjectDir = "") Then
47:             ProjectDir = CurDir
48:     ElseIf (ProjectDir = "") Then
49:         If (Len(Environ("TEMP")) <> 0) Then
50:              ProjectDir = Environ("TEMP")
51:         ElseIf (Len(Environ("HOME")) <> 0) Then
52:              ProjectDir = Environ("HOME")
53:         End If
54:     End If
55:     SDMGlobals.SDMPrjDir = ProjectDir
56:     gSDI_getProjectDir = ProjectDir
Exit Function

ErrorHandler:
  HandleError True, c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
61:     gSDI_getProjectDir = Environ("TEMP")
End Function
