Attribute VB_Name = "FuzzyModelUtils"
Option Explicit
Const c_sModuleFileName As String = ""

Function getFuzzyModel() As IStandaloneTable
  On Error GoTo ErrorHandler
'Record fuzzy logic model in a DBF file
Dim lstDlg As New ListDialogSDM
8: lstDlg.Message = "Select Fuzzy Logic Model table"
9: lstDlg.Title = "Fuzzy Logic Model Tables"
10: lstDlg.lbx_list.AddItem "Make and add a new table"

Dim saTblColl As IStandaloneTableCollection
13: Set saTblColl = SDMGlobals.SDMMap
Dim saTbl As IStandaloneTable
Dim nSATbl As Long
16: For nSATbl = 0 To saTblColl.StandaloneTableCount - 1
        Dim saName As String
18:     saName = saTblColl.StandaloneTable(nSATbl).Name
19:     If Left(saName, Len("Flmdl")) = "Flmdl" Then _
            lstDlg.lbx_list.AddItem saName
21: Next nSATbl
22: lstDlg.doModal
Dim saTblName As String
24: saTblName = lstDlg.getValue
25: If saTblName = "" Then
26:     Set getFuzzyModel = Nothing
    Exit Function
28: End If
29: If Left(saTblName, Len("Make and add")) = "Make and add" Then
        Dim CWD As IFileName
31:     Set CWD = FileDialog.GetCWD
        Dim flmFN As IFileName
33:     Set flmFN = WOETableUtils.MakeTmp(CWD.path, "Flmdl", "dbf")
        Dim flmFNVar As Variant
35:     flmFNVar = FileDialog.GetSaveFileName("Fuzzy Logic Model Table", CWD.path, FileDialog.GetFileName(flmFN.path))
36:     If IsEmpty(flmFNVar) Then
37:         Set getFuzzyModel = Nothing
38:              gFZ.ZOrder 0
            Exit Function
40:     End If
        
        Dim fdescs As New Collection
        Dim fdesc1 As Variant
50:     fdesc1 = Array("INPUT_THMS", esriFieldTypeString, 12, 0, "Input Theme", False)
51:     fdescs.Add fdesc1
        Dim fdesc2 As Variant
53:     fdesc2 = Array("FUZZY_OP", esriFieldTypeString, 128, 0, "Fuzzy Operations", False)
54:     fdescs.Add fdesc2
         Dim fdesc3 As Variant
56:     fdesc3 = Array("OUTPUT_THM", esriFieldTypeString, 12, 0, "Output Raster", False)
57:     fdescs.Add fdesc3
    
        Dim flmFNStr As String
60:     flmFNStr = flmFNVar(1) & "\" & flmFNVar(0)
        Dim flmTab As ITable
62:     Set flmTab = WOETableUtils.CreateTable(FileDialog.GetBaseName(flmFNStr), FileDialog.getDir(flmFNStr), fdescs, False)
63:     WOETableUtils.AddTable FileDialog.getDir(flmFNStr), FileDialog.GetBaseName(flmFNStr), SDMGlobals.SDMApp
64:     WOETableUtils.SetAliases FileDialog.GetBaseName(flmFNStr), fdescs
65:     saTblName = FileDialog.GetBaseName(flmFNStr)
66: End If
67:     Set saTbl = WOETableUtils.FindStandAloneTableByName(saTblName, SDMGlobals.SDMMap)
68:     Set getFuzzyModel = saTbl
69:     gFZ.ZOrder 0

  Exit Function
ErrorHandler:
  HandleError True, "getFuzzyModel " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Function

Sub writeFuzzyModel(ByRef flmTab As ITable, inputThms As String, fuzzyOp As String, OutputThm As String)
  On Error GoTo ErrorHandler

    Dim pdataSet As IDataset
80: Set pdataSet = flmTab
    Dim pWrkSpcEdit As IWorkspaceEdit
82: Set pWrkSpcEdit = FeatureUtils.startEditing(pdataSet.Workspace.PathName)

    Dim rw As IRow
85: Set rw = flmTab.CreateRow
86: rw.Value(flmTab.FindField("INPUT_THMS")) = inputThms
87: rw.Value(flmTab.FindField("FUZZY_OP")) = fuzzyOp
88: rw.Value(flmTab.FindField("OUTPUT_THM")) = OutputThm
89: rw.Store

91: FeatureUtils.stopEditing pWrkSpcEdit

  Exit Sub
ErrorHandler:
  HandleError True, "writeFuzzyModel " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

